# swagger-client


This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen
For more information, please visit [https://harness.io/](https://harness.io/)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:

```python
import harness_open_api 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:

```python
import harness_open_api
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import harness_open_api
from harness_open_api.rest import ApiException
from pprint import pprint

# Configure API key authorization: x-api-key
configuration = harness_open_api.Configuration()
configuration.api_key['x-api-key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-key'] = 'Bearer'

# create an instance of the API class
api_instance = harness_open_api.APIKeysApi(harness_open_api.ApiClient(configuration))
account_identifier = 'account_identifier_example' # str | Account Identifier
org_identifier = 'org_identifier_example' # str | Organization Identifier
environment_identifier = 'environment_identifier_example' # str | Environment Identifier
project_identifier = 'project_identifier_example' # str | The Project identifier
body = NULL # object |  (optional)

try:
    # Creates an API key for the given Environment
    api_response = api_instance.add_api_key(account_identifier, org_identifier, environment_identifier, project_identifier, body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIKeysApi->add_api_key: %s\n" % e)

# Configure API key authorization: x-api-key
configuration = harness_open_api.Configuration()
configuration.api_key['x-api-key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-key'] = 'Bearer'

# create an instance of the API class
api_instance = harness_open_api.APIKeysApi(harness_open_api.ApiClient(configuration))
identifier = 'identifier_example' # str | Unique identifier for the object in the API.
project_identifier = 'project_identifier_example' # str | The Project identifier
environment_identifier = 'environment_identifier_example' # str | Environment Identifier
account_identifier = 'account_identifier_example' # str | Account Identifier
org_identifier = 'org_identifier_example' # str | Organization Identifier

try:
    # Deletes an API Key
    api_instance.delete_api_key(identifier, project_identifier, environment_identifier, account_identifier, org_identifier)
except ApiException as e:
    print("Exception when calling APIKeysApi->delete_api_key: %s\n" % e)

# Configure API key authorization: x-api-key
configuration = harness_open_api.Configuration()
configuration.api_key['x-api-key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-key'] = 'Bearer'

# create an instance of the API class
api_instance = harness_open_api.APIKeysApi(harness_open_api.ApiClient(configuration))
account_identifier = 'account_identifier_example' # str | Account Identifier
org_identifier = 'org_identifier_example' # str | Organization Identifier
project_identifier = 'project_identifier_example' # str | The Project identifier
environment_identifier = 'environment_identifier_example' # str | Environment Identifier
page_number = 56 # int | PageNumber (optional)
page_size = 56 # int | PageSize (optional)

try:
    # Returns API Keys for an Environment
    api_response = api_instance.get_all_api_keys(account_identifier, org_identifier, project_identifier, environment_identifier, page_number=page_number, page_size=page_size)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIKeysApi->get_all_api_keys: %s\n" % e)

# Configure API key authorization: x-api-key
configuration = harness_open_api.Configuration()
configuration.api_key['x-api-key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-key'] = 'Bearer'

# create an instance of the API class
api_instance = harness_open_api.APIKeysApi(harness_open_api.ApiClient(configuration))
identifier = 'identifier_example' # str | Unique identifier for the object in the API.
project_identifier = 'project_identifier_example' # str | The Project identifier
environment_identifier = 'environment_identifier_example' # str | Environment Identifier
account_identifier = 'account_identifier_example' # str | Account Identifier
org_identifier = 'org_identifier_example' # str | Organization Identifier

try:
    # Returns API keys
    api_response = api_instance.get_api_key(identifier, project_identifier, environment_identifier, account_identifier, org_identifier)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIKeysApi->get_api_key: %s\n" % e)

# Configure API key authorization: x-api-key
configuration = harness_open_api.Configuration()
configuration.api_key['x-api-key'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['x-api-key'] = 'Bearer'

# create an instance of the API class
api_instance = harness_open_api.APIKeysApi(harness_open_api.ApiClient(configuration))
project_identifier = 'project_identifier_example' # str | The Project identifier
environment_identifier = 'environment_identifier_example' # str | Environment Identifier
account_identifier = 'account_identifier_example' # str | Account Identifier
org_identifier = 'org_identifier_example' # str | Organization Identifier
identifier = 'identifier_example' # str | Unique identifier for the object in the API.
body = NULL # object |  (optional)

try:
    # Updates an API Key
    api_instance.update_api_key(project_identifier, environment_identifier, account_identifier, org_identifier, identifier, body=body)
except ApiException as e:
    print("Exception when calling APIKeysApi->update_api_key: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://app.harness.io*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*APIKeysApi* | [**add_api_key**](docs/APIKeysApi.md#add_api_key) | **POST** /cf/admin/apikey | Creates an API key for the given Environment
*APIKeysApi* | [**delete_api_key**](docs/APIKeysApi.md#delete_api_key) | **DELETE** /cf/admin/apikey/{identifier} | Deletes an API Key
*APIKeysApi* | [**get_all_api_keys**](docs/APIKeysApi.md#get_all_api_keys) | **GET** /cf/admin/apikey | Returns API Keys for an Environment
*APIKeysApi* | [**get_api_key**](docs/APIKeysApi.md#get_api_key) | **GET** /cf/admin/apikey/{identifier} | Returns API keys
*APIKeysApi* | [**update_api_key**](docs/APIKeysApi.md#update_api_key) | **PUT** /cf/admin/apikey/{identifier} | Updates an API Key
*AccessControlListApi* | [**get_access_control_list**](docs/AccessControlListApi.md#get_access_control_list) | **POST** /authz/api/acl | Check Permission
*AccountSettingApi* | [**get_account_setting**](docs/AccountSettingApi.md#get_account_setting) | **GET** /ng/api/account-setting | Get the AccountSetting by accountIdentifier
*AccountSettingApi* | [**list_account_setting**](docs/AccountSettingApi.md#list_account_setting) | **GET** /ng/api/account-setting/list | Get the AccountSetting by accountIdentifier
*AccountSettingApi* | [**update_account_setting**](docs/AccountSettingApi.md#update_account_setting) | **PUT** /ng/api/account-setting | Updates account settings
*AccountConnectorApi* | [**create_account_scoped_connector**](docs/AccountConnectorApi.md#create_account_scoped_connector) | **POST** /v1/connectors | Create a Connector
*AccountConnectorApi* | [**delete_account_scoped_connector**](docs/AccountConnectorApi.md#delete_account_scoped_connector) | **DELETE** /v1/connectors/{connector} | Delete a connector
*AccountConnectorApi* | [**get_account_scoped_connector**](docs/AccountConnectorApi.md#get_account_scoped_connector) | **GET** /v1/connectors/{connector} | Retrieve a connector
*AccountConnectorApi* | [**test_account_scoped_connector**](docs/AccountConnectorApi.md#test_account_scoped_connector) | **GET** /v1/connectors/{connector}/test-connection | Test a connector
*AccountConnectorApi* | [**update_account_scoped_connector**](docs/AccountConnectorApi.md#update_account_scoped_connector) | **PUT** /v1/connectors/{connector} | Update a connector
*AccountEnvironmentsApi* | [**create_account_scoped_environment**](docs/AccountEnvironmentsApi.md#create_account_scoped_environment) | **POST** /v1/environments | Creates an account scoped Environment
*AccountEnvironmentsApi* | [**delete_account_scoped_environment**](docs/AccountEnvironmentsApi.md#delete_account_scoped_environment) | **DELETE** /v1/environments/{environment} | Delete an account scoped Environment
*AccountEnvironmentsApi* | [**get_account_scoped_environment**](docs/AccountEnvironmentsApi.md#get_account_scoped_environment) | **GET** /v1/environments/{environment} | Retrieve an account scoped environment
*AccountEnvironmentsApi* | [**get_account_scoped_environments**](docs/AccountEnvironmentsApi.md#get_account_scoped_environments) | **GET** /v1/environments | List account scoped Environments
*AccountEnvironmentsApi* | [**update_account_scoped_environment**](docs/AccountEnvironmentsApi.md#update_account_scoped_environment) | **PUT** /v1/environments/{environment} | Update account scoped Environment
*AccountInfrastructuresApi* | [**create_account_scoped_infrastructure**](docs/AccountInfrastructuresApi.md#create_account_scoped_infrastructure) | **POST** /v1/environments/{environment}/infrastructures | Creates an account scoped Infrastructure
*AccountInfrastructuresApi* | [**delete_account_scoped_infrastructure**](docs/AccountInfrastructuresApi.md#delete_account_scoped_infrastructure) | **DELETE** /v1/environments/{environment}/infrastructures/{infrastructure-definition} | Delete an account scoped Infrastructure
*AccountInfrastructuresApi* | [**get_account_scoped_infrastructure**](docs/AccountInfrastructuresApi.md#get_account_scoped_infrastructure) | **GET** /v1/environments/{environment}/infrastructures/{infrastructure-definition} | Retrieve an account scoped Infrastructure
*AccountInfrastructuresApi* | [**get_account_scoped_infrastructures**](docs/AccountInfrastructuresApi.md#get_account_scoped_infrastructures) | **GET** /v1/environments/{environment}/infrastructures | List account scoped Infrastructures
*AccountInfrastructuresApi* | [**update_account_scoped_infrastructure**](docs/AccountInfrastructuresApi.md#update_account_scoped_infrastructure) | **PUT** /v1/environments/{environment}/infrastructures/{infrastructure-definition} | Update account scoped Infrastructure
*AccountRancherInfrastructureApi* | [**list_account_scoped_rancher_clusters_using_connector**](docs/AccountRancherInfrastructureApi.md#list_account_scoped_rancher_clusters_using_connector) | **GET** /v1/rancher/connectors/{connector}/clusters | List rancher clusters using account level connector
*AccountRancherInfrastructureApi* | [**list_account_scoped_rancher_clusters_using_env_and_infra**](docs/AccountRancherInfrastructureApi.md#list_account_scoped_rancher_clusters_using_env_and_infra) | **GET** /v1/rancher/environments/{environment}/infrastructure-definitions/{infrastructure-definition}/clusters | List rancher clusters using account level env and infra def
*AccountResourceGroupsApi* | [**create_resource_group_acc**](docs/AccountResourceGroupsApi.md#create_resource_group_acc) | **POST** /v1/resource-groups | Create a Resource Group
*AccountResourceGroupsApi* | [**delete_resource_group_acc**](docs/AccountResourceGroupsApi.md#delete_resource_group_acc) | **DELETE** /v1/resource-groups/{resource-group} | Delete a Resource Group
*AccountResourceGroupsApi* | [**get_resource_group_acc**](docs/AccountResourceGroupsApi.md#get_resource_group_acc) | **GET** /v1/resource-groups/{resource-group} | Retrieve a Resource Group
*AccountResourceGroupsApi* | [**list_resource_groups_acc**](docs/AccountResourceGroupsApi.md#list_resource_groups_acc) | **GET** /v1/resource-groups | List Resource Groups
*AccountResourceGroupsApi* | [**update_resource_group_acc**](docs/AccountResourceGroupsApi.md#update_resource_group_acc) | **PUT** /v1/resource-groups/{resource-group} | Update a Resource Group
*AccountRoleAssignmentsApi* | [**create_account_scoped_role_assignments**](docs/AccountRoleAssignmentsApi.md#create_account_scoped_role_assignments) | **POST** /v1/role-assignments | Create a role assignment
*AccountRoleAssignmentsApi* | [**delete_account_scoped_role_assignment**](docs/AccountRoleAssignmentsApi.md#delete_account_scoped_role_assignment) | **DELETE** /v1/role-assignments/{role-assignment} | Delete a role assignment
*AccountRoleAssignmentsApi* | [**get_account_scoped_role_assignment**](docs/AccountRoleAssignmentsApi.md#get_account_scoped_role_assignment) | **GET** /v1/role-assignments/{role-assignment} | Retrieve a role assignment
*AccountRoleAssignmentsApi* | [**get_account_scoped_role_assignments**](docs/AccountRoleAssignmentsApi.md#get_account_scoped_role_assignments) | **GET** /v1/role-assignments | List role assignments
*AccountRolesApi* | [**create_role_acc**](docs/AccountRolesApi.md#create_role_acc) | **POST** /v1/roles | Create a Role
*AccountRolesApi* | [**delete_role_acc**](docs/AccountRolesApi.md#delete_role_acc) | **DELETE** /v1/roles/{role} | Delete a Role
*AccountRolesApi* | [**get_role_acc**](docs/AccountRolesApi.md#get_role_acc) | **GET** /v1/roles/{role} | Retrieve a Role
*AccountRolesApi* | [**list_roles_acc**](docs/AccountRolesApi.md#list_roles_acc) | **GET** /v1/roles | List Roles
*AccountRolesApi* | [**update_role_acc**](docs/AccountRolesApi.md#update_role_acc) | **PUT** /v1/roles/{role} | Update a Role
*AccountSecretApi* | [**create_account_scoped_secret**](docs/AccountSecretApi.md#create_account_scoped_secret) | **POST** /v1/secrets | Create a secret
*AccountSecretApi* | [**delete_account_scoped_secret**](docs/AccountSecretApi.md#delete_account_scoped_secret) | **DELETE** /v1/secrets/{secret} | Deletes a secret
*AccountSecretApi* | [**get_account_scoped_secret**](docs/AccountSecretApi.md#get_account_scoped_secret) | **GET** /v1/secrets/{secret} | Retrieve a secret
*AccountSecretApi* | [**get_account_scoped_secrets**](docs/AccountSecretApi.md#get_account_scoped_secrets) | **GET** /v1/secrets | List secrets
*AccountSecretApi* | [**update_account_scoped_secret**](docs/AccountSecretApi.md#update_account_scoped_secret) | **PUT** /v1/secrets/{secret} | Update a secret
*AccountSecretApi* | [**validate_account_secret_ref**](docs/AccountSecretApi.md#validate_account_secret_ref) | **POST** /v1/secrets/validate-secret-ref | Validate secret reference
*AccountServicesApi* | [**create_account_scoped_service**](docs/AccountServicesApi.md#create_account_scoped_service) | **POST** /v1/services | Create a service
*AccountServicesApi* | [**delete_account_scoped_service**](docs/AccountServicesApi.md#delete_account_scoped_service) | **DELETE** /v1/services/{service} | Delete a service
*AccountServicesApi* | [**get_account_scoped_service**](docs/AccountServicesApi.md#get_account_scoped_service) | **GET** /v1/services/{service} | Retrieve a service
*AccountServicesApi* | [**get_account_scoped_services**](docs/AccountServicesApi.md#get_account_scoped_services) | **GET** /v1/services | List services
*AccountServicesApi* | [**update_account_scoped_service**](docs/AccountServicesApi.md#update_account_scoped_service) | **PUT** /v1/services/{service} | Update service
*AccountTemplateApi* | [**create_templates_acc**](docs/AccountTemplateApi.md#create_templates_acc) | **POST** /v1/templates | Create Template
*AccountTemplateApi* | [**delete_template_acc**](docs/AccountTemplateApi.md#delete_template_acc) | **DELETE** /v1/templates/{template}/versions/{version} | Delete Template
*AccountTemplateApi* | [**get_template_acc**](docs/AccountTemplateApi.md#get_template_acc) | **GET** /v1/templates/{template}/versions/{version} | Retrieve a Template
*AccountTemplateApi* | [**get_template_stable_acc**](docs/AccountTemplateApi.md#get_template_stable_acc) | **GET** /v1/templates/{template} | Get Stable Template
*AccountTemplateApi* | [**get_templates_list_acc**](docs/AccountTemplateApi.md#get_templates_list_acc) | **GET** /v1/templates | Get Templates List
*AccountTemplateApi* | [**import_template_acc**](docs/AccountTemplateApi.md#import_template_acc) | **POST** /v1/templates/{template}/import | Import Template
*AccountTemplateApi* | [**update_git_metadata_details**](docs/AccountTemplateApi.md#update_git_metadata_details) | **PUT** /v1/templates/git-metadata/{template} | Update Git details
*AccountTemplateApi* | [**update_template_acc**](docs/AccountTemplateApi.md#update_template_acc) | **PUT** /v1/templates/{template}/versions/{version} | Update Template
*AccountTemplateApi* | [**update_template_stable_acc**](docs/AccountTemplateApi.md#update_template_stable_acc) | **PUT** /v1/templates/{template}/versions/{version}/stable | Update Stable Template
*AccountsApi* | [**get_account_ng**](docs/AccountsApi.md#get_account_ng) | **GET** /ng/api/accounts/{accountIdentifier} | Gets an account
*AccountsApi* | [**is_immutable_delegate_enabled**](docs/AccountsApi.md#is_immutable_delegate_enabled) | **GET** /ng/api/accounts/{accountIdentifier}/immutable-delegate-enabled | Checks if immutable delegate is enabled for account
*AccountsApi* | [**license_update_from_uing**](docs/AccountsApi.md#license_update_from_uing) | **PUT** /ng/api/accounts/license/update/{accountIdentifier} | License update from UI
*AccountsApi* | [**update_account_default_experience_ng**](docs/AccountsApi.md#update_account_default_experience_ng) | **PUT** /ng/api/accounts/{accountIdentifier}/default-experience | Update Default Experience
*AccountsApi* | [**update_account_name_ng**](docs/AccountsApi.md#update_account_name_ng) | **PUT** /ng/api/accounts/{accountIdentifier}/name | Update Account Name
*AgentMTLSEndpointManagementApi* | [**check_agent_mtls_endpoint_domain_prefix_availability**](docs/AgentMTLSEndpointManagementApi.md#check_agent_mtls_endpoint_domain_prefix_availability) | **GET** /ng/api/agent/mtls/check-availability | Checks whether a given agent mTLS endpoint domain prefix is available.
*AgentMTLSEndpointManagementApi* | [**create_agent_mtls_endpoint_for_account**](docs/AgentMTLSEndpointManagementApi.md#create_agent_mtls_endpoint_for_account) | **POST** /ng/api/agent/mtls/endpoint | Creates the agent mTLS endpoint for an account.
*AgentMTLSEndpointManagementApi* | [**delete_agent_mtls_endpoint_for_account**](docs/AgentMTLSEndpointManagementApi.md#delete_agent_mtls_endpoint_for_account) | **DELETE** /ng/api/agent/mtls/endpoint | Removes the agent mTLS endpoint for an account.
*AgentMTLSEndpointManagementApi* | [**get_agent_mtls_endpoint_for_account**](docs/AgentMTLSEndpointManagementApi.md#get_agent_mtls_endpoint_for_account) | **GET** /ng/api/agent/mtls/endpoint | Gets the agent mTLS endpoint for an account.
*AgentMTLSEndpointManagementApi* | [**patch_agent_mtls_endpoint_for_account**](docs/AgentMTLSEndpointManagementApi.md#patch_agent_mtls_endpoint_for_account) | **PATCH** /ng/api/agent/mtls/endpoint | Updates selected properties of the existing agent mTLS endpoint for an account.
*AgentMTLSEndpointManagementApi* | [**update_agent_mtls_endpoint_for_account**](docs/AgentMTLSEndpointManagementApi.md#update_agent_mtls_endpoint_for_account) | **PUT** /ng/api/agent/mtls/endpoint | Updates the existing agent mTLS endpoint for an account.
*AgentsApi* | [**agent_service_for_server_create**](docs/AgentsApi.md#agent_service_for_server_create) | **POST** /gitops/api/v1/agents | 
*AgentsApi* | [**agent_service_for_server_delete**](docs/AgentsApi.md#agent_service_for_server_delete) | **DELETE** /gitops/api/v1/agents/{identifier} | 
*AgentsApi* | [**agent_service_for_server_get**](docs/AgentsApi.md#agent_service_for_server_get) | **GET** /gitops/api/v1/agents/{identifier} | 
*AgentsApi* | [**agent_service_for_server_get_deploy_helm_chart**](docs/AgentsApi.md#agent_service_for_server_get_deploy_helm_chart) | **GET** /gitops/api/v1/agents/{agentIdentifier}/helm-chart | 
*AgentsApi* | [**agent_service_for_server_get_deploy_overrides**](docs/AgentsApi.md#agent_service_for_server_get_deploy_overrides) | **GET** /gitops/api/v1/agents/{agentIdentifier}/helm-overrides | 
*AgentsApi* | [**agent_service_for_server_get_deploy_yaml**](docs/AgentsApi.md#agent_service_for_server_get_deploy_yaml) | **GET** /gitops/api/v1/agents/{agentIdentifier}/deploy.yaml | 
*AgentsApi* | [**agent_service_for_server_list**](docs/AgentsApi.md#agent_service_for_server_list) | **GET** /gitops/api/v1/agents | 
*AgentsApi* | [**agent_service_for_server_post_deploy_helm_chart**](docs/AgentsApi.md#agent_service_for_server_post_deploy_helm_chart) | **POST** /gitops/api/v1/agents/{agentIdentifier}/deployment-spec/helm | 
*AgentsApi* | [**agent_service_for_server_post_deploy_overrides**](docs/AgentsApi.md#agent_service_for_server_post_deploy_overrides) | **POST** /gitops/api/v1/agents/{agentIdentifier}/helm-overrides | 
*AgentsApi* | [**agent_service_for_server_post_deploy_yaml**](docs/AgentsApi.md#agent_service_for_server_post_deploy_yaml) | **POST** /gitops/api/v1/agents/{agentIdentifier}/deployment-spec/yaml | 
*AgentsApi* | [**agent_service_for_server_regenerate_credentials**](docs/AgentsApi.md#agent_service_for_server_regenerate_credentials) | **POST** /gitops/api/v1/agents/{identifier}/credentials | 
*AgentsApi* | [**agent_service_for_server_scale**](docs/AgentsApi.md#agent_service_for_server_scale) | **POST** /gitops/api/v1/agents/{identifier}/scale | 
*AgentsApi* | [**agent_service_for_server_search**](docs/AgentsApi.md#agent_service_for_server_search) | **POST** /gitops/api/v1/agents/search | 
*AgentsApi* | [**agent_service_for_server_set_primary_node**](docs/AgentsApi.md#agent_service_for_server_set_primary_node) | **PATCH** /gitops/api/v1/agents/{agentIdentifier}/primaryNode | 
*AgentsApi* | [**agent_service_for_server_unique**](docs/AgentsApi.md#agent_service_for_server_unique) | **GET** /gitops/api/v1/agents/{identifier}/unique | 
*AgentsApi* | [**agent_service_for_server_update**](docs/AgentsApi.md#agent_service_for_server_update) | **PUT** /gitops/api/v1/agents/{agent.identifier} | 
*AgentsApi* | [**version_upgrade_service_upgrade_available_v2**](docs/AgentsApi.md#version_upgrade_service_upgrade_available_v2) | **GET** /gitops/api/v2/versions/agents/upgrade-available | 
*AiEngineApi* | [**get_prompt_resources**](docs/AiEngineApi.md#get_prompt_resources) | **GET** /ccm/api/governance/promptResources | Get supported prompt resources
*AiEngineApi* | [**get_prompt_rules**](docs/AiEngineApi.md#get_prompt_rules) | **GET** /ccm/api/governance/promptRules | Get sample prompt governance rules
*AnomaliesApi* | [**dismiss_anomaly**](docs/AnomaliesApi.md#dismiss_anomaly) | **PUT** /cf/admin/anomalies/{identifier}/dismiss | Dismisses an Anomaly
*ApiKeyApi* | [**create_api_key**](docs/ApiKeyApi.md#create_api_key) | **POST** /ng/api/apikey | Creates an API key
*ApiKeyApi* | [**delete_api_key**](docs/ApiKeyApi.md#delete_api_key) | **DELETE** /ng/api/apikey/{identifier} | Deletes the API Key corresponding to the provided ID.
*ApiKeyApi* | [**get_aggregated_api_key**](docs/ApiKeyApi.md#get_aggregated_api_key) | **GET** /ng/api/apikey/aggregate/{identifier} | Fetches the API Keys details corresponding to the provided ID and Scope.
*ApiKeyApi* | [**list_api_keys**](docs/ApiKeyApi.md#list_api_keys) | **GET** /ng/api/apikey/aggregate | Fetches the list of Aggregated API Keys corresponding to the request&#x27;s filter criteria.
*ApiKeyApi* | [**list_api_keys1**](docs/ApiKeyApi.md#list_api_keys1) | **GET** /ng/api/apikey | Fetches the list of API Keys corresponding to the request&#x27;s filter criteria.
*ApiKeyApi* | [**update_api_key**](docs/ApiKeyApi.md#update_api_key) | **PUT** /ng/api/apikey/{identifier} | Updates API Key for the provided ID
*AppConfigApi* | [**save_or_update_plugin_app_config**](docs/AppConfigApi.md#save_or_update_plugin_app_config) | **POST** /v1/app-config | Save Or Update Plugin Config
*AppConfigApi* | [**toggle_plugin_for_account**](docs/AppConfigApi.md#toggle_plugin_for_account) | **POST** /v1/plugin-toggle/{plugin-id} | Toggle Plugin
*ApplicationApi* | [**application_service_list_apps**](docs/ApplicationApi.md#application_service_list_apps) | **POST** /gitops/api/v1/applications | List applications
*ApplicationsApi* | [**agent_application_service_create**](docs/ApplicationsApi.md#agent_application_service_create) | **POST** /gitops/api/v1/agents/{agentIdentifier}/applications | Create an application
*ApplicationsApi* | [**agent_application_service_delete**](docs/ApplicationsApi.md#agent_application_service_delete) | **DELETE** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name} | Delete an application
*ApplicationsApi* | [**agent_application_service_delete_resource**](docs/ApplicationsApi.md#agent_application_service_delete_resource) | **DELETE** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name}/resource | Delete resource
*ApplicationsApi* | [**agent_application_service_get**](docs/ApplicationsApi.md#agent_application_service_get) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{query.name} | Get application
*ApplicationsApi* | [**agent_application_service_get_application_sync_windows**](docs/ApplicationsApi.md#agent_application_service_get_application_sync_windows) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{query.name}/syncwindows | Get sync windows of the application
*ApplicationsApi* | [**agent_application_service_get_manifests**](docs/ApplicationsApi.md#agent_application_service_get_manifests) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{query.name}/manifests | Get application manifest
*ApplicationsApi* | [**agent_application_service_get_resource**](docs/ApplicationsApi.md#agent_application_service_get_resource) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name}/resource | Get an application resource
*ApplicationsApi* | [**agent_application_service_list**](docs/ApplicationsApi.md#agent_application_service_list) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications | List applications for a specific agent
*ApplicationsApi* | [**agent_application_service_list_resource_actions**](docs/ApplicationsApi.md#agent_application_service_list_resource_actions) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name}/resource/actions | List resource actions
*ApplicationsApi* | [**agent_application_service_list_resource_events**](docs/ApplicationsApi.md#agent_application_service_list_resource_events) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{query.name}/events | List resource events
*ApplicationsApi* | [**agent_application_service_managed_resources**](docs/ApplicationsApi.md#agent_application_service_managed_resources) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{query.applicationName}/managed-resources | Get ManagedResources
*ApplicationsApi* | [**agent_application_service_parent**](docs/ApplicationsApi.md#agent_application_service_parent) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/parent/{query.name} | Get parent application
*ApplicationsApi* | [**agent_application_service_patch**](docs/ApplicationsApi.md#agent_application_service_patch) | **PATCH** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name} | Patch an application
*ApplicationsApi* | [**agent_application_service_patch_resource**](docs/ApplicationsApi.md#agent_application_service_patch_resource) | **POST** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name}/resource | Patch an application resource
*ApplicationsApi* | [**agent_application_service_pod_logs**](docs/ApplicationsApi.md#agent_application_service_pod_logs) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{query.name}/pods/{query.podName}/logs | PodLogs returns stream of log entries for the specified pod(s).
*ApplicationsApi* | [**agent_application_service_pod_logs2**](docs/ApplicationsApi.md#agent_application_service_pod_logs2) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{query.name}/logs | PodLogs returns stream of log entries for the specified pod(s).
*ApplicationsApi* | [**agent_application_service_resource_tree**](docs/ApplicationsApi.md#agent_application_service_resource_tree) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{query.name}/resource-tree | Get resource tree
*ApplicationsApi* | [**agent_application_service_revision_metadata**](docs/ApplicationsApi.md#agent_application_service_revision_metadata) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{query.name}/revisions/{query.revision}/metadata | Get revision metadata
*ApplicationsApi* | [**agent_application_service_rollback**](docs/ApplicationsApi.md#agent_application_service_rollback) | **POST** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name}/rollback | Rollback syncs an application to its target state
*ApplicationsApi* | [**agent_application_service_run_resource_action**](docs/ApplicationsApi.md#agent_application_service_run_resource_action) | **POST** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name}/resource/actions | Run resource action
*ApplicationsApi* | [**agent_application_service_sync**](docs/ApplicationsApi.md#agent_application_service_sync) | **POST** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name}/sync | Sync an application
*ApplicationsApi* | [**agent_application_service_terminate_operation**](docs/ApplicationsApi.md#agent_application_service_terminate_operation) | **DELETE** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name}/operation | Terminate operation
*ApplicationsApi* | [**agent_application_service_update**](docs/ApplicationsApi.md#agent_application_service_update) | **PUT** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.application.metadata.name} | Update an application
*ApplicationsApi* | [**agent_application_service_update_spec**](docs/ApplicationsApi.md#agent_application_service_update_spec) | **PUT** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name}/spec | Update application spec
*ApplicationsApi* | [**agent_application_service_watch**](docs/ApplicationsApi.md#agent_application_service_watch) | **GET** /gitops/api/v1/agents/{agentIdentifier}/stream/applications | Watch returns stream of application change events
*ApplicationsApi* | [**agent_application_service_watch_resource_tree**](docs/ApplicationsApi.md#agent_application_service_watch_resource_tree) | **GET** /gitops/api/v1/agents/{agentIdentifier}/stream/applications/{query.applicationName}/resource-tree | WatchResourceTree returns stream of application resource tree
*ApplicationsApi* | [**application_service_exists**](docs/ApplicationsApi.md#application_service_exists) | **GET** /gitops/api/v1/applications/{name}/exists | Check if an application exists
*ApplicationsApi* | [**application_service_is_multi_source_enabled**](docs/ApplicationsApi.md#application_service_is_multi_source_enabled) | **GET** /gitops/api/v1/applications/multisource | Check if multisource feature is enabled
*ApplicationsApi* | [**application_service_list_app_sets**](docs/ApplicationsApi.md#application_service_list_app_sets) | **GET** /gitops/api/v1/applications/sets | List ApplicationSets
*ApplicationsApi* | [**application_service_list_app_sync**](docs/ApplicationsApi.md#application_service_list_app_sync) | **POST** /gitops/api/v1/applications/sync | List application sync status
*ApplicationsApi* | [**application_service_list_attributes**](docs/ApplicationsApi.md#application_service_list_attributes) | **GET** /gitops/api/v1/applications/attributes | List attributes for applications
*ApplicationsApi* | [**application_service_list_ns**](docs/ApplicationsApi.md#application_service_list_ns) | **POST** /gitops/api/v1/applications/ns | List namespaces for a specific query
*ApprovalsApi* | [**add_harness_approval_activity**](docs/ApprovalsApi.md#add_harness_approval_activity) | **POST** /pipeline/api/approvals/{approvalInstanceId}/harness/activity | Approve or Reject a Pipeline Execution
*ApprovalsApi* | [**add_harness_approval_activity_by_pipeline_execution_id**](docs/ApprovalsApi.md#add_harness_approval_activity_by_pipeline_execution_id) | **POST** /v1/orgs/{org}/projects/{project}/approvals/execution/{execution-id} | Approve or Reject an Execution by Pipeline Execution ID
*ApprovalsApi* | [**get_approval_instances_by_execution_id**](docs/ApprovalsApi.md#get_approval_instances_by_execution_id) | **GET** /v1/orgs/{org}/projects/{project}/approvals/execution/{execution-id} | Gets Approval Instances by Execution Id
*AttributesApi* | [**create_attribute**](docs/AttributesApi.md#create_attribute) | **POST** /cf/admin/attributes | Creates a custom Attribute
*AttributesApi* | [**delete_attribute**](docs/AttributesApi.md#delete_attribute) | **DELETE** /cf/admin/attributes/{key} | Delete an Attribute
*AttributesApi* | [**get_attribute**](docs/AttributesApi.md#get_attribute) | **GET** /cf/admin/attributes/{key} | Returns an Attribute
*AttributesApi* | [**get_attributes**](docs/AttributesApi.md#get_attributes) | **GET** /cf/admin/attributes | Returns all custom attributes for the project
*AttributesApi* | [**patch_attribute**](docs/AttributesApi.md#patch_attribute) | **PATCH** /cf/admin/attributes/{key} | Update Attribute for the environment
*AuditApi* | [**get_audit_event_list**](docs/AuditApi.md#get_audit_event_list) | **POST** /audit/api/audits/list | List Audit Events
*AuditFiltersApi* | [**delete_audit_filter**](docs/AuditFiltersApi.md#delete_audit_filter) | **DELETE** /audit/api/auditFilters/{identifier} | Delete a Filter of type Audit by identifier
*AuditFiltersApi* | [**get_audit_filter**](docs/AuditFiltersApi.md#get_audit_filter) | **GET** /audit/api/auditFilters/{identifier} | Gets a Filter of type Audit by identifier
*AuditFiltersApi* | [**get_audit_filter_list**](docs/AuditFiltersApi.md#get_audit_filter_list) | **GET** /audit/api/auditFilters | Get the list of Filters of type Audit satisfying the criteria (if any) in the request
*AuditFiltersApi* | [**post_audit_filter**](docs/AuditFiltersApi.md#post_audit_filter) | **POST** /audit/api/auditFilters | Creates a Filter
*AuditFiltersApi* | [**update_audit_filter**](docs/AuditFiltersApi.md#update_audit_filter) | **PUT** /audit/api/auditFilters | Updates the Filter of type Audit
*AuditYamlApi* | [**get_yaml_diff**](docs/AuditYamlApi.md#get_yaml_diff) | **GET** /audit/api/auditYaml | Gets the YamlDiff of the Audit.
*AuthenticationSettingsApi* | [**create_ldap_settings**](docs/AuthenticationSettingsApi.md#create_ldap_settings) | **POST** /ng/api/authentication-settings/ldap/settings | Create Ldap setting
*AuthenticationSettingsApi* | [**delete_ldap_settings**](docs/AuthenticationSettingsApi.md#delete_ldap_settings) | **DELETE** /ng/api/authentication-settings/ldap/settings | Delete Ldap settings
*AuthenticationSettingsApi* | [**delete_saml_meta_data**](docs/AuthenticationSettingsApi.md#delete_saml_meta_data) | **DELETE** /ng/api/authentication-settings/delete-saml-metadata | Delete SAML meta data
*AuthenticationSettingsApi* | [**delete_saml_meta_data_for_saml_ssoid**](docs/AuthenticationSettingsApi.md#delete_saml_meta_data_for_saml_ssoid) | **DELETE** /ng/api/authentication-settings/saml-metadata/{samlSSOId}/delete | Delete SAML meta data for given SAML sso id
*AuthenticationSettingsApi* | [**enable_disable_authentication_for_saml_setting**](docs/AuthenticationSettingsApi.md#enable_disable_authentication_for_saml_setting) | **PUT** /ng/api/authentication-settings/saml-metadata-upload/{samlSSOId}/authentication | Update authentication enabled or not for given SAML setting
*AuthenticationSettingsApi* | [**get_authentication_settings**](docs/AuthenticationSettingsApi.md#get_authentication_settings) | **GET** /ng/api/authentication-settings | Gets authentication settings for the given Account ID
*AuthenticationSettingsApi* | [**get_authentication_settings_v2**](docs/AuthenticationSettingsApi.md#get_authentication_settings_v2) | **GET** /ng/api/authentication-settings/v2 | Gets authentication settings version 2 for the given Account ID
*AuthenticationSettingsApi* | [**get_ldap_settings**](docs/AuthenticationSettingsApi.md#get_ldap_settings) | **GET** /ng/api/authentication-settings/ldap/settings | Return configured Ldap settings for the account
*AuthenticationSettingsApi* | [**get_password_strength_settings**](docs/AuthenticationSettingsApi.md#get_password_strength_settings) | **GET** /ng/api/authentication-settings/login-settings/password-strength | Get password strength
*AuthenticationSettingsApi* | [**get_saml_login_test**](docs/AuthenticationSettingsApi.md#get_saml_login_test) | **GET** /ng/api/authentication-settings/saml-login-test | Test SAML connectivity
*AuthenticationSettingsApi* | [**get_saml_login_test_v2**](docs/AuthenticationSettingsApi.md#get_saml_login_test_v2) | **GET** /ng/api/authentication-settings/saml-login-test/{samlSSOId} | Test SAML connectivity
*AuthenticationSettingsApi* | [**remove_oauth_mechanism**](docs/AuthenticationSettingsApi.md#remove_oauth_mechanism) | **DELETE** /ng/api/authentication-settings/oauth/remove-mechanism | Delete OAuth Setting
*AuthenticationSettingsApi* | [**set_public_access**](docs/AuthenticationSettingsApi.md#set_public_access) | **PUT** /ng/api/authentication-settings/public-access | Enable/disable public access at account level
*AuthenticationSettingsApi* | [**set_session_timeout_at_account_level**](docs/AuthenticationSettingsApi.md#set_session_timeout_at_account_level) | **PUT** /ng/api/authentication-settings/session-timeout-account-level | Set session timeout at account level
*AuthenticationSettingsApi* | [**set_two_factor_auth_at_account_level**](docs/AuthenticationSettingsApi.md#set_two_factor_auth_at_account_level) | **PUT** /ng/api/authentication-settings/two-factor-admin-override-settings | Set two factor authorization
*AuthenticationSettingsApi* | [**update_auth_mechanism**](docs/AuthenticationSettingsApi.md#update_auth_mechanism) | **PUT** /ng/api/authentication-settings/update-auth-mechanism | Update Auth mechanism
*AuthenticationSettingsApi* | [**update_ldap_settings**](docs/AuthenticationSettingsApi.md#update_ldap_settings) | **PUT** /ng/api/authentication-settings/ldap/settings | Updates Ldap setting
*AuthenticationSettingsApi* | [**update_oauth_providers**](docs/AuthenticationSettingsApi.md#update_oauth_providers) | **PUT** /ng/api/authentication-settings/oauth/update-providers | Update Oauth providers
*AuthenticationSettingsApi* | [**update_saml_meta_data**](docs/AuthenticationSettingsApi.md#update_saml_meta_data) | **PUT** /ng/api/authentication-settings/saml-metadata-upload | Update SAML metadata
*AuthenticationSettingsApi* | [**update_saml_meta_data_for_saml_ssoid**](docs/AuthenticationSettingsApi.md#update_saml_meta_data_for_saml_ssoid) | **PUT** /ng/api/authentication-settings/saml-metadata-upload/{samlSSOId} | Update SAML metadata for a given SAML SSO Id
*AuthenticationSettingsApi* | [**update_whitelisted_domains**](docs/AuthenticationSettingsApi.md#update_whitelisted_domains) | **PUT** /ng/api/authentication-settings/whitelisted-domains | Updates the whitelisted domains
*AuthenticationSettingsApi* | [**upload_saml_meta_data**](docs/AuthenticationSettingsApi.md#upload_saml_meta_data) | **POST** /ng/api/authentication-settings/saml-metadata-upload | Upload SAML metadata
*CannyApi* | [**create_canny_post**](docs/CannyApi.md#create_canny_post) | **POST** /ng/api/canny/post | create Canny Post for given user
*CannyApi* | [**create_canny_post_v2**](docs/CannyApi.md#create_canny_post_v2) | **POST** /ng/api/canny/postV2 | create Canny Post for given user
*CannyApi* | [**get_canny_boards**](docs/CannyApi.md#get_canny_boards) | **GET** /ng/api/canny/boards | Get a list of boards available on Canny
*CannyApi* | [**get_canny_boards1**](docs/CannyApi.md#get_canny_boards1) | **GET** /ng/api/canny/categories | Get a list of categories available for a board in Canny
*CatalogCustomPropertiesApi* | [**delete_catalog_custom_properties**](docs/CatalogCustomPropertiesApi.md#delete_catalog_custom_properties) | **DELETE** /v1/catalog/custom-properties | Delete catalog custom properties
*CatalogCustomPropertiesApi* | [**delete_catalog_custom_properties_by_entity**](docs/CatalogCustomPropertiesApi.md#delete_catalog_custom_properties_by_entity) | **DELETE** /v1/catalog/custom-properties/entity | Delete catalog custom properties for given entity
*CatalogCustomPropertiesApi* | [**delete_entities_by_catalog_custom_property**](docs/CatalogCustomPropertiesApi.md#delete_entities_by_catalog_custom_property) | **DELETE** /v1/catalog/custom-properties/property | Delete entities for given custom property
*CatalogCustomPropertiesApi* | [**get_catalog_custom_properties_by_entity**](docs/CatalogCustomPropertiesApi.md#get_catalog_custom_properties_by_entity) | **GET** /v1/catalog/custom-properties/entity | Get catalog custom properties for given entity
*CatalogCustomPropertiesApi* | [**get_entities_by_catalog_custom_property**](docs/CatalogCustomPropertiesApi.md#get_entities_by_catalog_custom_property) | **GET** /v1/catalog/custom-properties/property | Get entities for given custom property
*CatalogCustomPropertiesApi* | [**ingest_catalog_custom_properties**](docs/CatalogCustomPropertiesApi.md#ingest_catalog_custom_properties) | **POST** /v1/catalog/custom-properties | Ingest catalog custom properties
*CatalogCustomPropertiesApi* | [**ingest_catalog_custom_properties_by_entity**](docs/CatalogCustomPropertiesApi.md#ingest_catalog_custom_properties_by_entity) | **POST** /v1/catalog/custom-properties/entity | Ingest catalog custom properties for given entity
*CatalogCustomPropertiesApi* | [**ingest_entities_by_catalog_custom_property**](docs/CatalogCustomPropertiesApi.md#ingest_entities_by_catalog_custom_property) | **POST** /v1/catalog/custom-properties/property | Ingest entities for given custom property
*CertificatesApi* | [**certificate_service_list_certs**](docs/CertificatesApi.md#certificate_service_list_certs) | **GET** /gitops/api/v1/certificates | List certificates
*ChecksApi* | [**create_check**](docs/ChecksApi.md#create_check) | **POST** /v1/checks | Create a custom check
*ChecksApi* | [**delete_check**](docs/ChecksApi.md#delete_check) | **DELETE** /v1/checks/{check-id} | Delete check details for given checkId
*ChecksApi* | [**get_check**](docs/ChecksApi.md#get_check) | **GET** /v1/checks/{check-id} | Get check details for given checkId
*ChecksApi* | [**get_check_graph**](docs/ChecksApi.md#get_check_graph) | **GET** /v1/checks/{check-id}/graph | Get check graph data for given checkId
*ChecksApi* | [**get_check_stats**](docs/ChecksApi.md#get_check_stats) | **GET** /v1/checks/{check-id}/stats | Get check stats for given checkId
*ChecksApi* | [**get_checks**](docs/ChecksApi.md#get_checks) | **GET** /v1/checks | Get all checks available
*ChecksApi* | [**update_check**](docs/ChecksApi.md#update_check) | **PUT** /v1/checks/{check-id} | Update check details for given checkId
*CloudCostAnomaliesApi* | [**anomaly_filter_values**](docs/CloudCostAnomaliesApi.md#anomaly_filter_values) | **POST** /ccm/api/anomaly/filter-values | Returns the list of distinct values for all the specified Anomaly fields.
*CloudCostAnomaliesApi* | [**get_anomalies_summary**](docs/CloudCostAnomaliesApi.md#get_anomalies_summary) | **POST** /ccm/api/anomaly/summary | List Anomalies
*CloudCostAnomaliesApi* | [**list_anomalies**](docs/CloudCostAnomaliesApi.md#list_anomalies) | **POST** /ccm/api/anomaly | List Anomalies
*CloudCostAnomaliesApi* | [**list_ignored_anomalies**](docs/CloudCostAnomaliesApi.md#list_ignored_anomalies) | **POST** /ccm/api/anomaly/listIgnoredAnomalies | List ignore list anomalies
*CloudCostAnomaliesApi* | [**list_perspective_anomalies**](docs/CloudCostAnomaliesApi.md#list_perspective_anomalies) | **POST** /ccm/api/anomaly/perspective/{perspectiveId} | List Anomalies for Perspective
*CloudCostAnomaliesApi* | [**report_anomaly_feedback**](docs/CloudCostAnomaliesApi.md#report_anomaly_feedback) | **PUT** /ccm/api/anomaly/feedback | Report Anomaly feedback
*CloudCostAutoStoppingFixedSchedulesApi* | [**create_auto_stopping_schedules**](docs/CloudCostAutoStoppingFixedSchedulesApi.md#create_auto_stopping_schedules) | **POST** /gateway/lw/api/accounts/{account_id}/schedules | Create a fixed schedule for an AutoStopping Rule
*CloudCostAutoStoppingFixedSchedulesApi* | [**delete_auto_stopping_schedule**](docs/CloudCostAutoStoppingFixedSchedulesApi.md#delete_auto_stopping_schedule) | **DELETE** /gateway/lw/api/accounts/{account_id}/schedules/{schedule_id} | Delete a fixed schedule for AutoStopping Rule.
*CloudCostAutoStoppingFixedSchedulesApi* | [**list_auto_stopping_schedules**](docs/CloudCostAutoStoppingFixedSchedulesApi.md#list_auto_stopping_schedules) | **GET** /gateway/lw/api/accounts/{account_id}/schedules | Return all the AutoStopping Rule fixed schedules
*CloudCostAutoStoppingLoadBalancersApi* | [**access_point_rules**](docs/CloudCostAutoStoppingLoadBalancersApi.md#access_point_rules) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/loadbalancers/{lb_id}/rules | Return all the AutoStopping Rules in a load balancer
*CloudCostAutoStoppingLoadBalancersApi* | [**create_load_balancer**](docs/CloudCostAutoStoppingLoadBalancersApi.md#create_load_balancer) | **POST** /gateway/lw/api/accounts/{account_id}/autostopping/loadbalancers | Create a load balancer
*CloudCostAutoStoppingLoadBalancersApi* | [**delete_load_balancer**](docs/CloudCostAutoStoppingLoadBalancersApi.md#delete_load_balancer) | **DELETE** /gateway/lw/api/accounts/{account_id}/autostopping/loadbalancers | Delete load balancers and the associated resources
*CloudCostAutoStoppingLoadBalancersApi* | [**describe_load_balancer**](docs/CloudCostAutoStoppingLoadBalancersApi.md#describe_load_balancer) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/loadbalancers/{lb_id} | Return details of a load balancer
*CloudCostAutoStoppingLoadBalancersApi* | [**edit_load_balancer**](docs/CloudCostAutoStoppingLoadBalancersApi.md#edit_load_balancer) | **PUT** /gateway/lw/api/accounts/{account_id}/autostopping/loadbalancers | Update a load balancer
*CloudCostAutoStoppingLoadBalancersApi* | [**list_load_balancers**](docs/CloudCostAutoStoppingLoadBalancersApi.md#list_load_balancers) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/loadbalancers | Return all the load balancers
*CloudCostAutoStoppingLoadBalancersApi* | [**load_balancer_activity**](docs/CloudCostAutoStoppingLoadBalancersApi.md#load_balancer_activity) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/loadbalancers/{lb_id}/last_active_at | Return last activity details of a load balancer
*CloudCostAutoStoppingRulesApi* | [**all_auto_stopping_resources**](docs/CloudCostAutoStoppingRulesApi.md#all_auto_stopping_resources) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/rules/{rule_id}/resources | List all the resources for an AutoStopping Rule
*CloudCostAutoStoppingRulesApi* | [**auto_stopping_rule_details**](docs/CloudCostAutoStoppingRulesApi.md#auto_stopping_rule_details) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/rules/{rule_id} | Return AutoStopping Rule details
*CloudCostAutoStoppingRulesApi* | [**cool_down_autostopping_rule**](docs/CloudCostAutoStoppingRulesApi.md#cool_down_autostopping_rule) | **POST** /gateway/lw/api/accounts/{account_id}/autostopping/rules/{rule_id}/cooldown | Cool down an AutoStopping Rule
*CloudCostAutoStoppingRulesApi* | [**cumulative_auto_stopping_savings**](docs/CloudCostAutoStoppingRulesApi.md#cumulative_auto_stopping_savings) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/rules/savings/cumulative | Return cumulative savings for all the AutoStopping Rules
*CloudCostAutoStoppingRulesApi* | [**delete_auto_stopping_rule**](docs/CloudCostAutoStoppingRulesApi.md#delete_auto_stopping_rule) | **DELETE** /gateway/lw/api/accounts/{account_id}/autostopping/rules/{rule_id} | Delete an AutoStopping Rule
*CloudCostAutoStoppingRulesApi* | [**get_auto_stopping_cool_down_meta**](docs/CloudCostAutoStoppingRulesApi.md#get_auto_stopping_cool_down_meta) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/rules/{rule_id}/cooldown_meta | Return metadata of cool down of an AutoStopping Rule
*CloudCostAutoStoppingRulesApi* | [**get_auto_stopping_diagnostics**](docs/CloudCostAutoStoppingRulesApi.md#get_auto_stopping_diagnostics) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/rules/{rule_id}/diagnostics | Return diagnostics result of an AutoStopping Rule
*CloudCostAutoStoppingRulesApi* | [**health_of_auto_stopping_rule**](docs/CloudCostAutoStoppingRulesApi.md#health_of_auto_stopping_rule) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/rules/{rule_id}/health | Return health status of an AutoStopping Rule
*CloudCostAutoStoppingRulesApi* | [**list_auto_stopping_rules**](docs/CloudCostAutoStoppingRulesApi.md#list_auto_stopping_rules) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/rules | List AutoStopping Rules
*CloudCostAutoStoppingRulesApi* | [**savings_from_auto_stopping_rule**](docs/CloudCostAutoStoppingRulesApi.md#savings_from_auto_stopping_rule) | **GET** /gateway/lw/api/accounts/{account_id}/autostopping/rules/{rule_id}/savings | Return savings details for an AutoStopping Rule
*CloudCostAutoStoppingRulesApi* | [**toggle_autostopping_rule**](docs/CloudCostAutoStoppingRulesApi.md#toggle_autostopping_rule) | **PUT** /gateway/lw/api/accounts/{account_id}/autostopping/rules/{rule_id}/toggle_state | Disable/Enable an Autostopping Rule
*CloudCostAutoStoppingRulesApi* | [**update_auto_stopping_rule**](docs/CloudCostAutoStoppingRulesApi.md#update_auto_stopping_rule) | **POST** /gateway/lw/api/accounts/{account_id}/autostopping/rules | Create an AutoStopping Rule
*CloudCostAutoStoppingRulesApi* | [**warm_up_autostopping_rule**](docs/CloudCostAutoStoppingRulesApi.md#warm_up_autostopping_rule) | **POST** /gateway/lw/api/accounts/{account_id}/autostopping/rules/{rule_id}/warmup | Warm up an AutoStopping Rule
*CloudCostAutoStoppingRulesV2Api* | [**create_auto_stopping_rule_v2**](docs/CloudCostAutoStoppingRulesV2Api.md#create_auto_stopping_rule_v2) | **POST** /gateway/lw/api/accounts/{account_id}/autostopping/v2/rules | Create an AutoStopping Rule
*CloudCostAutoStoppingRulesV2Api* | [**update_auto_stopping_rule_v2**](docs/CloudCostAutoStoppingRulesV2Api.md#update_auto_stopping_rule_v2) | **PUT** /gateway/lw/api/accounts/{account_id}/autostopping/v2/rules/{rule_id} | Update an existing AutoStopping Rule
*CloudCostBIDashboardsApi* | [**list_bi_dashboards**](docs/CloudCostBIDashboardsApi.md#list_bi_dashboards) | **GET** /ccm/api/bi-dashboards | List all the BI Dashboards for CCM
*CloudCostBudgetGroupsApi* | [**create_budget_group**](docs/CloudCostBudgetGroupsApi.md#create_budget_group) | **POST** /ccm/api/budgetGroups | Create a Budget Group
*CloudCostBudgetGroupsApi* | [**delete_budget_group**](docs/CloudCostBudgetGroupsApi.md#delete_budget_group) | **DELETE** /ccm/api/budgetGroups/{id} | Delete a budget group
*CloudCostBudgetGroupsApi* | [**get_budget_and_budget_groups_list**](docs/CloudCostBudgetGroupsApi.md#get_budget_and_budget_groups_list) | **GET** /ccm/api/budgetGroups/summary | Get list of budget and budget group summaries
*CloudCostBudgetGroupsApi* | [**get_budget_group**](docs/CloudCostBudgetGroupsApi.md#get_budget_group) | **GET** /ccm/api/budgetGroups/{id} | Fetch Budget group details
*CloudCostBudgetGroupsApi* | [**get_last_period_cost**](docs/CloudCostBudgetGroupsApi.md#get_last_period_cost) | **POST** /ccm/api/budgetGroups/aggregatedAmount | Get aggregated amount for given budget groups/budgets
*CloudCostBudgetGroupsApi* | [**list_budget_groups**](docs/CloudCostBudgetGroupsApi.md#list_budget_groups) | **GET** /ccm/api/budgetGroups | List all the Budget groups
*CloudCostBudgetGroupsApi* | [**update_budget_group**](docs/CloudCostBudgetGroupsApi.md#update_budget_group) | **PUT** /ccm/api/budgetGroups/{id} | Update an existing budget group
*CloudCostBudgetsApi* | [**clone_budget**](docs/CloudCostBudgetsApi.md#clone_budget) | **POST** /ccm/api/budgets/{id} | Clone a budget
*CloudCostBudgetsApi* | [**create_budget**](docs/CloudCostBudgetsApi.md#create_budget) | **POST** /ccm/api/budgets | Create a Budget
*CloudCostBudgetsApi* | [**delete_budget**](docs/CloudCostBudgetsApi.md#delete_budget) | **DELETE** /ccm/api/budgets/{id} | Delete a budget
*CloudCostBudgetsApi* | [**get_budget**](docs/CloudCostBudgetsApi.md#get_budget) | **GET** /ccm/api/budgets/{id} | Fetch Budget details
*CloudCostBudgetsApi* | [**get_cost_details**](docs/CloudCostBudgetsApi.md#get_cost_details) | **GET** /ccm/api/budgets/{id}/costDetails | Fetch the cost details of a Budget
*CloudCostBudgetsApi* | [**list_budgets**](docs/CloudCostBudgetsApi.md#list_budgets) | **GET** /ccm/api/budgets | List all the Budgets
*CloudCostBudgetsApi* | [**list_budgets_for_perspective**](docs/CloudCostBudgetsApi.md#list_budgets_for_perspective) | **GET** /ccm/api/budgets/perspectiveBudgets | List all the Budgets associated with a Perspective
*CloudCostBudgetsApi* | [**update_budget**](docs/CloudCostBudgetsApi.md#update_budget) | **PUT** /ccm/api/budgets/{id} | Update an existing budget
*CloudCostCostCategoriesApi* | [**create_business_mapping**](docs/CloudCostCostCategoriesApi.md#create_business_mapping) | **POST** /ccm/api/business-mapping | Create Cost category
*CloudCostCostCategoriesApi* | [**delete_business_mapping**](docs/CloudCostCostCategoriesApi.md#delete_business_mapping) | **DELETE** /ccm/api/business-mapping/{id} | Delete a Cost category
*CloudCostCostCategoriesApi* | [**get_business_mapping**](docs/CloudCostCostCategoriesApi.md#get_business_mapping) | **GET** /ccm/api/business-mapping/{id} | Fetch details of a Cost category
*CloudCostCostCategoriesApi* | [**get_business_mapping_list**](docs/CloudCostCostCategoriesApi.md#get_business_mapping_list) | **GET** /ccm/api/business-mapping | Return details of all the Cost categories
*CloudCostCostCategoriesApi* | [**update_business_mapping**](docs/CloudCostCostCategoriesApi.md#update_business_mapping) | **PUT** /ccm/api/business-mapping | Update a Cost category
*CloudCostDetailsApi* | [**cluster_data**](docs/CloudCostDetailsApi.md#cluster_data) | **POST** /ccm/api/costdetails/clusterData | Returns cluster data in a tabular format
*CloudCostDetailsApi* | [**costdetailoverview**](docs/CloudCostDetailsApi.md#costdetailoverview) | **POST** /ccm/api/costdetails/overview | Returns an overview of the cost
*CloudCostDetailsApi* | [**costdetailtabular**](docs/CloudCostDetailsApi.md#costdetailtabular) | **POST** /ccm/api/costdetails/tabularformat | Returns cost details in a tabular format
*CloudCostDetailsApi* | [**costdetailttimeseries**](docs/CloudCostDetailsApi.md#costdetailttimeseries) | **POST** /ccm/api/costdetails/timeseriesformat | Returns cost details in a time series format
*CloudCostK8SConnectorsMetadataApi* | [**ccm_k8s_meta**](docs/CloudCostK8SConnectorsMetadataApi.md#ccm_k8s_meta) | **POST** /ccm/api/ccmK8sMeta | Get CCM K8S Metadata
*CloudCostOverviewApi* | [**get_ccm_overview**](docs/CloudCostOverviewApi.md#get_ccm_overview) | **GET** /ccm/api/overview | Fetch high level overview details about CCM feature.
*CloudCostPerspectiveReportsApi* | [**create_report_setting**](docs/CloudCostPerspectiveReportsApi.md#create_report_setting) | **POST** /ccm/api/perspectiveReport/{accountIdentifier} | Create a schedule for a Report
*CloudCostPerspectiveReportsApi* | [**delete_report_setting**](docs/CloudCostPerspectiveReportsApi.md#delete_report_setting) | **DELETE** /ccm/api/perspectiveReport/{accountIdentifier} | Delete cost Perspective report
*CloudCostPerspectiveReportsApi* | [**get_report_setting**](docs/CloudCostPerspectiveReportsApi.md#get_report_setting) | **GET** /ccm/api/perspectiveReport/{accountIdentifier} | Fetch details of a cost Report
*CloudCostPerspectiveReportsApi* | [**update_report_setting**](docs/CloudCostPerspectiveReportsApi.md#update_report_setting) | **PUT** /ccm/api/perspectiveReport/{accountIdentifier} | Update a cost Perspective Report
*CloudCostPerspectivesApi* | [**create_perspective**](docs/CloudCostPerspectivesApi.md#create_perspective) | **POST** /ccm/api/perspective | Create a Perspective
*CloudCostPerspectivesApi* | [**delete_perspective**](docs/CloudCostPerspectivesApi.md#delete_perspective) | **DELETE** /ccm/api/perspective | Delete a Perspective
*CloudCostPerspectivesApi* | [**get_all_perspectives**](docs/CloudCostPerspectivesApi.md#get_all_perspectives) | **GET** /ccm/api/perspective/getAllPerspectives | Return details of all the Perspectives
*CloudCostPerspectivesApi* | [**get_last_period_cost1**](docs/CloudCostPerspectivesApi.md#get_last_period_cost1) | **GET** /ccm/api/perspective/lastPeriodCost | Get the last period cost for a Perspective
*CloudCostPerspectivesApi* | [**get_last_year_monthly_cost**](docs/CloudCostPerspectivesApi.md#get_last_year_monthly_cost) | **GET** /ccm/api/perspective/lastYearMonthlyCost | Get the last twelve month cost for a Perspective
*CloudCostPerspectivesApi* | [**get_perspective**](docs/CloudCostPerspectivesApi.md#get_perspective) | **GET** /ccm/api/perspective | Fetch details of a Perspective
*CloudCostPerspectivesApi* | [**update_perspective**](docs/CloudCostPerspectivesApi.md#update_perspective) | **PUT** /ccm/api/perspective | Update a Perspective
*CloudCostPerspectivesFoldersApi* | [**create_perspective_folder**](docs/CloudCostPerspectivesFoldersApi.md#create_perspective_folder) | **POST** /ccm/api/perspectiveFolders/create | Create a Perspective folder
*CloudCostPerspectivesFoldersApi* | [**delete_folder**](docs/CloudCostPerspectivesFoldersApi.md#delete_folder) | **DELETE** /ccm/api/perspectiveFolders/{folderId} | Delete a folder
*CloudCostPerspectivesFoldersApi* | [**get_all_folder_perspectives**](docs/CloudCostPerspectivesFoldersApi.md#get_all_folder_perspectives) | **GET** /ccm/api/perspectiveFolders/{folderId}/perspectives | Return details of all the Perspectives
*CloudCostPerspectivesFoldersApi* | [**get_folders**](docs/CloudCostPerspectivesFoldersApi.md#get_folders) | **GET** /ccm/api/perspectiveFolders | Fetch folders for an account
*CloudCostPerspectivesFoldersApi* | [**move_perspectives**](docs/CloudCostPerspectivesFoldersApi.md#move_perspectives) | **POST** /ccm/api/perspectiveFolders/movePerspectives | Move a Perspective
*CloudCostPerspectivesFoldersApi* | [**update_folder**](docs/CloudCostPerspectivesFoldersApi.md#update_folder) | **PUT** /ccm/api/perspectiveFolders | Update a folder
*CloudCostRecommendationIgnoreListApi* | [**add_recommendations_ignore_list**](docs/CloudCostRecommendationIgnoreListApi.md#add_recommendations_ignore_list) | **POST** /ccm/api/recommendation/ignore-list/add | Add resources to recommendations ignore list
*CloudCostRecommendationIgnoreListApi* | [**get_recommendations_ignore_list**](docs/CloudCostRecommendationIgnoreListApi.md#get_recommendations_ignore_list) | **GET** /ccm/api/recommendation/ignore-list | Get resources in recommendations ignore list
*CloudCostRecommendationIgnoreListApi* | [**remove_recommendations_ignore_list**](docs/CloudCostRecommendationIgnoreListApi.md#remove_recommendations_ignore_list) | **POST** /ccm/api/recommendation/ignore-list/remove | Remove resources from recommendations ignore list
*CloudCostRecommendationJiraApi* | [**create_recommendation_jira**](docs/CloudCostRecommendationJiraApi.md#create_recommendation_jira) | **POST** /ccm/api/recommendation/jira/create | Create jira for recommendation
*CloudCostRecommendationServicenowApi* | [**create_recommendation_servicenow_ticket**](docs/CloudCostRecommendationServicenowApi.md#create_recommendation_servicenow_ticket) | **POST** /ccm/api/recommendation/servicenow/create | Create servicenow ticket for recommendation
*CloudCostRecommendationTagsApi* | [**get_recommendation_tags**](docs/CloudCostRecommendationTagsApi.md#get_recommendation_tags) | **GET** /ccm/api/recommendation/tags | Get tags for given recommendation
*CloudCostRecommendationTagsApi* | [**get_tags_for_filter_panel**](docs/CloudCostRecommendationTagsApi.md#get_tags_for_filter_panel) | **GET** /ccm/api/recommendation/tags/filter-panel | Get tag (keys)/(values for a particular tag key) for recommendation filter panel
*CloudCostRecommendationsApi* | [**change_recommendation_state**](docs/CloudCostRecommendationsApi.md#change_recommendation_state) | **POST** /ccm/api/recommendation/overview/change-state | Return void
*CloudCostRecommendationsApi* | [**list_recommendations**](docs/CloudCostRecommendationsApi.md#list_recommendations) | **POST** /ccm/api/recommendation/overview/list | Return the list of Recommendations
*CloudCostRecommendationsApi* | [**recommendation_filter_values**](docs/CloudCostRecommendationsApi.md#recommendation_filter_values) | **POST** /ccm/api/recommendation/overview/filter-values | Return the list of filter values for the Recommendations
*CloudCostRecommendationsApi* | [**recommendation_resource_type_stats**](docs/CloudCostRecommendationsApi.md#recommendation_resource_type_stats) | **POST** /ccm/api/recommendation/overview/resource-type/stats | Return Recommendations statistics Grouped on Resource Type
*CloudCostRecommendationsApi* | [**recommendation_stats**](docs/CloudCostRecommendationsApi.md#recommendation_stats) | **POST** /ccm/api/recommendation/overview/stats | Return Recommendations statistics
*CloudCostRecommendationsApi* | [**recommendations_count**](docs/CloudCostRecommendationsApi.md#recommendations_count) | **POST** /ccm/api/recommendation/overview/count | Return the number of Recommendations
*CloudCostRecommendationsDetailsApi* | [**azure_vm_recommendation_detail**](docs/CloudCostRecommendationsDetailsApi.md#azure_vm_recommendation_detail) | **GET** /ccm/api/recommendation/details/azure-vm | Return Azure VM Recommendation
*CloudCostRecommendationsDetailsApi* | [**ec2_recommendation_detail**](docs/CloudCostRecommendationsDetailsApi.md#ec2_recommendation_detail) | **GET** /ccm/api/recommendation/details/ec2-instance | Return EC2 Recommendation
*CloudCostRecommendationsDetailsApi* | [**ecs_recommendation_detail**](docs/CloudCostRecommendationsDetailsApi.md#ecs_recommendation_detail) | **GET** /ccm/api/recommendation/details/ecs-service | Return ECS Recommendation
*CloudCostRecommendationsDetailsApi* | [**node_recommendation_detail**](docs/CloudCostRecommendationsDetailsApi.md#node_recommendation_detail) | **GET** /ccm/api/recommendation/details/node-pool | Return node pool Recommendation
*CloudCostRecommendationsDetailsApi* | [**workload_recommendation_detail**](docs/CloudCostRecommendationsDetailsApi.md#workload_recommendation_detail) | **GET** /ccm/api/recommendation/details/workload | Return workload Recommendation
*ClustersApi* | [**agent_cluster_service_create**](docs/ClustersApi.md#agent_cluster_service_create) | **POST** /gitops/api/v1/agents/{agentIdentifier}/clusters | Create creates a cluster
*ClustersApi* | [**agent_cluster_service_create_hosted**](docs/ClustersApi.md#agent_cluster_service_create_hosted) | **POST** /gitops/api/v1/agents/{agentIdentifier}/hosted/cluster | CreateHosted creates a harness hosted cluster
*ClustersApi* | [**agent_cluster_service_delete**](docs/ClustersApi.md#agent_cluster_service_delete) | **DELETE** /gitops/api/v1/agents/{agentIdentifier}/clusters/{identifier} | Delete deletes a cluster
*ClustersApi* | [**agent_cluster_service_get**](docs/ClustersApi.md#agent_cluster_service_get) | **GET** /gitops/api/v1/agents/{agentIdentifier}/clusters/{identifier} | Get returns a cluster by identifier
*ClustersApi* | [**agent_cluster_service_get_by_name**](docs/ClustersApi.md#agent_cluster_service_get_by_name) | **GET** /gitops/api/v1/agents/{agentIdentifier}/cluster_byname | Get a cluster managed by an agent by name
*ClustersApi* | [**agent_cluster_service_get_by_url**](docs/ClustersApi.md#agent_cluster_service_get_by_url) | **GET** /gitops/api/v1/agents/{agentIdentifier}/cluster_byurl | Get a cluster managed by an agent by URL
*ClustersApi* | [**agent_cluster_service_list**](docs/ClustersApi.md#agent_cluster_service_list) | **GET** /gitops/api/v1/agents/{agentIdentifier}/clusters | List returns list of clusters
*ClustersApi* | [**agent_cluster_service_update**](docs/ClustersApi.md#agent_cluster_service_update) | **PUT** /gitops/api/v1/agents/{agentIdentifier}/clusters/{identifier} | Update updates a cluster
*ClustersApi* | [**agent_gpg_key_service_list**](docs/ClustersApi.md#agent_gpg_key_service_list) | **GET** /gitops/api/v1/agents/{agentIdentifier}/gpgkeys | List all available repository certificates
*ClustersApi* | [**cluster_service_exists**](docs/ClustersApi.md#cluster_service_exists) | **GET** /gitops/api/v1/clusters/exists | Check if a cluster exists
*ClustersApi* | [**cluster_service_list_clusters**](docs/ClustersApi.md#cluster_service_list_clusters) | **POST** /gitops/api/v1/clusters | List clusters
*ClustersApi* | [**delete_cluster**](docs/ClustersApi.md#delete_cluster) | **DELETE** /ng/api/gitops/clusters/{identifier} | Delete a Cluster by identifier
*ClustersApi* | [**get_cluster**](docs/ClustersApi.md#get_cluster) | **GET** /ng/api/gitops/clusters/{identifier} | Gets a Cluster by identifier
*ClustersApi* | [**get_cluster_list**](docs/ClustersApi.md#get_cluster_list) | **GET** /ng/api/gitops/clusters | Gets cluster list
*ClustersApi* | [**link_cluster**](docs/ClustersApi.md#link_cluster) | **POST** /ng/api/gitops/clusters | link a Cluster
*ClustersApi* | [**link_clusters**](docs/ClustersApi.md#link_clusters) | **POST** /ng/api/gitops/clusters/batch | Link Clusters
*ClustersApi* | [**unlink_clusters_in_batch**](docs/ClustersApi.md#unlink_clusters_in_batch) | **POST** /ng/api/gitops/clusters/batchunlink | Unlink Clusters
*CollectionCategoriesApi* | [**categories_create_category**](docs/CollectionCategoriesApi.md#categories_create_category) | **POST** /v1/org/categories | Create a new Collection category
*CollectionCategoriesApi* | [**categories_delete_categories**](docs/CollectionCategoriesApi.md#categories_delete_categories) | **DELETE** /v1/org/categories | Delete multiple Collection categories
*CollectionCategoriesApi* | [**categories_delete_category**](docs/CollectionCategoriesApi.md#categories_delete_category) | **DELETE** /v1/org/categories/{id} | Delete a specific Collection category
*CollectionCategoriesApi* | [**categories_list_categories**](docs/CollectionCategoriesApi.md#categories_list_categories) | **POST** /v1/org/workspaces/units/list | List all Collection categories
*CollectionCategoriesApi* | [**categories_update_category**](docs/CollectionCategoriesApi.md#categories_update_category) | **PUT** /v1/org/categories/{id} | Update an existing Collection category
*CollectionsApi* | [**collections_create_collection**](docs/CollectionsApi.md#collections_create_collection) | **POST** /v1/org/units | Create a new collection
*CollectionsApi* | [**collections_delete_collection**](docs/CollectionsApi.md#collections_delete_collection) | **DELETE** /v1/org/units | Delete an existing collection
*CollectionsApi* | [**collections_edit_collection**](docs/CollectionsApi.md#collections_edit_collection) | **PUT** /v1/org/units | Edit an existing collection
*CollectionsApi* | [**collections_list_collections**](docs/CollectionsApi.md#collections_list_collections) | **POST** /v1/org/units/list | Retrieve a list of collections
*CommitmentOrchestratorAPIsApi* | [**event_logs**](docs/CommitmentOrchestratorAPIsApi.md#event_logs) | **POST** /gateway/lw/api/accounts/{account_id}/v1/events/logs | List event logs
*CommitmentOrchestratorEventsAPIsApi* | [**events_chart**](docs/CommitmentOrchestratorEventsAPIsApi.md#events_chart) | **POST** /gateway/lw/api/accounts/{account_id}/v1/events/chart | List event logs
*CommitmentOrchestratorSetupAPIsApi* | [**list_accounts**](docs/CommitmentOrchestratorSetupAPIsApi.md#list_accounts) | **GET** /gateway/lw/api/accounts/{account_id}/v1/setup/{cloud_account_id}/child_accounts | List child accounts for a given master account
*CommitmentOrchestratorSetupAPIsApi* | [**list_masters**](docs/CommitmentOrchestratorSetupAPIsApi.md#list_masters) | **POST** /gateway/lw/api/accounts/{account_id}/v1/setup/listMasterAccounts | List master accounts for commitment Setup
*CommitmentOrchestratorSetupAPIsApi* | [**list_setups**](docs/CommitmentOrchestratorSetupAPIsApi.md#list_setups) | **GET** /gateway/lw/api/accounts/{account_id}/v1/setup/list | List of commitment Setups
*CommitmentOrchestratorSetupAPIsApi* | [**setup_instance_types**](docs/CommitmentOrchestratorSetupAPIsApi.md#setup_instance_types) | **POST** /gateway/lw/api/accounts/{account_id}/v1/setup/{cloud_account_id}/instance_types | Instance types in usage to support configuring exclusions
*CommitmentOrchestratorSetupAPIsApi* | [**setup_validate**](docs/CommitmentOrchestratorSetupAPIsApi.md#setup_validate) | **POST** /gateway/lw/api/accounts/{account_id}/v1/setup/validate | Validate commitment Setup
*CommitmentOrchestratorUserApprovalAPIsApi* | [**approvals_list**](docs/CommitmentOrchestratorUserApprovalAPIsApi.md#approvals_list) | **POST** /gateway/lw/api/accounts/{account_id}/v1/approvals/list | List of Commitment transactions awaiting user approvals
*CommitmentOrchestratorUserApprovalAPIsApi* | [**approvals_update**](docs/CommitmentOrchestratorUserApprovalAPIsApi.md#approvals_update) | **POST** /gateway/lw/api/accounts/{account_id}/v1/approvals/update | Approve/Reject commitment transactions
*ConnectorInfoApi* | [**get_connector_info**](docs/ConnectorInfoApi.md#get_connector_info) | **GET** /v1/connector-info | Get Connector Info
*ConnectorInfoApi* | [**get_connector_info_by_provider_type**](docs/ConnectorInfoApi.md#get_connector_info_by_provider_type) | **GET** /v1/connector-info/{provider-type} | Get Connector Info by Provider Type
*ConnectorInfoApi* | [**save_connector_info**](docs/ConnectorInfoApi.md#save_connector_info) | **POST** /v1/connector-info | Create or Update Connector Info
*ConnectorsApi* | [**create_connector**](docs/ConnectorsApi.md#create_connector) | **POST** /ng/api/connectors | Create a Connector
*ConnectorsApi* | [**delete_connector**](docs/ConnectorsApi.md#delete_connector) | **DELETE** /ng/api/connectors/{identifier} | Delete a Connector
*ConnectorsApi* | [**get_all_allowed_field_values**](docs/ConnectorsApi.md#get_all_allowed_field_values) | **GET** /ng/api/connectors/fieldValues | List all the configured field values for the given Connector type.
*ConnectorsApi* | [**get_ccmk8_s_connector_list**](docs/ConnectorsApi.md#get_ccmk8_s_connector_list) | **POST** /ng/api/connectors/ccmK8sList | Fetches the list of CMC K8S Connectors corresponding to the request&#x27;s filter criteria.
*ConnectorsApi* | [**get_ce_aws_template**](docs/ConnectorsApi.md#get_ce_aws_template) | **POST** /ng/api/connectors/getceawstemplateurl | Get the Template URL of connector
*ConnectorsApi* | [**get_connector**](docs/ConnectorsApi.md#get_connector) | **GET** /ng/api/connectors/{identifier} | Return Connector details
*ConnectorsApi* | [**get_connector_catalogue**](docs/ConnectorsApi.md#get_connector_catalogue) | **GET** /ng/api/connectors/catalogue | Lists all Connectors for an account
*ConnectorsApi* | [**get_connector_list**](docs/ConnectorsApi.md#get_connector_list) | **GET** /ng/api/connectors | List all Connectors using filters
*ConnectorsApi* | [**get_connector_list_v2**](docs/ConnectorsApi.md#get_connector_list_v2) | **POST** /ng/api/connectors/listV2 | Fetches the list of Connectors corresponding to the request&#x27;s filter criteria.
*ConnectorsApi* | [**get_connector_statistics**](docs/ConnectorsApi.md#get_connector_statistics) | **GET** /ng/api/connectors/stats | Gets the connector&#x27;s statistics by Account Identifier, Project Identifier and Organization Identifier
*ConnectorsApi* | [**get_test_connection_result**](docs/ConnectorsApi.md#get_test_connection_result) | **POST** /ng/api/connectors/testConnection/{identifier} | Test Harness Connector connection with third-party tool
*ConnectorsApi* | [**get_test_git_repo_connection_result**](docs/ConnectorsApi.md#get_test_git_repo_connection_result) | **POST** /ng/api/connectors/testGitRepoConnection/{identifier} | Test Git Connector sync with repo
*ConnectorsApi* | [**list_connector_by_fqn**](docs/ConnectorsApi.md#list_connector_by_fqn) | **POST** /ng/api/connectors/listbyfqn | Get list of Connectors by FQN
*ConnectorsApi* | [**update_connector**](docs/ConnectorsApi.md#update_connector) | **PUT** /ng/api/connectors | Update a Connector
*ConnectorsApi* | [**validate_the_identifier_is_unique**](docs/ConnectorsApi.md#validate_the_identifier_is_unique) | **GET** /ng/api/connectors/validateUniqueIdentifier | Test a Harness Connector
*ContributorsApi* | [**contributors_get_active_versions**](docs/ContributorsApi.md#contributors_get_active_versions) | **GET** /v1/org/users/versions | Retrieve the list of active versions
*ContributorsApi* | [**contributors_get_schema**](docs/ContributorsApi.md#contributors_get_schema) | **GET** /v1/org/users/schema | Retrieve the Ccontributor data schema
*ContributorsApi* | [**contributors_update_contributors**](docs/ContributorsApi.md#contributors_update_contributors) | **PUT** /v1/org/users | Update existing contributors
*ContributorsApi* | [**sei_contributors_list_contributors**](docs/ContributorsApi.md#sei_contributors_list_contributors) | **POST** /v1/sei_contributor/list | Retrieve SEI contributors list
*ContributorsApi* | [**users_list_active_users**](docs/ContributorsApi.md#users_list_active_users) | **POST** /v1/org/users/list | Retrieve the list of current active licensed contributors
*CreditsOverUsageDataByAccountApi* | [**credits_overusage**](docs/CreditsOverUsageDataByAccountApi.md#credits_overusage) | **GET** /v1/creditOverUsage/{accountIdentifier} | Get over usage count of Credits for a given account
*CreditsAllocationByAccountAndModuleTypeApi* | [**credits_allocation_export_data**](docs/CreditsAllocationByAccountAndModuleTypeApi.md#credits_allocation_export_data) | **GET** /v1/credits/allocation/export/{accountIdentifier} | Get credits allocation Data for an account for a given moduleType
*CustomDeploymentApi* | [**get_custom_deployment_entity_references**](docs/CustomDeploymentApi.md#get_custom_deployment_entity_references) | **POST** /ng/api/customDeployment/get-references | Gets Custom Deployment Entity References
*CustomDeploymentApi* | [**get_custom_deployment_expression_variables**](docs/CustomDeploymentApi.md#get_custom_deployment_expression_variables) | **POST** /ng/api/customDeployment/expression-variables | Gets Custom Deployment Expression Variables
*CustomDeploymentApi* | [**get_custom_deployment_infra_variables**](docs/CustomDeploymentApi.md#get_custom_deployment_infra_variables) | **GET** /ng/api/customDeployment/variables/{templateIdentifier} | Gets Infra Variables from a Custom Deployment Template by identifier
*CustomDeploymentApi* | [**get_updated_yaml_for_infrastructure**](docs/CustomDeploymentApi.md#get_updated_yaml_for_infrastructure) | **POST** /ng/api/customDeployment/get-updated-Yaml/{infraIdentifier} | Return the updated yaml for infrastructure based on Deployment template
*CustomDeploymentApi* | [**validate_infrastructure_for_deployment_template**](docs/CustomDeploymentApi.md#validate_infrastructure_for_deployment_template) | **GET** /ng/api/customDeployment/validate-infrastructure/{infraIdentifier} | This validates whether Infrastructure is valid or not
*DORAApi* | [**dora_get_change_failure_rate**](docs/DORAApi.md#dora_get_change_failure_rate) | **POST** /v1/dora/change_failure_rate | Retrieve change failure rate data
*DORAApi* | [**dora_get_deployment_frequency**](docs/DORAApi.md#dora_get_deployment_frequency) | **POST** /v1/dora/deployment_frequency | Retrieve deployment frequency data
*DORAApi* | [**dora_get_lead_time**](docs/DORAApi.md#dora_get_lead_time) | **POST** /v1/dora/lead-time | Retrieve lead time data
*DORAApi* | [**dora_get_mean_time_to_restore**](docs/DORAApi.md#dora_get_mean_time_to_restore) | **POST** /v1/dora/mean-time | Retrieve Mean Time to Restore (MTTR) data
*DashboardAggregatesApi* | [**dashboard_service_recent_deployments**](docs/DashboardAggregatesApi.md#dashboard_service_recent_deployments) | **POST** /gitops/api/v1/dashboard/activity | Get recent deployment statistics
*DashboardAggregatesApi* | [**dashboard_service_top_application_phase_stats**](docs/DashboardAggregatesApi.md#dashboard_service_top_application_phase_stats) | **GET** /gitops/api/v1/dashboard/topapps | List top 5 most deployed apps
*DashboardsApi* | [**dashboard_service_get_dashboard_overview**](docs/DashboardsApi.md#dashboard_service_get_dashboard_overview) | **GET** /gitops/api/v1/dashboard/overview | Get dashboard overview
*DashboardsApi* | [**dashboard_service_recently_created_counts**](docs/DashboardsApi.md#dashboard_service_recently_created_counts) | **GET** /gitops/api/v1/dashboard/counts | Get recently created app, cluster, repo counts
*DataSourceApi* | [**get_all_datasources_for_account**](docs/DataSourceApi.md#get_all_datasources_for_account) | **GET** /v1/data-sources | Get Datasources Present In Account
*DataSourceApi* | [**get_data_points_for_data_source**](docs/DataSourceApi.md#get_data_points_for_data_source) | **GET** /v1/data-sources/{data-source}/datapoints | Get DataPoints present in DataSources for an account
*DataSourceApi* | [**get_data_sources_data_points_map**](docs/DataSourceApi.md#get_data_sources_data_points_map) | **GET** /v1/data-sources/data-points/map | Get Data Sources and Data Points Map for Account
*DelegateDownloadResourceApi* | [**download_docker_delegate_yaml**](docs/DelegateDownloadResourceApi.md#download_docker_delegate_yaml) | **POST** /ng/api/download-delegates/docker | Downloads a docker delegate yaml file.
*DelegateDownloadResourceApi* | [**download_kubernetes_delegate_yaml**](docs/DelegateDownloadResourceApi.md#download_kubernetes_delegate_yaml) | **POST** /ng/api/download-delegates/kubernetes | Downloads a kubernetes delegate yaml file.
*DelegateGroupTagsResourceApi* | [**add_tags_to_delegate_group**](docs/DelegateGroupTagsResourceApi.md#add_tags_to_delegate_group) | **POST** /ng/api/delegate-group-tags/{groupIdentifier} | Add given list of tags to the Delegate group
*DelegateGroupTagsResourceApi* | [**delete_tags_from_delegate_group**](docs/DelegateGroupTagsResourceApi.md#delete_tags_from_delegate_group) | **DELETE** /ng/api/delegate-group-tags/{groupIdentifier} | Deletes all tags from the Delegate group
*DelegateGroupTagsResourceApi* | [**list_delegate_groups_using_tags**](docs/DelegateGroupTagsResourceApi.md#list_delegate_groups_using_tags) | **POST** /ng/api/delegate-group-tags/delegate-groups | List delegate groups that are having mentioned tags.
*DelegateGroupTagsResourceApi* | [**list_tags_for_delegate_group**](docs/DelegateGroupTagsResourceApi.md#list_tags_for_delegate_group) | **GET** /ng/api/delegate-group-tags/{groupIdentifier} | Retrieves list of tags attached with Delegate group
*DelegateGroupTagsResourceApi* | [**update_tags_of_delegate_group**](docs/DelegateGroupTagsResourceApi.md#update_tags_of_delegate_group) | **PUT** /ng/api/delegate-group-tags/{groupIdentifier} | Clears all existing tags with delegate group and attach given set of tags to delegate group.
*DelegateSetupResourceApi* | [**delete_delegate**](docs/DelegateSetupResourceApi.md#delete_delegate) | **DELETE** /ng/api/delegate-setup/delegate/{delegateIdentifier} | Deletes a Delegate by its identifier.
*DelegateSetupResourceApi* | [**generate_ng_helm_values_yaml**](docs/DelegateSetupResourceApi.md#generate_ng_helm_values_yaml) | **POST** /ng/api/delegate-setup/generate-helm-values | Generates helm values yaml file from the data specified in request body (Delegate setup details).
*DelegateSetupResourceApi* | [**generate_terraform_module**](docs/DelegateSetupResourceApi.md#generate_terraform_module) | **GET** /ng/api/delegate-setup/delegate-terraform-module-file | Generates delegate terraform example module file from the account
*DelegateSetupResourceApi* | [**list_delegates**](docs/DelegateSetupResourceApi.md#list_delegates) | **POST** /ng/api/delegate-setup/listDelegates | Lists all delegates in NG filtered by provided conditions
*DelegateSetupResourceApi* | [**override_delegate_image_tag**](docs/DelegateSetupResourceApi.md#override_delegate_image_tag) | **PUT** /ng/api/delegate-setup/override-delegate-tag | Overrides delegate image tag for account
*DelegateSetupResourceApi* | [**published_delegate_version**](docs/DelegateSetupResourceApi.md#published_delegate_version) | **GET** /ng/api/delegate-setup/latest-supported-version | Gets the latest supported delegate version. The version has YY.MM.XXXXX format. You can use any version lower than the returned results(upto 3 months old)
*DelegateTokenResourceApi* | [**create_delegate_token**](docs/DelegateTokenResourceApi.md#create_delegate_token) | **POST** /ng/api/delegate-token-ng | Creates Delegate Token.
*DelegateTokenResourceApi* | [**get_cg_delegate_tokens**](docs/DelegateTokenResourceApi.md#get_cg_delegate_tokens) | **GET** /ng/api/delegate-token-ng | Retrieves Delegate Tokens by Account, Organization, Project and status.
*DelegateTokenResourceApi* | [**get_delegate_groups_using_token**](docs/DelegateTokenResourceApi.md#get_delegate_groups_using_token) | **GET** /ng/api/delegate-token-ng/delegate-groups | Lists delegate groups that are using the specified delegate token.
*DelegateTokenResourceApi* | [**revoke_cg_delegate_token**](docs/DelegateTokenResourceApi.md#revoke_cg_delegate_token) | **PUT** /ng/api/delegate-token-ng | Revokes Delegate Token.
*DowntimeApi* | [**delete_downtime_data**](docs/DowntimeApi.md#delete_downtime_data) | **DELETE** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/downtime/identifier/{identifier} | 
*DowntimeApi* | [**get_associated_monitored_services**](docs/DowntimeApi.md#get_associated_monitored_services) | **GET** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/downtime/monitored-services/{identifier} | 
*DowntimeApi* | [**get_downtime**](docs/DowntimeApi.md#get_downtime) | **GET** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/downtime/identifier/{identifier} | 
*DowntimeApi* | [**get_downtime_associated_monitored_services**](docs/DowntimeApi.md#get_downtime_associated_monitored_services) | **GET** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/downtime/monitored-services | 
*DowntimeApi* | [**get_history**](docs/DowntimeApi.md#get_history) | **GET** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/downtime/history | 
*DowntimeApi* | [**list_downtimes**](docs/DowntimeApi.md#list_downtimes) | **GET** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/downtime/list | 
*DowntimeApi* | [**save_downtime**](docs/DowntimeApi.md#save_downtime) | **POST** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/downtime | 
*DowntimeApi* | [**update_downtime_data**](docs/DowntimeApi.md#update_downtime_data) | **PUT** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/downtime/identifier/{identifier} | 
*DowntimeApi* | [**update_downtime_enabled**](docs/DowntimeApi.md#update_downtime_enabled) | **PUT** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/downtime/flag/{identifier} | 
*EULAApi* | [**sign_eula**](docs/EULAApi.md#sign_eula) | **POST** /v1/eula/sign | Sign an End User License Agreement
*EULAApi* | [**validate_eula_sign**](docs/EULAApi.md#validate_eula_sign) | **GET** /v1/eula/validate-sign | Validate specified agreement is signed or not
*EnvironmentGroupApi* | [**delete_environment_group**](docs/EnvironmentGroupApi.md#delete_environment_group) | **DELETE** /ng/api/environmentGroup/{envGroupIdentifier} | Delete en Environment Group by Identifier
*EnvironmentGroupApi* | [**get_environment_group**](docs/EnvironmentGroupApi.md#get_environment_group) | **GET** /ng/api/environmentGroup/{envGroupIdentifier} | Gets an Environment Group by identifier
*EnvironmentGroupApi* | [**get_environment_group_list**](docs/EnvironmentGroupApi.md#get_environment_group_list) | **POST** /ng/api/environmentGroup/list | Gets Environment Group list
*EnvironmentGroupApi* | [**post_environment_group**](docs/EnvironmentGroupApi.md#post_environment_group) | **POST** /ng/api/environmentGroup | Create an Environment Group
*EnvironmentGroupApi* | [**update_environment_group**](docs/EnvironmentGroupApi.md#update_environment_group) | **PUT** /ng/api/environmentGroup/{envGroupIdentifier} | Update an Environment Group by Identifier
*EnvironmentPerspectivesApi* | [**delete_perspective**](docs/EnvironmentPerspectivesApi.md#delete_perspective) | **DELETE** /cf/admin/environments/perspectives | Delete a Perspective - Environment link.
*EnvironmentPerspectivesApi* | [**upsert_perspective**](docs/EnvironmentPerspectivesApi.md#upsert_perspective) | **PUT** /cf/admin/environments/perspectives | Upsert a Perspective to an Environment.
*EnvironmentsApi* | [**create_environment_v2**](docs/EnvironmentsApi.md#create_environment_v2) | **POST** /ng/api/environmentsV2 | Create an Environment
*EnvironmentsApi* | [**delete_environment_v2**](docs/EnvironmentsApi.md#delete_environment_v2) | **DELETE** /ng/api/environmentsV2/{environmentIdentifier} | Delete an Environment by identifier
*EnvironmentsApi* | [**delete_service_override**](docs/EnvironmentsApi.md#delete_service_override) | **DELETE** /ng/api/environmentsV2/serviceOverrides | Delete a ServiceOverride entity
*EnvironmentsApi* | [**get_environment_access_list**](docs/EnvironmentsApi.md#get_environment_access_list) | **GET** /ng/api/environmentsV2/list/access | Gets Environment Access list
*EnvironmentsApi* | [**get_environment_list**](docs/EnvironmentsApi.md#get_environment_list) | **GET** /ng/api/environmentsV2 | Gets Environment list for a project
*EnvironmentsApi* | [**get_environment_v2**](docs/EnvironmentsApi.md#get_environment_v2) | **GET** /ng/api/environmentsV2/{environmentIdentifier} | Gets an Environment by identifier
*EnvironmentsApi* | [**get_service_overrides_list**](docs/EnvironmentsApi.md#get_service_overrides_list) | **GET** /ng/api/environmentsV2/serviceOverrides | Gets Service Overrides list
*EnvironmentsApi* | [**import_environment**](docs/EnvironmentsApi.md#import_environment) | **POST** /ng/api/environmentsV2/import | Import and Create Environment from Git Repository
*EnvironmentsApi* | [**move_environment_configs**](docs/EnvironmentsApi.md#move_environment_configs) | **POST** /ng/api/environmentsV2/move-config/{environmentIdentifier} | Move environment YAML from inline to remote
*EnvironmentsApi* | [**update_environment_git_details**](docs/EnvironmentsApi.md#update_environment_git_details) | **PUT** /ng/api/environmentsV2/{environmentIdentifier}/update-git-metadata | Update git-metadata in remote environment Entity
*EnvironmentsApi* | [**update_environment_v2**](docs/EnvironmentsApi.md#update_environment_v2) | **PUT** /ng/api/environmentsV2 | Update an Environment by identifier
*EnvironmentsApi* | [**upsert_environment_v2**](docs/EnvironmentsApi.md#upsert_environment_v2) | **PUT** /ng/api/environmentsV2/upsert | Upsert an Environment by identifier
*EnvironmentsApi* | [**upsert_service_override**](docs/EnvironmentsApi.md#upsert_service_override) | **POST** /ng/api/environmentsV2/serviceOverrides | upsert a Service Override for an Environment
*ExemptionsApi* | [**exemptions_approve_exemption**](docs/ExemptionsApi.md#exemptions_approve_exemption) | **PUT** /sto/api/v2/exemptions/{id}/{action} | 
*ExemptionsApi* | [**exemptions_create_exemption**](docs/ExemptionsApi.md#exemptions_create_exemption) | **POST** /sto/api/v2/exemptions | 
*ExemptionsApi* | [**exemptions_find_exemption_by_id**](docs/ExemptionsApi.md#exemptions_find_exemption_by_id) | **GET** /sto/api/v2/exemptions/{id} | 
*ExemptionsApi* | [**exemptions_list_exemptions**](docs/ExemptionsApi.md#exemptions_list_exemptions) | **GET** /sto/api/v2/exemptions | 
*ExemptionsApi* | [**exemptions_update_exemption**](docs/ExemptionsApi.md#exemptions_update_exemption) | **PUT** /sto/api/v2/exemptions/{id} | 
*ExportLicenseUsageDataByAccountApi* | [**export_license_usage_activity**](docs/ExportLicenseUsageDataByAccountApi.md#export_license_usage_activity) | **POST** /v1/licenseUsageActivity/export/{accountIdentifier} | Get exported License Usage Data for an account based on the filters
*FeatureFlagsApi* | [**create_feature_flag**](docs/FeatureFlagsApi.md#create_feature_flag) | **POST** /cf/admin/features | Creates a Feature Flag
*FeatureFlagsApi* | [**delete_feature_flag**](docs/FeatureFlagsApi.md#delete_feature_flag) | **DELETE** /cf/admin/features/{identifier} | Delete a Feature Flag
*FeatureFlagsApi* | [**get_all_features**](docs/FeatureFlagsApi.md#get_all_features) | **GET** /cf/admin/features | Returns all Feature Flags for the project
*FeatureFlagsApi* | [**get_dependent_features**](docs/FeatureFlagsApi.md#get_dependent_features) | **GET** /cf/admin/features/{identifier}/dependants | Return a list of dependant flags
*FeatureFlagsApi* | [**get_feature_flag**](docs/FeatureFlagsApi.md#get_feature_flag) | **GET** /cf/admin/features/{identifier} | Returns a Feature Flag
*FeatureFlagsApi* | [**patch_feature**](docs/FeatureFlagsApi.md#patch_feature) | **PATCH** /cf/admin/features/{identifier} | Updates a Feature Flag
*FeatureFlagsApi* | [**put_feature_flag**](docs/FeatureFlagsApi.md#put_feature_flag) | **PUT** /cf/admin/features/{identifier} | Updates a Feature Flag
*FeatureFlagsApi* | [**restore_feature_flag**](docs/FeatureFlagsApi.md#restore_feature_flag) | **POST** /cf/admin/features/{identifier}/restore | Restore a Feature Flag
*FileStoreApi* | [**create**](docs/FileStoreApi.md#create) | **POST** /ng/api/file-store | Create Folder or File including content
*FileStoreApi* | [**create_via_yaml**](docs/FileStoreApi.md#create_via_yaml) | **POST** /ng/api/file-store/yaml | Creates File or Folder metadata via YAML
*FileStoreApi* | [**delete_file**](docs/FileStoreApi.md#delete_file) | **DELETE** /ng/api/file-store/{identifier} | Delete File or Folder by identifier
*FileStoreApi* | [**download_file**](docs/FileStoreApi.md#download_file) | **GET** /ng/api/file-store/files/{identifier}/download | Download File
*FileStoreApi* | [**get_created_by_list**](docs/FileStoreApi.md#get_created_by_list) | **GET** /ng/api/file-store/files/createdBy | Get list of created by user details
*FileStoreApi* | [**get_entity_types**](docs/FileStoreApi.md#get_entity_types) | **GET** /ng/api/file-store/supported-entity-types | Get the list of supported entity types for files
*FileStoreApi* | [**get_file**](docs/FileStoreApi.md#get_file) | **GET** /ng/api/file-store/{identifier} | Get the Folder or File metadata
*FileStoreApi* | [**get_file_content_using_scoped_file_path**](docs/FileStoreApi.md#get_file_content_using_scoped_file_path) | **GET** /ng/api/file-store/files/{scopedFilePath}/content | Get file content of scopedFilePath
*FileStoreApi* | [**get_file_content_using_scoped_file_path_v2**](docs/FileStoreApi.md#get_file_content_using_scoped_file_path_v2) | **POST** /ng/api/file-store/files/content | Get file content of scopedFilePathV2
*FileStoreApi* | [**get_folder_nodes**](docs/FileStoreApi.md#get_folder_nodes) | **POST** /ng/api/file-store/folder | Get folder nodes at first level, not including sub-nodes
*FileStoreApi* | [**get_referenced_by**](docs/FileStoreApi.md#get_referenced_by) | **GET** /ng/api/file-store/{identifier}/referenced-by | Get list of entities where file is referenced by queried entity type
*FileStoreApi* | [**list_files_and_folders**](docs/FileStoreApi.md#list_files_and_folders) | **GET** /ng/api/file-store | List Files and Folders metadata
*FileStoreApi* | [**list_files_with_filter**](docs/FileStoreApi.md#list_files_with_filter) | **POST** /ng/api/file-store/files/filter | Get filtered list of Files or Folders
*FileStoreApi* | [**update**](docs/FileStoreApi.md#update) | **PUT** /ng/api/file-store/{identifier} | Update Folder or File including content
*FileStoreApi* | [**update_via_yaml**](docs/FileStoreApi.md#update_via_yaml) | **PUT** /ng/api/file-store/yaml/{identifier} | Update File or Folder metadata via YAML
*FilterApi* | [**ccmdelete_filter**](docs/FilterApi.md#ccmdelete_filter) | **DELETE** /ccm/api/filters/{identifier} | Delete a Filter
*FilterApi* | [**ccmget_filter**](docs/FilterApi.md#ccmget_filter) | **GET** /ccm/api/filters/{identifier} | Return Filter Details
*FilterApi* | [**ccmget_filter_list**](docs/FilterApi.md#ccmget_filter_list) | **GET** /ccm/api/filters | List Filters
*FilterApi* | [**ccmpost_filter**](docs/FilterApi.md#ccmpost_filter) | **POST** /ccm/api/filters | Create a Filter
*FilterApi* | [**ccmupdate_filter**](docs/FilterApi.md#ccmupdate_filter) | **PUT** /ccm/api/filters | Update a Filter
*FilterApi* | [**delete_filter**](docs/FilterApi.md#delete_filter) | **DELETE** /ng/api/filters/{identifier} | Delete a Filter
*FilterApi* | [**get_filter**](docs/FilterApi.md#get_filter) | **GET** /ng/api/filters/{identifier} | Return Filter Details
*FilterApi* | [**get_filter_list**](docs/FilterApi.md#get_filter_list) | **GET** /ng/api/filters | List Filters
*FilterApi* | [**pipelinedelete_filter**](docs/FilterApi.md#pipelinedelete_filter) | **DELETE** /pipeline/api/filters/{identifier} | Delete a Filter
*FilterApi* | [**pipelineget_filter**](docs/FilterApi.md#pipelineget_filter) | **GET** /pipeline/api/filters/{identifier} | Return Filter Details
*FilterApi* | [**pipelineget_filter_list**](docs/FilterApi.md#pipelineget_filter_list) | **GET** /pipeline/api/filters | List Filters
*FilterApi* | [**pipelinepost_filter**](docs/FilterApi.md#pipelinepost_filter) | **POST** /pipeline/api/filters | Create a Filter
*FilterApi* | [**pipelineupdate_filter**](docs/FilterApi.md#pipelineupdate_filter) | **PUT** /pipeline/api/filters | Update a Filter
*FilterApi* | [**post_filter**](docs/FilterApi.md#post_filter) | **POST** /ng/api/filters | Create a Filter
*FilterApi* | [**templatedelete_filter**](docs/FilterApi.md#templatedelete_filter) | **DELETE** /template/api/filters/{identifier} | Delete a Filter
*FilterApi* | [**templateget_filter**](docs/FilterApi.md#templateget_filter) | **GET** /template/api/filters/{identifier} | Return Filter Details
*FilterApi* | [**templateget_filter_list**](docs/FilterApi.md#templateget_filter_list) | **GET** /template/api/filters | List Filters
*FilterApi* | [**templatepost_filter**](docs/FilterApi.md#templatepost_filter) | **POST** /template/api/filters | Create a Filter
*FilterApi* | [**templateupdate_filter**](docs/FilterApi.md#templateupdate_filter) | **PUT** /template/api/filters | Update a Filter
*FilterApi* | [**update_filter**](docs/FilterApi.md#update_filter) | **PUT** /ng/api/filters | Update a Filter
*FilterResourceGroupsApi* | [**filter_resource_groups**](docs/FilterResourceGroupsApi.md#filter_resource_groups) | **POST** /v1/resource-groups/filter | Filter Resource Groups
*FreezeCRUDApi* | [**create_freeze**](docs/FreezeCRUDApi.md#create_freeze) | **POST** /ng/api/freeze | Create a Freeze
*FreezeCRUDApi* | [**create_global_freeze**](docs/FreezeCRUDApi.md#create_global_freeze) | **POST** /ng/api/freeze/manageGlobalFreeze | Create Global Freeze
*FreezeCRUDApi* | [**delete_freeze**](docs/FreezeCRUDApi.md#delete_freeze) | **DELETE** /ng/api/freeze/{freezeIdentifier} | Delete a Freeze
*FreezeCRUDApi* | [**delete_many_freezes**](docs/FreezeCRUDApi.md#delete_many_freezes) | **POST** /ng/api/freeze/delete | Delete many Freezes
*FreezeCRUDApi* | [**get_freeze**](docs/FreezeCRUDApi.md#get_freeze) | **GET** /ng/api/freeze/{freezeIdentifier} | Get a Freeze
*FreezeCRUDApi* | [**get_freeze_list**](docs/FreezeCRUDApi.md#get_freeze_list) | **POST** /ng/api/freeze/list | Gets Freeze list
*FreezeCRUDApi* | [**get_frozen_execution_details**](docs/FreezeCRUDApi.md#get_frozen_execution_details) | **GET** /ng/api/freeze/getFrozenExecutionDetails | Get list of freeze acted on a frozen execution
*FreezeCRUDApi* | [**get_global_freeze**](docs/FreezeCRUDApi.md#get_global_freeze) | **GET** /ng/api/freeze/getGlobalFreeze | Get Global Freeze Yaml
*FreezeCRUDApi* | [**update_freeze**](docs/FreezeCRUDApi.md#update_freeze) | **PUT** /ng/api/freeze/{freezeIdentifier} | Updates a Freeze
*FreezeCRUDApi* | [**update_freeze_status**](docs/FreezeCRUDApi.md#update_freeze_status) | **POST** /ng/api/freeze/updateFreezeStatus | Update the status of Freeze to active or inactive
*GPGKeysApi* | [**gnu_pg_key_service_list_gpg_keys**](docs/GPGKeysApi.md#gnu_pg_key_service_list_gpg_keys) | **GET** /gitops/api/v1/gpgkeys | List all GPG keys
*GitXWebhooksApi* | [**create_gitx_webhook**](docs/GitXWebhooksApi.md#create_gitx_webhook) | **POST** /v1/gitx-webhooks | Create a GitX webhook at Account level
*GitXWebhooksApi* | [**delete_gitx_webhook**](docs/GitXWebhooksApi.md#delete_gitx_webhook) | **DELETE** /v1/gitx-webhooks/{gitx-webhook} | Deletes a GitX Webhook at Account level
*GitXWebhooksApi* | [**get_gitx_webhook**](docs/GitXWebhooksApi.md#get_gitx_webhook) | **GET** /v1/gitx-webhooks/{gitx-webhook} | Fetch GitX Webhook at Account level
*GitXWebhooksApi* | [**list_gitx_webhooks**](docs/GitXWebhooksApi.md#list_gitx_webhooks) | **GET** /v1/gitx-webhooks | Lists all the GitX Webhooks at Account level
*GitXWebhooksApi* | [**update_gitx_webhook**](docs/GitXWebhooksApi.md#update_gitx_webhook) | **PUT** /v1/gitx-webhooks/{gitx-webhook} | Updates a GitX Webhook at Account level
*GitBranchesApi* | [**get_list_of_branches_with_status**](docs/GitBranchesApi.md#get_list_of_branches_with_status) | **GET** /ng/api/git-sync-branch/listBranchesWithStatus | Lists branches with their status(Synced, Unsynced) by Git Sync Config Id for the given scope
*GitBranchesApi* | [**sync_git_branch**](docs/GitBranchesApi.md#sync_git_branch) | **POST** /ng/api/git-sync-branch/sync | Sync the content of new Git Branch into harness with Git Sync Config Id
*GitFullSyncApi* | [**create_git_full_sync_config**](docs/GitFullSyncApi.md#create_git_full_sync_config) | **POST** /ng/api/git-full-sync/config | Create Configuration for Git Full Sync for the provided scope
*GitFullSyncApi* | [**get_git_full_sync_config**](docs/GitFullSyncApi.md#get_git_full_sync_config) | **GET** /ng/api/git-full-sync/config | Fetch Configuration for Git Full Sync for the provided scope
*GitFullSyncApi* | [**list_full_sync_files**](docs/GitFullSyncApi.md#list_full_sync_files) | **POST** /ng/api/git-full-sync/files | List files in full sync along with their status
*GitFullSyncApi* | [**trigger_full_sync**](docs/GitFullSyncApi.md#trigger_full_sync) | **POST** /ng/api/git-full-sync | Trigger Full Sync
*GitFullSyncApi* | [**update_git_full_sync_config**](docs/GitFullSyncApi.md#update_git_full_sync_config) | **PUT** /ng/api/git-full-sync/config | Update Configuration for Git Full Sync for the provided scope
*GitSyncApi* | [**create_git_sync_config**](docs/GitSyncApi.md#create_git_sync_config) | **POST** /ng/api/git-sync | Creates Git Sync Config in given scope
*GitSyncApi* | [**get_git_sync_config_list**](docs/GitSyncApi.md#get_git_sync_config_list) | **GET** /ng/api/git-sync | Lists Git Sync Config for the given scope
*GitSyncApi* | [**is_git_sync_enabled**](docs/GitSyncApi.md#is_git_sync_enabled) | **GET** /ng/api/git-sync/git-sync-enabled | Check whether Git Sync is enabled for given scope or not
*GitSyncApi* | [**update_default_folder**](docs/GitSyncApi.md#update_default_folder) | **PUT** /ng/api/git-sync/{identifier}/folder/{folderIdentifier}/default | Update existing Git Sync Config default root folder by Identifier
*GitSyncApi* | [**update_git_sync_config**](docs/GitSyncApi.md#update_git_sync_config) | **PUT** /ng/api/git-sync | Update existing Git Sync Config by Identifier
*GitSyncErrorsApi* | [**get_git_sync_errors_count**](docs/GitSyncErrorsApi.md#get_git_sync_errors_count) | **GET** /ng/api/git-sync-errors/count | Get Errors Count for the given scope, Repo and Branch
*GitSyncErrorsApi* | [**list_git_sync_errors**](docs/GitSyncErrorsApi.md#list_git_sync_errors) | **GET** /ng/api/git-sync-errors | Lists Git to Harness Errors by file or connectivity errors for the given scope, Repo and Branch
*GitSyncErrorsApi* | [**list_git_to_harness_error_for_commit**](docs/GitSyncErrorsApi.md#list_git_to_harness_error_for_commit) | **GET** /ng/api/git-sync-errors/commits/{commitId} | Lists Git to Harness Errors for the given Commit Id
*GitSyncErrorsApi* | [**list_git_to_harness_errors_grouped_by_commits**](docs/GitSyncErrorsApi.md#list_git_to_harness_errors_grouped_by_commits) | **GET** /ng/api/git-sync-errors/aggregate | Lists Git to Harness Errors grouped by Commits for the given scope, Repo and Branch
*GitSyncSettingsApi* | [**create_git_sync_setting**](docs/GitSyncSettingsApi.md#create_git_sync_setting) | **POST** /ng/api/git-sync-settings | Creates Git Sync Setting in a scope
*GitSyncSettingsApi* | [**get_git_sync_settings**](docs/GitSyncSettingsApi.md#get_git_sync_settings) | **GET** /ng/api/git-sync-settings | Get Git Sync Setting for the given scope
*GitSyncSettingsApi* | [**update_git_sync_setting**](docs/GitSyncSettingsApi.md#update_git_sync_setting) | **PUT** /ng/api/git-sync-settings | This updates the existing Git Sync settings within the scope. Only changing Connectivity Mode is allowed
*GnuPGPKeysApi* | [**agent_gpg_key_service_create**](docs/GnuPGPKeysApi.md#agent_gpg_key_service_create) | **POST** /gitops/api/v1/agents/{agentIdentifier}/gpgkeys | Create one or more GPG public keys in the server&#x27;s configuration
*GnuPGPKeysApi* | [**agent_gpg_key_service_delete**](docs/GnuPGPKeysApi.md#agent_gpg_key_service_delete) | **DELETE** /gitops/api/v1/agents/{agentIdentifier}/gpgkeys/{query.keyID} | Delete specified GPG public key from the server&#x27;s configuration
*GnuPGPKeysApi* | [**agent_gpg_key_service_get**](docs/GnuPGPKeysApi.md#agent_gpg_key_service_get) | **GET** /gitops/api/v1/agents/{agentIdentifier}/gpgkeys/{query.keyID} | Get information about specified GPG public key from the server
*GoogleSecretManagerConnectorApi* | [**get_gcp_regions**](docs/GoogleSecretManagerConnectorApi.md#get_gcp_regions) | **GET** /ng/api/google-secret-manager-connector/gcp-regions | Get list of GCP Regions
*GovernanceOverviewApi* | [**day_wise_total_evaluations**](docs/GovernanceOverviewApi.md#day_wise_total_evaluations) | **POST** /ccm/api/governance/overview/dayWiseTotalEvaluations | Return day wise total evaluations grouped by evaluation status.
*GovernanceOverviewApi* | [**total_active_enforcements**](docs/GovernanceOverviewApi.md#total_active_enforcements) | **GET** /ccm/api/governance/overview/totalActiveEnforcements | Return total number of active enforcements.
*GovernanceOverviewApi* | [**total_evaluations**](docs/GovernanceOverviewApi.md#total_evaluations) | **GET** /ccm/api/governance/overview/totalEvaluations | Return total number of evaluations.
*GovernanceOverviewApi* | [**total_realised_savings_grouped**](docs/GovernanceOverviewApi.md#total_realised_savings_grouped) | **GET** /ccm/api/governance/overview/totalRealisedSavingsGrouped | Return total realised Savings grouped by cloud provider/resource type.
*GovernanceOverviewApi* | [**total_realised_savings_v2**](docs/GovernanceOverviewApi.md#total_realised_savings_v2) | **POST** /ccm/api/governance/overview/totalRealisedSavingsV2 | Return total realised Savings.
*GroupsApi* | [**delete_group**](docs/GroupsApi.md#delete_group) | **DELETE** /v1/groups/{group-identifier} | Delete a group
*GroupsApi* | [**get_all_groups_for_account**](docs/GroupsApi.md#get_all_groups_for_account) | **GET** /v1/groups | Get all groups for account
*GroupsApi* | [**get_group_details**](docs/GroupsApi.md#get_group_details) | **GET** /v1/groups/{group-identifier} | Get Group Details
*GroupsApi* | [**get_groups_yaml**](docs/GroupsApi.md#get_groups_yaml) | **GET** /v1/groups/yaml | Get Groups Yaml
*GroupsApi* | [**get_workflows_for_account**](docs/GroupsApi.md#get_workflows_for_account) | **GET** /v1/groups/workflows | Get workflows for account
*GroupsApi* | [**save_group**](docs/GroupsApi.md#save_group) | **POST** /v1/groups | Save a group
*GroupsApi* | [**update_groups**](docs/GroupsApi.md#update_groups) | **PUT** /v1/groups | Update Groups
*HarnessResourceGroupApi* | [**create_resource_group_v2**](docs/HarnessResourceGroupApi.md#create_resource_group_v2) | **POST** /resourcegroup/api/v2/resourcegroup | Create Resource Group
*HarnessResourceGroupApi* | [**delete_resource_group_v2**](docs/HarnessResourceGroupApi.md#delete_resource_group_v2) | **DELETE** /resourcegroup/api/v2/resourcegroup/{identifier} | Delete Resource Group
*HarnessResourceGroupApi* | [**get_filter_resource_group_list_v2**](docs/HarnessResourceGroupApi.md#get_filter_resource_group_list_v2) | **POST** /resourcegroup/api/v2/resourcegroup/filter | List Resource Groups by filter
*HarnessResourceGroupApi* | [**get_resource_group_list_v2**](docs/HarnessResourceGroupApi.md#get_resource_group_list_v2) | **GET** /resourcegroup/api/v2/resourcegroup | List Resource Groups
*HarnessResourceGroupApi* | [**get_resource_group_v2**](docs/HarnessResourceGroupApi.md#get_resource_group_v2) | **GET** /resourcegroup/api/v2/resourcegroup/{identifier} | Get Resource Group
*HarnessResourceGroupApi* | [**update_resource_group_v2**](docs/HarnessResourceGroupApi.md#update_resource_group_v2) | **PUT** /resourcegroup/api/v2/resourcegroup/{identifier} | Update Resource Group
*HarnessResourceTypeApi* | [**get_resource_types**](docs/HarnessResourceTypeApi.md#get_resource_types) | **GET** /resourcegroup/api/resourcetype | Gets all resource types available at this scope
*HomePageLayoutApi* | [**delete_custom_link_card_quick_links**](docs/HomePageLayoutApi.md#delete_custom_link_card_quick_links) | **DELETE** /v1/home-page-layout/custom-card/{card-identifier}/quick-links/{quick-link-identifier}/icon | Delete custom link card quick links icon
*HomePageLayoutApi* | [**delete_headers_quick_links_icon**](docs/HomePageLayoutApi.md#delete_headers_quick_links_icon) | **DELETE** /v1/home-page-layout/header/quick-links/{quick-link-identifier}/icon | Delete header quick links icon
*HomePageLayoutApi* | [**delete_home_page_layout_cards_icon**](docs/HomePageLayoutApi.md#delete_home_page_layout_cards_icon) | **DELETE** /v1/home-page-layout/card/{card-identifier}/icon | Delete card icon
*HomePageLayoutApi* | [**delete_home_page_layout_icon**](docs/HomePageLayoutApi.md#delete_home_page_layout_icon) | **DELETE** /v1/home-page-layout/icon | Delete homepage layout icon
*HomePageLayoutApi* | [**get_home_page_layout_info**](docs/HomePageLayoutApi.md#get_home_page_layout_info) | **GET** /v1/home-page-layout | Get Home Page Layout Details
*HomePageLayoutApi* | [**get_yaml_for_home_page_layout**](docs/HomePageLayoutApi.md#get_yaml_for_home_page_layout) | **GET** /v1/home-page-layout/yaml | Get yaml for home page layout
*HomePageLayoutApi* | [**save_home_page_layout_info**](docs/HomePageLayoutApi.md#save_home_page_layout_info) | **POST** /v1/home-page-layout | Save Home Page Layout Details
*HostsApi* | [**filter_hosts_by_connector**](docs/HostsApi.md#filter_hosts_by_connector) | **POST** /ng/api/hosts/filter | Gets the list of hosts filtered by accountIdentifier and connectorIdentifier
*HostsApi* | [**validate_hosts1**](docs/HostsApi.md#validate_hosts1) | **POST** /ng/api/hosts/validate | Validates hosts connectivity credentials
*IPAllowlistApi* | [**create_ip_allowlist_config**](docs/IPAllowlistApi.md#create_ip_allowlist_config) | **POST** /v1/ip-allowlist | Create a IP Allowlist config
*IPAllowlistApi* | [**delete_ip_allowlist_config**](docs/IPAllowlistApi.md#delete_ip_allowlist_config) | **DELETE** /v1/ip-allowlist/{ip-config-identifier} | Delete an IP Allowlist config
*IPAllowlistApi* | [**get_ip_allowlist_config**](docs/IPAllowlistApi.md#get_ip_allowlist_config) | **GET** /v1/ip-allowlist/{ip-config-identifier} | Retrieve a IP Allowlist config
*IPAllowlistApi* | [**get_ip_allowlist_configs**](docs/IPAllowlistApi.md#get_ip_allowlist_configs) | **GET** /v1/ip-allowlist | List IP Allowlist Configs
*IPAllowlistApi* | [**update_ip_allowlist_config**](docs/IPAllowlistApi.md#update_ip_allowlist_config) | **PUT** /v1/ip-allowlist/{ip-config-identifier} | Update IP Allowlist config
*IPAllowlistApi* | [**validate_ip_address_allowlisted_or_not**](docs/IPAllowlistApi.md#validate_ip_address_allowlisted_or_not) | **GET** /v1/ip-allowlist/validate/ip-address | Validate IP address lies in a specified range or not
*IPAllowlistApi* | [**validate_unique_ip_allowlist_config_identifier**](docs/IPAllowlistApi.md#validate_unique_ip_allowlist_config_identifier) | **GET** /v1/ip-allowlist/validate-unique-identifier/{ip-config-identifier} | Validate unique IP Allowlist config identifier
*InfrastructuresApi* | [**create_infrastructure**](docs/InfrastructuresApi.md#create_infrastructure) | **POST** /ng/api/infrastructures | Create an Infrastructure in an Environment
*InfrastructuresApi* | [**delete_infrastructure**](docs/InfrastructuresApi.md#delete_infrastructure) | **DELETE** /ng/api/infrastructures/{infraIdentifier} | Delete an Infrastructure by identifier
*InfrastructuresApi* | [**get_infrastructure**](docs/InfrastructuresApi.md#get_infrastructure) | **GET** /ng/api/infrastructures/{infraIdentifier} | Gets an Infrastructure by identifier
*InfrastructuresApi* | [**get_infrastructure_list**](docs/InfrastructuresApi.md#get_infrastructure_list) | **GET** /ng/api/infrastructures | Gets Infrastructure list
*InfrastructuresApi* | [**import_infrastructure**](docs/InfrastructuresApi.md#import_infrastructure) | **POST** /ng/api/infrastructures/import | Import and Create Infrastructure from Git Repository
*InfrastructuresApi* | [**move_infra_configs**](docs/InfrastructuresApi.md#move_infra_configs) | **POST** /ng/api/infrastructures/move-config/{infraIdentifier} | Move infra YAML from inline to remote
*InfrastructuresApi* | [**update_infrastructure**](docs/InfrastructuresApi.md#update_infrastructure) | **PUT** /ng/api/infrastructures | Update an Infrastructure by identifier
*InfrastructuresApi* | [**update_infrastructure_git_details**](docs/InfrastructuresApi.md#update_infrastructure_git_details) | **PUT** /ng/api/infrastructures/{infraIdentifier}/update-git-metadata | Update git-metadata in remote infrastructure Entity
*InputSetsApi* | [**create_input_set**](docs/InputSetsApi.md#create_input_set) | **POST** /v1/orgs/{org}/projects/{project}/input-sets | Create an Input Set
*InputSetsApi* | [**delete_input_set**](docs/InputSetsApi.md#delete_input_set) | **DELETE** /v1/orgs/{org}/projects/{project}/input-sets/{input-set} | Delete an Input Set
*InputSetsApi* | [**get_input_set**](docs/InputSetsApi.md#get_input_set) | **GET** /v1/orgs/{org}/projects/{project}/input-sets/{input-set} | Retrieve an Input Set
*InputSetsApi* | [**import_input_set_from_git**](docs/InputSetsApi.md#import_input_set_from_git) | **POST** /v1/orgs/{org}/projects/{project}/input-sets/{input-set}/import | Get Input Set YAML from Git Repository
*InputSetsApi* | [**input_sets_move_config**](docs/InputSetsApi.md#input_sets_move_config) | **POST** /v1/orgs/{org}/projects/{project}/input-sets/{input-set}/move-config | Move InputSet YAML from inline to remote
*InputSetsApi* | [**list_input_sets**](docs/InputSetsApi.md#list_input_sets) | **GET** /v1/orgs/{org}/projects/{project}/input-sets | List Input Sets
*InputSetsApi* | [**update_input_set**](docs/InputSetsApi.md#update_input_set) | **PUT** /v1/orgs/{org}/projects/{project}/input-sets/{input-set} | Update an Input Set
*InputSetsApi* | [**update_input_set_git_metadata**](docs/InputSetsApi.md#update_input_set_git_metadata) | **PUT** /v1/orgs/{org}/projects/{project}/input-sets/{input-set}/git-metadata | Update GitMetadata for Remote InputSet
*InviteApi* | [**delete_invite**](docs/InviteApi.md#delete_invite) | **DELETE** /ng/api/invites/{inviteId} | Delete Invite
*InviteApi* | [**get_invite**](docs/InviteApi.md#get_invite) | **GET** /ng/api/invites/invite | Get Invite
*InviteApi* | [**get_invites**](docs/InviteApi.md#get_invites) | **GET** /ng/api/invites | List Invites
*InviteApi* | [**get_pending_users_aggregated**](docs/InviteApi.md#get_pending_users_aggregated) | **POST** /ng/api/invites/aggregate | Get pending users
*InviteApi* | [**update_invite**](docs/InviteApi.md#update_invite) | **PUT** /ng/api/invites/{inviteId} | Resend invite
*IssuesApi* | [**issues_create_issue**](docs/IssuesApi.md#issues_create_issue) | **POST** /sto/api/v2/issues | 
*IssuesApi* | [**issues_find_issue_by_id**](docs/IssuesApi.md#issues_find_issue_by_id) | **GET** /sto/api/v2/issues/{id} | 
*IssuesApi* | [**issues_issues_augment_remediation**](docs/IssuesApi.md#issues_issues_augment_remediation) | **POST** /sto/api/v2/issues/{id}/augment-remediation | 
*IssuesApi* | [**issues_list_issues**](docs/IssuesApi.md#issues_list_issues) | **GET** /sto/api/v2/issues | 
*IssuesApi* | [**issues_update_issue**](docs/IssuesApi.md#issues_update_issue) | **PUT** /sto/api/v2/issues/{id} | 
*K8sReleaseServiceMappingApi* | [**get_v1_release_details**](docs/K8sReleaseServiceMappingApi.md#get_v1_release_details) | **GET** /v1/kubernetes/releases/service-mapping | List service and environment details using namespace and releasename
*KubernetesDataPointsApi* | [**get_k8s_data_point_values**](docs/KubernetesDataPointsApi.md#get_k8s_data_point_values) | **POST** /v1/data-sources/kubernetes/data-point/values | Get data points data for kubernetes data source
*LayoutProxyApi* | [**layout_ingest**](docs/LayoutProxyApi.md#layout_ingest) | **POST** /v1/layout/ingest | Ingest plugin layout
*LdapSettingsApi* | [**create_ng_ldap_settings**](docs/LdapSettingsApi.md#create_ng_ldap_settings) | **POST** /v1/ldap-settings | Create Account LDAP Settings
*LdapSettingsApi* | [**delete_ldap_settings**](docs/LdapSettingsApi.md#delete_ldap_settings) | **DELETE** /v1/ldap-settings/{ldap-settings-id} | Delete Account Ldap Settings
*LdapSettingsApi* | [**get_ldap_settings**](docs/LdapSettingsApi.md#get_ldap_settings) | **GET** /v1/ldap-settings/{ldap-settings-id} | Get Account Ldap Settings by identifier
*LdapSettingsApi* | [**ldap_settings_iterations**](docs/LdapSettingsApi.md#ldap_settings_iterations) | **POST** /v1/ldap-settings/iterations | Ldap Settings iterations
*LdapSettingsApi* | [**ldap_settings_ldap_login_test**](docs/LdapSettingsApi.md#ldap_settings_ldap_login_test) | **POST** /v1/ldap-settings/ldap-login-test | Ldap login test
*LdapSettingsApi* | [**ldap_settings_search_group**](docs/LdapSettingsApi.md#ldap_settings_search_group) | **GET** /v1/ldap-settings/search-group/{group-id} | Search Ldap groups with matching name
*LdapSettingsApi* | [**ldap_settings_sync_group_with_id**](docs/LdapSettingsApi.md#ldap_settings_sync_group_with_id) | **GET** /v1/ldap-settings/sync-group/{group-id} | Ldap Sync Group with user group id
*LdapSettingsApi* | [**ldap_settings_sync_groups**](docs/LdapSettingsApi.md#ldap_settings_sync_groups) | **PUT** /v1/ldap-settings/sync-groups | Ldap Settings Sync User Groups
*LdapSettingsApi* | [**update_ldap_settings**](docs/LdapSettingsApi.md#update_ldap_settings) | **PUT** /v1/ldap-settings/{ldap-settings-id} | Update Account Ldap Settings
*LdapSettingsApi* | [**validate_connection_settings**](docs/LdapSettingsApi.md#validate_connection_settings) | **POST** /v1/ldap-settings/validate/connection-settings | Validate Ldap Connection Settings
*LdapSettingsApi* | [**validate_group_settings**](docs/LdapSettingsApi.md#validate_group_settings) | **POST** /v1/ldap-settings/validate/group-settings | Validate Ldap Group Settings
*LdapSettingsApi* | [**validate_user_settings**](docs/LdapSettingsApi.md#validate_user_settings) | **POST** /v1/ldap-settings/validate/user-settings | Validate Ldap User Settings
*LicenseUsageDataByAccountApi* | [**license_usage_activity**](docs/LicenseUsageDataByAccountApi.md#license_usage_activity) | **POST** /v1/licenseUsageActivity/{accountIdentifier} | Get License Usage Data for an account for a given time range
*MonitoredServicesApi* | [**create_default_monitored_service**](docs/MonitoredServicesApi.md#create_default_monitored_service) | **POST** /cv/api/monitored-service/create-default | 
*MonitoredServicesApi* | [**cvget_anomalies_summary**](docs/MonitoredServicesApi.md#cvget_anomalies_summary) | **GET** /cv/api/monitored-service/{identifier}/anomaliesCount | 
*MonitoredServicesApi* | [**delete_monitored_service**](docs/MonitoredServicesApi.md#delete_monitored_service) | **DELETE** /cv/api/monitored-service/{identifier} | Delete monitored service data
*MonitoredServicesApi* | [**detach_monitored_service_from_template**](docs/MonitoredServicesApi.md#detach_monitored_service_from_template) | **PUT** /cv/api/monitored-service/{identifier}/detach-template | delete template reference from monitored service
*MonitoredServicesApi* | [**get_all_monitored_services_with_health_sources**](docs/MonitoredServicesApi.md#get_all_monitored_services_with_health_sources) | **GET** /cv/api/monitored-service/all/time-series-health-sources | 
*MonitoredServicesApi* | [**get_count_of_services**](docs/MonitoredServicesApi.md#get_count_of_services) | **GET** /cv/api/monitored-service/count-of-services | 
*MonitoredServicesApi* | [**get_environments**](docs/MonitoredServicesApi.md#get_environments) | **GET** /cv/api/monitored-service/environments | 
*MonitoredServicesApi* | [**get_health_sources**](docs/MonitoredServicesApi.md#get_health_sources) | **GET** /cv/api/monitored-service/health-sources | 
*MonitoredServicesApi* | [**get_health_sources_for_monitored_service_identifier**](docs/MonitoredServicesApi.md#get_health_sources_for_monitored_service_identifier) | **GET** /cv/api/monitored-service/{monitoredServiceIdentifier}/health-sources | 
*MonitoredServicesApi* | [**get_list**](docs/MonitoredServicesApi.md#get_list) | **GET** /cv/api/monitored-service/list | 
*MonitoredServicesApi* | [**get_list_v2**](docs/MonitoredServicesApi.md#get_list_v2) | **GET** /cv/api/monitored-service/platform/list | 
*MonitoredServicesApi* | [**get_monitored_service**](docs/MonitoredServicesApi.md#get_monitored_service) | **GET** /cv/api/monitored-service/{identifier} | Get monitored service data
*MonitoredServicesApi* | [**get_monitored_service_change_details**](docs/MonitoredServicesApi.md#get_monitored_service_change_details) | **GET** /cv/api/monitored-service/{monitoredServiceIdentifier}/change-details | 
*MonitoredServicesApi* | [**get_monitored_service_details**](docs/MonitoredServicesApi.md#get_monitored_service_details) | **GET** /cv/api/monitored-service/{monitoredServiceIdentifier}/service-details | 
*MonitoredServicesApi* | [**get_monitored_service_details1**](docs/MonitoredServicesApi.md#get_monitored_service_details1) | **GET** /cv/api/monitored-service/service-details | 
*MonitoredServicesApi* | [**get_monitored_service_from_service_and_environment**](docs/MonitoredServicesApi.md#get_monitored_service_from_service_and_environment) | **GET** /cv/api/monitored-service/service-environment | 
*MonitoredServicesApi* | [**get_monitored_service_logs**](docs/MonitoredServicesApi.md#get_monitored_service_logs) | **GET** /cv/api/monitored-service/{monitoredServiceIdentifier}/logs | 
*MonitoredServicesApi* | [**get_monitored_service_reconciliation_statuses**](docs/MonitoredServicesApi.md#get_monitored_service_reconciliation_statuses) | **GET** /cv/api/monitored-service/reconciliation-status | fetch reconciliation status for template referenced monitored services
*MonitoredServicesApi* | [**get_monitored_service_resolved_template_inputs**](docs/MonitoredServicesApi.md#get_monitored_service_resolved_template_inputs) | **GET** /cv/api/monitored-service/{identifier}/resolved-template-inputs | get monitored service resolved template inputs
*MonitoredServicesApi* | [**get_monitored_service_score**](docs/MonitoredServicesApi.md#get_monitored_service_score) | **GET** /cv/api/monitored-service/{identifier}/scores | 
*MonitoredServicesApi* | [**get_ms_secondary_events**](docs/MonitoredServicesApi.md#get_ms_secondary_events) | **GET** /cv/api/monitored-service/{identifier}/secondary-events | 
*MonitoredServicesApi* | [**get_ms_secondary_events_details**](docs/MonitoredServicesApi.md#get_ms_secondary_events_details) | **GET** /cv/api/monitored-service/secondary-events-details | 
*MonitoredServicesApi* | [**get_notification_rules_for_monitored_service**](docs/MonitoredServicesApi.md#get_notification_rules_for_monitored_service) | **GET** /cv/api/monitored-service/{identifier}/notification-rules | Get notification rules for MonitoredService
*MonitoredServicesApi* | [**get_over_all_health_score**](docs/MonitoredServicesApi.md#get_over_all_health_score) | **GET** /cv/api/monitored-service/{identifier}/overall-health-score | 
*MonitoredServicesApi* | [**get_services**](docs/MonitoredServicesApi.md#get_services) | **GET** /cv/api/monitored-service/services | 
*MonitoredServicesApi* | [**get_slo_metrics**](docs/MonitoredServicesApi.md#get_slo_metrics) | **GET** /cv/api/monitored-service/{monitoredServiceIdentifier}/health-source/{healthSourceIdentifier}/slo-metrics | 
*MonitoredServicesApi* | [**is_reconciliation_required_for_monitored_services**](docs/MonitoredServicesApi.md#is_reconciliation_required_for_monitored_services) | **GET** /cv/api/monitored-service/reconciliation-required | check if a template referenced monitored service(s) require reconciliation
*MonitoredServicesApi* | [**list**](docs/MonitoredServicesApi.md#list) | **GET** /cv/api/monitored-service | 
*MonitoredServicesApi* | [**save_monitored_service**](docs/MonitoredServicesApi.md#save_monitored_service) | **POST** /cv/api/monitored-service | Saves monitored service data
*MonitoredServicesApi* | [**save_monitored_service_from_template_input**](docs/MonitoredServicesApi.md#save_monitored_service_from_template_input) | **POST** /cv/api/monitored-service/template-input | Saves monitored service from template input
*MonitoredServicesApi* | [**save_monitored_service_from_yaml**](docs/MonitoredServicesApi.md#save_monitored_service_from_yaml) | **POST** /cv/api/monitored-service/yaml | 
*MonitoredServicesApi* | [**set_health_monitoring_flag**](docs/MonitoredServicesApi.md#set_health_monitoring_flag) | **PUT** /cv/api/monitored-service/{identifier}/health-monitoring-flag | 
*MonitoredServicesApi* | [**update_monitored_service**](docs/MonitoredServicesApi.md#update_monitored_service) | **PUT** /cv/api/monitored-service/{identifier} | Updates monitored service data
*MonitoredServicesApi* | [**update_monitored_service_from_template_input**](docs/MonitoredServicesApi.md#update_monitored_service_from_template_input) | **PUT** /cv/api/monitored-service/{identifier}/template-input | Update monitored service from yaml or template
*MonitoredServicesApi* | [**update_monitored_service_from_yaml**](docs/MonitoredServicesApi.md#update_monitored_service_from_yaml) | **PUT** /cv/api/monitored-service/{identifier}/yaml | 
*MonitoredServicesApi* | [**yaml_template**](docs/MonitoredServicesApi.md#yaml_template) | **GET** /cv/api/monitored-service/yaml-template | 
*NGSLOsApi* | [**delete_slo_data_ng**](docs/NGSLOsApi.md#delete_slo_data_ng) | **DELETE** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/slo/v2/identifier/{identifier} | Delete SLO data
*NGSLOsApi* | [**get_onboarding_graph_ng**](docs/NGSLOsApi.md#get_onboarding_graph_ng) | **POST** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/slo/v2/composite-slo/onboarding-graph | Get onBoarding graph for composite slo
*NGSLOsApi* | [**get_service_level_objective_ng**](docs/NGSLOsApi.md#get_service_level_objective_ng) | **GET** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/slo/v2/identifier/{identifier} | Get SLO data
*NGSLOsApi* | [**get_service_level_objectives_ng**](docs/NGSLOsApi.md#get_service_level_objectives_ng) | **GET** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/slo/v2 | Get all SLOs
*NGSLOsApi* | [**get_slo_health_list_view_ng**](docs/NGSLOsApi.md#get_slo_health_list_view_ng) | **POST** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/slo/v2/status-list | Get SLO list view
*NGSLOsApi* | [**save_slo_data_ng**](docs/NGSLOsApi.md#save_slo_data_ng) | **POST** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/slo/v2 | Saves SLO data
*NGSLOsApi* | [**update_slo_data_ng**](docs/NGSLOsApi.md#update_slo_data_ng) | **PUT** /cv/api/account/{accountIdentifier}/org/{orgIdentifier}/project/{projectIdentifier}/slo/v2/identifier/{identifier} | Update SLO data
*NextgenLdapApi* | [**get_ng_ldap_settings**](docs/NextgenLdapApi.md#get_ng_ldap_settings) | **GET** /ng/api/ldap/ngLdapSettings | Get the NgLdap Setting
*NextgenLdapApi* | [**post_ldap_authentication_test**](docs/NextgenLdapApi.md#post_ldap_authentication_test) | **POST** /ng/api/ldap/ldap-login-test | Test LDAP authentication
*NextgenLdapApi* | [**search_ldap_groups**](docs/NextgenLdapApi.md#search_ldap_groups) | **GET** /ng/api/ldap/{ldapId}/search/group | Return Ldap groups matching name
*OIDCApi* | [**get_harness_open_id_config**](docs/OIDCApi.md#get_harness_open_id_config) | **GET** /ng/api/oidc/account/{accountId}/.wellknown/jwks | Get the openid configuration for Harness
*OIDCApi* | [**get_harness_open_id_config1**](docs/OIDCApi.md#get_harness_open_id_config1) | **GET** /ng/api/oidc/account/{accountId}/.well-known/openid-configuration | Get the openid configuration for Harness
*OidcAccessTokenApi* | [**generate_oidc_iam_role_credential_for_aws**](docs/OidcAccessTokenApi.md#generate_oidc_iam_role_credential_for_aws) | **POST** /ng/api/oidc/access-token/aws/webidentity-session-access | Generate an OIDC IAM Role Credential for AWS
*OidcAccessTokenApi* | [**get_oidc_service_account_access_token_for_gcp**](docs/OidcAccessTokenApi.md#get_oidc_service_account_access_token_for_gcp) | **POST** /ng/api/oidc/access-token/gcp/service-account-access | Generates an OIDC Service Account Access Token for GCP
*OidcAccessTokenApi* | [**oidc_workload_access_token_response**](docs/OidcAccessTokenApi.md#oidc_workload_access_token_response) | **POST** /ng/api/oidc/access-token/gcp/workload-access | Generates an OIDC Workload Access Token for GCP
*OidcIDTokenApi* | [**generate_oidc_id_token_for_aws**](docs/OidcIDTokenApi.md#generate_oidc_id_token_for_aws) | **POST** /ng/api/oidc/id-token/aws | Generates an OIDC ID Token for AWS
*OidcIDTokenApi* | [**generate_oidc_id_token_for_gcp**](docs/OidcIDTokenApi.md#generate_oidc_id_token_for_gcp) | **POST** /ng/api/oidc/id-token/gcp | Generates an OIDC ID Token for GCP
*OidcIDTokenApi* | [**generate_oidc_id_token_for_gcp1**](docs/OidcIDTokenApi.md#generate_oidc_id_token_for_gcp1) | **POST** /ng/api/oidc/id-token/gcp-v2 | Generates an OIDC ID Token for GCP
*OrgConnectorApi* | [**create_org_scoped_connector**](docs/OrgConnectorApi.md#create_org_scoped_connector) | **POST** /v1/orgs/{org}/connectors | Create a Connector
*OrgConnectorApi* | [**delete_org_scoped_connector**](docs/OrgConnectorApi.md#delete_org_scoped_connector) | **DELETE** /v1/orgs/{org}/connectors/{connector} | Delete a connector
*OrgConnectorApi* | [**get_org_scoped_connector**](docs/OrgConnectorApi.md#get_org_scoped_connector) | **GET** /v1/orgs/{org}/connectors/{connector} | Retrieve a connector
*OrgConnectorApi* | [**test_org_scoped_connector**](docs/OrgConnectorApi.md#test_org_scoped_connector) | **GET** /v1/orgs/{org}/connectors/{connector}/test-connection | Test a connector
*OrgConnectorApi* | [**update_org_scoped_connector**](docs/OrgConnectorApi.md#update_org_scoped_connector) | **PUT** /v1/orgs/{org}/connectors/{connector} | Update a connector
*OrgEnvironmentsApi* | [**create_org_scoped_environment**](docs/OrgEnvironmentsApi.md#create_org_scoped_environment) | **POST** /v1/orgs/{org}/environments | Creates an org scoped Environment
*OrgEnvironmentsApi* | [**delete_org_scoped_environment**](docs/OrgEnvironmentsApi.md#delete_org_scoped_environment) | **DELETE** /v1/orgs/{org}/environments/{environment} | Delete an org scoped Environment
*OrgEnvironmentsApi* | [**get_org_scoped_environment**](docs/OrgEnvironmentsApi.md#get_org_scoped_environment) | **GET** /v1/orgs/{org}/environments/{environment} | Retrieve an org scoped environment
*OrgEnvironmentsApi* | [**get_org_scoped_environments**](docs/OrgEnvironmentsApi.md#get_org_scoped_environments) | **GET** /v1/orgs/{org}/environments | List org scoped Environments
*OrgEnvironmentsApi* | [**update_org_scoped_environment**](docs/OrgEnvironmentsApi.md#update_org_scoped_environment) | **PUT** /v1/orgs/{org}/environments/{environment} | Update org scoped Environment
*OrgGitxWebhooksApi* | [**create_org_gitx_webhook**](docs/OrgGitxWebhooksApi.md#create_org_gitx_webhook) | **POST** /v1/orgs/{org}/gitx-webhooks | Create Org Level GitX webhook
*OrgGitxWebhooksApi* | [**delete_org_gitx_webhook**](docs/OrgGitxWebhooksApi.md#delete_org_gitx_webhook) | **DELETE** /v1/orgs/{org}/gitx-webhooks/{gitx-webhook} | Deletes a GitX Webhook at org level
*OrgGitxWebhooksApi* | [**get_org_gitx_webhook**](docs/OrgGitxWebhooksApi.md#get_org_gitx_webhook) | **GET** /v1/orgs/{org}/gitx-webhooks/{gitx-webhook} | Fetch GitX Webhook at org level
*OrgGitxWebhooksApi* | [**list_org_gitx_webhooks**](docs/OrgGitxWebhooksApi.md#list_org_gitx_webhooks) | **GET** /v1/orgs/{org}/gitx-webhooks | Lists all the GitX Webhooks at Org level
*OrgGitxWebhooksApi* | [**update_org_gitx_webhook**](docs/OrgGitxWebhooksApi.md#update_org_gitx_webhook) | **PUT** /v1/orgs/{org}/gitx-webhooks/{gitx-webhook} | Updates a GitX Webhook at org level
*OrgInfrastructuresApi* | [**create_org_scoped_infrastructure**](docs/OrgInfrastructuresApi.md#create_org_scoped_infrastructure) | **POST** /v1/orgs/{org}/environments/{environment}/infrastructures | Creates an org scoped Infrastructure
*OrgInfrastructuresApi* | [**delete_org_scoped_infrastructure**](docs/OrgInfrastructuresApi.md#delete_org_scoped_infrastructure) | **DELETE** /v1/orgs/{org}/environments/{environment}/infrastructures/{infrastructure-definition} | Delete an org scoped Infrastructure
*OrgInfrastructuresApi* | [**get_org_scoped_infrastructure**](docs/OrgInfrastructuresApi.md#get_org_scoped_infrastructure) | **GET** /v1/orgs/{org}/environments/{environment}/infrastructures/{infrastructure-definition} | Retrieve an org scoped Infrastructure
*OrgInfrastructuresApi* | [**get_org_scoped_infrastructures**](docs/OrgInfrastructuresApi.md#get_org_scoped_infrastructures) | **GET** /v1/orgs/{org}/environments/{environment}/infrastructures | List org scoped Infrastructures
*OrgInfrastructuresApi* | [**update_org_scoped_infrastructure**](docs/OrgInfrastructuresApi.md#update_org_scoped_infrastructure) | **PUT** /v1/orgs/{org}/environments/{environment}/infrastructures/{infrastructure-definition} | Update org scoped Infrastructure
*OrgProjectApi* | [**create_org_scoped_project**](docs/OrgProjectApi.md#create_org_scoped_project) | **POST** /v1/orgs/{org}/projects | Create a project
*OrgProjectApi* | [**delete_org_scoped_project**](docs/OrgProjectApi.md#delete_org_scoped_project) | **DELETE** /v1/orgs/{org}/projects/{project} | Delete a project
*OrgProjectApi* | [**get_org_scoped_project**](docs/OrgProjectApi.md#get_org_scoped_project) | **GET** /v1/orgs/{org}/projects/{project} | Retrieve a project
*OrgProjectApi* | [**get_org_scoped_projects**](docs/OrgProjectApi.md#get_org_scoped_projects) | **GET** /v1/orgs/{org}/projects | List projects
*OrgProjectApi* | [**update_org_scoped_project**](docs/OrgProjectApi.md#update_org_scoped_project) | **PUT** /v1/orgs/{org}/projects/{project} | Update a project
*OrgRancherInfrastructureApi* | [**list_org_scoped_rancher_clusters_using_connector**](docs/OrgRancherInfrastructureApi.md#list_org_scoped_rancher_clusters_using_connector) | **GET** /v1/orgs/{org}/rancher/connectors/{connector}/clusters | List rancher clusters using org level connector
*OrgRancherInfrastructureApi* | [**list_org_scoped_rancher_clusters_using_env_and_infra**](docs/OrgRancherInfrastructureApi.md#list_org_scoped_rancher_clusters_using_env_and_infra) | **GET** /v1/orgs/{org}/rancher/environments/{environment}/infrastructure-definitions/{infrastructure-definition}/clusters | List rancher clusters using org level env and infra def
*OrgRoleAssignmentsApi* | [**create_org_scoped_role_assignments**](docs/OrgRoleAssignmentsApi.md#create_org_scoped_role_assignments) | **POST** /v1/orgs/{org}/role-assignments | Create a role assignment
*OrgRoleAssignmentsApi* | [**delete_org_scoped_role_assignment**](docs/OrgRoleAssignmentsApi.md#delete_org_scoped_role_assignment) | **DELETE** /v1/orgs/{org}/role-assignments/{role-assignment} | Delete a role assignment
*OrgRoleAssignmentsApi* | [**get_org_scoped_role_assignment**](docs/OrgRoleAssignmentsApi.md#get_org_scoped_role_assignment) | **GET** /v1/orgs/{org}/role-assignments/{role-assignment} | Retrieve a role assignment
*OrgRoleAssignmentsApi* | [**get_org_scoped_role_assignments**](docs/OrgRoleAssignmentsApi.md#get_org_scoped_role_assignments) | **GET** /v1/orgs/{org}/role-assignments | List role assignments
*OrgSecretApi* | [**create_org_scoped_secret**](docs/OrgSecretApi.md#create_org_scoped_secret) | **POST** /v1/orgs/{org}/secrets | Create a secret
*OrgSecretApi* | [**delete_org_scoped_secret**](docs/OrgSecretApi.md#delete_org_scoped_secret) | **DELETE** /v1/orgs/{org}/secrets/{secret} | Delete a secret
*OrgSecretApi* | [**get_org_scoped_secret**](docs/OrgSecretApi.md#get_org_scoped_secret) | **GET** /v1/orgs/{org}/secrets/{secret} | Retrieve a secret
*OrgSecretApi* | [**get_org_scoped_secrets**](docs/OrgSecretApi.md#get_org_scoped_secrets) | **GET** /v1/orgs/{org}/secrets | List secrets
*OrgSecretApi* | [**update_org_scoped_secret**](docs/OrgSecretApi.md#update_org_scoped_secret) | **PUT** /v1/orgs/{org}/secrets/{secret} | Update a secret
*OrgSecretApi* | [**validate_org_secret_ref**](docs/OrgSecretApi.md#validate_org_secret_ref) | **POST** /v1/orgs/{org}/secrets/validate-secret-ref | Validate secret reference
*OrgServicesApi* | [**create_org_scoped_service**](docs/OrgServicesApi.md#create_org_scoped_service) | **POST** /v1/orgs/{org}/services | Create a service
*OrgServicesApi* | [**delete_org_scoped_service**](docs/OrgServicesApi.md#delete_org_scoped_service) | **DELETE** /v1/orgs/{org}/services/{service} | Delete a service
*OrgServicesApi* | [**get_org_scoped_service**](docs/OrgServicesApi.md#get_org_scoped_service) | **GET** /v1/orgs/{org}/services/{service} | Retrieve a service
*OrgServicesApi* | [**get_org_scoped_services**](docs/OrgServicesApi.md#get_org_scoped_services) | **GET** /v1/orgs/{org}/services | List Services
*OrgServicesApi* | [**update_org_scoped_service**](docs/OrgServicesApi.md#update_org_scoped_service) | **PUT** /v1/orgs/{org}/services/{service} | Update Service
*OrgTemplateApi* | [**create_templates_org**](docs/OrgTemplateApi.md#create_templates_org) | **POST** /v1/orgs/{org}/templates | Create Template
*OrgTemplateApi* | [**delete_template_org**](docs/OrgTemplateApi.md#delete_template_org) | **DELETE** /v1/orgs/{org}/templates/{template}/versions/{version} | Delete Template
*OrgTemplateApi* | [**get_template_org**](docs/OrgTemplateApi.md#get_template_org) | **GET** /v1/orgs/{org}/templates/{template}/versions/{version} | Retrieve a Template
*OrgTemplateApi* | [**get_template_stable_org**](docs/OrgTemplateApi.md#get_template_stable_org) | **GET** /v1/orgs/{org}/templates/{template} | Get Stable Template
*OrgTemplateApi* | [**get_templates_list_org**](docs/OrgTemplateApi.md#get_templates_list_org) | **GET** /v1/orgs/{org}/templates | Get Templates List
*OrgTemplateApi* | [**import_template_org**](docs/OrgTemplateApi.md#import_template_org) | **POST** /v1/orgs/{org}/templates/{template}/import | Import template
*OrgTemplateApi* | [**update_git_metadata_details_org**](docs/OrgTemplateApi.md#update_git_metadata_details_org) | **PUT** /v1/orgs/{org}/templates/git-metadata/{template} | Update Git details
*OrgTemplateApi* | [**update_template_org**](docs/OrgTemplateApi.md#update_template_org) | **PUT** /v1/orgs/{org}/templates/{template}/versions/{version} | Update Template
*OrgTemplateApi* | [**update_template_stable_org**](docs/OrgTemplateApi.md#update_template_stable_org) | **PUT** /v1/orgs/{org}/templates/{template}/versions/{version}/stable | Update Stable Template
*OrganizationApi* | [**create_organization**](docs/OrganizationApi.md#create_organization) | **POST** /v1/orgs | Create an organization [Beta]
*OrganizationApi* | [**delete_organization**](docs/OrganizationApi.md#delete_organization) | **DELETE** /v1/orgs/{org} | Delete an organization [Beta]
*OrganizationApi* | [**delete_organization_0**](docs/OrganizationApi.md#delete_organization_0) | **DELETE** /ng/api/organizations/{identifier} | Delete an Organization
*OrganizationApi* | [**get_organization**](docs/OrganizationApi.md#get_organization) | **GET** /v1/orgs/{org} | Retrieve an organization [Beta]
*OrganizationApi* | [**get_organization_0**](docs/OrganizationApi.md#get_organization_0) | **GET** /ng/api/organizations/{identifier} | List Organization details
*OrganizationApi* | [**get_organization_list**](docs/OrganizationApi.md#get_organization_list) | **GET** /ng/api/organizations | List Organizations by filter
*OrganizationApi* | [**get_organizations**](docs/OrganizationApi.md#get_organizations) | **GET** /v1/orgs | List organizations [Beta]
*OrganizationApi* | [**post_organization**](docs/OrganizationApi.md#post_organization) | **POST** /ng/api/organizations | Create an Organization
*OrganizationApi* | [**put_organization**](docs/OrganizationApi.md#put_organization) | **PUT** /ng/api/organizations/{identifier} | Update an Organization
*OrganizationApi* | [**update_organization**](docs/OrganizationApi.md#update_organization) | **PUT** /v1/orgs/{org} | Update an organization [Beta]
*OrganizationResourceGroupsApi* | [**create_resource_group_org**](docs/OrganizationResourceGroupsApi.md#create_resource_group_org) | **POST** /v1/orgs/{org}/resource-groups | Create a Resource Group
*OrganizationResourceGroupsApi* | [**delete_resource_group_org**](docs/OrganizationResourceGroupsApi.md#delete_resource_group_org) | **DELETE** /v1/orgs/{org}/resource-groups/{resource-group} | Delete a Resource Group
*OrganizationResourceGroupsApi* | [**get_resource_group_org**](docs/OrganizationResourceGroupsApi.md#get_resource_group_org) | **GET** /v1/orgs/{org}/resource-groups/{resource-group} | Retrieve a Resource Group
*OrganizationResourceGroupsApi* | [**list_resource_groups_org**](docs/OrganizationResourceGroupsApi.md#list_resource_groups_org) | **GET** /v1/orgs/{org}/resource-groups | List Resource Groups
*OrganizationResourceGroupsApi* | [**update_resource_group_org**](docs/OrganizationResourceGroupsApi.md#update_resource_group_org) | **PUT** /v1/orgs/{org}/resource-groups/{resource-group} | Update a Resource Group
*OrganizationRolesApi* | [**create_role_org**](docs/OrganizationRolesApi.md#create_role_org) | **POST** /v1/orgs/{org}/roles | Create a Role
*OrganizationRolesApi* | [**delete_role_org**](docs/OrganizationRolesApi.md#delete_role_org) | **DELETE** /v1/orgs/{org}/roles/{role} | Delete a Role
*OrganizationRolesApi* | [**get_role_org**](docs/OrganizationRolesApi.md#get_role_org) | **GET** /v1/orgs/{org}/roles/{role} | Retrieve a Role
*OrganizationRolesApi* | [**list_roles_org**](docs/OrganizationRolesApi.md#list_roles_org) | **GET** /v1/orgs/{org}/roles | List Roles
*OrganizationRolesApi* | [**update_role_org**](docs/OrganizationRolesApi.md#update_role_org) | **PUT** /v1/orgs/{org}/roles/{role} | Update a Role
*OverridesApi* | [**create_override**](docs/OverridesApi.md#create_override) | **POST** /ng/api/overrides | Create an Override Entity
*OverridesApi* | [**delete_override**](docs/OverridesApi.md#delete_override) | **DELETE** /ng/api/overrides/{identifier} | Delete a Override entity
*OverridesApi* | [**get_overrides_via_identifier**](docs/OverridesApi.md#get_overrides_via_identifier) | **GET** /ng/api/overrides/{identifier} | Gets Overrides by Identifier
*OverridesApi* | [**override_move_configs**](docs/OverridesApi.md#override_move_configs) | **POST** /ng/api/overrides/move-config | Move Override YAML from inline to remote or remote to inline
*OverridesApi* | [**update_override**](docs/OverridesApi.md#update_override) | **PUT** /ng/api/overrides | Update an Override Entity
*OverridesApi* | [**update_override_git_details**](docs/OverridesApi.md#update_override_git_details) | **PUT** /ng/api/overrides/update-git-metadata | Update git-metadata in remote Override Entity
*PermissionsApi* | [**get_permission_list**](docs/PermissionsApi.md#get_permission_list) | **GET** /authz/api/permissions | List Permissions
*PermissionsApi* | [**get_permission_resource_types_list**](docs/PermissionsApi.md#get_permission_resource_types_list) | **GET** /authz/api/permissions/resourcetypes | List Resource Types
*PipelineApi* | [**delete_pipeline**](docs/PipelineApi.md#delete_pipeline) | **DELETE** /pipeline/api/pipelines/{pipelineIdentifier} | Delete a Pipeline
*PipelineApi* | [**get_pipeline**](docs/PipelineApi.md#get_pipeline) | **GET** /pipeline/api/pipelines/{pipelineIdentifier} | Fetch a Pipeline
*PipelineApi* | [**get_pipeline_list**](docs/PipelineApi.md#get_pipeline_list) | **POST** /pipeline/api/pipelines/list | List Pipelines
*PipelineApi* | [**get_pipeline_summary**](docs/PipelineApi.md#get_pipeline_summary) | **GET** /pipeline/api/pipelines/summary/{pipelineIdentifier} | Fetch Pipeline Summary
*PipelineApi* | [**import_pipeline**](docs/PipelineApi.md#import_pipeline) | **POST** /pipeline/api/pipelines/import | Import and Create Pipeline from Git Repository
*PipelineApi* | [**import_pipeline1**](docs/PipelineApi.md#import_pipeline1) | **POST** /pipeline/api/pipelines/import/{pipelineIdentifier} | Import and Create Pipeline from Git Repository
*PipelineApi* | [**pipelineget_file**](docs/PipelineApi.md#pipelineget_file) | **GET** /pipeline/api/input-file/file/{planExecutionId} | Returns a file uploaded or filtered based on the fileIdentifier provided for a given nodeExecutionId
*PipelineApi* | [**post_pipeline**](docs/PipelineApi.md#post_pipeline) | **POST** /pipeline/api/pipelines | Create a Pipeline
*PipelineApi* | [**post_pipeline_v2**](docs/PipelineApi.md#post_pipeline_v2) | **POST** /pipeline/api/pipelines/v2 | Create a Pipeline
*PipelineApi* | [**update_pipeline**](docs/PipelineApi.md#update_pipeline) | **PUT** /pipeline/api/pipelines/{pipelineIdentifier} | Update a Pipeline
*PipelineApi* | [**update_pipeline_git_details**](docs/PipelineApi.md#update_pipeline_git_details) | **PUT** /pipeline/api/pipelines/{pipelineIdentifier}/update-git-metadata | Update git-metadata in remote pipeline Entity
*PipelineApi* | [**update_pipeline_v2**](docs/PipelineApi.md#update_pipeline_v2) | **PUT** /pipeline/api/pipelines/v2/{pipelineIdentifier} | Update a Pipeline
*PipelineDashboardApi* | [**get_pipeline_execution**](docs/PipelineDashboardApi.md#get_pipeline_execution) | **GET** /pipeline/api/pipelines/pipelineExecution | Fetch Execution Details for an Interval
*PipelineExecuteApi* | [**handle_stage_interrupt**](docs/PipelineExecuteApi.md#handle_stage_interrupt) | **PUT** /pipeline/api/pipeline/execute/interrupt/{planExecutionId}/{nodeExecutionId} | Handles the interrupt for a given stage in a pipeline
*PipelineExecuteApi* | [**post_execute_stages**](docs/PipelineExecuteApi.md#post_execute_stages) | **POST** /pipeline/api/pipeline/execute/{identifier}/stages | Execute given Stages of a Pipeline
*PipelineExecuteApi* | [**post_pipeline_execute_with_input_set_list**](docs/PipelineExecuteApi.md#post_pipeline_execute_with_input_set_list) | **POST** /pipeline/api/pipeline/execute/{identifier}/inputSetList | Execute a Pipeline with Input Set References
*PipelineExecuteApi* | [**post_pipeline_execute_with_input_set_yaml**](docs/PipelineExecuteApi.md#post_pipeline_execute_with_input_set_yaml) | **POST** /pipeline/api/pipeline/execute/{identifier} | Execute a Pipeline with Runtime Input YAML
*PipelineExecuteApi* | [**put_handle_interrupt**](docs/PipelineExecuteApi.md#put_handle_interrupt) | **PUT** /pipeline/api/pipeline/execute/interrupt/{planExecutionId} | Execute an Interrupt
*PipelineExecuteApi* | [**retry_history**](docs/PipelineExecuteApi.md#retry_history) | **GET** /pipeline/api/pipeline/execute/retryHistory/{planExecutionId} | Retry History for a given execution
*PipelineExecuteApi* | [**retry_pipeline**](docs/PipelineExecuteApi.md#retry_pipeline) | **POST** /pipeline/api/pipeline/execute/retry/{identifier} | Retry a executed pipeline with inputSet pipeline yaml
*PipelineExecutionApi* | [**execute_pipeline**](docs/PipelineExecutionApi.md#execute_pipeline) | **POST** /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/execute | Execute Pipeline
*PipelineExecutionApi* | [**execute_stages_with_input_yaml**](docs/PipelineExecutionApi.md#execute_stages_with_input_yaml) | **POST** /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/execute/stages | Execute given Stages of a Pipeline
*PipelineExecutionApi* | [**get_stages_execution_list**](docs/PipelineExecutionApi.md#get_stages_execution_list) | **GET** /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/execute/stages-execution-list | Get Stages execution List for a given Pipeline execution.
*PipelineExecutionApi* | [**rerun_stages_execution_of_pipeline**](docs/PipelineExecutionApi.md#rerun_stages_execution_of_pipeline) | **POST** /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/execute/rerun/{execution-id}/stages | Re-run Stages Execution of a Pipeline
*PipelineExecutionDetailsApi* | [**get_execution_detail**](docs/PipelineExecutionDetailsApi.md#get_execution_detail) | **GET** /pipeline/api/pipelines/execution/{planExecutionId} | Fetch Execution Details
*PipelineExecutionDetailsApi* | [**get_execution_detail_v2**](docs/PipelineExecutionDetailsApi.md#get_execution_detail_v2) | **GET** /pipeline/api/pipelines/execution/v2/{planExecutionId} | Fetch Execution Details
*PipelineExecutionDetailsApi* | [**get_execution_sub_graph_for_node_execution**](docs/PipelineExecutionDetailsApi.md#get_execution_sub_graph_for_node_execution) | **GET** /pipeline/api/pipelines/execution/subGraph/{planExecutionId}/{nodeExecutionId} | Fetch Execution SubGraph for a Given Retried StepGroup NodeExecution ID
*PipelineExecutionDetailsApi* | [**get_execution_url**](docs/PipelineExecutionDetailsApi.md#get_execution_url) | **POST** /pipeline/api/pipelines/execution/url | Fetch Execution Url
*PipelineExecutionDetailsApi* | [**get_inputset_yaml_v2**](docs/PipelineExecutionDetailsApi.md#get_inputset_yaml_v2) | **GET** /pipeline/api/pipelines/execution/{planExecutionId}/inputsetV2 | Get the Input Set YAML used for given Plan Execution
*PipelineExecutionDetailsApi* | [**get_list_of_execution_identifier**](docs/PipelineExecutionDetailsApi.md#get_list_of_execution_identifier) | **POST** /pipeline/api/pipelines/execution/executionSummary | List Execution Identifier
*PipelineExecutionDetailsApi* | [**get_list_of_executions**](docs/PipelineExecutionDetailsApi.md#get_list_of_executions) | **POST** /pipeline/api/pipelines/execution/summary | List Executions
*PipelineExecutionDetailsApi* | [**get_list_of_executions_outline**](docs/PipelineExecutionDetailsApi.md#get_list_of_executions_outline) | **POST** /pipeline/api/pipelines/execution/summary/outline | List Executions Outline
*PipelineExecutionDetailsApi* | [**get_notes_for_execution**](docs/PipelineExecutionDetailsApi.md#get_notes_for_execution) | **GET** /pipeline/api/pipelines/execution/{planExecutionId}/notes | Get Notes for a pipelineExecution
*PipelineExecutionDetailsApi* | [**update_notes_for_execution**](docs/PipelineExecutionDetailsApi.md#update_notes_for_execution) | **PUT** /pipeline/api/pipelines/execution/{planExecutionId}/notes | Updates Notes for a pipelineExecution
*PipelineInputSetApi* | [**delete_input_set**](docs/PipelineInputSetApi.md#delete_input_set) | **DELETE** /pipeline/api/inputSets/{inputSetIdentifier} | Delete an Input Set
*PipelineInputSetApi* | [**get_input_set**](docs/PipelineInputSetApi.md#get_input_set) | **GET** /pipeline/api/inputSets/{inputSetIdentifier} | Fetch an Input Set
*PipelineInputSetApi* | [**get_overlay_input_set**](docs/PipelineInputSetApi.md#get_overlay_input_set) | **GET** /pipeline/api/inputSets/overlay/{inputSetIdentifier} | Gets an Overlay Input Set by identifier
*PipelineInputSetApi* | [**list_input_set**](docs/PipelineInputSetApi.md#list_input_set) | **GET** /pipeline/api/inputSets | List Input Sets
*PipelineInputSetApi* | [**post_input_set**](docs/PipelineInputSetApi.md#post_input_set) | **POST** /pipeline/api/inputSets | Create an Input Set
*PipelineInputSetApi* | [**post_overlay_input_set**](docs/PipelineInputSetApi.md#post_overlay_input_set) | **POST** /pipeline/api/inputSets/overlay | Create an Overlay Input Set for a pipeline
*PipelineInputSetApi* | [**put_input_set**](docs/PipelineInputSetApi.md#put_input_set) | **PUT** /pipeline/api/inputSets/{inputSetIdentifier} | Update an Input Set
*PipelineInputSetApi* | [**put_overlay_input_set**](docs/PipelineInputSetApi.md#put_overlay_input_set) | **PUT** /pipeline/api/inputSets/overlay/{inputSetIdentifier} | Update an Overlay Input Set for a pipeline
*PipelineInputSetApi* | [**runtime_input_template**](docs/PipelineInputSetApi.md#runtime_input_template) | **POST** /pipeline/api/inputSets/template | Fetch Runtime Input Template
*PipelineInputSetApi* | [**update_input_set_git_details**](docs/PipelineInputSetApi.md#update_input_set_git_details) | **PUT** /pipeline/api/inputSets/{inputSetIdentifier}/update-git-metadata | Update git-metadata in remote input-set
*PipelineRefreshApi* | [**refresh_all_templates_inputs_in_pipeline**](docs/PipelineRefreshApi.md#refresh_all_templates_inputs_in_pipeline) | **POST** /pipeline/api/refresh-template/refresh-all | This recursively refresh and update template inputs in pipeline
*PipelineRefreshApi* | [**validate_template_inputs**](docs/PipelineRefreshApi.md#validate_template_inputs) | **GET** /pipeline/api/refresh-template/validate-template-inputs | Validates template inputs in a pipeline&#x27;s YAML specification.
*PipelineDataRetentionApi* | [**get_retention_period_in_months**](docs/PipelineDataRetentionApi.md#get_retention_period_in_months) | **GET** /pipeline/api/pipelines/retention/{accountIdentifier} | Get retention period for pipeline executions
*PipelinesApi* | [**create_pipeline**](docs/PipelinesApi.md#create_pipeline) | **POST** /v1/orgs/{org}/projects/{project}/pipelines | Create a Pipeline
*PipelinesApi* | [**delete_pipeline**](docs/PipelinesApi.md#delete_pipeline) | **DELETE** /v1/orgs/{org}/projects/{project}/pipelines/{pipeline} | Delete a Pipeline
*PipelinesApi* | [**get_pipeline**](docs/PipelinesApi.md#get_pipeline) | **GET** /v1/orgs/{org}/projects/{project}/pipelines/{pipeline} | Retrieve a Pipeline
*PipelinesApi* | [**import_pipeline_from_git**](docs/PipelinesApi.md#import_pipeline_from_git) | **POST** /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/import | Get Pipeline YAML from Git Repository
*PipelinesApi* | [**list_pipelines**](docs/PipelinesApi.md#list_pipelines) | **GET** /v1/orgs/{org}/projects/{project}/pipelines | List Pipelines
*PipelinesApi* | [**move_config**](docs/PipelinesApi.md#move_config) | **POST** /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/move-config | Move Pipeline YAML from inline to remote
*PipelinesApi* | [**patch_pipeline**](docs/PipelinesApi.md#patch_pipeline) | **PATCH** /v1/orgs/{org}/projects/{project}/pipelines/{pipeline} | Patch API for pipeline
*PipelinesApi* | [**update_pipeline**](docs/PipelinesApi.md#update_pipeline) | **PUT** /v1/orgs/{org}/projects/{project}/pipelines/{pipeline} | Update a Pipeline
*PipelinesApi* | [**update_pipeline_git_metadata**](docs/PipelinesApi.md#update_pipeline_git_metadata) | **PUT** /v1/orgs/{org}/projects/{project}/pipelines/{pipeline}/git-metadata | Update GitMetadata for Remote Pipelines
*PluginInfoApi* | [**get_plugin_request**](docs/PluginInfoApi.md#get_plugin_request) | **GET** /v1/plugin/request | Get all plugin requests for an account
*PluginInfoApi* | [**get_plugins**](docs/PluginInfoApi.md#get_plugins) | **GET** /v1/plugins-info | List Available Plugins
*PluginInfoApi* | [**get_plugins_info_plugin_id**](docs/PluginInfoApi.md#get_plugins_info_plugin_id) | **GET** /v1/plugins-info/{plugin-id} | Get Plugin
*PluginInfoApi* | [**post_plugin_request**](docs/PluginInfoApi.md#post_plugin_request) | **POST** /v1/plugin/request | Request for a Plugin
*ProductsApi* | [**products_find_product_by_id**](docs/ProductsApi.md#products_find_product_by_id) | **GET** /sto/api/v2/products/{id} | 
*ProductsApi* | [**products_list_products**](docs/ProductsApi.md#products_list_products) | **GET** /sto/api/v2/products | 
*ProjectApi* | [**delete_project**](docs/ProjectApi.md#delete_project) | **DELETE** /ng/api/projects/{identifier} | Delete a Project
*ProjectApi* | [**get_project**](docs/ProjectApi.md#get_project) | **GET** /ng/api/projects/{identifier} | List Project details
*ProjectApi* | [**get_project_list**](docs/ProjectApi.md#get_project_list) | **GET** /ng/api/projects | List all Projects for a user
*ProjectApi* | [**get_project_list_with_multi_org_filter**](docs/ProjectApi.md#get_project_list_with_multi_org_filter) | **GET** /ng/api/projects/list | List user&#x27;s project with support to filter by multiple organizations
*ProjectApi* | [**post_project**](docs/ProjectApi.md#post_project) | **POST** /ng/api/projects | Create a Project
*ProjectApi* | [**put_project**](docs/ProjectApi.md#put_project) | **PUT** /ng/api/projects/{identifier} | Update a Project
*ProjectConnectorApi* | [**create_project_scoped_connector**](docs/ProjectConnectorApi.md#create_project_scoped_connector) | **POST** /v1/orgs/{org}/projects/{project}/connectors | Create a Connector
*ProjectConnectorApi* | [**delete_project_scoped_connector**](docs/ProjectConnectorApi.md#delete_project_scoped_connector) | **DELETE** /v1/orgs/{org}/projects/{project}/connectors/{connector} | Delete a connector
*ProjectConnectorApi* | [**get_project_scoped_connector**](docs/ProjectConnectorApi.md#get_project_scoped_connector) | **GET** /v1/orgs/{org}/projects/{project}/connectors/{connector} | Retrieve a connector
*ProjectConnectorApi* | [**test_project_scoped_connector**](docs/ProjectConnectorApi.md#test_project_scoped_connector) | **GET** /v1/orgs/{org}/projects/{project}/connectors/{connector}/test-connection | Test a connector
*ProjectConnectorApi* | [**update_project_scoped_connector**](docs/ProjectConnectorApi.md#update_project_scoped_connector) | **PUT** /v1/orgs/{org}/projects/{project}/connectors/{connector} | Update a connector
*ProjectEnvironmentsApi* | [**create_environment**](docs/ProjectEnvironmentsApi.md#create_environment) | **POST** /v1/orgs/{org}/projects/{project}/environments | Creates an Environment
*ProjectEnvironmentsApi* | [**delete_environment**](docs/ProjectEnvironmentsApi.md#delete_environment) | **DELETE** /v1/orgs/{org}/projects/{project}/environments/{environment} | Delete a Environment
*ProjectEnvironmentsApi* | [**get_environment**](docs/ProjectEnvironmentsApi.md#get_environment) | **GET** /v1/orgs/{org}/projects/{project}/environments/{environment} | Retrieve a environment
*ProjectEnvironmentsApi* | [**get_environments**](docs/ProjectEnvironmentsApi.md#get_environments) | **GET** /v1/orgs/{org}/projects/{project}/environments | List Environments
*ProjectEnvironmentsApi* | [**update_environment**](docs/ProjectEnvironmentsApi.md#update_environment) | **PUT** /v1/orgs/{org}/projects/{project}/environments/{environment} | Update Environment
*ProjectGitxWebhooksApi* | [**create_project_gitx_webhook**](docs/ProjectGitxWebhooksApi.md#create_project_gitx_webhook) | **POST** /v1/orgs/{org}/projects/{project}/gitx-webhooks | Create Project level GitX webhook
*ProjectGitxWebhooksApi* | [**delete_project_gitx_webhook**](docs/ProjectGitxWebhooksApi.md#delete_project_gitx_webhook) | **DELETE** /v1/orgs/{org}/projects/{project}/gitx-webhooks/{gitx-webhook} | Deletes a GitX Webhook at project level
*ProjectGitxWebhooksApi* | [**get_project_gitx_webhook**](docs/ProjectGitxWebhooksApi.md#get_project_gitx_webhook) | **GET** /v1/orgs/{org}/projects/{project}/gitx-webhooks/{gitx-webhook} | Fetch GitX Webhook at project level
*ProjectGitxWebhooksApi* | [**list_project_gitx_webhook**](docs/ProjectGitxWebhooksApi.md#list_project_gitx_webhook) | **GET** /v1/orgs/{org}/projects/{project}/gitx-webhooks | Lists all the GitX Webhooks at project level
*ProjectGitxWebhooksApi* | [**update_project_gitx_webhook**](docs/ProjectGitxWebhooksApi.md#update_project_gitx_webhook) | **PUT** /v1/orgs/{org}/projects/{project}/gitx-webhooks/{gitx-webhook} | Updates a GitX Webhook at project level
*ProjectInfrastructuresApi* | [**create_infrastructure**](docs/ProjectInfrastructuresApi.md#create_infrastructure) | **POST** /v1/orgs/{org}/projects/{project}/environments/{environment}/infrastructures | Creates an Infrastructure
*ProjectInfrastructuresApi* | [**delete_infrastructure**](docs/ProjectInfrastructuresApi.md#delete_infrastructure) | **DELETE** /v1/orgs/{org}/projects/{project}/environments/{environment}/infrastructures/{infrastructure-definition} | Delete a Infrastructure
*ProjectInfrastructuresApi* | [**get_infrastructure**](docs/ProjectInfrastructuresApi.md#get_infrastructure) | **GET** /v1/orgs/{org}/projects/{project}/environments/{environment}/infrastructures/{infrastructure-definition} | Retrieve a infrastructure
*ProjectInfrastructuresApi* | [**get_infrastructures**](docs/ProjectInfrastructuresApi.md#get_infrastructures) | **GET** /v1/orgs/{org}/projects/{project}/environments/{environment}/infrastructures | List Infrastructures
*ProjectInfrastructuresApi* | [**update_infrastructure**](docs/ProjectInfrastructuresApi.md#update_infrastructure) | **PUT** /v1/orgs/{org}/projects/{project}/environments/{environment}/infrastructures/{infrastructure-definition} | Update Infrastructure
*ProjectRancherInfrastructureApi* | [**list_project_scoped_rancher_clusters_using_connector**](docs/ProjectRancherInfrastructureApi.md#list_project_scoped_rancher_clusters_using_connector) | **GET** /v1/orgs/{org}/projects/{project}/rancher/connectors/{connector}/clusters | List rancher clusters using project level connector
*ProjectRancherInfrastructureApi* | [**list_project_scoped_rancher_clusters_using_env_and_infra**](docs/ProjectRancherInfrastructureApi.md#list_project_scoped_rancher_clusters_using_env_and_infra) | **GET** /v1/orgs/{org}/projects/{project}/rancher/environments/{environment}/infrastructure-definitions/{infrastructure-definition}/clusters | List rancher clusters using project level env and infra def
*ProjectResourceGroupsApi* | [**create_resource_group_project**](docs/ProjectResourceGroupsApi.md#create_resource_group_project) | **POST** /v1/orgs/{org}/projects/{project}/resource-groups | Create a Resource Group
*ProjectResourceGroupsApi* | [**delete_resource_group_project**](docs/ProjectResourceGroupsApi.md#delete_resource_group_project) | **DELETE** /v1/orgs/{org}/projects/{project}/resource-groups/{resource-group} | Delete a Resource Group
*ProjectResourceGroupsApi* | [**get_resource_group_project**](docs/ProjectResourceGroupsApi.md#get_resource_group_project) | **GET** /v1/orgs/{org}/projects/{project}/resource-groups/{resource-group} | Retrieve a Resource Group
*ProjectResourceGroupsApi* | [**list_resource_groups_project**](docs/ProjectResourceGroupsApi.md#list_resource_groups_project) | **GET** /v1/orgs/{org}/projects/{project}/resource-groups | List Resource Groups
*ProjectResourceGroupsApi* | [**update_resource_group_project**](docs/ProjectResourceGroupsApi.md#update_resource_group_project) | **PUT** /v1/orgs/{org}/projects/{project}/resource-groups/{resource-group} | Update a Resource Group
*ProjectRoleAssignmentsApi* | [**create_project_scoped_role_assignments**](docs/ProjectRoleAssignmentsApi.md#create_project_scoped_role_assignments) | **POST** /v1/orgs/{org}/projects/{project}/role-assignments | Create a role assignment
*ProjectRoleAssignmentsApi* | [**delete_project_scoped_role_assignment**](docs/ProjectRoleAssignmentsApi.md#delete_project_scoped_role_assignment) | **DELETE** /v1/orgs/{org}/projects/{project}/role-assignments/{role-assignment} | Delete a role assignment
*ProjectRoleAssignmentsApi* | [**get_project_scoped_role_assignment**](docs/ProjectRoleAssignmentsApi.md#get_project_scoped_role_assignment) | **GET** /v1/orgs/{org}/projects/{project}/role-assignments/{role-assignment} | Retrieve a role assignment
*ProjectRoleAssignmentsApi* | [**get_project_scoped_role_assignments**](docs/ProjectRoleAssignmentsApi.md#get_project_scoped_role_assignments) | **GET** /v1/orgs/{org}/projects/{project}/role-assignments | List role assignments
*ProjectRolesApi* | [**create_role_project**](docs/ProjectRolesApi.md#create_role_project) | **POST** /v1/orgs/{org}/projects/{project}/roles | Create a Role
*ProjectRolesApi* | [**delete_role_project**](docs/ProjectRolesApi.md#delete_role_project) | **DELETE** /v1/orgs/{org}/projects/{project}/roles/{role} | Delete a Role
*ProjectRolesApi* | [**get_role_project**](docs/ProjectRolesApi.md#get_role_project) | **GET** /v1/orgs/{org}/projects/{project}/roles/{role} | Retrieve a Role
*ProjectRolesApi* | [**list_roles_project**](docs/ProjectRolesApi.md#list_roles_project) | **GET** /v1/orgs/{org}/projects/{project}/roles | List Roles
*ProjectRolesApi* | [**update_role_project**](docs/ProjectRolesApi.md#update_role_project) | **PUT** /v1/orgs/{org}/projects/{project}/roles/{role} | Update a Role
*ProjectSecretApi* | [**create_project_scoped_secret**](docs/ProjectSecretApi.md#create_project_scoped_secret) | **POST** /v1/orgs/{org}/projects/{project}/secrets | Create a secret
*ProjectSecretApi* | [**delete_project_scoped_secret**](docs/ProjectSecretApi.md#delete_project_scoped_secret) | **DELETE** /v1/orgs/{org}/projects/{project}/secrets/{secret} | Delete a secret
*ProjectSecretApi* | [**get_project_scoped_secret**](docs/ProjectSecretApi.md#get_project_scoped_secret) | **GET** /v1/orgs/{org}/projects/{project}/secrets/{secret} | Retrieve a secret
*ProjectSecretApi* | [**get_project_scoped_secrets**](docs/ProjectSecretApi.md#get_project_scoped_secrets) | **GET** /v1/orgs/{org}/projects/{project}/secrets | List secrets
*ProjectSecretApi* | [**update_project_scoped_secret**](docs/ProjectSecretApi.md#update_project_scoped_secret) | **PUT** /v1/orgs/{org}/projects/{project}/secrets/{secret} | Update a secret
*ProjectSecretApi* | [**validate_project_secret_ref**](docs/ProjectSecretApi.md#validate_project_secret_ref) | **POST** /v1/orgs/{org}/projects/{project}/secrets/validate-secret-ref | Validate secret reference
*ProjectServicesApi* | [**create_service**](docs/ProjectServicesApi.md#create_service) | **POST** /v1/orgs/{org}/projects/{project}/services | Create a Service
*ProjectServicesApi* | [**delete_service**](docs/ProjectServicesApi.md#delete_service) | **DELETE** /v1/orgs/{org}/projects/{project}/services/{service} | Delete a Service
*ProjectServicesApi* | [**get_service**](docs/ProjectServicesApi.md#get_service) | **GET** /v1/orgs/{org}/projects/{project}/services/{service} | Retrieve a service
*ProjectServicesApi* | [**get_services**](docs/ProjectServicesApi.md#get_services) | **GET** /v1/orgs/{org}/projects/{project}/services | List Services
*ProjectServicesApi* | [**update_service**](docs/ProjectServicesApi.md#update_service) | **PUT** /v1/orgs/{org}/projects/{project}/services/{service} | Update Service
*ProjectTemplateApi* | [**create_templates_project**](docs/ProjectTemplateApi.md#create_templates_project) | **POST** /v1/orgs/{org}/projects/{project}/templates | Create Template
*ProjectTemplateApi* | [**delete_template_project**](docs/ProjectTemplateApi.md#delete_template_project) | **DELETE** /v1/orgs/{org}/projects/{project}/templates/{template}/versions/{version} | Delete Template
*ProjectTemplateApi* | [**get_template_project**](docs/ProjectTemplateApi.md#get_template_project) | **GET** /v1/orgs/{org}/projects/{project}/templates/{template}/versions/{version} | Retrieve a Template
*ProjectTemplateApi* | [**get_template_stable_project**](docs/ProjectTemplateApi.md#get_template_stable_project) | **GET** /v1/orgs/{org}/projects/{project}/templates/{template} | Get Stable Template
*ProjectTemplateApi* | [**get_templates_list_project**](docs/ProjectTemplateApi.md#get_templates_list_project) | **GET** /v1/orgs/{org}/projects/{project}/templates | Get Templates List
*ProjectTemplateApi* | [**import_template_project**](docs/ProjectTemplateApi.md#import_template_project) | **POST** /v1/orgs/{org}/projects/{project}/templates/{template}/import | Import Template
*ProjectTemplateApi* | [**update_git_metadata_details_project**](docs/ProjectTemplateApi.md#update_git_metadata_details_project) | **PUT** /v1/orgs/{org}/projects/{project}/templates/git-metadata/{template} | Update Git details
*ProjectTemplateApi* | [**update_template_project**](docs/ProjectTemplateApi.md#update_template_project) | **PUT** /v1/orgs/{org}/projects/{project}/templates/{template}/versions/{version} | Update Template
*ProjectTemplateApi* | [**update_template_stable_project**](docs/ProjectTemplateApi.md#update_template_stable_project) | **PUT** /v1/orgs/{org}/projects/{project}/templates/{template}/versions/{version}/stable | Update Stable Template
*ProjectMappingsApi* | [**app_project_mapping_service_create**](docs/ProjectMappingsApi.md#app_project_mapping_service_create) | **POST** /gitops/api/v1/agents/{agentIdentifier}/appprojectsmapping | Create Harness-Argo project mapping
*ProjectMappingsApi* | [**app_project_mapping_service_create_v2**](docs/ProjectMappingsApi.md#app_project_mapping_service_create_v2) | **POST** /gitops/api/v2/agents/{agentIdentifier}/appprojectsmapping | Create Harness-Argo project mapping V2
*ProjectMappingsApi* | [**app_project_mapping_service_delete**](docs/ProjectMappingsApi.md#app_project_mapping_service_delete) | **DELETE** /gitops/api/v1/agents/{agentIdentifier}/appprojectsmapping/{name} | Delete Harness-Arog project mapping
*ProjectMappingsApi* | [**app_project_mapping_service_delete_v2**](docs/ProjectMappingsApi.md#app_project_mapping_service_delete_v2) | **DELETE** /gitops/api/v2/agents/{agentIdentifier}/appprojectsmapping/{identifier} | Delete Harness-Argo project mapping
*ProjectMappingsApi* | [**app_project_mapping_service_get_app_project_mapping_list**](docs/ProjectMappingsApi.md#app_project_mapping_service_get_app_project_mapping_list) | **GET** /gitops/api/v1/appprojectsmapping | Get Harness-Argo project mappings
*ProjectMappingsApi* | [**app_project_mapping_service_get_app_project_mapping_list_by_agent**](docs/ProjectMappingsApi.md#app_project_mapping_service_get_app_project_mapping_list_by_agent) | **GET** /gitops/api/v1/agents/{agentIdentifier}/appprojectsmapping | Get Harness-Argo project mapping by agent
*ProjectMappingsApi* | [**app_project_mapping_service_get_app_project_mapping_v2**](docs/ProjectMappingsApi.md#app_project_mapping_service_get_app_project_mapping_v2) | **GET** /gitops/api/v2/agents/{agentIdentifier}/appprojectsmapping/{identifier} | Get Harness-Argo project mapping V2
*ProjectMappingsApi* | [**app_project_mapping_service_get_app_project_mappings_list_by_agent_v2**](docs/ProjectMappingsApi.md#app_project_mapping_service_get_app_project_mappings_list_by_agent_v2) | **GET** /gitops/api/v2/agents/{agentIdentifier}/appprojectsmappings | Get Harness-Argo project mapping list by agent V2
*ProjectMappingsApi* | [**app_project_mapping_service_update_v2**](docs/ProjectMappingsApi.md#app_project_mapping_service_update_v2) | **PUT** /gitops/api/v2/agents/{agentIdentifier}/appprojectsmapping/{identifier} | Update Harness-Argo project mappings V2
*ProjectsApi* | [**agent_project_service_create**](docs/ProjectsApi.md#agent_project_service_create) | **POST** /gitops/api/v1/agents/{agentIdentifier}/projects | Create a new Argo project
*ProjectsApi* | [**agent_project_service_delete**](docs/ProjectsApi.md#agent_project_service_delete) | **DELETE** /gitops/api/v1/agents/{agentIdentifier}/projects/{query.name} | Delete deletes an Argo project
*ProjectsApi* | [**agent_project_service_get**](docs/ProjectsApi.md#agent_project_service_get) | **GET** /gitops/api/v1/agents/{agentIdentifier}/projects/{query.name} | Get returns an Argo project by name
*ProjectsApi* | [**agent_project_service_list**](docs/ProjectsApi.md#agent_project_service_list) | **GET** /gitops/api/v1/agents/{agentIdentifier}/projects | List returns list of Argo projects
*ProjectsApi* | [**agent_project_service_update**](docs/ProjectsApi.md#agent_project_service_update) | **PUT** /gitops/api/v1/agents/{agentIdentifier}/projects/{request.project.metadata.name} | Update updates an Argo project
*ProviderApi* | [**create_provider**](docs/ProviderApi.md#create_provider) | **POST** /ng/api/provider | Create a Provider
*ProviderApi* | [**delete_provider**](docs/ProviderApi.md#delete_provider) | **DELETE** /ng/api/provider/{providerIdentifier} | Delete a Provider by identifier
*ProviderApi* | [**get_provider**](docs/ProviderApi.md#get_provider) | **GET** /ng/api/provider/{providerIdentifier} | Gets a Provider by identifier
*ProviderApi* | [**get_provider_list**](docs/ProviderApi.md#get_provider_list) | **GET** /ng/api/provider | Gets Provider list
*ProviderApi* | [**update_provider**](docs/ProviderApi.md#update_provider) | **PUT** /ng/api/provider/{providerIdentifier} | Update a Provider by identifier
*ProxyApi* | [**create_proxy_key**](docs/ProxyApi.md#create_proxy_key) | **POST** /cf/admin/proxy/keys | Creates a Proxy Key in the account &amp; org
*ProxyApi* | [**delete_proxy_key**](docs/ProxyApi.md#delete_proxy_key) | **DELETE** /cf/admin/proxy/keys/{identifier} | Deletes a ProxyKey
*ProxyApi* | [**get_proxy_key**](docs/ProxyApi.md#get_proxy_key) | **GET** /cf/admin/proxy/keys/{identifier} | Returns a ProxyKey
*ProxyApi* | [**get_proxy_keys**](docs/ProxyApi.md#get_proxy_keys) | **GET** /cf/admin/proxy/keys | Returns all Proxy keys in an account
*ProxyApi* | [**patch_proxy_key**](docs/ProxyApi.md#patch_proxy_key) | **PATCH** /cf/admin/proxy/keys/{identifier} | Updates a Proxy Key in the account &amp; org
*ReconcilerApi* | [**reconciler_service_collect_counts**](docs/ReconcilerApi.md#reconciler_service_collect_counts) | **POST** /gitops/api/v1/agents/{agentIdentifier}/reconcile/counts | Collect entity counts on cluster via agent
*ReconcilerApi* | [**reconciler_service_import_data**](docs/ReconcilerApi.md#reconciler_service_import_data) | **POST** /gitops/api/v1/agents/{agentIdentifier}/reconcile/import | Import data from cluster via agent
*ReferenceIdentifiersApi* | [**reference_identifiers_get_by_reference_id**](docs/ReferenceIdentifiersApi.md#reference_identifiers_get_by_reference_id) | **GET** /sto/api/v2/reference-identifiers/{refId} | 
*RepositoriesApi* | [**agent_repository_service_check_external_secrets_operator**](docs/RepositoriesApi.md#agent_repository_service_check_external_secrets_operator) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories/eso/check | Checks whether External Secrets Operator is installed
*RepositoriesApi* | [**agent_repository_service_check_oci_repo_type**](docs/RepositoriesApi.md#agent_repository_service_check_oci_repo_type) | **POST** /gitops/api/v1/agents/{agentIdentifier}/repositories/oci/type | Returns the Repository type of OCI repo
*RepositoriesApi* | [**agent_repository_service_create_repository**](docs/RepositoriesApi.md#agent_repository_service_create_repository) | **POST** /gitops/api/v1/agents/{agentIdentifier}/repositories | CreateRepository creates a new repository configuration
*RepositoriesApi* | [**agent_repository_service_delete_repository**](docs/RepositoriesApi.md#agent_repository_service_delete_repository) | **DELETE** /gitops/api/v1/agents/{agentIdentifier}/repositories/{identifier} | DeleteRepository deletes a repository from the configuration
*RepositoriesApi* | [**agent_repository_service_get**](docs/RepositoriesApi.md#agent_repository_service_get) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories/{identifier} | Get returns a repository or its credentials
*RepositoriesApi* | [**agent_repository_service_get_app_details**](docs/RepositoriesApi.md#agent_repository_service_get_app_details) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories/{identifier}/appdetails | GetAppDetails returns application details by given path
*RepositoriesApi* | [**agent_repository_service_get_app_details_by_url**](docs/RepositoriesApi.md#agent_repository_service_get_app_details_by_url) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories_byurl/appdetails | GetAppDetailsByUrl returns application details by given path for repositories by URL
*RepositoriesApi* | [**agent_repository_service_get_by_url**](docs/RepositoriesApi.md#agent_repository_service_get_by_url) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repository_byurl | Get a repository configured in gitops by URL from Harness
*RepositoriesApi* | [**agent_repository_service_get_helm_charts**](docs/RepositoriesApi.md#agent_repository_service_get_helm_charts) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories/{identifier}/helmcharts | GetHelmCharts returns list of helm charts in the specified repository
*RepositoriesApi* | [**agent_repository_service_get_helm_charts_by_url**](docs/RepositoriesApi.md#agent_repository_service_get_helm_charts_by_url) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories_byurl/helmcharts | GetHelmChartsByUrl returns list of helm charts in the repository by URL
*RepositoriesApi* | [**agent_repository_service_list_apps**](docs/RepositoriesApi.md#agent_repository_service_list_apps) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories/{identifier}/apps | ListApps returns list of apps in the repo
*RepositoriesApi* | [**agent_repository_service_list_apps_by_url**](docs/RepositoriesApi.md#agent_repository_service_list_apps_by_url) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories_byurl/apps | ListAppsByUrl returns list of apps in the repo
*RepositoriesApi* | [**agent_repository_service_list_eso_generators**](docs/RepositoriesApi.md#agent_repository_service_list_eso_generators) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories/eso/generators | Returns a list of ESO generators installed in agent namespace.
*RepositoriesApi* | [**agent_repository_service_list_refs**](docs/RepositoriesApi.md#agent_repository_service_list_refs) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories/{identifier}/refs | Returns a list of refs (e.g. branches and tags) in the repo
*RepositoriesApi* | [**agent_repository_service_list_refs_by_url**](docs/RepositoriesApi.md#agent_repository_service_list_refs_by_url) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories_byurl/refs | Returns a list of refs (e.g. branches and tags) in the repo by URL
*RepositoriesApi* | [**agent_repository_service_list_repositories**](docs/RepositoriesApi.md#agent_repository_service_list_repositories) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repositories | ListRepositories gets a list of all configured repositories
*RepositoriesApi* | [**agent_repository_service_update_repository**](docs/RepositoriesApi.md#agent_repository_service_update_repository) | **PUT** /gitops/api/v1/agents/{agentIdentifier}/repositories/{identifier} | UpdateRepository updates a repository configuration
*RepositoriesApi* | [**agent_repository_service_validate_access**](docs/RepositoriesApi.md#agent_repository_service_validate_access) | **POST** /gitops/api/v1/agents/{agentIdentifier}/repositories/validate | ValidateAccess gets connection state for a repository
*RepositoriesApi* | [**repository_service_exists**](docs/RepositoriesApi.md#repository_service_exists) | **GET** /gitops/api/v1/repositories/exists | Check if a repository exists
*RepositoriesApi* | [**repository_service_list_repositories**](docs/RepositoriesApi.md#repository_service_list_repositories) | **POST** /gitops/api/v1/repositories | List repositories
*RepositoriesApi* | [**repository_service_list_repositories_by_repository_credential_template**](docs/RepositoriesApi.md#repository_service_list_repositories_by_repository_credential_template) | **GET** /gitops/api/v1/repositories | List Repositories by repository credential template
*RepositoryCertificatesApi* | [**agent_certificate_service_create**](docs/RepositoryCertificatesApi.md#agent_certificate_service_create) | **POST** /gitops/api/v1/agents/{agentIdentifier}/certificates | Creates repository certificates on the server
*RepositoryCertificatesApi* | [**agent_certificate_service_delete**](docs/RepositoryCertificatesApi.md#agent_certificate_service_delete) | **DELETE** /gitops/api/v1/agents/{agentIdentifier}/certificates | Delete the certificates that match the RepositoryCertificateQuery
*RepositoryCertificatesApi* | [**agent_certificate_service_list**](docs/RepositoryCertificatesApi.md#agent_certificate_service_list) | **GET** /gitops/api/v1/agents/{agentIdentifier}/certificates | List all available repository certificates
*RepositoryCredentialsApi* | [**agent_repository_credentials_service_create_repository_credentials**](docs/RepositoryCredentialsApi.md#agent_repository_credentials_service_create_repository_credentials) | **POST** /gitops/api/v1/agents/{agentIdentifier}/repocreds | Create a new repository credential
*RepositoryCredentialsApi* | [**agent_repository_credentials_service_delete_repository_credentials**](docs/RepositoryCredentialsApi.md#agent_repository_credentials_service_delete_repository_credentials) | **DELETE** /gitops/api/v1/agents/{agentIdentifier}/repocreds/{identifier} | Delete a repository credential
*RepositoryCredentialsApi* | [**agent_repository_credentials_service_get_credentials_for_repository_url**](docs/RepositoryCredentialsApi.md#agent_repository_credentials_service_get_credentials_for_repository_url) | **POST** /gitops/api/v1/agents/{agentIdentifier}/repocreds/get | Get credentials for repository url
*RepositoryCredentialsApi* | [**agent_repository_credentials_service_get_repository_credentials**](docs/RepositoryCredentialsApi.md#agent_repository_credentials_service_get_repository_credentials) | **GET** /gitops/api/v1/agents/{agentIdentifier}/repocreds/{identifier} | Get repository credential by identifier
*RepositoryCredentialsApi* | [**agent_repository_credentials_service_list_repository_credentials**](docs/RepositoryCredentialsApi.md#agent_repository_credentials_service_list_repository_credentials) | **POST** /gitops/api/v1/repocreds | List repository credentials
*RepositoryCredentialsApi* | [**agent_repository_credentials_service_update_repository_credentials**](docs/RepositoryCredentialsApi.md#agent_repository_credentials_service_update_repository_credentials) | **PUT** /gitops/api/v1/agents/{agentIdentifier}/repocreds/{identifier} | Update a repository credential
*RoleAssignmentsApi* | [**bulk_delete_role_assignment**](docs/RoleAssignmentsApi.md#bulk_delete_role_assignment) | **POST** /authz/api/roleassignments/delete/batch | Bulk Delete Role Assignment
*RoleAssignmentsApi* | [**delete_role_assignment**](docs/RoleAssignmentsApi.md#delete_role_assignment) | **DELETE** /authz/api/roleassignments/{identifier} | Delete Role Assignment
*RoleAssignmentsApi* | [**get_filtered_role_assignment_by_scope_list**](docs/RoleAssignmentsApi.md#get_filtered_role_assignment_by_scope_list) | **POST** /authz/api/roleassignments/v2/filter | List Role Assignments by scope filter
*RoleAssignmentsApi* | [**get_filtered_role_assignment_list**](docs/RoleAssignmentsApi.md#get_filtered_role_assignment_list) | **POST** /authz/api/roleassignments/filter | List Role Assignments by filter
*RoleAssignmentsApi* | [**get_role_assignment**](docs/RoleAssignmentsApi.md#get_role_assignment) | **GET** /authz/api/roleassignments/{identifier} | Get Role Assignment
*RoleAssignmentsApi* | [**get_role_assignment_aggregate_list**](docs/RoleAssignmentsApi.md#get_role_assignment_aggregate_list) | **POST** /authz/api/roleassignments/aggregate | List Aggregated Role Assignments by filter
*RoleAssignmentsApi* | [**get_role_assignment_list**](docs/RoleAssignmentsApi.md#get_role_assignment_list) | **GET** /authz/api/roleassignments | List Role Assignments
*RoleAssignmentsApi* | [**post_role_assignment**](docs/RoleAssignmentsApi.md#post_role_assignment) | **POST** /authz/api/roleassignments | Create Role Assignment
*RoleAssignmentsApi* | [**post_role_assignments**](docs/RoleAssignmentsApi.md#post_role_assignments) | **POST** /authz/api/roleassignments/multi | Create Role Assignments
*RoleAssignmentsApi* | [**validate_role_assignment**](docs/RoleAssignmentsApi.md#validate_role_assignment) | **POST** /authz/api/roleassignments/validate | Validate Role Assignment
*RolesApi* | [**delete_role**](docs/RolesApi.md#delete_role) | **DELETE** /authz/api/roles/{identifier} | Delete Role
*RolesApi* | [**get_role**](docs/RolesApi.md#get_role) | **GET** /authz/api/roles/{identifier} | Get Role
*RolesApi* | [**get_role_list**](docs/RolesApi.md#get_role_list) | **GET** /authz/api/roles | List Roles
*RolesApi* | [**post_role**](docs/RolesApi.md#post_role) | **POST** /authz/api/roles | Create Role
*RolesApi* | [**put_role**](docs/RolesApi.md#put_role) | **PUT** /authz/api/roles/{identifier} | Update Role
*RollbackApi* | [**check_if_instance_can_be_rolled_back**](docs/RollbackApi.md#check_if_instance_can_be_rolled_back) | **POST** /ng/api/rollback/check | Verification for rollback eligibility for service
*RollbackApi* | [**trigger_rollback**](docs/RollbackApi.md#trigger_rollback) | **POST** /ng/api/rollback/trigger | Trigger the rollback for specific service
*RolloutsApi* | [**rollouts_service_get_rollout_status**](docs/RolloutsApi.md#rollouts_service_get_rollout_status) | **GET** /gitops/api/v1/agents/{agentIdentifier}/applications/{request.name}/rollouts/status | 
*RuleApi* | [**clone_rule**](docs/RuleApi.md#clone_rule) | **POST** /ccm/api/governance/ruleClone | Clone a rule
*RuleApi* | [**cost_co_relation_supported_resources**](docs/RuleApi.md#cost_co_relation_supported_resources) | **GET** /ccm/api/governance/rule/costCoRelationSupportedResources | List resources for which cost co-relation is supported.
*RuleApi* | [**create_new_rule**](docs/RuleApi.md#create_new_rule) | **POST** /ccm/api/governance/rule | Add a rule
*RuleApi* | [**delete_rule**](docs/RuleApi.md#delete_rule) | **DELETE** /ccm/api/governance/rule/{ruleID} | Delete a rule
*RuleApi* | [**enqueue_governance_job**](docs/RuleApi.md#enqueue_governance_job) | **POST** /ccm/api/governance/enqueue | Enqueues job for execution
*RuleApi* | [**get_policies**](docs/RuleApi.md#get_policies) | **POST** /ccm/api/governance/rule/list | Fetch rules for account
*RuleApi* | [**governance_rule_schema**](docs/RuleApi.md#governance_rule_schema) | **GET** /ccm/api/governance/ruleSchema | Custodian Schema
*RuleApi* | [**governance_target_list**](docs/RuleApi.md#governance_target_list) | **GET** /ccm/api/governance/governanceTargetList | Governance Targets
*RuleApi* | [**regions**](docs/RuleApi.md#regions) | **GET** /ccm/api/governance/regions | List of Regions for Aws/Azure
*RuleApi* | [**simple_enqueue_adhoc_governance_rule**](docs/RuleApi.md#simple_enqueue_adhoc_governance_rule) | **POST** /ccm/api/governance/enqueueAdhocV2 | Simple Request to enqueue rule for execution
*RuleApi* | [**toggle_for_recommendation**](docs/RuleApi.md#toggle_for_recommendation) | **PUT** /ccm/api/governance/rule/toggleForRecommendation | Enable/Disable a custom Rule to be considered for recommendation
*RuleApi* | [**update_rule**](docs/RuleApi.md#update_rule) | **PUT** /ccm/api/governance/rule | Update a Rule
*RuleApi* | [**validate_governance_rule**](docs/RuleApi.md#validate_governance_rule) | **POST** /ccm/api/governance/ruleValidate | Validate Governance Rule
*RuleEnforcementApi* | [**add_rule_enforcement**](docs/RuleEnforcementApi.md#add_rule_enforcement) | **POST** /ccm/api/governance/enforcement | Add a new rule Enforcement 
*RuleEnforcementApi* | [**delete_rule_enforcement**](docs/RuleEnforcementApi.md#delete_rule_enforcement) | **DELETE** /ccm/api/governance/enforcement/{enforcementID} | Delete a rule enforcement
*RuleEnforcementApi* | [**enforcement_details**](docs/RuleEnforcementApi.md#enforcement_details) | **GET** /ccm/api/governance/enforcement/details | Get Rule Enforcement details for given Enforcement Id
*RuleEnforcementApi* | [**get_rule_enforcement**](docs/RuleEnforcementApi.md#get_rule_enforcement) | **GET** /ccm/api/governance/enforcement/list | Fetch Rule Enforcements for account
*RuleEnforcementApi* | [**get_rule_enforcement_count**](docs/RuleEnforcementApi.md#get_rule_enforcement_count) | **POST** /ccm/api/governance/enforcement/count | Fetch Rule Enforcements for given RuleIds/RuleSetIds
*RuleEnforcementApi* | [**toggle_enforcement**](docs/RuleEnforcementApi.md#toggle_enforcement) | **PUT** /ccm/api/governance/enforcement/toggle | Enable/Disable a Rule Enforcement for given Enforcement Id
*RuleEnforcementApi* | [**update_enforcement**](docs/RuleEnforcementApi.md#update_enforcement) | **PUT** /ccm/api/governance/enforcement | Update a Rule enforcement
*RuleExecutionsApi* | [**get_rule_execution_details**](docs/RuleExecutionsApi.md#get_rule_execution_details) | **GET** /ccm/api/governance/execution/{ruleExecutionId} | Resources/logs for a rule execution 
*RuleExecutionsApi* | [**get_rule_execution_logs**](docs/RuleExecutionsApi.md#get_rule_execution_logs) | **GET** /ccm/api/governance/logs/{ruleExecutionId} | Return logs for a rule execution
*RuleExecutionsApi* | [**get_rule_execution_status**](docs/RuleExecutionsApi.md#get_rule_execution_status) | **GET** /ccm/api/governance/status/{ruleExecutionId} | Return resources for a rule execution
*RuleExecutionsApi* | [**get_rule_executions**](docs/RuleExecutionsApi.md#get_rule_executions) | **POST** /ccm/api/governance/execution/list | Fetch RuleExecution for account
*RuleExecutionsApi* | [**get_rule_executions_filter_values**](docs/RuleExecutionsApi.md#get_rule_executions_filter_values) | **GET** /ccm/api/governance/execution/filter-value | Rule Execution Filter Values
*RuleExecutionsApi* | [**get_rule_last_execution**](docs/RuleExecutionsApi.md#get_rule_last_execution) | **POST** /ccm/api/governance/execution/ruleLastExecution | Find last execution given rules list
*RuleExecutionsApi* | [**get_rule_recommendation**](docs/RuleExecutionsApi.md#get_rule_recommendation) | **GET** /ccm/api/governance/recommendation/{recommendationId} | Governance recommendation details
*RuleExecutionsApi* | [**refresh_cost_for_rule_execution**](docs/RuleExecutionsApi.md#refresh_cost_for_rule_execution) | **GET** /ccm/api/governance/execution/refreshCost/{ruleExecutionId} | Refresh cost for a rule execution
*RuleSetsApi* | [**add_rule_set**](docs/RuleSetsApi.md#add_rule_set) | **POST** /ccm/api/governance/ruleSet | Add a rule Set 
*RuleSetsApi* | [**delete_rule_set**](docs/RuleSetsApi.md#delete_rule_set) | **DELETE** /ccm/api/governance/ruleSet/{ruleSetId} | Delete a rule set
*RuleSetsApi* | [**list_rule_sets**](docs/RuleSetsApi.md#list_rule_sets) | **POST** /ccm/api/governance/ruleSet/list | Fetch rule sets for account
*RuleSetsApi* | [**update_rule_set**](docs/RuleSetsApi.md#update_rule_set) | **PUT** /ccm/api/governance/ruleSet | Update a Rule set
*SLOsApi* | [**get_error_budget_reset_history**](docs/SLOsApi.md#get_error_budget_reset_history) | **GET** /cv/api/slo/{identifier}/errorBudgetResetHistory | Get Error budget reset history
*SLOsApi* | [**get_metric_graph_for_slo**](docs/SLOsApi.md#get_metric_graph_for_slo) | **GET** /cv/api/v1/orgs/{org}/projects/{project}/metric-graph/{slo-identifier} | Get Metric Graph For SLO
*SLOsApi* | [**get_notification_rules_for_slo**](docs/SLOsApi.md#get_notification_rules_for_slo) | **GET** /cv/api/slo/{identifier}/notification-rules | Get notification rules for SLO
*SLOsApi* | [**get_service_level_objective_logs**](docs/SLOsApi.md#get_service_level_objective_logs) | **GET** /cv/api/slo/{identifier}/logs | Get SLO logs
*SLOsApi* | [**list_slo**](docs/SLOsApi.md#list_slo) | **GET** /cv/api/v1/orgs/{org}/projects/{project}/slo | List SLOs
*SLOsApi* | [**reset_error_budget**](docs/SLOsApi.md#reset_error_budget) | **POST** /cv/api/slo/{identifier}/resetErrorBudget | Reset Error budget history
*SLOsDashboardApi* | [**get_secondary_event_details**](docs/SLOsDashboardApi.md#get_secondary_event_details) | **GET** /cv/api/slo-dashboard/secondary-events-details | 
*SLOsDashboardApi* | [**get_secondary_events**](docs/SLOsDashboardApi.md#get_secondary_events) | **GET** /cv/api/slo-dashboard/secondary-events/{identifier} | 
*SLOsDashboardApi* | [**get_service_level_objectives_risk_count**](docs/SLOsDashboardApi.md#get_service_level_objectives_risk_count) | **GET** /cv/api/slo-dashboard/risk-count | Get all SLOs count by risk
*SLOsDashboardApi* | [**get_slo_associated_environment_identifiers**](docs/SLOsDashboardApi.md#get_slo_associated_environment_identifiers) | **GET** /cv/api/slo-dashboard/environment-identifiers | 
*SLOsDashboardApi* | [**get_slo_associated_monitored_services**](docs/SLOsDashboardApi.md#get_slo_associated_monitored_services) | **GET** /cv/api/slo-dashboard/monitored-services | 
*SLOsDashboardApi* | [**get_slo_consumption_breakdown_view**](docs/SLOsDashboardApi.md#get_slo_consumption_breakdown_view) | **GET** /cv/api/slo-dashboard/widget/{identifier}/consumption | Get SLO consumption breakdown
*SLOsDashboardApi* | [**get_slo_details**](docs/SLOsDashboardApi.md#get_slo_details) | **GET** /cv/api/slo-dashboard/widget/{identifier} | Get SLO dashboard details
*SLOsDashboardApi* | [**get_slo_health_list_view**](docs/SLOsDashboardApi.md#get_slo_health_list_view) | **GET** /cv/api/slo-dashboard/widgets/list | Get SLO list view
*SLOsDashboardApi* | [**get_slo_health_list_view_v2**](docs/SLOsDashboardApi.md#get_slo_health_list_view_v2) | **POST** /cv/api/slo-dashboard/widgets/list | Get SLO list view
*SMTPApi* | [**create_smtp_config**](docs/SMTPApi.md#create_smtp_config) | **POST** /ng/api/smtpConfig | Creates SMTP config
*SMTPApi* | [**delete_smtp_config**](docs/SMTPApi.md#delete_smtp_config) | **DELETE** /ng/api/smtpConfig/{identifier} | Delete Smtp Config by identifier
*SMTPApi* | [**get_smtp_config**](docs/SMTPApi.md#get_smtp_config) | **GET** /ng/api/smtpConfig | Gets Smtp config by accountId
*SMTPApi* | [**update_smtp**](docs/SMTPApi.md#update_smtp) | **PUT** /ng/api/smtpConfig | Updates the Smtp Config
*SMTPApi* | [**validate_connectivity**](docs/SMTPApi.md#validate_connectivity) | **POST** /ng/api/smtpConfig/validate-connectivity | Tests the config&#x27;s connectivity by sending a test email
*SMTPApi* | [**validate_name**](docs/SMTPApi.md#validate_name) | **POST** /ng/api/smtpConfig/validateName | Checks whether other connectors exist with the same name
*SavingsOverviewApi* | [**get_savings_overview**](docs/SavingsOverviewApi.md#get_savings_overview) | **POST** /gateway/lw/api/accounts/{account_id}/v2/savings/overview | Get Savings Overview
*SavingsRateApi* | [**get_savings_rate**](docs/SavingsRateApi.md#get_savings_rate) | **POST** /gateway/lw/api/accounts/{account_id}/v2/savings/savings-rate | Get Effective Savings Rate
*ScansApi* | [**scans_create_scan**](docs/ScansApi.md#scans_create_scan) | **POST** /sto/api/v2/scans | 
*ScansApi* | [**scans_find_scan_by_id**](docs/ScansApi.md#scans_find_scan_by_id) | **GET** /sto/api/v2/scans/{id} | 
*ScansApi* | [**scans_list_scans**](docs/ScansApi.md#scans_list_scans) | **GET** /sto/api/v2/scans | 
*ScansApi* | [**scans_scan_issue**](docs/ScansApi.md#scans_scan_issue) | **GET** /sto/api/v2/scans/{id}/issue/{issueId} | 
*ScansApi* | [**scans_scan_issue_counts**](docs/ScansApi.md#scans_scan_issue_counts) | **GET** /sto/api/v2/scans/{id}/issues/counts | 
*ScansApi* | [**scans_scan_issues**](docs/ScansApi.md#scans_scan_issues) | **GET** /sto/api/v2/scans/{id}/issues | 
*ScansApi* | [**scans_update_scan**](docs/ScansApi.md#scans_update_scan) | **PUT** /sto/api/v2/scans/{id} | 
*ScmDataPointsApi* | [**get_scm_data_point_values**](docs/ScmDataPointsApi.md#get_scm_data_point_values) | **POST** /v1/data-sources/scm/data-point/values | Get data points data for scm data source
*ScorecardsApi* | [**create_scorecard**](docs/ScorecardsApi.md#create_scorecard) | **POST** /v1/scorecards | Create scorecard
*ScorecardsApi* | [**delete_scorecard**](docs/ScorecardsApi.md#delete_scorecard) | **DELETE** /v1/scorecards/{scorecard-id} | Delete scorecard details for given scorecardId
*ScorecardsApi* | [**get_entity_facets**](docs/ScorecardsApi.md#get_entity_facets) | **GET** /v1/entity-facets | Get all entity facets for given kind
*ScorecardsApi* | [**get_scorecard**](docs/ScorecardsApi.md#get_scorecard) | **GET** /v1/scorecards/{scorecard-id} | Get scorecard details for given scorecardId
*ScorecardsApi* | [**get_scorecard_stats**](docs/ScorecardsApi.md#get_scorecard_stats) | **GET** /v1/scorecards/{scorecard-id}/stats | Get scorecard stats for given scorecardId
*ScorecardsApi* | [**get_scorecards**](docs/ScorecardsApi.md#get_scorecards) | **GET** /v1/scorecards | Get all scorecards available
*ScorecardsApi* | [**update_scorecard**](docs/ScorecardsApi.md#update_scorecard) | **PUT** /v1/scorecards/{scorecard-id} | Update scorecard details for given scorecardId
*ScoresApi* | [**get_aggregated_scores**](docs/ScoresApi.md#get_aggregated_scores) | **POST** /v1/scores/aggregate | Get Aggregated Scores for backstage entities
*ScoresApi* | [**get_all_scorecard_summary**](docs/ScoresApi.md#get_all_scorecard_summary) | **GET** /v1/scores/summary | Get Score Summary for Scorecards
*ScoresApi* | [**get_scorecards_scores_overview**](docs/ScoresApi.md#get_scorecards_scores_overview) | **GET** /v1/scores | Get Scores for Scorecards
*SecretManagersApi* | [**get_metadata**](docs/SecretManagersApi.md#get_metadata) | **POST** /ng/api/secret-managers/meta-data | Gets the metadata of Secret Manager
*SecretsApi* | [**delete_secret_v2**](docs/SecretsApi.md#delete_secret_v2) | **DELETE** /ng/api/v2/secrets/{identifier} | Deletes Secret by ID and Scope
*SecretsApi* | [**get_secret_v2**](docs/SecretsApi.md#get_secret_v2) | **GET** /ng/api/v2/secrets/{identifier} | Get the Secret by ID and Scope
*SecretsApi* | [**list_secrets_v2**](docs/SecretsApi.md#list_secrets_v2) | **GET** /ng/api/v2/secrets | Fetches the list of Secrets corresponding to the request&#x27;s filter criteria.
*SecretsApi* | [**list_secrets_v3**](docs/SecretsApi.md#list_secrets_v3) | **POST** /ng/api/v2/secrets/list | Fetches the list of Secrets corresponding to the request&#x27;s filter criteria.
*SecretsApi* | [**list_secrets_v4**](docs/SecretsApi.md#list_secrets_v4) | **POST** /ng/api/v2/secrets/list/secrets | Fetches the list of Secrets corresponding to the request&#x27;s filter criteria.
*SecretsApi* | [**post_secret**](docs/SecretsApi.md#post_secret) | **POST** /ng/api/v2/secrets | Creates a Secret at given Scope
*SecretsApi* | [**post_secret_file_v2**](docs/SecretsApi.md#post_secret_file_v2) | **POST** /ng/api/v2/secrets/files | Creates a Secret File
*SecretsApi* | [**post_secret_via_yaml**](docs/SecretsApi.md#post_secret_via_yaml) | **POST** /ng/api/v2/secrets/yaml | Creates a secret via YAML
*SecretsApi* | [**put_secret**](docs/SecretsApi.md#put_secret) | **PUT** /ng/api/v2/secrets/{identifier} | Updates the Secret by ID and Scope
*SecretsApi* | [**put_secret_file_v2**](docs/SecretsApi.md#put_secret_file_v2) | **PUT** /ng/api/v2/secrets/files/{identifier} | Updates the Secret file by ID and Scope
*SecretsApi* | [**put_secret_via_yaml**](docs/SecretsApi.md#put_secret_via_yaml) | **PUT** /ng/api/v2/secrets/{identifier}/yaml | Updates the Secret by ID and Scope via YAML
*SecretsApi* | [**validate_secret**](docs/SecretsApi.md#validate_secret) | **POST** /ng/api/v2/secrets/validate | Validates Secret with the provided ID and Scope
*SecretsApi* | [**validate_secret_identifier_is_unique**](docs/SecretsApi.md#validate_secret_identifier_is_unique) | **GET** /ng/api/v2/secrets/validateUniqueIdentifier/{identifier} | Checks whether the identifier is unique or not
*ServiceLevelObjectiveApi* | [**get_metric_graph_for_slo**](docs/ServiceLevelObjectiveApi.md#get_metric_graph_for_slo) | **GET** /cv/api/v1/orgs/{org}/projects/{project}/metric-graph/{slo-identifier} | Get Metric Graph For SLO
*ServiceLevelObjectiveApi* | [**list_slo**](docs/ServiceLevelObjectiveApi.md#list_slo) | **GET** /cv/api/v1/orgs/{org}/projects/{project}/slo | List SLOs
*ServiceOverridesApi* | [**create_service_override**](docs/ServiceOverridesApi.md#create_service_override) | **POST** /ng/api/serviceOverrides | Create an ServiceOverride Entity
*ServiceOverridesApi* | [**delete_service_override1**](docs/ServiceOverridesApi.md#delete_service_override1) | **DELETE** /ng/api/serviceOverrides/{identifier} | Delete a ServiceOverride entity
*ServiceOverridesApi* | [**get_service_overrides**](docs/ServiceOverridesApi.md#get_service_overrides) | **GET** /ng/api/serviceOverrides/{identifier} | Gets Service Overrides by Identifier
*ServiceOverridesApi* | [**service_override_move_configs**](docs/ServiceOverridesApi.md#service_override_move_configs) | **POST** /ng/api/serviceOverrides/move-config | Move ServiceOverride YAML from inline to remote or remote to inline
*ServiceOverridesApi* | [**update_service_override**](docs/ServiceOverridesApi.md#update_service_override) | **PUT** /ng/api/serviceOverrides | Update an ServiceOverride Entity
*ServiceOverridesApi* | [**update_service_override_git_details**](docs/ServiceOverridesApi.md#update_service_override_git_details) | **PUT** /ng/api/serviceOverrides/update-git-metadata | Update git-metadata in remote ServiceOverride Entity
*ServiceAccountApi* | [**create_service_account**](docs/ServiceAccountApi.md#create_service_account) | **POST** /ng/api/serviceaccount | Create a Service Account
*ServiceAccountApi* | [**delete_service_account**](docs/ServiceAccountApi.md#delete_service_account) | **DELETE** /ng/api/serviceaccount/{identifier} | Delete a Service Account
*ServiceAccountApi* | [**get_aggregated_service_account**](docs/ServiceAccountApi.md#get_aggregated_service_account) | **GET** /ng/api/serviceaccount/aggregate/{identifier} | Get Service Account In Scope
*ServiceAccountApi* | [**list_aggregated_service_accounts**](docs/ServiceAccountApi.md#list_aggregated_service_accounts) | **GET** /ng/api/serviceaccount/aggregate | List aggregated Service Accounts
*ServiceAccountApi* | [**list_service_account**](docs/ServiceAccountApi.md#list_service_account) | **GET** /ng/api/serviceaccount | Get Service Accounts
*ServiceAccountApi* | [**update_service_account**](docs/ServiceAccountApi.md#update_service_account) | **PUT** /ng/api/serviceaccount/{identifier} | Update a Service Account
*ServiceDashboardApi* | [**pipeline_execution_count**](docs/ServiceDashboardApi.md#pipeline_execution_count) | **GET** /ng/api/dashboard/getPipelineExecutionCount | Get pipeline execution count for a service with grouping support on artifact and deployment status
*ServicesApi* | [**create_service_v2**](docs/ServicesApi.md#create_service_v2) | **POST** /ng/api/servicesV2 | Create a Service
*ServicesApi* | [**create_services_v2**](docs/ServicesApi.md#create_services_v2) | **POST** /ng/api/servicesV2/batch | Create Services
*ServicesApi* | [**delete_service_v2**](docs/ServicesApi.md#delete_service_v2) | **DELETE** /ng/api/servicesV2/{serviceIdentifier} | Delete a Service by identifier
*ServicesApi* | [**get_service_access_list**](docs/ServicesApi.md#get_service_access_list) | **GET** /ng/api/servicesV2/list/access | Gets Service Access list
*ServicesApi* | [**get_service_list**](docs/ServicesApi.md#get_service_list) | **GET** /ng/api/servicesV2 | Gets Service list
*ServicesApi* | [**get_service_v2**](docs/ServicesApi.md#get_service_v2) | **GET** /ng/api/servicesV2/{serviceIdentifier} | Gets a Service by identifier
*ServicesApi* | [**hook_actions**](docs/ServicesApi.md#hook_actions) | **GET** /ng/api/servicesV2/hooks/actions | Retrieving the list of actions available for service hooks
*ServicesApi* | [**import_service**](docs/ServicesApi.md#import_service) | **POST** /ng/api/servicesV2/import | Get Service YAML from Git Repository
*ServicesApi* | [**k8s_cmd_flags**](docs/ServicesApi.md#k8s_cmd_flags) | **GET** /ng/api/servicesV2/k8s/command-flags | Retrieving the list of Kubernetes Command Options
*ServicesApi* | [**kustomize_cmd_flags**](docs/ServicesApi.md#kustomize_cmd_flags) | **GET** /ng/api/servicesV2/kustomize/command-flags | Retrieving the list of Kustomize Command Flags
*ServicesApi* | [**move_service_configs**](docs/ServicesApi.md#move_service_configs) | **POST** /ng/api/servicesV2/move-config/{serviceIdentifier} | Move Service YAML from inline to remote
*ServicesApi* | [**update_service_git_details**](docs/ServicesApi.md#update_service_git_details) | **PUT** /ng/api/servicesV2/{serviceIdentifier}/update-git-metadata | Update git-metadata in remote service Entity
*ServicesApi* | [**update_service_v2**](docs/ServicesApi.md#update_service_v2) | **PUT** /ng/api/servicesV2 | Update a Service by identifier
*ServicesApi* | [**upsert_service_v2**](docs/ServicesApi.md#upsert_service_v2) | **PUT** /ng/api/servicesV2/upsert | Upsert a Service by identifier
*SettingApi* | [**get_setting_value**](docs/SettingApi.md#get_setting_value) | **GET** /ng/api/settings/{identifier} | Get a setting value by identifier
*SettingApi* | [**get_settings_list**](docs/SettingApi.md#get_settings_list) | **GET** /ng/api/settings | Get list of settings under the specified category
*SettingApi* | [**update_setting_value**](docs/SettingApi.md#update_setting_value) | **PUT** /ng/api/settings | Update settings
*SourceCodeManagerApi* | [**create_source_code_manager**](docs/SourceCodeManagerApi.md#create_source_code_manager) | **POST** /ng/api/source-code-manager | Creates Source Code Manager
*SourceCodeManagerApi* | [**delete_source_code_manager**](docs/SourceCodeManagerApi.md#delete_source_code_manager) | **DELETE** /ng/api/source-code-manager/{identifier} | Deletes the Source Code Manager corresponding to the specified Source Code Manager Id
*SourceCodeManagerApi* | [**get_source_code_managers**](docs/SourceCodeManagerApi.md#get_source_code_managers) | **GET** /ng/api/source-code-manager | Lists Source Code Managers for the given account
*SourceCodeManagerApi* | [**update_source_code_manager**](docs/SourceCodeManagerApi.md#update_source_code_manager) | **PUT** /ng/api/source-code-manager/{identifier} | Updates Source Code Manager Details with the given Source Code Manager Id
*SpendOverviewApi* | [**spend_overview**](docs/SpendOverviewApi.md#spend_overview) | **POST** /gateway/lw/api/accounts/{account_id}/v2/spend/overview | Get overall spend breakdown across RI, SP and Ondemand cost
*SrmNotificationApi* | [**delete_notification_rule_data**](docs/SrmNotificationApi.md#delete_notification_rule_data) | **DELETE** /cv/api/notification-rule/{identifier} | 
*SrmNotificationApi* | [**get_notification_rule_data**](docs/SrmNotificationApi.md#get_notification_rule_data) | **GET** /cv/api/notification-rule/{identifier} | 
*SrmNotificationApi* | [**get_notification_rule_data1**](docs/SrmNotificationApi.md#get_notification_rule_data1) | **GET** /cv/api/notification-rule | 
*SrmNotificationApi* | [**save_notification_rule_data**](docs/SrmNotificationApi.md#save_notification_rule_data) | **POST** /cv/api/notification-rule | 
*SrmNotificationApi* | [**update_notification_rule_data**](docs/SrmNotificationApi.md#update_notification_rule_data) | **PUT** /cv/api/notification-rule/{identifier} | 
*SystemApi* | [**system_health**](docs/SystemApi.md#system_health) | **GET** /sto/api/v2/system/health | 
*SystemApi* | [**system_version**](docs/SystemApi.md#system_version) | **GET** /sto/api/v2/system/version | 
*TagsApi* | [**create_tag**](docs/TagsApi.md#create_tag) | **POST** /cf/admin/tags | Creates a Tag
*TagsApi* | [**delete_tag**](docs/TagsApi.md#delete_tag) | **DELETE** /cf/admin/tags/{identifier} | Delete a Tag
*TagsApi* | [**get_all_tags**](docs/TagsApi.md#get_all_tags) | **GET** /cf/admin/tags | Returns all Tags
*TagsApi* | [**get_tag**](docs/TagsApi.md#get_tag) | **GET** /cf/admin/tags/{identifier} | Returns a Tag
*TargetGroupsApi* | [**create_segment**](docs/TargetGroupsApi.md#create_segment) | **POST** /cf/admin/segments | Creates a Target Group
*TargetGroupsApi* | [**delete_segment**](docs/TargetGroupsApi.md#delete_segment) | **DELETE** /cf/admin/segments/{identifier} | Deletes a Target Group
*TargetGroupsApi* | [**get_all_segments**](docs/TargetGroupsApi.md#get_all_segments) | **GET** /cf/admin/segments | Returns all Target Groups
*TargetGroupsApi* | [**get_available_flags_for_segment**](docs/TargetGroupsApi.md#get_available_flags_for_segment) | **GET** /cf/admin/segments/{identifier}/available_flags | Returns Feature Flags that are available to be added to the given Target Group
*TargetGroupsApi* | [**get_segment**](docs/TargetGroupsApi.md#get_segment) | **GET** /cf/admin/segments/{identifier} | Returns Target Group details for the given identifier
*TargetGroupsApi* | [**get_segment_flags**](docs/TargetGroupsApi.md#get_segment_flags) | **GET** /cf/admin/segments/{identifier}/flags | Returns Feature Flags in a Target Group
*TargetGroupsApi* | [**patch_segment**](docs/TargetGroupsApi.md#patch_segment) | **PATCH** /cf/admin/segments/{identifier} | Updates a Target Group
*TargetVariantsApi* | [**target_variants_create_target_variant**](docs/TargetVariantsApi.md#target_variants_create_target_variant) | **POST** /sto/api/v2/targets/{targetId}/variants | 
*TargetVariantsApi* | [**target_variants_find_target_variant_by_id**](docs/TargetVariantsApi.md#target_variants_find_target_variant_by_id) | **GET** /sto/api/v2/targets/{targetId}/variants/{id} | 
*TargetVariantsApi* | [**target_variants_list_target_variants**](docs/TargetVariantsApi.md#target_variants_list_target_variants) | **GET** /sto/api/v2/targets/{targetId}/variants | 
*TargetVariantsApi* | [**target_variants_update_target_variant**](docs/TargetVariantsApi.md#target_variants_update_target_variant) | **PUT** /sto/api/v2/targets/{targetId}/variants/{id} | 
*TargetsApi* | [**create_target**](docs/TargetsApi.md#create_target) | **POST** /cf/admin/targets | Creates a Target
*TargetsApi* | [**delete_target**](docs/TargetsApi.md#delete_target) | **DELETE** /cf/admin/targets/{identifier} | Deletes a Target
*TargetsApi* | [**get_all_targets**](docs/TargetsApi.md#get_all_targets) | **GET** /cf/admin/targets | Returns all Targets
*TargetsApi* | [**get_target**](docs/TargetsApi.md#get_target) | **GET** /cf/admin/targets/{identifier} | Returns details of a Target
*TargetsApi* | [**get_target_segments**](docs/TargetsApi.md#get_target_segments) | **GET** /cf/admin/targets/{identifier}/segments | Returns Target Groups for the given Target
*TargetsApi* | [**modify_target**](docs/TargetsApi.md#modify_target) | **PUT** /cf/admin/targets/{identifier} | Modifies a Target
*TargetsApi* | [**patch_target**](docs/TargetsApi.md#patch_target) | **PATCH** /cf/admin/targets/{identifier} | Updates a Target
*TargetsApi* | [**upload_targets**](docs/TargetsApi.md#upload_targets) | **POST** /cf/admin/targets/upload | Add Target details
*TemplatesApi* | [**create_template**](docs/TemplatesApi.md#create_template) | **POST** /template/api/templates | Create a Template
*TemplatesApi* | [**delete_template_version**](docs/TemplatesApi.md#delete_template_version) | **DELETE** /template/api/templates/{templateIdentifier}/{versionLabel} | Delete Template Version
*TemplatesApi* | [**get_refreshed_yaml**](docs/TemplatesApi.md#get_refreshed_yaml) | **POST** /template/api/refresh-template/refreshed-yaml | Get YAML with updated Template Inputs
*TemplatesApi* | [**get_template**](docs/TemplatesApi.md#get_template) | **GET** /template/api/templates/{templateIdentifier} | Get Template
*TemplatesApi* | [**get_template_input_set_yaml**](docs/TemplatesApi.md#get_template_input_set_yaml) | **GET** /template/api/templates/templateInputs/{templateIdentifier} | Gets Template Input Set YAML
*TemplatesApi* | [**get_template_metadata_list**](docs/TemplatesApi.md#get_template_metadata_list) | **POST** /template/api/templates/list-metadata | Gets all metadata of template list
*TemplatesApi* | [**move_template_configs**](docs/TemplatesApi.md#move_template_configs) | **POST** /template/api/templates/move-config/{templateIdentifier} | Move Template YAML from inline to remote
*TemplatesApi* | [**templatevalidate_template_inputs**](docs/TemplatesApi.md#templatevalidate_template_inputs) | **GET** /template/api/refresh-template/validate-template-inputs | Validate Template Inputs in a YAML
*TemplatesApi* | [**update_existing_template_version**](docs/TemplatesApi.md#update_existing_template_version) | **PUT** /template/api/templates/update/{templateIdentifier}/{versionLabel} | Update Template Version
*TemplatesApi* | [**update_git_details**](docs/TemplatesApi.md#update_git_details) | **POST** /template/api/templates/update/git-metadata/{templateIdentifier}/{versionLabel} | Update git metadata details for a remote template
*TemplatesApi* | [**update_stable_template**](docs/TemplatesApi.md#update_stable_template) | **PUT** /template/api/templates/updateStableTemplate/{templateIdentifier}/{versionLabel} | Update Stable Template Version
*TestTargetsApi* | [**targets_create_target**](docs/TestTargetsApi.md#targets_create_target) | **POST** /sto/api/v2/targets | 
*TestTargetsApi* | [**targets_find_target_by_id**](docs/TestTargetsApi.md#targets_find_target_by_id) | **GET** /sto/api/v2/targets/{id} | 
*TestTargetsApi* | [**targets_list_targets**](docs/TestTargetsApi.md#targets_list_targets) | **GET** /sto/api/v2/targets | 
*TestTargetsApi* | [**targets_patch_target**](docs/TestTargetsApi.md#targets_patch_target) | **PATCH** /sto/api/v2/targets/{id} | 
*TestTargetsApi* | [**targets_update_target**](docs/TestTargetsApi.md#targets_update_target) | **PUT** /sto/api/v2/targets/{id} | 
*TokenApi* | [**create_token**](docs/TokenApi.md#create_token) | **POST** /ng/api/token | Create a Token
*TokenApi* | [**delete_token**](docs/TokenApi.md#delete_token) | **DELETE** /ng/api/token/{identifier} | Delete a Token
*TokenApi* | [**list_aggregated_tokens**](docs/TokenApi.md#list_aggregated_tokens) | **GET** /ng/api/token/aggregate | List all Tokens
*TokenApi* | [**rotate_token**](docs/TokenApi.md#rotate_token) | **POST** /ng/api/token/rotate/{identifier} | Rotate a Token
*TokenApi* | [**update_token**](docs/TokenApi.md#update_token) | **PUT** /ng/api/token/{identifier} | Update a Token
*TokenApi* | [**validate_token**](docs/TokenApi.md#validate_token) | **POST** /ng/api/token/validate | Validate a Token
*TriggersApi* | [**create_trigger**](docs/TriggersApi.md#create_trigger) | **POST** /pipeline/api/triggers | Creates Trigger for triggering target pipeline identifier.
*TriggersApi* | [**delete_trigger**](docs/TriggersApi.md#delete_trigger) | **DELETE** /pipeline/api/triggers/{triggerIdentifier} | Deletes Trigger by identifier.
*TriggersApi* | [**get_list_for_target**](docs/TriggersApi.md#get_list_for_target) | **GET** /pipeline/api/triggers | Gets the paginated list of triggers for accountIdentifier, orgIdentifier, projectIdentifier, targetIdentifier.
*TriggersApi* | [**get_trigger**](docs/TriggersApi.md#get_trigger) | **GET** /pipeline/api/triggers/{triggerIdentifier} | Gets the trigger by accountIdentifier, orgIdentifier, projectIdentifier, targetIdentifier and triggerIdentifier.
*TriggersApi* | [**get_trigger_catalog**](docs/TriggersApi.md#get_trigger_catalog) | **GET** /pipeline/api/triggers/catalog | Lists all Triggers
*TriggersApi* | [**get_trigger_details**](docs/TriggersApi.md#get_trigger_details) | **GET** /pipeline/api/triggers/{triggerIdentifier}/details | Fetches Trigger details for a specific accountIdentifier, orgIdentifier, projectIdentifier, targetIdentifier, triggerIdentifier.
*TriggersApi* | [**trigger_event_history**](docs/TriggersApi.md#trigger_event_history) | **GET** /pipeline/api/triggers/{triggerIdentifier}/eventHistory | Get event history for a trigger
*TriggersApi* | [**update_trigger**](docs/TriggersApi.md#update_trigger) | **PUT** /pipeline/api/triggers/{triggerIdentifier} | Updates trigger for pipeline with target pipeline identifier.
*TriggersEventsApi* | [**polled_response_trigger_identifier**](docs/TriggersEventsApi.md#polled_response_trigger_identifier) | **GET** /pipeline/api/triggers/eventHistory/polledResponse/{triggerIdentifier} | Get all the polled response for a given trigger
*TriggersEventsApi* | [**trigger_event_history_build_source_type**](docs/TriggersEventsApi.md#trigger_event_history_build_source_type) | **GET** /pipeline/api/triggers/eventHistory/artifact-manifest-info | Get artifact and manifest trigger event history based on build source type
*TriggersEventsApi* | [**trigger_event_history_new**](docs/TriggersEventsApi.md#trigger_event_history_new) | **GET** /pipeline/api/triggers/eventHistory/{triggerIdentifier} | Get event history for a trigger
*TriggersEventsApi* | [**trigger_event_history_using_filters**](docs/TriggersEventsApi.md#trigger_event_history_using_filters) | **GET** /pipeline/api/triggers/eventHistory/events | Get event history for a trigger using filters.
*TriggersEventsApi* | [**trigger_history_event_correlation**](docs/TriggersEventsApi.md#trigger_history_event_correlation) | **GET** /pipeline/api/triggers/eventHistory/eventCorrelation/{eventCorrelationId} | Get Trigger history event correlation
*TriggersEventsApi* | [**trigger_history_event_correlation_v2**](docs/TriggersEventsApi.md#trigger_history_event_correlation_v2) | **GET** /pipeline/api/triggers/eventHistory/v2/eventCorrelation/{eventCorrelationId} | Get Trigger history event correlation V2
*UsageApi* | [**ccmdownload_active_service_csv_report**](docs/UsageApi.md#ccmdownload_active_service_csv_report) | **GET** /ccm/api/usage/cd/active-services/csv/download | Download CSV Active Services report
*UsageApi* | [**ccmget_cd_license_usage_for_service_instances**](docs/UsageApi.md#ccmget_cd_license_usage_for_service_instances) | **GET** /ccm/api/usage/CD/serviceInstancesLicense | Gets License Usage By Module, Timestamp, and Account Identifier
*UsageApi* | [**ccmget_cd_license_usage_for_services**](docs/UsageApi.md#ccmget_cd_license_usage_for_services) | **GET** /ccm/api/usage/CD/servicesLicense | Gets License Usage By Module, Timestamp, and Account Identifier
*UsageApi* | [**ccmget_license_usage**](docs/UsageApi.md#ccmget_license_usage) | **GET** /ccm/api/usage/{module} | Gets License Usage By Module, Timestamp, and Account Identifier
*UsageApi* | [**cvget_license_usage**](docs/UsageApi.md#cvget_license_usage) | **GET** /cv/api/usage/CV | 
*UsageApi* | [**download_active_monitored_service_csv_report**](docs/UsageApi.md#download_active_monitored_service_csv_report) | **GET** /cv/api/usage/SRM/active-monitored-services/csv/download | Download CSV Active Monitored Services report
*UsageApi* | [**download_active_service_csv_report**](docs/UsageApi.md#download_active_service_csv_report) | **GET** /ng/api/usage/cd/active-services/csv/download | Download CSV Active Services report
*UsageApi* | [**download_active_service_monitored_csv_report**](docs/UsageApi.md#download_active_service_monitored_csv_report) | **GET** /cv/api/usage/SRM/active-services-monitored/csv/download | Download CSV Active Services Monitored report
*UsageApi* | [**download_cd_usage_csv_report**](docs/UsageApi.md#download_cd_usage_csv_report) | **GET** /ng/api/license-usage-cd/v2/{usageType}/csv/download | Download CD Usage CSV report
*UsageApi* | [**get_cd_license_usage_for_service_instances**](docs/UsageApi.md#get_cd_license_usage_for_service_instances) | **GET** /ng/api/usage/CD/serviceInstancesLicense | Gets License Usage By Module, Timestamp, and Account Identifier
*UsageApi* | [**get_cd_license_usage_for_services**](docs/UsageApi.md#get_cd_license_usage_for_services) | **GET** /ng/api/usage/CD/servicesLicense | Gets License Usage By Module, Timestamp, and Account Identifier
*UsageApi* | [**get_license_usage**](docs/UsageApi.md#get_license_usage) | **GET** /ng/api/usage/{module} | Gets License Usage By Module, Timestamp, and Account Identifier
*UsageApi* | [**get_srm_license_usage**](docs/UsageApi.md#get_srm_license_usage) | **GET** /cv/api/usage/SRM | 
*UsageApi* | [**list_srm_active_monitored_services**](docs/UsageApi.md#list_srm_active_monitored_services) | **POST** /cv/api/usage/SRM/active-monitored-services | Returns a List of active monitored services along with identifier,Active Monitored Services Count and other details
*UserApi* | [**add_user_to_user_groups**](docs/UserApi.md#add_user_to_user_groups) | **PUT** /ng/api/user/add-user-to-groups/{userId} | Add user to user groups
*UserApi* | [**add_users**](docs/UserApi.md#add_users) | **POST** /ng/api/user/users | Add user(s) to scope
*UserApi* | [**change_user_password**](docs/UserApi.md#change_user_password) | **PUT** /ng/api/user/password | Change user password
*UserApi* | [**check_if_last_admin**](docs/UserApi.md#check_if_last_admin) | **GET** /ng/api/user/last-admin | Check if user is last admin
*UserApi* | [**disable_t_two_factor_auth**](docs/UserApi.md#disable_t_two_factor_auth) | **PUT** /ng/api/user/disable-two-factor-auth | Disable two factor authentication
*UserApi* | [**enable_two_factor_auth**](docs/UserApi.md#enable_two_factor_auth) | **PUT** /ng/api/user/enable-two-factor-auth | Enable two factor authentication
*UserApi* | [**get_aggregated_user**](docs/UserApi.md#get_aggregated_user) | **GET** /ng/api/user/aggregate/{userId} | Get detailed user information
*UserApi* | [**get_aggregated_users**](docs/UserApi.md#get_aggregated_users) | **POST** /ng/api/user/aggregate | Get list of users
*UserApi* | [**get_current_user_info**](docs/UserApi.md#get_current_user_info) | **GET** /ng/api/user/currentUser | Get Current User Info
*UserApi* | [**get_two_factor_auth_settings**](docs/UserApi.md#get_two_factor_auth_settings) | **GET** /ng/api/user/two-factor-auth/{authMechanism} | Gets Two Factor Auth Settings
*UserApi* | [**get_users**](docs/UserApi.md#get_users) | **POST** /ng/api/user/batch | Get users list
*UserApi* | [**remove_user**](docs/UserApi.md#remove_user) | **DELETE** /ng/api/user/{userId} | Remove user from scope
*UserApi* | [**reset2fa**](docs/UserApi.md#reset2fa) | **GET** /ng/api/user/reset-two-factor-auth/{userId} | Reset two factor authorization
*UserApi* | [**unlock_user**](docs/UserApi.md#unlock_user) | **PUT** /ng/api/user/unlock-user/{userId} | Unlock user
*UserApi* | [**update_user_info**](docs/UserApi.md#update_user_info) | **PUT** /ng/api/user | Update User
*UserApi* | [**update_user_info1**](docs/UserApi.md#update_user_info1) | **PUT** /ng/api/user/{userId} | Update User
*UserSettingApi* | [**get_user_preferences_list**](docs/UserSettingApi.md#get_user_preferences_list) | **GET** /ng/api/user-settings/get-user-preferences | Get list of user preferences 
*UserSettingApi* | [**get_user_setting_value**](docs/UserSettingApi.md#get_user_setting_value) | **GET** /ng/api/user-settings/{identifier} | Get a user setting value by identifier
*UserSettingApi* | [**get_user_settings_list**](docs/UserSettingApi.md#get_user_settings_list) | **GET** /ng/api/user-settings | Get list of user settings under the specified category
*UserSettingApi* | [**update_user_setting_value**](docs/UserSettingApi.md#update_user_setting_value) | **PUT** /ng/api/user-settings | Update user settings
*UserGroupApi* | [**copy_user_group**](docs/UserGroupApi.md#copy_user_group) | **PUT** /ng/api/user-groups/copy | Copy User Group
*UserGroupApi* | [**delete_member**](docs/UserGroupApi.md#delete_member) | **DELETE** /ng/api/user-groups/{identifier}/member/{userIdentifier} | Remove user from User Group
*UserGroupApi* | [**delete_user_group**](docs/UserGroupApi.md#delete_user_group) | **DELETE** /ng/api/user-groups/{identifier} | Delete a User Group in an account/org/project
*UserGroupApi* | [**get_batch_users_group_list**](docs/UserGroupApi.md#get_batch_users_group_list) | **POST** /ng/api/user-groups/batch | List User Groups by filter
*UserGroupApi* | [**get_filtered_user_groups_list**](docs/UserGroupApi.md#get_filtered_user_groups_list) | **POST** /ng/api/user-groups/filter | Get filtered User Groups
*UserGroupApi* | [**get_inheriting_child_scope_list**](docs/UserGroupApi.md#get_inheriting_child_scope_list) | **GET** /ng/api/user-groups/{identifier}/scopes | Get Inheriting Child Scopes
*UserGroupApi* | [**get_member**](docs/UserGroupApi.md#get_member) | **GET** /ng/api/user-groups/{identifier}/member/{userIdentifier} | Check user membership
*UserGroupApi* | [**get_user_group**](docs/UserGroupApi.md#get_user_group) | **GET** /ng/api/user-groups/{identifier} | Get User Group
*UserGroupApi* | [**get_user_group_list**](docs/UserGroupApi.md#get_user_group_list) | **GET** /ng/api/user-groups | List the User Groups in an account/org/project
*UserGroupApi* | [**get_user_group_v2**](docs/UserGroupApi.md#get_user_group_v2) | **GET** /ng/api/v2/user-groups/{identifier} | Get User Group
*UserGroupApi* | [**get_user_list_in_user_group**](docs/UserGroupApi.md#get_user_list_in_user_group) | **POST** /ng/api/user-groups/{identifier}/users | List users in User Group
*UserGroupApi* | [**link_user_group_to_ldap**](docs/UserGroupApi.md#link_user_group_to_ldap) | **PUT** /ng/api/user-groups/{userGroupId}/link/ldap/{ldapId} | Link LDAP Group to the User Group to an account/org/project
*UserGroupApi* | [**link_user_group_to_saml**](docs/UserGroupApi.md#link_user_group_to_saml) | **PUT** /ng/api/user-groups/{userGroupId}/link/saml/{samlId} | Link SAML Group to the User Group in an account/org/project
*UserGroupApi* | [**post_user_group**](docs/UserGroupApi.md#post_user_group) | **POST** /ng/api/user-groups | Create User Group
*UserGroupApi* | [**post_user_group_v2**](docs/UserGroupApi.md#post_user_group_v2) | **POST** /ng/api/v2/user-groups | Create User Group
*UserGroupApi* | [**put_member**](docs/UserGroupApi.md#put_member) | **PUT** /ng/api/user-groups/{identifier}/member/{userIdentifier} | Add user to User Group
*UserGroupApi* | [**put_user_group**](docs/UserGroupApi.md#put_user_group) | **PUT** /ng/api/user-groups | Update User Group
*UserGroupApi* | [**put_user_group_v2**](docs/UserGroupApi.md#put_user_group_v2) | **PUT** /ng/api/v2/user-groups | Update User Group
*UserGroupApi* | [**unlink_user_groupfrom_sso**](docs/UserGroupApi.md#unlink_user_groupfrom_sso) | **PUT** /ng/api/user-groups/{userGroupId}/unlink | Unlink SSO Group from the User Group in an account/org/project
*UtilizationOverviewApi* | [**gateway_lw_api_accounts_account_id_v2_utilisation_overview_post**](docs/UtilizationOverviewApi.md#gateway_lw_api_accounts_account_id_v2_utilisation_overview_post) | **POST** /gateway/lw/api/accounts/{accountId}/v2/utilisation/overview | Get Utilization Overview
*ValidateHostApi* | [**validate_hosts**](docs/ValidateHostApi.md#validate_hosts) | **POST** /ng/api/host-validation | Validates hosts connectivity credentials
*VariablesApi* | [**create_variable**](docs/VariablesApi.md#create_variable) | **POST** /ng/api/variables | Creates a Variable.
*VariablesApi* | [**delete_variable**](docs/VariablesApi.md#delete_variable) | **DELETE** /ng/api/variables/{identifier} | Deletes Variable by ID.
*VariablesApi* | [**get_variable**](docs/VariablesApi.md#get_variable) | **GET** /ng/api/variables/{identifier} | Get the Variable by scope identifiers and variable identifier.
*VariablesApi* | [**get_variable_list**](docs/VariablesApi.md#get_variable_list) | **GET** /ng/api/variables | Fetches the list of Variables.
*VariablesApi* | [**list_variable**](docs/VariablesApi.md#list_variable) | **POST** /ng/api/variables/list | Get list of  Variable by scope identifiers and variable identifiers.
*VariablesApi* | [**update_variable**](docs/VariablesApi.md#update_variable) | **PUT** /ng/api/variables | Updates the Variable.
*WebhookEventHandlerApi* | [**process_webhook_event**](docs/WebhookEventHandlerApi.md#process_webhook_event) | **POST** /ng/api/webhook | Process event payload for webhook triggers.
*WebhookTriggersApi* | [**fetch_webhook_details**](docs/WebhookTriggersApi.md#fetch_webhook_details) | **GET** /pipeline/api/webhook/triggerProcessingDetails | Gets webhook event processing details for input eventId.
*WebhookTriggersApi* | [**fetch_webhook_execution_details**](docs/WebhookTriggersApi.md#fetch_webhook_execution_details) | **GET** /pipeline/api/webhook/triggerExecutionDetails/{eventId} | Gets webhook event processing details for input eventId.
*WebhookTriggersApi* | [**fetch_webhook_execution_details_v2**](docs/WebhookTriggersApi.md#fetch_webhook_execution_details_v2) | **GET** /pipeline/api/webhook/triggerExecutionDetailsV2/{eventId} | Gets webhook event processing details for input eventId when the trigger is queued and has not triggered the pipeline yet.
*WebhookTriggersApi* | [**pipelineprocess_webhook_event**](docs/WebhookTriggersApi.md#pipelineprocess_webhook_event) | **POST** /pipeline/api/webhook/trigger | Handles event payload for webhook triggers.
*WebhookTriggersApi* | [**process_custom_webhook_event**](docs/WebhookTriggersApi.md#process_custom_webhook_event) | **POST** /pipeline/api/webhook/custom | Handles event payload for custom webhook triggers.
*WebhookTriggersApi* | [**process_custom_webhook_event_v2**](docs/WebhookTriggersApi.md#process_custom_webhook_event_v2) | **POST** /pipeline/api/webhook/custom/v2 | Handles event payload for custom webhook triggers.
*WebhookTriggersApi* | [**process_custom_webhook_event_v3**](docs/WebhookTriggersApi.md#process_custom_webhook_event_v3) | **POST** /pipeline/api/webhook/custom/{webhookToken}/v3 | Handles event payload for custom webhook triggers.
*ZendeskApi* | [**create_zendesk_ticket**](docs/ZendeskApi.md#create_zendesk_ticket) | **POST** /resourcegroup/api/zendesk | create zendesk ticket for given user
*ZendeskApi* | [**get_coveo_token**](docs/ZendeskApi.md#get_coveo_token) | **GET** /resourcegroup/api/zendesk/token | get short live token for Coveo
*ActivitiesApi* | [**activities_list_activities**](docs/ActivitiesApi.md#activities_list_activities) | **GET** /iacm/api/orgs/{org}/projects/{project}/activities | List activities
*AidaApi* | [**aida_analyze**](docs/AidaApi.md#aida_analyze) | **POST** /pm/api/v1/aida/analyze | 
*AidaApi* | [**aida_generate**](docs/AidaApi.md#aida_generate) | **POST** /pm/api/v1/aida/generate | 
*ApprovalsApi* | [**approvals_create_approval**](docs/ApprovalsApi.md#approvals_create_approval) | **POST** /iacm/api/orgs/{org}/projects/{project}/approvals | Create approval
*ApprovalsApi* | [**approvals_list_approvals**](docs/ApprovalsApi.md#approvals_list_approvals) | **GET** /iacm/api/orgs/{org}/projects/{project}/approvals | List approvals
*ApprovalsApi* | [**approvals_show_approval**](docs/ApprovalsApi.md#approvals_show_approval) | **GET** /iacm/api/orgs/{org}/projects/{project}/approvals/{id} | Show approval
*ApprovalsApi* | [**approvals_update_approval**](docs/ApprovalsApi.md#approvals_update_approval) | **PUT** /iacm/api/orgs/{org}/projects/{project}/approvals/{id} | Update approval
*CostsApi* | [**costs_list_costs**](docs/CostsApi.md#costs_list_costs) | **GET** /iacm/api/orgs/{org}/projects/{project}/costs | list-costs costs
*CostsApi* | [**costs_list_costs_per_workspace**](docs/CostsApi.md#costs_list_costs_per_workspace) | **GET** /iacm/api/orgs/{org}/projects/{project}/costs/{workspace} | list-costs-per-workspace costs
*DashboardApi* | [**dashboard_metrics**](docs/DashboardApi.md#dashboard_metrics) | **GET** /pm/api/v1/dashboard | 
*DashboardsApi* | [**clone_dashboard**](docs/DashboardsApi.md#clone_dashboard) | **POST** /dashboard/clone | 
*DashboardsApi* | [**get_dashboard_data**](docs/DashboardsApi.md#get_dashboard_data) | **GET** /dashboard/api/dashboards/{dashboard_id}/download | Download data within a Dashboard
*DashboardsApi* | [**get_dashboard_download_csv**](docs/DashboardsApi.md#get_dashboard_download_csv) | **GET** /dashboard/download/dashboards/{dashboard_id}/csv | Download a Dashboard CSV
*DashboardsApi* | [**get_dashboard_download_pdf**](docs/DashboardsApi.md#get_dashboard_download_pdf) | **GET** /dashboard/download/dashboards/{dashboard_id}/pdf | Download a Dashboard PDF
*DashboardsApi* | [**schedules_run_once**](docs/DashboardsApi.md#schedules_run_once) | **POST** /dashboard/schedules/run_once | Runs a schedule delivery once that is then immediately sent via email to recipients
*EvaluateApi* | [**evaluate_evaluate**](docs/EvaluateApi.md#evaluate_evaluate) | **POST** /pm/api/v1/evaluate | 
*EvaluationsApi* | [**evaluations_find**](docs/EvaluationsApi.md#evaluations_find) | **GET** /pm/api/v1/evaluations/{id} | 
*EvaluationsApi* | [**evaluations_list**](docs/EvaluationsApi.md#evaluations_list) | **GET** /pm/api/v1/evaluations | 
*ExamplesApi* | [**examples_list**](docs/ExamplesApi.md#examples_list) | **GET** /pm/api/v1/examples | 
*ExecutionsApi* | [**executions_create_execution**](docs/ExecutionsApi.md#executions_create_execution) | **POST** /iacm/api/orgs/{org}/projects/{project}/executions | create-execution executions
*ExecutionsApi* | [**executions_list_cost_changes**](docs/ExecutionsApi.md#executions_list_cost_changes) | **GET** /iacm/api/orgs/{org}/projects/{project}/executions/{pipeline_execution_id}/cost-changes | list-cost-changes executions
*ExecutionsApi* | [**executions_list_executions**](docs/ExecutionsApi.md#executions_list_executions) | **GET** /iacm/api/orgs/{org}/projects/{project}/executions | list-executions executions
*ExecutionsApi* | [**executions_list_resource_changes**](docs/ExecutionsApi.md#executions_list_resource_changes) | **GET** /iacm/api/orgs/{org}/projects/{project}/executions/{pipeline_execution_id}/resource-changes | list-resource-changes executions
*ExecutionsApi* | [**executions_modify_execution**](docs/ExecutionsApi.md#executions_modify_execution) | **POST** /iacm/api/orgs/{org}/projects/{project}/executions/{pipeline_execution_id}/{pipeline_stage_id}/audit-event | modify-execution executions
*ExecutionsApi* | [**executions_show_execution**](docs/ExecutionsApi.md#executions_show_execution) | **GET** /iacm/api/orgs/{org}/projects/{project}/executions/{pipeline_execution_id}/{pipeline_stage_id} | show-execution executions
*LabelsApi* | [**assign_label**](docs/LabelsApi.md#assign_label) | **PUT** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/labels | Assign label to pull request
*LabelsApi* | [**define_repo_label**](docs/LabelsApi.md#define_repo_label) | **POST** /code/api/v1/repos/{repo_identifier}/labels | Create label at repo level
*LabelsApi* | [**define_repo_label_value**](docs/LabelsApi.md#define_repo_label_value) | **POST** /code/api/v1/repos/{repo_identifier}/labels/{key}/values | Create label value at repo level
*LabelsApi* | [**define_space_label**](docs/LabelsApi.md#define_space_label) | **POST** /code/api/v1/labels | Create label at account, org or project level
*LabelsApi* | [**define_space_label_value**](docs/LabelsApi.md#define_space_label_value) | **POST** /code/api/v1/labels/{key}/values | Create label value at account, org or project level
*LabelsApi* | [**delete_repo_label**](docs/LabelsApi.md#delete_repo_label) | **DELETE** /code/api/v1/repos/{repo_identifier}/labels/{key} | Delete label at repo level
*LabelsApi* | [**delete_repo_label_value**](docs/LabelsApi.md#delete_repo_label_value) | **DELETE** /code/api/v1/repos/{repo_identifier}/labels/{key}/values/{value} | Delete label value at repo level
*LabelsApi* | [**delete_space_label**](docs/LabelsApi.md#delete_space_label) | **DELETE** /code/api/v1/labels/{key} | Delete label at account, org or project level
*LabelsApi* | [**delete_space_label_value**](docs/LabelsApi.md#delete_space_label_value) | **DELETE** /code/api/v1/labels/{key}/values/{value} | Delete label value at account, org or project level
*LabelsApi* | [**list_pull_req_labels**](docs/LabelsApi.md#list_pull_req_labels) | **GET** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/labels | List labels assigned to pull request
*LabelsApi* | [**list_repo_label_values**](docs/LabelsApi.md#list_repo_label_values) | **GET** /code/api/v1/repos/{repo_identifier}/labels/{key}/values | List label values at repo level
*LabelsApi* | [**list_repo_labels**](docs/LabelsApi.md#list_repo_labels) | **GET** /code/api/v1/repos/{repo_identifier}/labels | List labels at repo level
*LabelsApi* | [**list_space_label_values**](docs/LabelsApi.md#list_space_label_values) | **GET** /code/api/v1/labels/{key}/values | List label values at account, org or project level
*LabelsApi* | [**list_space_labels**](docs/LabelsApi.md#list_space_labels) | **GET** /code/api/v1/labels | List labels at account, org or project level
*LabelsApi* | [**save_repo_label**](docs/LabelsApi.md#save_repo_label) | **PUT** /code/api/v1/repos/{repo_identifier}/labels | Save label and values at repo level
*LabelsApi* | [**save_space_label**](docs/LabelsApi.md#save_space_label) | **PUT** /code/api/v1/labels | Save label and values at account, org or project level
*LabelsApi* | [**unassign_label**](docs/LabelsApi.md#unassign_label) | **DELETE** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/labels/{label_id} | Unassign label from pull request
*LabelsApi* | [**update_repo_label**](docs/LabelsApi.md#update_repo_label) | **PATCH** /code/api/v1/repos/{repo_identifier}/labels/{key} | Update label at repo level
*LabelsApi* | [**update_repo_label_value**](docs/LabelsApi.md#update_repo_label_value) | **PATCH** /code/api/v1/repos/{repo_identifier}/labels/{key}/values/{value} | Update label value at repo level
*LabelsApi* | [**update_space_label**](docs/LabelsApi.md#update_space_label) | **PATCH** /code/api/v1/labels/{key} | Update label at account, org or project level
*LabelsApi* | [**update_space_label_value**](docs/LabelsApi.md#update_space_label_value) | **PATCH** /code/api/v1/labels/{key}/values/{value} | Update label value at account, org or project level
*LdapSettingsApi* | [**get_account_ldap_settings**](docs/LdapSettingsApi.md#get_account_ldap_settings) | **GET** /v1/ldap-settings | Get ldap settings for the account
*ModuleRegistryApi* | [**module_registry_create_module**](docs/ModuleRegistryApi.md#module_registry_create_module) | **POST** /iacm/api/modules | create-module module-registry
*ModuleRegistryApi* | [**module_registry_delete_module**](docs/ModuleRegistryApi.md#module_registry_delete_module) | **DELETE** /iacm/api/modules/{id} | delete-module module-registry
*ModuleRegistryApi* | [**module_registry_download**](docs/ModuleRegistryApi.md#module_registry_download) | **GET** /iacm/registry/account/{account}/{name}/{system}/{version}/download | download module-registry
*ModuleRegistryApi* | [**module_registry_list_connectors**](docs/ModuleRegistryApi.md#module_registry_list_connectors) | **GET** /iacm/api/modules/connectors | list-connectors module-registry
*ModuleRegistryApi* | [**module_registry_list_metadata_by_module**](docs/ModuleRegistryApi.md#module_registry_list_metadata_by_module) | **GET** /iacm/api/modules/{module_id}/metadata | list-metadata-by-module module-registry
*ModuleRegistryApi* | [**module_registry_list_modules_by_account**](docs/ModuleRegistryApi.md#module_registry_list_modules_by_account) | **GET** /iacm/api/modules | list_modules-by-account module-registry
*ModuleRegistryApi* | [**module_registry_list_modules_by_id**](docs/ModuleRegistryApi.md#module_registry_list_modules_by_id) | **GET** /iacm/api/modules/{id} | list-modules-by-id module-registry
*ModuleRegistryApi* | [**module_registry_list_readme_by_id**](docs/ModuleRegistryApi.md#module_registry_list_readme_by_id) | **GET** /iacm/api/modules/{module_id}/readme | list-readme-by-id module-registry
*ModuleRegistryApi* | [**module_registry_list_versions**](docs/ModuleRegistryApi.md#module_registry_list_versions) | **GET** /iacm/registry/account/{account}/{name}/{system}/versions | list-versions module-registry
*ModuleRegistryApi* | [**module_registry_module_parsed_data**](docs/ModuleRegistryApi.md#module_registry_module_parsed_data) | **POST** /iacm/api/modules/{name}/{system}/{version}/metadata | module-parsed-data module-registry
*ModuleRegistryApi* | [**module_registry_post_module_readme**](docs/ModuleRegistryApi.md#module_registry_post_module_readme) | **POST** /iacm/api/modules/{name}/{system}/{version}/readme | post-module-readme module-registry
*ModuleRegistryApi* | [**module_registry_post_module_tags**](docs/ModuleRegistryApi.md#module_registry_post_module_tags) | **POST** /iacm/api/modules/{name}/{system}/tags | post-module-tags module-registry
*ModuleRegistryApi* | [**module_registry_sync_module_metadata**](docs/ModuleRegistryApi.md#module_registry_sync_module_metadata) | **POST** /iacm/api/modules/{id}/sync | sync-module-metadata module-registry
*ModuleRegistryApi* | [**module_registry_update_module**](docs/ModuleRegistryApi.md#module_registry_update_module) | **PUT** /iacm/api/modules/{id} | update-module module-registry
*PoliciesApi* | [**policies_create**](docs/PoliciesApi.md#policies_create) | **POST** /pm/api/v1/policies | 
*PoliciesApi* | [**policies_delete**](docs/PoliciesApi.md#policies_delete) | **DELETE** /pm/api/v1/policies/{identifier} | 
*PoliciesApi* | [**policies_find**](docs/PoliciesApi.md#policies_find) | **GET** /pm/api/v1/policies/{identifier} | 
*PoliciesApi* | [**policies_list**](docs/PoliciesApi.md#policies_list) | **GET** /pm/api/v1/policies | 
*PoliciesApi* | [**policies_update**](docs/PoliciesApi.md#policies_update) | **PATCH** /pm/api/v1/policies/{identifier} | 
*PolicysetsApi* | [**policysets_create**](docs/PolicysetsApi.md#policysets_create) | **POST** /pm/api/v1/policysets | 
*PolicysetsApi* | [**policysets_delete**](docs/PolicysetsApi.md#policysets_delete) | **DELETE** /pm/api/v1/policysets/{identifier} | 
*PolicysetsApi* | [**policysets_find**](docs/PolicysetsApi.md#policysets_find) | **GET** /pm/api/v1/policysets/{identifier} | 
*PolicysetsApi* | [**policysets_list**](docs/PolicysetsApi.md#policysets_list) | **GET** /pm/api/v1/policysets | 
*PolicysetsApi* | [**policysets_update**](docs/PolicysetsApi.md#policysets_update) | **PATCH** /pm/api/v1/policysets/{identifier} | 
*PullreqApi* | [**checks_pull_req**](docs/PullreqApi.md#checks_pull_req) | **GET** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/checks | Get status checks
*PullreqApi* | [**codeowners_pull_req**](docs/PullreqApi.md#codeowners_pull_req) | **GET** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/codeowners | Get code owners
*PullreqApi* | [**comment_apply_suggestions**](docs/PullreqApi.md#comment_apply_suggestions) | **POST** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/comments/apply-suggestions | Apply pull request code comment suggestions
*PullreqApi* | [**comment_create_pull_req**](docs/PullreqApi.md#comment_create_pull_req) | **POST** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/comments | Create new pull request comment
*PullreqApi* | [**comment_delete_pull_req**](docs/PullreqApi.md#comment_delete_pull_req) | **DELETE** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/comments/{pullreq_comment_id} | Delete pull request comment
*PullreqApi* | [**comment_status_pull_req**](docs/PullreqApi.md#comment_status_pull_req) | **PUT** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/comments/{pullreq_comment_id}/status | Update status of pull request comment
*PullreqApi* | [**comment_update_pull_req**](docs/PullreqApi.md#comment_update_pull_req) | **PATCH** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/comments/{pullreq_comment_id} | Update pull request comment
*PullreqApi* | [**create_pull_req**](docs/PullreqApi.md#create_pull_req) | **POST** /code/api/v1/repos/{repo_identifier}/pullreq | Create pull request
*PullreqApi* | [**diff_pull_req**](docs/PullreqApi.md#diff_pull_req) | **GET** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/diff | Get file changes
*PullreqApi* | [**diff_pull_req_post**](docs/PullreqApi.md#diff_pull_req_post) | **POST** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/diff | Get file changes
*PullreqApi* | [**file_view_add_pull_req**](docs/PullreqApi.md#file_view_add_pull_req) | **PUT** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/file-views | Mark file as viewed
*PullreqApi* | [**file_view_delete_pull_req**](docs/PullreqApi.md#file_view_delete_pull_req) | **DELETE** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/file-views/{file_path} | Remove file view
*PullreqApi* | [**file_view_list_pull_req**](docs/PullreqApi.md#file_view_list_pull_req) | **GET** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/file-views | List viewed files
*PullreqApi* | [**get_pull_req**](docs/PullreqApi.md#get_pull_req) | **GET** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number} | Get pull request
*PullreqApi* | [**list_pull_req**](docs/PullreqApi.md#list_pull_req) | **GET** /code/api/v1/repos/{repo_identifier}/pullreq | List pull requests
*PullreqApi* | [**list_pull_req_activities**](docs/PullreqApi.md#list_pull_req_activities) | **GET** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/activities | List activities
*PullreqApi* | [**list_pull_req_commits**](docs/PullreqApi.md#list_pull_req_commits) | **GET** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/commits | List commits
*PullreqApi* | [**merge_pull_req_op**](docs/PullreqApi.md#merge_pull_req_op) | **POST** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/merge | Merge
*PullreqApi* | [**pull_req_meta_data**](docs/PullreqApi.md#pull_req_meta_data) | **GET** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/metadata | Get metadata
*PullreqApi* | [**restore_pull_req_source_branch**](docs/PullreqApi.md#restore_pull_req_source_branch) | **POST** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/branch | Restore pull request source branch
*PullreqApi* | [**review_submit_pull_req**](docs/PullreqApi.md#review_submit_pull_req) | **POST** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/reviews | Submit review
*PullreqApi* | [**reviewer_add_pull_req**](docs/PullreqApi.md#reviewer_add_pull_req) | **PUT** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/reviewers | Add reviewer
*PullreqApi* | [**reviewer_delete_pull_req**](docs/PullreqApi.md#reviewer_delete_pull_req) | **DELETE** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/reviewers/{pullreq_reviewer_id} | Remove reviewer
*PullreqApi* | [**reviewer_list_pull_req**](docs/PullreqApi.md#reviewer_list_pull_req) | **GET** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/reviewers | List reviewers
*PullreqApi* | [**state_pull_req**](docs/PullreqApi.md#state_pull_req) | **POST** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number}/state | Update state of pull request
*PullreqApi* | [**update_pull_req**](docs/PullreqApi.md#update_pull_req) | **PATCH** /code/api/v1/repos/{repo_identifier}/pullreq/{pullreq_number} | Update pull request
*RepositoryApi* | [**archive**](docs/RepositoryApi.md#archive) | **GET** /code/api/v1/repos/{repo_identifier}/archive/{git_ref}.{format} | Download repo in archived format
*RepositoryApi* | [**calculate_commit_divergence**](docs/RepositoryApi.md#calculate_commit_divergence) | **POST** /code/api/v1/repos/{repo_identifier}/commits/calculate-divergence | Get commit divergence
*RepositoryApi* | [**code_owners_validate**](docs/RepositoryApi.md#code_owners_validate) | **GET** /code/api/v1/repos/{repo_identifier}/codeowners/validate | Validate code owners file
*RepositoryApi* | [**commit_files**](docs/RepositoryApi.md#commit_files) | **POST** /code/api/v1/repos/{repo_identifier}/commits | Commit files
*RepositoryApi* | [**create_branch**](docs/RepositoryApi.md#create_branch) | **POST** /code/api/v1/repos/{repo_identifier}/branches | Create branch
*RepositoryApi* | [**create_repository**](docs/RepositoryApi.md#create_repository) | **POST** /code/api/v1/repos | Create repository
*RepositoryApi* | [**create_tag**](docs/RepositoryApi.md#create_tag) | **POST** /code/api/v1/repos/{repo_identifier}/tags | Create tag
*RepositoryApi* | [**delete_branch**](docs/RepositoryApi.md#delete_branch) | **DELETE** /code/api/v1/repos/{repo_identifier}/branches/{branch_name} | Delete branch
*RepositoryApi* | [**delete_repository**](docs/RepositoryApi.md#delete_repository) | **DELETE** /code/api/v1/repos/{repo_identifier} | Soft delete repository
*RepositoryApi* | [**delete_tag**](docs/RepositoryApi.md#delete_tag) | **DELETE** /code/api/v1/repos/{repo_identifier}/tags/{tag_name} | Delete tag
*RepositoryApi* | [**diff_stats**](docs/RepositoryApi.md#diff_stats) | **GET** /code/api/v1/repos/{repo_identifier}/diff-stats/{range} | Get diff stats
*RepositoryApi* | [**find_general_settings**](docs/RepositoryApi.md#find_general_settings) | **GET** /code/api/v1/repos/{repo_identifier}/settings/general | Get general settings
*RepositoryApi* | [**find_security_settings**](docs/RepositoryApi.md#find_security_settings) | **GET** /code/api/v1/repos/{repo_identifier}/settings/security | Get security settings
*RepositoryApi* | [**get_blame**](docs/RepositoryApi.md#get_blame) | **GET** /code/api/v1/repos/{repo_identifier}/blame/{path} | Get git blame
*RepositoryApi* | [**get_branch**](docs/RepositoryApi.md#get_branch) | **GET** /code/api/v1/repos/{repo_identifier}/branches/{branch_name} | Get branch
*RepositoryApi* | [**get_commit**](docs/RepositoryApi.md#get_commit) | **GET** /code/api/v1/repos/{repo_identifier}/commits/{commit_sha} | Get commit
*RepositoryApi* | [**get_commit_diff**](docs/RepositoryApi.md#get_commit_diff) | **GET** /code/api/v1/repos/{repo_identifier}/commits/{commit_sha}/diff | Get raw git diff of a commit
*RepositoryApi* | [**get_content**](docs/RepositoryApi.md#get_content) | **GET** /code/api/v1/repos/{repo_identifier}/content/{path} | Get content of a file
*RepositoryApi* | [**get_raw**](docs/RepositoryApi.md#get_raw) | **GET** /code/api/v1/repos/{repo_identifier}/raw/{path} | Get raw file content
*RepositoryApi* | [**get_repository**](docs/RepositoryApi.md#get_repository) | **GET** /code/api/v1/repos/{repo_identifier} | Get repository
*RepositoryApi* | [**import_repository**](docs/RepositoryApi.md#import_repository) | **POST** /code/api/v1/repos/import | Import repository
*RepositoryApi* | [**list_branches**](docs/RepositoryApi.md#list_branches) | **GET** /code/api/v1/repos/{repo_identifier}/branches | List branches
*RepositoryApi* | [**list_commits**](docs/RepositoryApi.md#list_commits) | **GET** /code/api/v1/repos/{repo_identifier}/commits | List commits
*RepositoryApi* | [**list_paths**](docs/RepositoryApi.md#list_paths) | **GET** /code/api/v1/repos/{repo_identifier}/paths | List all paths
*RepositoryApi* | [**list_repos**](docs/RepositoryApi.md#list_repos) | **GET** /code/api/v1/repos | List repositories
*RepositoryApi* | [**list_tags**](docs/RepositoryApi.md#list_tags) | **GET** /code/api/v1/repos/{repo_identifier}/tags | List tags
*RepositoryApi* | [**merge_check**](docs/RepositoryApi.md#merge_check) | **POST** /code/api/v1/repos/{repo_identifier}/merge-check/{range} | Check mergeability
*RepositoryApi* | [**path_details**](docs/RepositoryApi.md#path_details) | **POST** /code/api/v1/repos/{repo_identifier}/path-details | Get commit details
*RepositoryApi* | [**purge_repository**](docs/RepositoryApi.md#purge_repository) | **POST** /code/api/v1/repos/{repo_identifier}/purge | Purge repository
*RepositoryApi* | [**raw_diff**](docs/RepositoryApi.md#raw_diff) | **GET** /code/api/v1/repos/{repo_identifier}/diff/{range} | Get raw diff
*RepositoryApi* | [**raw_diff_post**](docs/RepositoryApi.md#raw_diff_post) | **POST** /code/api/v1/repos/{repo_identifier}/diff/{range} | Get raw diff
*RepositoryApi* | [**rebase_branch**](docs/RepositoryApi.md#rebase_branch) | **POST** /code/api/v1/repos/{repo_identifier}/rebase | Rebase a branch relative to another branch or a commit
*RepositoryApi* | [**restore_repository**](docs/RepositoryApi.md#restore_repository) | **POST** /code/api/v1/repos/{repo_identifier}/restore | Restore repository
*RepositoryApi* | [**rule_add**](docs/RepositoryApi.md#rule_add) | **POST** /code/api/v1/repos/{repo_identifier}/rules | Add protection rule
*RepositoryApi* | [**rule_delete**](docs/RepositoryApi.md#rule_delete) | **DELETE** /code/api/v1/repos/{repo_identifier}/rules/{rule_uid} | Delete protection rule
*RepositoryApi* | [**rule_get**](docs/RepositoryApi.md#rule_get) | **GET** /code/api/v1/repos/{repo_identifier}/rules/{rule_uid} | Get protection rule
*RepositoryApi* | [**rule_list**](docs/RepositoryApi.md#rule_list) | **GET** /code/api/v1/repos/{repo_identifier}/rules | List protection rules
*RepositoryApi* | [**rule_update**](docs/RepositoryApi.md#rule_update) | **PATCH** /code/api/v1/repos/{repo_identifier}/rules/{rule_uid} | Update protection rule
*RepositoryApi* | [**squash_branch**](docs/RepositoryApi.md#squash_branch) | **POST** /code/api/v1/repos/{repo_identifier}/squash | Squashes commits in a branch relative to another branch or a commit
*RepositoryApi* | [**summary**](docs/RepositoryApi.md#summary) | **GET** /code/api/v1/repos/{repo_identifier}/summary | Get repository summary
*RepositoryApi* | [**update_default_branch**](docs/RepositoryApi.md#update_default_branch) | **POST** /code/api/v1/repos/{repo_identifier}/default-branch | Update default branch
*RepositoryApi* | [**update_general_settings**](docs/RepositoryApi.md#update_general_settings) | **PATCH** /code/api/v1/repos/{repo_identifier}/settings/general | Update general settings
*RepositoryApi* | [**update_repository**](docs/RepositoryApi.md#update_repository) | **PATCH** /code/api/v1/repos/{repo_identifier} | Update repository
*RepositoryApi* | [**update_security_settings**](docs/RepositoryApi.md#update_security_settings) | **PATCH** /code/api/v1/repos/{repo_identifier}/settings/security | Update security settings
*ResourceApi* | [**list_gitignore**](docs/ResourceApi.md#list_gitignore) | **GET** /code/api/v1/resources/gitignore | List available gitignore names
*ResourceApi* | [**list_licenses**](docs/ResourceApi.md#list_licenses) | **GET** /code/api/v1/resources/license | List available license names
*SettingsApi* | [**settings_check_push_data**](docs/SettingsApi.md#settings_check_push_data) | **GET** /iacm/api/orgs/{org}/projects/{project}/settings/disabled | check-push-data settings
*SettingsApi* | [**settings_delete_default_pipeline**](docs/SettingsApi.md#settings_delete_default_pipeline) | **DELETE** /iacm/api/orgs/{org}/projects/{project}/settings/default-pipelines | delete-default-pipeline settings
*SettingsApi* | [**settings_list_default_pipelines**](docs/SettingsApi.md#settings_list_default_pipelines) | **GET** /iacm/api/orgs/{org}/projects/{project}/settings/default-pipelines | list-default-pipelines settings
*SettingsApi* | [**settings_upsert_default_pipeline**](docs/SettingsApi.md#settings_upsert_default_pipeline) | **PUT** /iacm/api/orgs/{org}/projects/{project}/settings/default-pipelines | upsert-default-pipeline settings
*StatusChecksApi* | [**list_status_check_recent**](docs/StatusChecksApi.md#list_status_check_recent) | **GET** /code/api/v1/repos/{repo_identifier}/checks/recent | List recent status check
*StatusChecksApi* | [**list_status_check_results**](docs/StatusChecksApi.md#list_status_check_results) | **GET** /code/api/v1/repos/{repo_identifier}/checks/commits/{commit_sha} | List status check results
*StatusChecksApi* | [**report_status_check_results**](docs/StatusChecksApi.md#report_status_check_results) | **PUT** /code/api/v1/repos/{repo_identifier}/checks/commits/{commit_sha} | Report status check results
*SystemApi* | [**ia_c_msystem_health**](docs/SystemApi.md#ia_c_msystem_health) | **GET** /iacm/api/health | health system
*SystemApi* | [**ia_c_msystem_version**](docs/SystemApi.md#ia_c_msystem_version) | **GET** /iacm/api/version | version system
*SystemApi* | [**system_health**](docs/SystemApi.md#system_health) | **GET** /pm/api/v1/system/health | 
*SystemApi* | [**system_latest_plugin_version**](docs/SystemApi.md#system_latest_plugin_version) | **POST** /iacm/api/latest-plugin-version | latest-plugin-version system
*SystemApi* | [**system_list_supported_provisioner_versions**](docs/SystemApi.md#system_list_supported_provisioner_versions) | **GET** /iacm/api/provisioners/supported/{provisioner} | list-supported-provisioner-versions system
*SystemApi* | [**system_version**](docs/SystemApi.md#system_version) | **GET** /pm/api/v1/system/version | 
*TasApi* | [**get_tas_organizations**](docs/TasApi.md#get_tas_organizations) | **GET** /ng/api/tas/organizations | Return the Tas organizations
*TasApi* | [**get_tas_spaces**](docs/TasApi.md#get_tas_spaces) | **GET** /ng/api/tas/space | Return the Tas spaces
*TasApi* | [**get_tas_spaces_v2**](docs/TasApi.md#get_tas_spaces_v2) | **GET** /ng/api/tas/v2/space | Return the Tas spaces
*TfStandardBackendApi* | [**tf_standard_backend_lock_workspace**](docs/TfStandardBackendApi.md#tf_standard_backend_lock_workspace) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/terraform-backend/lock | lock-workspace tf-standard-backend
*TfStandardBackendApi* | [**tf_standard_backend_pull_terraform_state**](docs/TfStandardBackendApi.md#tf_standard_backend_pull_terraform_state) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/terraform-backend | pull-terraform-state tf-standard-backend
*TfStandardBackendApi* | [**tf_standard_backend_push_terraform_state**](docs/TfStandardBackendApi.md#tf_standard_backend_push_terraform_state) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/terraform-backend | push-terraform-state tf-standard-backend
*TfStandardBackendApi* | [**tf_standard_backend_unlock_workspace**](docs/TfStandardBackendApi.md#tf_standard_backend_unlock_workspace) | **DELETE** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/terraform-backend/lock | unlock-workspace tf-standard-backend
*UploadApi* | [**repo_artifact_download**](docs/UploadApi.md#repo_artifact_download) | **GET** /code/api/v1/repos/{repo_identifier}/uploads/{file_ref} | Repo artifact download
*UploadApi* | [**repo_artifact_upload**](docs/UploadApi.md#repo_artifact_upload) | **POST** /code/api/v1/repos/{repo_identifier}/uploads | Repo artifact upload
*UsageApi* | [**usage_check_licence**](docs/UsageApi.md#usage_check_licence) | **GET** /iacm/api/usage/check-licence | checkLicence usage
*UsageApi* | [**usage_get_usage**](docs/UsageApi.md#usage_get_usage) | **PUT** /iacm/api/enforcement/client/usage/{metric} | getUsage usage
*VariablesApi* | [**variables_create_variable**](docs/VariablesApi.md#variables_create_variable) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/variables | Create workspace variable
*VariablesApi* | [**variables_destroy_variable**](docs/VariablesApi.md#variables_destroy_variable) | **DELETE** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/variables/{kind}/{key} | Destroy workspace variable
*VariablesApi* | [**variables_list_variables**](docs/VariablesApi.md#variables_list_variables) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/variables | List workspace variables
*VariablesApi* | [**variables_show_variable**](docs/VariablesApi.md#variables_show_variable) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/variables/{kind}/{key} | Show workspace variable
*VariablesApi* | [**variables_update_variable**](docs/VariablesApi.md#variables_update_variable) | **PUT** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/variables/{kind}/{key} | Update workspace variable
*WebhookApi* | [**create_repo_webhook**](docs/WebhookApi.md#create_repo_webhook) | **POST** /code/api/v1/repos/{repo_identifier}/webhooks | Create repo webhook
*WebhookApi* | [**create_space_webhook**](docs/WebhookApi.md#create_space_webhook) | **POST** /code/api/v1/webhooks | Create acc, org or proj webhook
*WebhookApi* | [**delete_repo_webhook**](docs/WebhookApi.md#delete_repo_webhook) | **DELETE** /code/api/v1/repos/{repo_identifier}/webhooks/{webhook_identifier} | Delete repo webhook
*WebhookApi* | [**delete_space_webhook**](docs/WebhookApi.md#delete_space_webhook) | **DELETE** /code/api/v1/webhooks/{webhook_identifier} | Delete acc, org or proj webhook
*WebhookApi* | [**get_repo_webhook**](docs/WebhookApi.md#get_repo_webhook) | **GET** /code/api/v1/repos/{repo_identifier}/webhooks/{webhook_identifier} | Get repo webhook
*WebhookApi* | [**get_repo_webhook_execution**](docs/WebhookApi.md#get_repo_webhook_execution) | **GET** /code/api/v1/repos/{repo_identifier}/webhooks/{webhook_identifier}/executions/{webhook_execution_id} | Get repo webhook execution
*WebhookApi* | [**get_space_webhook**](docs/WebhookApi.md#get_space_webhook) | **GET** /code/api/v1/webhooks/{webhook_identifier} | Get acc, org or proj webhook
*WebhookApi* | [**get_space_webhook_execution**](docs/WebhookApi.md#get_space_webhook_execution) | **GET** /code/api/v1/webhooks/{webhook_identifier}/executions/{webhook_execution_id} | Get acc, org or proj webhook execution
*WebhookApi* | [**list_repo_webhook_executions**](docs/WebhookApi.md#list_repo_webhook_executions) | **GET** /code/api/v1/repos/{repo_identifier}/webhooks/{webhook_identifier}/executions | List repo webhook executions
*WebhookApi* | [**list_repo_webhooks**](docs/WebhookApi.md#list_repo_webhooks) | **GET** /code/api/v1/repos/{repo_identifier}/webhooks | List repo webhooks
*WebhookApi* | [**list_space_webhook_executions**](docs/WebhookApi.md#list_space_webhook_executions) | **GET** /code/api/v1/webhooks/{webhook_identifier}/executions | List acc, org or proj webhook executions
*WebhookApi* | [**list_space_webhooks**](docs/WebhookApi.md#list_space_webhooks) | **GET** /code/api/v1/webhooks | List acc, org or proj webhooks
*WebhookApi* | [**retrigger_repo_webhook_execution**](docs/WebhookApi.md#retrigger_repo_webhook_execution) | **POST** /code/api/v1/repos/{repo_identifier}/webhooks/{webhook_identifier}/executions/{webhook_execution_id}/retrigger | Retrigger repo webhook execution
*WebhookApi* | [**retrigger_space_webhook_execution**](docs/WebhookApi.md#retrigger_space_webhook_execution) | **POST** /code/api/v1/webhooks/{webhook_identifier}/executions/{webhook_execution_id}/retrigger | Retrigger acc, org or proj webhook execution
*WebhookApi* | [**update_repo_webhook**](docs/WebhookApi.md#update_repo_webhook) | **PATCH** /code/api/v1/repos/{repo_identifier}/webhooks/{webhook_identifier} | Update repo webhook
*WebhookApi* | [**update_space_webhook**](docs/WebhookApi.md#update_space_webhook) | **PATCH** /code/api/v1/webhooks/{webhook_identifier} | Update acc, org or proj webhook
*WorkspaceTemplatesApi* | [**workspace_templates_add_workspace_template**](docs/WorkspaceTemplatesApi.md#workspace_templates_add_workspace_template) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspace/templates | Create workspace template
*WorkspaceTemplatesApi* | [**workspace_templates_get_workspaces_by_template_id**](docs/WorkspaceTemplatesApi.md#workspace_templates_get_workspaces_by_template_id) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspace/templates/{template_id} | List workspaces by template id
*WorkspaceTemplatesApi* | [**workspace_templates_update_workspace_template**](docs/WorkspaceTemplatesApi.md#workspace_templates_update_workspace_template) | **PUT** /iacm/api/orgs/{org}/projects/{project}/workspace/templates/{template_id}/{workspace_id} | Update workspace template
*WorkspacesApi* | [**workspaces_clone_workspace**](docs/WorkspacesApi.md#workspaces_clone_workspace) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/clone | clone-workspace workspaces
*WorkspacesApi* | [**workspaces_create_data**](docs/WorkspacesApi.md#workspaces_create_data) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/data | create-data workspaces
*WorkspacesApi* | [**workspaces_create_speculative_plan**](docs/WorkspacesApi.md#workspaces_create_speculative_plan) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/speculative-plans | create-speculative-plan workspaces
*WorkspacesApi* | [**workspaces_create_workspace**](docs/WorkspacesApi.md#workspaces_create_workspace) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspaces | create-workspace workspaces
*WorkspacesApi* | [**workspaces_destroy_workspace**](docs/WorkspacesApi.md#workspaces_destroy_workspace) | **DELETE** /iacm/api/orgs/{org}/projects/{project}/workspaces/{identifier} | destroy-workspace workspaces
*WorkspacesApi* | [**workspaces_download_speculative_plan**](docs/WorkspacesApi.md#workspaces_download_speculative_plan) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/speculative-plans/{id}/download | download-speculative-plan workspaces
*WorkspacesApi* | [**workspaces_evaluate_data**](docs/WorkspacesApi.md#workspaces_evaluate_data) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/data/{id}/evaluate-policy | evaluate-data workspaces
*WorkspacesApi* | [**workspaces_execute_speculative_plan**](docs/WorkspacesApi.md#workspaces_execute_speculative_plan) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/speculative-plans/{id}/execute | execute-speculative-plan workspaces
*WorkspacesApi* | [**workspaces_find_speculative_plan**](docs/WorkspacesApi.md#workspaces_find_speculative_plan) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/speculative-plans/{id} | find-speculative-plan workspaces
*WorkspacesApi* | [**workspaces_force_unlock_workspace**](docs/WorkspacesApi.md#workspaces_force_unlock_workspace) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspaces/{identifier}/actions/force-unlock | force-unlock-workspace workspaces
*WorkspacesApi* | [**workspaces_list_data**](docs/WorkspacesApi.md#workspaces_list_data) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/data | list-data workspaces
*WorkspacesApi* | [**workspaces_list_pipelines**](docs/WorkspacesApi.md#workspaces_list_pipelines) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/pipelines | list-pipelines workspaces
*WorkspacesApi* | [**workspaces_list_resources**](docs/WorkspacesApi.md#workspaces_list_resources) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces/{identifier}/resources | list-resources workspaces
*WorkspacesApi* | [**workspaces_list_workspaces**](docs/WorkspacesApi.md#workspaces_list_workspaces) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces | list-workspaces workspaces
*WorkspacesApi* | [**workspaces_send_event**](docs/WorkspacesApi.md#workspaces_send_event) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/events | send-event workspaces
*WorkspacesApi* | [**workspaces_show_data**](docs/WorkspacesApi.md#workspaces_show_data) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/data/{id} | show-data workspaces
*WorkspacesApi* | [**workspaces_show_workspace**](docs/WorkspacesApi.md#workspaces_show_workspace) | **GET** /iacm/api/orgs/{org}/projects/{project}/workspaces/{identifier} | show-workspace workspaces
*WorkspacesApi* | [**workspaces_update_workspace**](docs/WorkspacesApi.md#workspaces_update_workspace) | **PUT** /iacm/api/orgs/{org}/projects/{project}/workspaces/{identifier} | update-workspace workspaces
*WorkspacesApi* | [**workspaces_upload_speculative_plan**](docs/WorkspacesApi.md#workspaces_upload_speculative_plan) | **POST** /iacm/api/orgs/{org}/projects/{project}/workspaces/{workspace}/speculative-plans/{id}/upload | upload-speculative-plan workspaces

## Documentation For Models

 - [ACLAggregateFilter](docs/ACLAggregateFilter.md)
 - [AMIFilter](docs/AMIFilter.md)
 - [ASGMinimal](docs/ASGMinimal.md)
 - [AWSViewPreferences](docs/AWSViewPreferences.md)
 - [AbortedBy](docs/AbortedBy.md)
 - [AbstractServiceLevelObjective](docs/AbstractServiceLevelObjective.md)
 - [AccessCheckRequest](docs/AccessCheckRequest.md)
 - [AccessCheckResponse](docs/AccessCheckResponse.md)
 - [AccessControl](docs/AccessControl.md)
 - [AccessDeniedError](docs/AccessDeniedError.md)
 - [AccessPoint](docs/AccessPoint.md)
 - [AccessPointActivityResponse](docs/AccessPointActivityResponse.md)
 - [AccessPointMeta](docs/AccessPointMeta.md)
 - [AccessPointMetaDns](docs/AccessPointMetaDns.md)
 - [AccessPointMetaDnsRoute53](docs/AccessPointMetaDnsRoute53.md)
 - [Account](docs/Account.md)
 - [AccountSettingConfig](docs/AccountSettingConfig.md)
 - [AccountSettingResponse](docs/AccountSettingResponse.md)
 - [AccountSettings](docs/AccountSettings.md)
 - [AccountUsage](docs/AccountUsage.md)
 - [AcrArtifactSpec](docs/AcrArtifactSpec.md)
 - [AcrArtifactTriggerSpec](docs/AcrArtifactTriggerSpec.md)
 - [Action](docs/Action.md)
 - [ActivationUpdate](docs/ActivationUpdate.md)
 - [ActiveMonitoredService](docs/ActiveMonitoredService.md)
 - [ActiveServiceMonitoredFilterParams](docs/ActiveServiceMonitoredFilterParams.md)
 - [ActivityMetadata](docs/ActivityMetadata.md)
 - [ActivityResourceCollection](docs/ActivityResourceCollection.md)
 - [AddCollaboratorAuditEventData](docs/AddCollaboratorAuditEventData.md)
 - [AddUsersDTO](docs/AddUsersDTO.md)
 - [AddUsersResponse](docs/AddUsersResponse.md)
 - [AdditionalMetadata](docs/AdditionalMetadata.md)
 - [AdviserIssuer](docs/AdviserIssuer.md)
 - [AffectedEntity](docs/AffectedEntity.md)
 - [AgentMtlsEndpointDetails](docs/AgentMtlsEndpointDetails.md)
 - [AgentMtlsEndpointRequest](docs/AgentMtlsEndpointRequest.md)
 - [AgentQueryAgentSortByOptions](docs/AgentQueryAgentSortByOptions.md)
 - [AggregateStatus](docs/AggregateStatus.md)
 - [AgreementType](docs/AgreementType.md)
 - [AlertThreshold](docs/AlertThreshold.md)
 - [AllEntitiesImport](docs/AllEntitiesImport.md)
 - [AllEntitiesRule](docs/AllEntitiesRule.md)
 - [AllResourcesOfAccountResponse](docs/AllResourcesOfAccountResponse.md)
 - [AllowListRequest](docs/AllowListRequest.md)
 - [AllowListResponse](docs/AllowListResponse.md)
 - [AllowedSourceType](docs/AllowedSourceType.md)
 - [AmazonMachineImageArtifactSpec](docs/AmazonMachineImageArtifactSpec.md)
 - [AmazonMachineImageArtifactTriggerSpec](docs/AmazonMachineImageArtifactTriggerSpec.md)
 - [AmazonS3ArtifactSpec](docs/AmazonS3ArtifactSpec.md)
 - [AmazonS3ArtifactTriggerSpec](docs/AmazonS3ArtifactTriggerSpec.md)
 - [Ambiance](docs/Ambiance.md)
 - [AnalysisDTO](docs/AnalysisDTO.md)
 - [AnalyzeRequestBody](docs/AnalyzeRequestBody.md)
 - [AnalyzeResponse](docs/AnalyzeResponse.md)
 - [AnnotationInstance](docs/AnnotationInstance.md)
 - [AnnotationInstanceDetails](docs/AnnotationInstanceDetails.md)
 - [AnomaliesSummaryDTO](docs/AnomaliesSummaryDTO.md)
 - [AnomalyData](docs/AnomalyData.md)
 - [AnomalyFeedback](docs/AnomalyFeedback.md)
 - [AnomalyFilterProperties](docs/AnomalyFilterProperties.md)
 - [AnomalySummary](docs/AnomalySummary.md)
 - [AnyOfHealthSourceSpec](docs/AnyOfHealthSourceSpec.md)
 - [ApiCallLogDTO](docs/ApiCallLogDTO.md)
 - [ApiCallLogDTOField](docs/ApiCallLogDTOField.md)
 - [ApiFileDiffRequest](docs/ApiFileDiffRequest.md)
 - [ApiFilestoreBody](docs/ApiFilestoreBody.md)
 - [ApiKey](docs/ApiKey.md)
 - [ApiKeyAggregate](docs/ApiKeyAggregate.md)
 - [ApiKeyRequestType](docs/ApiKeyRequestType.md)
 - [ApiKeys](docs/ApiKeys.md)
 - [ApiZendeskBody](docs/ApiZendeskBody.md)
 - [AppConfig](docs/AppConfig.md)
 - [AppConfigRequest](docs/AppConfigRequest.md)
 - [AppConfigResponse](docs/AppConfigResponse.md)
 - [AppDMetricDefinitions](docs/AppDMetricDefinitions.md)
 - [AppDynamicsConnectorDTO](docs/AppDynamicsConnectorDTO.md)
 - [AppDynamicsHealthSource](docs/AppDynamicsHealthSource.md)
 - [AppdynamicsClientIdConnectorSpec](docs/AppdynamicsClientIdConnectorSpec.md)
 - [AppdynamicsConnectorSpec](docs/AppdynamicsConnectorSpec.md)
 - [ApplicationBudgetScope](docs/ApplicationBudgetScope.md)
 - [ApplicationId](docs/ApplicationId.md)
 - [ApplicationQueryApplicationSortByOptions](docs/ApplicationQueryApplicationSortByOptions.md)
 - [ApplicationSettingsConfiguration](docs/ApplicationSettingsConfiguration.md)
 - [ApplicationsApplication](docs/ApplicationsApplication.md)
 - [ApplicationsApplicationCondition](docs/ApplicationsApplicationCondition.md)
 - [ApplicationsApplicationCreateRequest](docs/ApplicationsApplicationCreateRequest.md)
 - [ApplicationsApplicationDeleteRequest](docs/ApplicationsApplicationDeleteRequest.md)
 - [ApplicationsApplicationDestination](docs/ApplicationsApplicationDestination.md)
 - [ApplicationsApplicationList](docs/ApplicationsApplicationList.md)
 - [ApplicationsApplicationManifestQuery](docs/ApplicationsApplicationManifestQuery.md)
 - [ApplicationsApplicationPatchRequest](docs/ApplicationsApplicationPatchRequest.md)
 - [ApplicationsApplicationPodLogsQuery](docs/ApplicationsApplicationPodLogsQuery.md)
 - [ApplicationsApplicationQuery](docs/ApplicationsApplicationQuery.md)
 - [ApplicationsApplicationResourceDeleteRequest](docs/ApplicationsApplicationResourceDeleteRequest.md)
 - [ApplicationsApplicationResourceEventsQuery](docs/ApplicationsApplicationResourceEventsQuery.md)
 - [ApplicationsApplicationResourcePatchRequest](docs/ApplicationsApplicationResourcePatchRequest.md)
 - [ApplicationsApplicationResourceRequest](docs/ApplicationsApplicationResourceRequest.md)
 - [ApplicationsApplicationResourceResponse](docs/ApplicationsApplicationResourceResponse.md)
 - [ApplicationsApplicationResponse](docs/ApplicationsApplicationResponse.md)
 - [ApplicationsApplicationRollbackRequest](docs/ApplicationsApplicationRollbackRequest.md)
 - [ApplicationsApplicationSource](docs/ApplicationsApplicationSource.md)
 - [ApplicationsApplicationSourceDirectory](docs/ApplicationsApplicationSourceDirectory.md)
 - [ApplicationsApplicationSourceHelm](docs/ApplicationsApplicationSourceHelm.md)
 - [ApplicationsApplicationSourceJsonnet](docs/ApplicationsApplicationSourceJsonnet.md)
 - [ApplicationsApplicationSourceKsonnet](docs/ApplicationsApplicationSourceKsonnet.md)
 - [ApplicationsApplicationSourceKustomize](docs/ApplicationsApplicationSourceKustomize.md)
 - [ApplicationsApplicationSourcePlugin](docs/ApplicationsApplicationSourcePlugin.md)
 - [ApplicationsApplicationSpec](docs/ApplicationsApplicationSpec.md)
 - [ApplicationsApplicationStatus](docs/ApplicationsApplicationStatus.md)
 - [ApplicationsApplicationSummary](docs/ApplicationsApplicationSummary.md)
 - [ApplicationsApplicationSyncRequest](docs/ApplicationsApplicationSyncRequest.md)
 - [ApplicationsApplicationSyncWindow](docs/ApplicationsApplicationSyncWindow.md)
 - [ApplicationsApplicationSyncWindowsQuery](docs/ApplicationsApplicationSyncWindowsQuery.md)
 - [ApplicationsApplicationSyncWindowsResponse](docs/ApplicationsApplicationSyncWindowsResponse.md)
 - [ApplicationsApplicationTree](docs/ApplicationsApplicationTree.md)
 - [ApplicationsApplicationUpdateRequest](docs/ApplicationsApplicationUpdateRequest.md)
 - [ApplicationsApplicationUpdateSpecRequest](docs/ApplicationsApplicationUpdateSpecRequest.md)
 - [ApplicationsApplicationWatchEvent](docs/ApplicationsApplicationWatchEvent.md)
 - [ApplicationsBackoff](docs/ApplicationsBackoff.md)
 - [ApplicationsComparedTo](docs/ApplicationsComparedTo.md)
 - [ApplicationsEnvEntry](docs/ApplicationsEnvEntry.md)
 - [ApplicationsEvent](docs/ApplicationsEvent.md)
 - [ApplicationsEventList](docs/ApplicationsEventList.md)
 - [ApplicationsEventSeries](docs/ApplicationsEventSeries.md)
 - [ApplicationsEventSource](docs/ApplicationsEventSource.md)
 - [ApplicationsHealthStatus](docs/ApplicationsHealthStatus.md)
 - [ApplicationsHelmFileParameter](docs/ApplicationsHelmFileParameter.md)
 - [ApplicationsHelmParameter](docs/ApplicationsHelmParameter.md)
 - [ApplicationsHostInfo](docs/ApplicationsHostInfo.md)
 - [ApplicationsHostResourceInfo](docs/ApplicationsHostResourceInfo.md)
 - [ApplicationsInfo](docs/ApplicationsInfo.md)
 - [ApplicationsInfoItem](docs/ApplicationsInfoItem.md)
 - [ApplicationsJsonnetVar](docs/ApplicationsJsonnetVar.md)
 - [ApplicationsKsonnetParameter](docs/ApplicationsKsonnetParameter.md)
 - [ApplicationsKustomizeReplicas](docs/ApplicationsKustomizeReplicas.md)
 - [ApplicationsLogEntry](docs/ApplicationsLogEntry.md)
 - [ApplicationsManagedResourcesResponse](docs/ApplicationsManagedResourcesResponse.md)
 - [ApplicationsObjectReference](docs/ApplicationsObjectReference.md)
 - [ApplicationsOperation](docs/ApplicationsOperation.md)
 - [ApplicationsOperationInitiator](docs/ApplicationsOperationInitiator.md)
 - [ApplicationsOperationState](docs/ApplicationsOperationState.md)
 - [ApplicationsOperationTerminateRequest](docs/ApplicationsOperationTerminateRequest.md)
 - [ApplicationsOperationTerminateResponse](docs/ApplicationsOperationTerminateResponse.md)
 - [ApplicationsResourceAction](docs/ApplicationsResourceAction.md)
 - [ApplicationsResourceActionParam](docs/ApplicationsResourceActionParam.md)
 - [ApplicationsResourceActionRunRequest](docs/ApplicationsResourceActionRunRequest.md)
 - [ApplicationsResourceActionsListResponse](docs/ApplicationsResourceActionsListResponse.md)
 - [ApplicationsResourceDiff](docs/ApplicationsResourceDiff.md)
 - [ApplicationsResourceIgnoreDifferences](docs/ApplicationsResourceIgnoreDifferences.md)
 - [ApplicationsResourceNetworkingInfo](docs/ApplicationsResourceNetworkingInfo.md)
 - [ApplicationsResourceNode](docs/ApplicationsResourceNode.md)
 - [ApplicationsResourceRef](docs/ApplicationsResourceRef.md)
 - [ApplicationsResourceResult](docs/ApplicationsResourceResult.md)
 - [ApplicationsResourceStatus](docs/ApplicationsResourceStatus.md)
 - [ApplicationsResourcesQuery](docs/ApplicationsResourcesQuery.md)
 - [ApplicationsRetryStrategy](docs/ApplicationsRetryStrategy.md)
 - [ApplicationsRevisionHistory](docs/ApplicationsRevisionHistory.md)
 - [ApplicationsRevisionMetadataQuery](docs/ApplicationsRevisionMetadataQuery.md)
 - [ApplicationsSyncOperation](docs/ApplicationsSyncOperation.md)
 - [ApplicationsSyncOperationResource](docs/ApplicationsSyncOperationResource.md)
 - [ApplicationsSyncOperationResult](docs/ApplicationsSyncOperationResult.md)
 - [ApplicationsSyncOptions](docs/ApplicationsSyncOptions.md)
 - [ApplicationsSyncPolicy](docs/ApplicationsSyncPolicy.md)
 - [ApplicationsSyncPolicyAutomated](docs/ApplicationsSyncPolicyAutomated.md)
 - [ApplicationsSyncStatus](docs/ApplicationsSyncStatus.md)
 - [ApplicationsSyncStrategy](docs/ApplicationsSyncStrategy.md)
 - [ApplicationsSyncStrategyApply](docs/ApplicationsSyncStrategyApply.md)
 - [ApplicationsSyncStrategyHook](docs/ApplicationsSyncStrategyHook.md)
 - [Applicationv1alpha1RepositoryCertificate](docs/Applicationv1alpha1RepositoryCertificate.md)
 - [Applicationv1alpha1RepositoryCertificateList](docs/Applicationv1alpha1RepositoryCertificateList.md)
 - [AppprojectsAppProject](docs/AppprojectsAppProject.md)
 - [AppprojectsAppProjectList](docs/AppprojectsAppProjectList.md)
 - [AppprojectsAppProjectSpec](docs/AppprojectsAppProjectSpec.md)
 - [AppprojectsAppProjectStatus](docs/AppprojectsAppProjectStatus.md)
 - [AppprojectsApplicationDestination](docs/AppprojectsApplicationDestination.md)
 - [AppprojectsJWTToken](docs/AppprojectsJWTToken.md)
 - [AppprojectsJWTTokens](docs/AppprojectsJWTTokens.md)
 - [AppprojectsOrphanedResourceKey](docs/AppprojectsOrphanedResourceKey.md)
 - [AppprojectsOrphanedResourcesMonitorSettings](docs/AppprojectsOrphanedResourcesMonitorSettings.md)
 - [AppprojectsProjectRole](docs/AppprojectsProjectRole.md)
 - [AppprojectsSignatureKey](docs/AppprojectsSignatureKey.md)
 - [AppprojectsSyncWindow](docs/AppprojectsSyncWindow.md)
 - [Approval](docs/Approval.md)
 - [ApprovalAction](docs/ApprovalAction.md)
 - [ApprovalEvent](docs/ApprovalEvent.md)
 - [ApprovalEventsSuccessResponse](docs/ApprovalEventsSuccessResponse.md)
 - [ApprovalEventsSuccessResponseResponse](docs/ApprovalEventsSuccessResponseResponse.md)
 - [ApprovalIdentifier](docs/ApprovalIdentifier.md)
 - [ApprovalInstanceDetailsDTO](docs/ApprovalInstanceDetailsDTO.md)
 - [ApprovalInstanceResponse](docs/ApprovalInstanceResponse.md)
 - [ApprovalInstanceResponseBody](docs/ApprovalInstanceResponseBody.md)
 - [ApprovalPayload](docs/ApprovalPayload.md)
 - [ApprovalResourceCollection](docs/ApprovalResourceCollection.md)
 - [ApprovalServiceAccount](docs/ApprovalServiceAccount.md)
 - [ApprovalUpdate](docs/ApprovalUpdate.md)
 - [ApprovalUserGroup](docs/ApprovalUserGroup.md)
 - [ApprovalsCreateApprovalResponseBodyCreation](docs/ApprovalsCreateApprovalResponseBodyCreation.md)
 - [ApprovalsShowApprovalResponseBodyStatusInfo](docs/ApprovalsShowApprovalResponseBodyStatusInfo.md)
 - [ApproveExemptionRequestBody](docs/ApproveExemptionRequestBody.md)
 - [ApproverInput](docs/ApproverInput.md)
 - [ApproverInputDTO](docs/ApproverInputDTO.md)
 - [ApproverInputInfo](docs/ApproverInputInfo.md)
 - [Approvers](docs/Approvers.md)
 - [Artifact](docs/Artifact.md)
 - [ArtifactData](docs/ArtifactData.md)
 - [ArtifactDataOrBuilder](docs/ArtifactDataOrBuilder.md)
 - [ArtifactTriggerSource](docs/ArtifactTriggerSource.md)
 - [ArtifactTriggerSpec](docs/ArtifactTriggerSpec.md)
 - [ArtifactType](docs/ArtifactType.md)
 - [ArtifactTypeSpecWrapper](docs/ArtifactTypeSpecWrapper.md)
 - [ArtifactoryAnonymousConnectorSpec](docs/ArtifactoryAnonymousConnectorSpec.md)
 - [ArtifactoryAuthCredentials](docs/ArtifactoryAuthCredentials.md)
 - [ArtifactoryAuthentication](docs/ArtifactoryAuthentication.md)
 - [ArtifactoryConnector](docs/ArtifactoryConnector.md)
 - [ArtifactoryConnectorSpec](docs/ArtifactoryConnectorSpec.md)
 - [ArtifactoryEncryptedConnectorSpec](docs/ArtifactoryEncryptedConnectorSpec.md)
 - [ArtifactoryRegistryArtifactSpec](docs/ArtifactoryRegistryArtifactSpec.md)
 - [ArtifactoryRegistryArtifactTriggerSpec](docs/ArtifactoryRegistryArtifactTriggerSpec.md)
 - [ArtifactoryUsernamePasswordAuth](docs/ArtifactoryUsernamePasswordAuth.md)
 - [AsyncChainExecutableResponse](docs/AsyncChainExecutableResponse.md)
 - [AsyncChainExecutableResponseOrBuilder](docs/AsyncChainExecutableResponseOrBuilder.md)
 - [AsyncExecutableResponse](docs/AsyncExecutableResponse.md)
 - [AsyncExecutableResponseOrBuilder](docs/AsyncExecutableResponseOrBuilder.md)
 - [Attribute](docs/Attribute.md)
 - [AttributeFilter](docs/AttributeFilter.md)
 - [AttributeResponseMetadata](docs/AttributeResponseMetadata.md)
 - [AttributeResponseMetadataDetails](docs/AttributeResponseMetadataDetails.md)
 - [Attributes](docs/Attributes.md)
 - [Audit](docs/Audit.md)
 - [AuditEnvironment](docs/AuditEnvironment.md)
 - [AuditError](docs/AuditError.md)
 - [AuditErrorMetadata](docs/AuditErrorMetadata.md)
 - [AuditEvent](docs/AuditEvent.md)
 - [AuditEvent2](docs/AuditEvent2.md)
 - [AuditEventDTO](docs/AuditEventDTO.md)
 - [AuditEventData](docs/AuditEventData.md)
 - [AuditFilterProperties](docs/AuditFilterProperties.md)
 - [AuditFilterPropertiesV1DTO](docs/AuditFilterPropertiesV1DTO.md)
 - [AuditHttpRequestInfo](docs/AuditHttpRequestInfo.md)
 - [AuditPrincipal](docs/AuditPrincipal.md)
 - [AuditRequestMetadata](docs/AuditRequestMetadata.md)
 - [AuditResource](docs/AuditResource.md)
 - [AuditResourceScope](docs/AuditResourceScope.md)
 - [AuditRoleBinding](docs/AuditRoleBinding.md)
 - [AugmentRemediationResult](docs/AugmentRemediationResult.md)
 - [AuthInfo](docs/AuthInfo.md)
 - [AuthInfoResponse](docs/AuthInfoResponse.md)
 - [AuthenticationInfo](docs/AuthenticationInfo.md)
 - [AuthenticationInfoDTO](docs/AuthenticationInfoDTO.md)
 - [AuthenticationSettingsResponse](docs/AuthenticationSettingsResponse.md)
 - [AuthenticationsettingsSamlmetadatauploadBody](docs/AuthenticationsettingsSamlmetadatauploadBody.md)
 - [AuthenticationsettingsSamlmetadatauploadBody1](docs/AuthenticationsettingsSamlmetadatauploadBody1.md)
 - [AuthzError](docs/AuthzError.md)
 - [AuthzErrorMetadata](docs/AuthzErrorMetadata.md)
 - [AuthzPrincipal](docs/AuthzPrincipal.md)
 - [AuthzResourceFilter](docs/AuthzResourceFilter.md)
 - [AuthzRoleAssignment](docs/AuthzRoleAssignment.md)
 - [AuthzRoleAssignmentResponse](docs/AuthzRoleAssignmentResponse.md)
 - [AuthzScope](docs/AuthzScope.md)
 - [AuthzValidationResult](docs/AuthzValidationResult.md)
 - [AutoApproval](docs/AutoApproval.md)
 - [AutoCUDConfig](docs/AutoCUDConfig.md)
 - [AutoCUDSetup](docs/AutoCUDSetup.md)
 - [AwsAccessKeyConnectorSpec](docs/AwsAccessKeyConnectorSpec.md)
 - [AwsCodeCommitAuthentication](docs/AwsCodeCommitAuthentication.md)
 - [AwsCodeCommitConnector](docs/AwsCodeCommitConnector.md)
 - [AwsCodeCommitConnectorSpec](docs/AwsCodeCommitConnectorSpec.md)
 - [AwsCodeCommitCredentials](docs/AwsCodeCommitCredentials.md)
 - [AwsCodeCommitHttpsCredentials](docs/AwsCodeCommitHttpsCredentials.md)
 - [AwsCodeCommitHttpsCredentialsSpec](docs/AwsCodeCommitHttpsCredentialsSpec.md)
 - [AwsCodeCommitSecretKeyAccessKey](docs/AwsCodeCommitSecretKeyAccessKey.md)
 - [AwsCodeCommitWebhookSpec](docs/AwsCodeCommitWebhookSpec.md)
 - [AwsCodeCommitWebhookTriggerSpec](docs/AwsCodeCommitWebhookTriggerSpec.md)
 - [AwsConnector](docs/AwsConnector.md)
 - [AwsCredential](docs/AwsCredential.md)
 - [AwsCredentialSpec](docs/AwsCredentialSpec.md)
 - [AwsCurAttributes](docs/AwsCurAttributes.md)
 - [AwsEncryptedAccessKeyConnectorSpec](docs/AwsEncryptedAccessKeyConnectorSpec.md)
 - [AwsEqualJitterBackoffStrategy](docs/AwsEqualJitterBackoffStrategy.md)
 - [AwsFixedDelayBackoffStrategy](docs/AwsFixedDelayBackoffStrategy.md)
 - [AwsFullJitterBackoffStrategy](docs/AwsFullJitterBackoffStrategy.md)
 - [AwsIAMRoleConnectorSpec](docs/AwsIAMRoleConnectorSpec.md)
 - [AwsIRSAConnectorSpec](docs/AwsIRSAConnectorSpec.md)
 - [AwsKmsAccessKeyConnectorSpec](docs/AwsKmsAccessKeyConnectorSpec.md)
 - [AwsKmsAssumeIAMConnectorSpec](docs/AwsKmsAssumeIAMConnectorSpec.md)
 - [AwsKmsAssumeSTSConnectorSpec](docs/AwsKmsAssumeSTSConnectorSpec.md)
 - [AwsKmsConnector](docs/AwsKmsConnector.md)
 - [AwsKmsConnectorCredential](docs/AwsKmsConnectorCredential.md)
 - [AwsKmsCredentialSpec](docs/AwsKmsCredentialSpec.md)
 - [AwsKmsCredentialSpecAssumeIAM](docs/AwsKmsCredentialSpecAssumeIAM.md)
 - [AwsKmsCredentialSpecAssumeSTS](docs/AwsKmsCredentialSpecAssumeSTS.md)
 - [AwsKmsCredentialSpecManualConfig](docs/AwsKmsCredentialSpecManualConfig.md)
 - [AwsManualConfigSpec](docs/AwsManualConfigSpec.md)
 - [AwsOidcCredentialResponseDto](docs/AwsOidcCredentialResponseDto.md)
 - [AwsOidcCredentialsRequest](docs/AwsOidcCredentialsRequest.md)
 - [AwsOidcSpec](docs/AwsOidcSpec.md)
 - [AwsOidcTokenExchangeDetailsForDelegate](docs/AwsOidcTokenExchangeDetailsForDelegate.md)
 - [AwsOidcTokenRequest](docs/AwsOidcTokenRequest.md)
 - [AwsPrometheusHealthSource](docs/AwsPrometheusHealthSource.md)
 - [AwsRecommendationAdhocDTO](docs/AwsRecommendationAdhocDTO.md)
 - [AwsS3StreamingDestinationSpecDTO](docs/AwsS3StreamingDestinationSpecDTO.md)
 - [AwsSMCredentialSpecAssumeIAM](docs/AwsSMCredentialSpecAssumeIAM.md)
 - [AwsSMCredentialSpecAssumeSTS](docs/AwsSMCredentialSpecAssumeSTS.md)
 - [AwsSMCredentialSpecManualConfig](docs/AwsSMCredentialSpecManualConfig.md)
 - [AwsSdkBackOffStrategySpec](docs/AwsSdkBackOffStrategySpec.md)
 - [AwsSdkClientBackOffStrategySpec](docs/AwsSdkClientBackOffStrategySpec.md)
 - [AwsSdkClientBackoffStrategy](docs/AwsSdkClientBackoffStrategy.md)
 - [AwsSdkRetryPolicySpec](docs/AwsSdkRetryPolicySpec.md)
 - [AwsSecretManager](docs/AwsSecretManager.md)
 - [AwsSecretManagerAccessKeyConnectorSpec](docs/AwsSecretManagerAccessKeyConnectorSpec.md)
 - [AwsSecretManagerAssumeIAMConnectorSpec](docs/AwsSecretManagerAssumeIAMConnectorSpec.md)
 - [AwsSecretManagerAssumeSTSConnectorSpec](docs/AwsSecretManagerAssumeSTSConnectorSpec.md)
 - [AwsSecretManagerCredential](docs/AwsSecretManagerCredential.md)
 - [AwsSecretManagerCredentialSpec](docs/AwsSecretManagerCredentialSpec.md)
 - [AzureArtifactsArtifactSpec](docs/AzureArtifactsArtifactSpec.md)
 - [AzureArtifactsArtifactTriggerSpec](docs/AzureArtifactsArtifactTriggerSpec.md)
 - [AzureArtifactsAuthentication](docs/AzureArtifactsAuthentication.md)
 - [AzureArtifactsConnector](docs/AzureArtifactsConnector.md)
 - [AzureArtifactsHttpCredentials](docs/AzureArtifactsHttpCredentials.md)
 - [AzureArtifactsUsernameToken](docs/AzureArtifactsUsernameToken.md)
 - [AzureAuth](docs/AzureAuth.md)
 - [AzureAuthCredential](docs/AzureAuthCredential.md)
 - [AzureClientCertificateConnectorSpec](docs/AzureClientCertificateConnectorSpec.md)
 - [AzureClientKeyCert](docs/AzureClientKeyCert.md)
 - [AzureClientSecretKey](docs/AzureClientSecretKey.md)
 - [AzureClientSecretKeyConnectorSpec](docs/AzureClientSecretKeyConnectorSpec.md)
 - [AzureConnector](docs/AzureConnector.md)
 - [AzureCredential](docs/AzureCredential.md)
 - [AzureCredentialSpec](docs/AzureCredentialSpec.md)
 - [AzureInheritFromDelegateDetails](docs/AzureInheritFromDelegateDetails.md)
 - [AzureInheritFromDelegateSystemAssignedManagedIdentityConnectorSpec](docs/AzureInheritFromDelegateSystemAssignedManagedIdentityConnectorSpec.md)
 - [AzureInheritFromDelegateUserAssignedManagedIdentityConnectorSpec](docs/AzureInheritFromDelegateUserAssignedManagedIdentityConnectorSpec.md)
 - [AzureKeyVaultConnector](docs/AzureKeyVaultConnector.md)
 - [AzureMSIAuth](docs/AzureMSIAuth.md)
 - [AzureManualDetails](docs/AzureManualDetails.md)
 - [AzureRecommendationAdhocDTO](docs/AzureRecommendationAdhocDTO.md)
 - [AzureRepoApiAccess](docs/AzureRepoApiAccess.md)
 - [AzureRepoApiAccessSpec](docs/AzureRepoApiAccessSpec.md)
 - [AzureRepoAuthentication](docs/AzureRepoAuthentication.md)
 - [AzureRepoConfig](docs/AzureRepoConfig.md)
 - [AzureRepoCredentials](docs/AzureRepoCredentials.md)
 - [AzureRepoHttpCredentials](docs/AzureRepoHttpCredentials.md)
 - [AzureRepoHttpCredentialsSpec](docs/AzureRepoHttpCredentialsSpec.md)
 - [AzureRepoSshCredentials](docs/AzureRepoSshCredentials.md)
 - [AzureRepoTokenSpec](docs/AzureRepoTokenSpec.md)
 - [AzureRepoUsernameToken](docs/AzureRepoUsernameToken.md)
 - [AzureRepoWebhookSpec](docs/AzureRepoWebhookSpec.md)
 - [AzureRepoWebhookTriggerSpec](docs/AzureRepoWebhookTriggerSpec.md)
 - [AzureSystemAssignedMSIAuth](docs/AzureSystemAssignedMSIAuth.md)
 - [AzureUserAssignedMSIAuth](docs/AzureUserAssignedMSIAuth.md)
 - [AzureViewPreferences](docs/AzureViewPreferences.md)
 - [AzureVmDTO](docs/AzureVmDTO.md)
 - [AzureVmRecommendation](docs/AzureVmRecommendation.md)
 - [BIDashboardSummary](docs/BIDashboardSummary.md)
 - [BackstageEnvConfigVariable](docs/BackstageEnvConfigVariable.md)
 - [BackstageEnvSecretVariable](docs/BackstageEnvSecretVariable.md)
 - [BackstageEnvVariable](docs/BackstageEnvVariable.md)
 - [BackstageEnvVariableBatchRequest](docs/BackstageEnvVariableBatchRequest.md)
 - [BackstageEnvVariableRequest](docs/BackstageEnvVariableRequest.md)
 - [BackstageEnvVariableResponse](docs/BackstageEnvVariableResponse.md)
 - [BackstageHarnessSyncEntitiesResponse](docs/BackstageHarnessSyncEntitiesResponse.md)
 - [BackstageHarnessSyncRequest](docs/BackstageHarnessSyncRequest.md)
 - [BackstagePermissions](docs/BackstagePermissions.md)
 - [BackstagePermissionsRequest](docs/BackstagePermissionsRequest.md)
 - [BackstagePermissionsResponse](docs/BackstagePermissionsResponse.md)
 - [BambooArtifactSpec](docs/BambooArtifactSpec.md)
 - [BambooArtifactTriggerSpec](docs/BambooArtifactTriggerSpec.md)
 - [BambooAuthCredentialsDTO](docs/BambooAuthCredentialsDTO.md)
 - [BambooAuthenticationDTO](docs/BambooAuthenticationDTO.md)
 - [BambooConnector](docs/BambooConnector.md)
 - [BambooUserNamePasswordDTO](docs/BambooUserNamePasswordDTO.md)
 - [BannerInfo](docs/BannerInfo.md)
 - [BaseSSHSpec](docs/BaseSSHSpec.md)
 - [BaseWinRmSpec](docs/BaseWinRmSpec.md)
 - [BaselineExecutions](docs/BaselineExecutions.md)
 - [BatchReleaseDetailsResponse](docs/BatchReleaseDetailsResponse.md)
 - [BillingExportSpec](docs/BillingExportSpec.md)
 - [BitbucketApiAccess](docs/BitbucketApiAccess.md)
 - [BitbucketAuthentication](docs/BitbucketAuthentication.md)
 - [BitbucketConnector](docs/BitbucketConnector.md)
 - [BitbucketCredentials](docs/BitbucketCredentials.md)
 - [BitbucketHttpCredentials](docs/BitbucketHttpCredentials.md)
 - [BitbucketHttpCredentialsSpec](docs/BitbucketHttpCredentialsSpec.md)
 - [BitbucketOauth](docs/BitbucketOauth.md)
 - [BitbucketServerProviderRequestInfo](docs/BitbucketServerProviderRequestInfo.md)
 - [BitbucketSshCredentials](docs/BitbucketSshCredentials.md)
 - [BitbucketUsernamePassword](docs/BitbucketUsernamePassword.md)
 - [BitbucketUsernameTokenApiAccess](docs/BitbucketUsernameTokenApiAccess.md)
 - [BitbucketWebhookSpec](docs/BitbucketWebhookSpec.md)
 - [BitbucketWebhookTriggerSpec](docs/BitbucketWebhookTriggerSpec.md)
 - [Board](docs/Board.md)
 - [BranchHook](docs/BranchHook.md)
 - [BranchHookOrBuilder](docs/BranchHookOrBuilder.md)
 - [Budget](docs/Budget.md)
 - [BudgetCostData](docs/BudgetCostData.md)
 - [BudgetData](docs/BudgetData.md)
 - [BudgetGroup](docs/BudgetGroup.md)
 - [BudgetGroupChildEntityDTO](docs/BudgetGroupChildEntityDTO.md)
 - [BudgetMonthlyBreakdown](docs/BudgetMonthlyBreakdown.md)
 - [BudgetScope](docs/BudgetScope.md)
 - [BudgetSummary](docs/BudgetSummary.md)
 - [BuildDetails](docs/BuildDetails.md)
 - [BuildInfo](docs/BuildInfo.md)
 - [BuildInfoOrBuilder](docs/BuildInfoOrBuilder.md)
 - [BuildStore](docs/BuildStore.md)
 - [BurnRate](docs/BurnRate.md)
 - [BusinessMapping](docs/BusinessMapping.md)
 - [BusinessMappingListDTO](docs/BusinessMappingListDTO.md)
 - [ByteString](docs/ByteString.md)
 - [CCM](docs/CCM.md)
 - [CCMAggregation](docs/CCMAggregation.md)
 - [CCMAnomalies](docs/CCMAnomalies.md)
 - [CCMEcsEntity](docs/CCMEcsEntity.md)
 - [CCMGroupBy](docs/CCMGroupBy.md)
 - [CCMJiraCreateDTO](docs/CCMJiraCreateDTO.md)
 - [CCMJiraDetails](docs/CCMJiraDetails.md)
 - [CCMK8sEntity](docs/CCMK8sEntity.md)
 - [CCMOverview](docs/CCMOverview.md)
 - [CCMRecommendationFilterProperties](docs/CCMRecommendationFilterProperties.md)
 - [CCMServiceNowCreateDTO](docs/CCMServiceNowCreateDTO.md)
 - [CCMServiceNowDetails](docs/CCMServiceNowDetails.md)
 - [CCMSort](docs/CCMSort.md)
 - [CCMTagDTO](docs/CCMTagDTO.md)
 - [CCMTimeFilter](docs/CCMTimeFilter.md)
 - [CEAwsConnector](docs/CEAwsConnector.md)
 - [CEAzureConnector](docs/CEAzureConnector.md)
 - [CEKubernetesClusterConfigDTO](docs/CEKubernetesClusterConfigDTO.md)
 - [CEReportSchedule](docs/CEReportSchedule.md)
 - [CEView](docs/CEView.md)
 - [CEViewFolder](docs/CEViewFolder.md)
 - [CVNGEmailChannelSpec](docs/CVNGEmailChannelSpec.md)
 - [CVNGLog](docs/CVNGLog.md)
 - [CVNGLogTag](docs/CVNGLogTag.md)
 - [CVNGMSTeamsChannelSpec](docs/CVNGMSTeamsChannelSpec.md)
 - [CVNGNotificationChannel](docs/CVNGNotificationChannel.md)
 - [CVNGNotificationChannelSpec](docs/CVNGNotificationChannelSpec.md)
 - [CVNGPagerDutyChannelSpec](docs/CVNGPagerDutyChannelSpec.md)
 - [CVNGSlackChannelSpec](docs/CVNGSlackChannelSpec.md)
 - [CacheResponseMetadata](docs/CacheResponseMetadata.md)
 - [CacheResponseMetadataDTO](docs/CacheResponseMetadataDTO.md)
 - [CalenderSLOTargetSpec](docs/CalenderSLOTargetSpec.md)
 - [CalenderSpec](docs/CalenderSpec.md)
 - [CannyBoardsResponse](docs/CannyBoardsResponse.md)
 - [CannyCategoriesResponse](docs/CannyCategoriesResponse.md)
 - [CannyPostBody](docs/CannyPostBody.md)
 - [CannyPostV2Body](docs/CannyPostV2Body.md)
 - [CannyResponse](docs/CannyResponse.md)
 - [CardIconResponse](docs/CardIconResponse.md)
 - [CardResponse](docs/CardResponse.md)
 - [CatalogConnectorInfo](docs/CatalogConnectorInfo.md)
 - [CategoriesIdBody](docs/CategoriesIdBody.md)
 - [Category](docs/Category.md)
 - [CategoryCountDetails](docs/CategoryCountDetails.md)
 - [CategoryResponse](docs/CategoryResponse.md)
 - [CcmDataPoint](docs/CcmDataPoint.md)
 - [CcmError](docs/CcmError.md)
 - [CcmErrorMetadata](docs/CcmErrorMetadata.md)
 - [CcmK8sConnectorResponse](docs/CcmK8sConnectorResponse.md)
 - [CcmK8sMetaDTO](docs/CcmK8sMetaDTO.md)
 - [CcmK8sMetaInfo](docs/CcmK8sMetaInfo.md)
 - [CcmK8sMetaInfoResponseDTO](docs/CcmK8sMetaInfoResponseDTO.md)
 - [CcmReference](docs/CcmReference.md)
 - [CcmRule](docs/CcmRule.md)
 - [CertificateDTO](docs/CertificateDTO.md)
 - [CertificateData](docs/CertificateData.md)
 - [CertificateDetailsDTO](docs/CertificateDetailsDTO.md)
 - [CertificateInfoDTO](docs/CertificateInfoDTO.md)
 - [CertificateInputSpecDTO](docs/CertificateInputSpecDTO.md)
 - [CertificateInputSpecType](docs/CertificateInputSpecType.md)
 - [CertificateIssuanceInfo](docs/CertificateIssuanceInfo.md)
 - [CertificateRepositoryCertificateCreateRequest](docs/CertificateRepositoryCertificateCreateRequest.md)
 - [CertificateRepositoryCertificateQuery](docs/CertificateRepositoryCertificateQuery.md)
 - [CertificateResponseDTO](docs/CertificateResponseDTO.md)
 - [CertificatesRepositoryCertificate](docs/CertificatesRepositoryCertificate.md)
 - [CertificatesRepositoryCertificateList](docs/CertificatesRepositoryCertificateList.md)
 - [CfApiKey](docs/CfApiKey.md)
 - [CfError](docs/CfError.md)
 - [CfGitDetails](docs/CfGitDetails.md)
 - [CfService](docs/CfService.md)
 - [ChangeImpactConditionSpec](docs/ChangeImpactConditionSpec.md)
 - [ChangeObservedConditionSpec](docs/ChangeObservedConditionSpec.md)
 - [ChangeSourceDTO](docs/ChangeSourceDTO.md)
 - [ChangeSourceSpec](docs/ChangeSourceSpec.md)
 - [ChangeSummaryDTO](docs/ChangeSummaryDTO.md)
 - [ChangedResourceCollection](docs/ChangedResourceCollection.md)
 - [ChaosAuditEventData](docs/ChaosAuditEventData.md)
 - [ChartResponse](docs/ChartResponse.md)
 - [Check](docs/Check.md)
 - [CheckDetails](docs/CheckDetails.md)
 - [CheckDetailsRequest](docs/CheckDetailsRequest.md)
 - [CheckDetailsResponse](docs/CheckDetailsResponse.md)
 - [CheckGraph](docs/CheckGraph.md)
 - [CheckListItem](docs/CheckListItem.md)
 - [CheckResponse](docs/CheckResponse.md)
 - [CheckStats](docs/CheckStats.md)
 - [CheckStatsResponse](docs/CheckStatsResponse.md)
 - [CheckStatus](docs/CheckStatus.md)
 - [Child](docs/Child.md)
 - [ChildChainExecutableResponse](docs/ChildChainExecutableResponse.md)
 - [ChildChainExecutableResponseOrBuilder](docs/ChildChainExecutableResponseOrBuilder.md)
 - [ChildExecutableResponse](docs/ChildExecutableResponse.md)
 - [ChildExecutableResponseOrBuilder](docs/ChildExecutableResponseOrBuilder.md)
 - [ChildExecutionDetail](docs/ChildExecutionDetail.md)
 - [ChildOrBuilder](docs/ChildOrBuilder.md)
 - [ChildrenExecutableResponse](docs/ChildrenExecutableResponse.md)
 - [ChildrenExecutableResponseOrBuilder](docs/ChildrenExecutableResponseOrBuilder.md)
 - [Clause](docs/Clause.md)
 - [CloneDashboardRequestBody](docs/CloneDashboardRequestBody.md)
 - [CloneRuleDTO](docs/CloneRuleDTO.md)
 - [CloneWorkspaceRequestBody](docs/CloneWorkspaceRequestBody.md)
 - [ClonedDashboard](docs/ClonedDashboard.md)
 - [ClonedDashboardResponse](docs/ClonedDashboardResponse.md)
 - [CloudWatchMetricDefinition](docs/CloudWatchMetricDefinition.md)
 - [CloudWatchMetricsHealthSource](docs/CloudWatchMetricsHealthSource.md)
 - [ClusterBasicDTO](docs/ClusterBasicDTO.md)
 - [ClusterBatchRequest](docs/ClusterBatchRequest.md)
 - [ClusterBatchResponse](docs/ClusterBatchResponse.md)
 - [ClusterBudgetScope](docs/ClusterBudgetScope.md)
 - [ClusterConfig](docs/ClusterConfig.md)
 - [ClusterCostDetails](docs/ClusterCostDetails.md)
 - [ClusterCostDetailsQueryParams](docs/ClusterCostDetailsQueryParams.md)
 - [ClusterQueryClusterSortByOptions](docs/ClusterQueryClusterSortByOptions.md)
 - [ClusterRecommendationAccuracy](docs/ClusterRecommendationAccuracy.md)
 - [ClusterRequest](docs/ClusterRequest.md)
 - [ClusterResponse](docs/ClusterResponse.md)
 - [ClustersAWSAuthConfig](docs/ClustersAWSAuthConfig.md)
 - [ClustersCluster](docs/ClustersCluster.md)
 - [ClustersClusterCacheInfo](docs/ClustersClusterCacheInfo.md)
 - [ClustersClusterConfig](docs/ClustersClusterConfig.md)
 - [ClustersClusterCreateRequest](docs/ClustersClusterCreateRequest.md)
 - [ClustersClusterID](docs/ClustersClusterID.md)
 - [ClustersClusterInfo](docs/ClustersClusterInfo.md)
 - [ClustersClusterList](docs/ClustersClusterList.md)
 - [ClustersClusterQuery](docs/ClustersClusterQuery.md)
 - [ClustersClusterResponse](docs/ClustersClusterResponse.md)
 - [ClustersClusterType](docs/ClustersClusterType.md)
 - [ClustersClusterUpdateRequest](docs/ClustersClusterUpdateRequest.md)
 - [ClustersExecProviderConfig](docs/ClustersExecProviderConfig.md)
 - [ClustersTLSClientConfig](docs/ClustersTLSClientConfig.md)
 - [Commit](docs/Commit.md)
 - [CommitOrBuilder](docs/CommitOrBuilder.md)
 - [CommitsCommitShaBody](docs/CommitsCommitShaBody.md)
 - [CommonsConnectionState](docs/CommonsConnectionState.md)
 - [CompositeServiceLevelObjectiveSpec](docs/CompositeServiceLevelObjectiveSpec.md)
 - [Condition](docs/Condition.md)
 - [ConfigFile](docs/ConfigFile.md)
 - [ConfigFileAttributes](docs/ConfigFileAttributes.md)
 - [ConfigFileWrapper](docs/ConfigFileWrapper.md)
 - [ConfigurationEntities](docs/ConfigurationEntities.md)
 - [ConnectionStringsConfiguration](docs/ConnectionStringsConfiguration.md)
 - [Connector](docs/Connector.md)
 - [Connector2](docs/Connector2.md)
 - [ConnectorActivityDetails](docs/ConnectorActivityDetails.md)
 - [ConnectorCatalogueItem](docs/ConnectorCatalogueItem.md)
 - [ConnectorCatalogueResponse](docs/ConnectorCatalogueResponse.md)
 - [ConnectorConfig](docs/ConnectorConfig.md)
 - [ConnectorConnectivityDetail](docs/ConnectorConnectivityDetail.md)
 - [ConnectorConnectivityDetails](docs/ConnectorConnectivityDetails.md)
 - [ConnectorDetails](docs/ConnectorDetails.md)
 - [ConnectorFilterProperties](docs/ConnectorFilterProperties.md)
 - [ConnectorInfo](docs/ConnectorInfo.md)
 - [ConnectorInfoRequest](docs/ConnectorInfoRequest.md)
 - [ConnectorInfoResponse](docs/ConnectorInfoResponse.md)
 - [ConnectorRequest](docs/ConnectorRequest.md)
 - [ConnectorResponse](docs/ConnectorResponse.md)
 - [ConnectorResponse1](docs/ConnectorResponse1.md)
 - [ConnectorSettings](docs/ConnectorSettings.md)
 - [ConnectorSpec](docs/ConnectorSpec.md)
 - [ConnectorStatistics](docs/ConnectorStatistics.md)
 - [ConnectorStatusStats](docs/ConnectorStatusStats.md)
 - [ConnectorTestConnectionErrorDetail](docs/ConnectorTestConnectionErrorDetail.md)
 - [ConnectorTestConnectionResponse](docs/ConnectorTestConnectionResponse.md)
 - [ConnectorTypeStats](docs/ConnectorTypeStats.md)
 - [ConnectorValidationResult](docs/ConnectorValidationResult.md)
 - [ContainerHistogramDTO](docs/ContainerHistogramDTO.md)
 - [ContainerRecommendation](docs/ContainerRecommendation.md)
 - [ContainerSvc](docs/ContainerSvc.md)
 - [CoolDownMetaFailureResponse](docs/CoolDownMetaFailureResponse.md)
 - [CoolDownMetaSuccessResponse](docs/CoolDownMetaSuccessResponse.md)
 - [CoolDownOption](docs/CoolDownOption.md)
 - [Cost](docs/Cost.md)
 - [CostCategoryDeleteDTO](docs/CostCategoryDeleteDTO.md)
 - [CostDetailsQueryParams](docs/CostDetailsQueryParams.md)
 - [CostOverview](docs/CostOverview.md)
 - [CostResourceCollection](docs/CostResourceCollection.md)
 - [CostResourcesCollection](docs/CostResourcesCollection.md)
 - [CostTarget](docs/CostTarget.md)
 - [CountGroupedOnArtifact](docs/CountGroupedOnArtifact.md)
 - [CountGroupedOnService](docs/CountGroupedOnService.md)
 - [CountGroupedOnStatus](docs/CountGroupedOnStatus.md)
 - [CountServiceDTO](docs/CountServiceDTO.md)
 - [CoveoResponseDTO](docs/CoveoResponseDTO.md)
 - [CreateAccessPointResponse](docs/CreateAccessPointResponse.md)
 - [CreateApprovalRequest](docs/CreateApprovalRequest.md)
 - [CreateExemptionRequestBody](docs/CreateExemptionRequestBody.md)
 - [CreateGitXWebhookRequest](docs/CreateGitXWebhookRequest.md)
 - [CreateGitXWebhookResponse](docs/CreateGitXWebhookResponse.md)
 - [CreateIssueRequestBody](docs/CreateIssueRequestBody.md)
 - [CreateOrganizationRequest](docs/CreateOrganizationRequest.md)
 - [CreatePerspectiveFolderDTO](docs/CreatePerspectiveFolderDTO.md)
 - [CreateProjectRequest](docs/CreateProjectRequest.md)
 - [CreateProviderRequestDTO](docs/CreateProviderRequestDTO.md)
 - [CreateProviderResponse](docs/CreateProviderResponse.md)
 - [CreatePullRequestRequestBody](docs/CreatePullRequestRequestBody.md)
 - [CreateRequestBody](docs/CreateRequestBody.md)
 - [CreateRequestBody2](docs/CreateRequestBody2.md)
 - [CreateResourceGroupRequest](docs/CreateResourceGroupRequest.md)
 - [CreateRoleRequest](docs/CreateRoleRequest.md)
 - [CreateRuleDTO](docs/CreateRuleDTO.md)
 - [CreateRuleEnforcementDTO](docs/CreateRuleEnforcementDTO.md)
 - [CreateRuleExecutionFilterDTO](docs/CreateRuleExecutionFilterDTO.md)
 - [CreateRuleSetDTO](docs/CreateRuleSetDTO.md)
 - [CreateRuleSetFilterDTO](docs/CreateRuleSetFilterDTO.md)
 - [CreateScanRequestBody](docs/CreateScanRequestBody.md)
 - [CreateTargetRequestBody](docs/CreateTargetRequestBody.md)
 - [CreateTargetVariantRequestBody](docs/CreateTargetVariantRequestBody.md)
 - [CreateWorkspaceTemplateRequest](docs/CreateWorkspaceTemplateRequest.md)
 - [CreateWorkspaceTemplateResponse](docs/CreateWorkspaceTemplateResponse.md)
 - [CreateWorkspaceVariableRequest](docs/CreateWorkspaceVariableRequest.md)
 - [CreateWorkspaceVariableResponse](docs/CreateWorkspaceVariableResponse.md)
 - [CreditOverUsage](docs/CreditOverUsage.md)
 - [CreditUsage](docs/CreditUsage.md)
 - [CriteriaSpecDTO](docs/CriteriaSpecDTO.md)
 - [CriteriaSpecWrapper](docs/CriteriaSpecWrapper.md)
 - [CronExpressionRequestDTO](docs/CronExpressionRequestDTO.md)
 - [CronScheduledTriggerSpec](docs/CronScheduledTriggerSpec.md)
 - [CrossAccountAccess](docs/CrossAccountAccess.md)
 - [CumulativeSavings](docs/CumulativeSavings.md)
 - [CumulativeSavingsResponse](docs/CumulativeSavingsResponse.md)
 - [CurrentOrUpcomingWindow](docs/CurrentOrUpcomingWindow.md)
 - [CustomArtifactSpec](docs/CustomArtifactSpec.md)
 - [CustomArtifactTriggerSpec](docs/CustomArtifactTriggerSpec.md)
 - [CustomDeploymentInfraResponseDTO](docs/CustomDeploymentInfraResponseDTO.md)
 - [CustomDeploymentRefreshYamlDTO](docs/CustomDeploymentRefreshYamlDTO.md)
 - [CustomDeploymentVariableProperties](docs/CustomDeploymentVariableProperties.md)
 - [CustomDeploymentVariableResponseDTO](docs/CustomDeploymentVariableResponseDTO.md)
 - [CustomDeploymentYamlDTO](docs/CustomDeploymentYamlDTO.md)
 - [CustomDeploymentYamlRequestDTO](docs/CustomDeploymentYamlRequestDTO.md)
 - [CustomHealthConnectorDTO](docs/CustomHealthConnectorDTO.md)
 - [CustomHealthKeyAndValue](docs/CustomHealthKeyAndValue.md)
 - [CustomHealthLogDefinition](docs/CustomHealthLogDefinition.md)
 - [CustomHealthMetricDefinition](docs/CustomHealthMetricDefinition.md)
 - [CustomHealthRequestDefinition](docs/CustomHealthRequestDefinition.md)
 - [CustomHealthSourceLog](docs/CustomHealthSourceLog.md)
 - [CustomHealthSourceMetric](docs/CustomHealthSourceMetric.md)
 - [CustomLinkCard](docs/CustomLinkCard.md)
 - [CustomPagePipelineExecutionOutline](docs/CustomPagePipelineExecutionOutline.md)
 - [CustomPluginDetailedInfo](docs/CustomPluginDetailedInfo.md)
 - [CustomPluginInfoRequest](docs/CustomPluginInfoRequest.md)
 - [CustomPluginInfoResponse](docs/CustomPluginInfoResponse.md)
 - [CustomPropertiesBase](docs/CustomPropertiesBase.md)
 - [CustomPropertyByEntityDeleteRequest](docs/CustomPropertyByEntityDeleteRequest.md)
 - [CustomPropertyByEntityGetResponse](docs/CustomPropertyByEntityGetResponse.md)
 - [CustomPropertyByEntityRequest](docs/CustomPropertyByEntityRequest.md)
 - [CustomPropertyByFieldDeleteRequest](docs/CustomPropertyByFieldDeleteRequest.md)
 - [CustomPropertyByFieldDeleteResponse](docs/CustomPropertyByFieldDeleteResponse.md)
 - [CustomPropertyByFieldGetResponse](docs/CustomPropertyByFieldGetResponse.md)
 - [CustomPropertyByFieldRequest](docs/CustomPropertyByFieldRequest.md)
 - [CustomPropertyByFieldResponse](docs/CustomPropertyByFieldResponse.md)
 - [CustomPropertyEntitiesCount](docs/CustomPropertyEntitiesCount.md)
 - [CustomPropertyFilterDeleteRequest](docs/CustomPropertyFilterDeleteRequest.md)
 - [CustomPropertyFilterRequest](docs/CustomPropertyFilterRequest.md)
 - [CustomPropertyResponse](docs/CustomPropertyResponse.md)
 - [CustomSecretManager](docs/CustomSecretManager.md)
 - [CustomWebhookSpec](docs/CustomWebhookSpec.md)
 - [CustomWebhookTriggerSpec](docs/CustomWebhookTriggerSpec.md)
 - [CvEntityDetails](docs/CvEntityDetails.md)
 - [CvEntityGitDetails](docs/CvEntityGitDetails.md)
 - [CvEnvironmentResponse](docs/CvEnvironmentResponse.md)
 - [CvError](docs/CvError.md)
 - [CvErrorMetadata](docs/CvErrorMetadata.md)
 - [CvResponseDTOListEnvironmentResponse](docs/CvResponseDTOListEnvironmentResponse.md)
 - [CvResponseDTOListServiceResponse](docs/CvResponseDTOListServiceResponse.md)
 - [CvServiceResponse](docs/CvServiceResponse.md)
 - [DashboardDownloadResponse](docs/DashboardDownloadResponse.md)
 - [DashboardMetrics](docs/DashboardMetrics.md)
 - [DashboardPipelineExecution](docs/DashboardPipelineExecution.md)
 - [DashboardsErrorResponse](docs/DashboardsErrorResponse.md)
 - [DataCollectionFailureInstanceDetails](docs/DataCollectionFailureInstanceDetails.md)
 - [DataPoint](docs/DataPoint.md)
 - [DataPointInputValues](docs/DataPointInputValues.md)
 - [DataPoints](docs/DataPoints.md)
 - [DataPointsResponse](docs/DataPointsResponse.md)
 - [DataSource](docs/DataSource.md)
 - [DataSourceDataPointInfo](docs/DataSourceDataPointInfo.md)
 - [DataSourceDataPointsMap](docs/DataSourceDataPointsMap.md)
 - [DataSourceDataPointsMapResponse](docs/DataSourceDataPointsMapResponse.md)
 - [DataSourceLocationInfo](docs/DataSourceLocationInfo.md)
 - [DataSourcesResponse](docs/DataSourcesResponse.md)
 - [DatadogConnectorDTO](docs/DatadogConnectorDTO.md)
 - [DatadogLogHealthSource](docs/DatadogLogHealthSource.md)
 - [DatadogLogHealthSourceQueryDTO](docs/DatadogLogHealthSourceQueryDTO.md)
 - [DatadogMetricHealthDefinition](docs/DatadogMetricHealthDefinition.md)
 - [DatadogMetricHealthSource](docs/DatadogMetricHealthSource.md)
 - [Declaration](docs/Declaration.md)
 - [DeclarationOrBuilder](docs/DeclarationOrBuilder.md)
 - [DefaultPipelineCollection](docs/DefaultPipelineCollection.md)
 - [DefaultPipelineIdentifier](docs/DefaultPipelineIdentifier.md)
 - [DefaultPipelineIdentifier2](docs/DefaultPipelineIdentifier2.md)
 - [DefaultPipelineOverride](docs/DefaultPipelineOverride.md)
 - [DefaultPluginDetailedInfo](docs/DefaultPluginDetailedInfo.md)
 - [DefaultSaveResponse](docs/DefaultSaveResponse.md)
 - [DelegateConnectionDetails](docs/DelegateConnectionDetails.md)
 - [DelegateDeleteResponse](docs/DelegateDeleteResponse.md)
 - [DelegateDownloadRequest](docs/DelegateDownloadRequest.md)
 - [DelegateFilterPropertiesDTO](docs/DelegateFilterPropertiesDTO.md)
 - [DelegateGroupDTO](docs/DelegateGroupDTO.md)
 - [DelegateGroupDetails](docs/DelegateGroupDetails.md)
 - [DelegateGroupListing](docs/DelegateGroupListing.md)
 - [DelegateGroupTags](docs/DelegateGroupTags.md)
 - [DelegateInfo](docs/DelegateInfo.md)
 - [DelegateInner](docs/DelegateInner.md)
 - [DelegateListResponse](docs/DelegateListResponse.md)
 - [DelegateReplica](docs/DelegateReplica.md)
 - [DelegateSetupDetails](docs/DelegateSetupDetails.md)
 - [DelegateTokenDetails](docs/DelegateTokenDetails.md)
 - [DeleteAccessPointPayload](docs/DeleteAccessPointPayload.md)
 - [DeleteGitXWebhookResponse](docs/DeleteGitXWebhookResponse.md)
 - [DeleteHomePageLayoutIconRequest](docs/DeleteHomePageLayoutIconRequest.md)
 - [DeleteProviderResponse](docs/DeleteProviderResponse.md)
 - [DependenciesMetadata](docs/DependenciesMetadata.md)
 - [DeploymentImpactReportConditionSpec](docs/DeploymentImpactReportConditionSpec.md)
 - [DeploymentVerificationDTO](docs/DeploymentVerificationDTO.md)
 - [Descriptor](docs/Descriptor.md)
 - [DescriptorProto](docs/DescriptorProto.md)
 - [DescriptorProtoOrBuilder](docs/DescriptorProtoOrBuilder.md)
 - [DestroyWorkspaceVariableResponse](docs/DestroyWorkspaceVariableResponse.md)
 - [Distribution](docs/Distribution.md)
 - [DockerAuthCredentials](docs/DockerAuthCredentials.md)
 - [DockerAuthentication](docs/DockerAuthentication.md)
 - [DockerConnector](docs/DockerConnector.md)
 - [DockerRegistryArtifactSpec](docs/DockerRegistryArtifactSpec.md)
 - [DockerRegistryArtifactTriggerSpec](docs/DockerRegistryArtifactTriggerSpec.md)
 - [DockerUserNamePassword](docs/DockerUserNamePassword.md)
 - [Document](docs/Document.md)
 - [DoraChangeFailureRateBody](docs/DoraChangeFailureRateBody.md)
 - [DoraDeploymentFrequencyBody](docs/DoraDeploymentFrequencyBody.md)
 - [DoraLeadtimeBody](docs/DoraLeadtimeBody.md)
 - [DoraMeantimeBody](docs/DoraMeantimeBody.md)
 - [DownloadCsvDashboardResponse](docs/DownloadCsvDashboardResponse.md)
 - [DownloadPdfDashboardResponse](docs/DownloadPdfDashboardResponse.md)
 - [Downtime](docs/Downtime.md)
 - [DowntimeDuration](docs/DowntimeDuration.md)
 - [DowntimeHistoryView](docs/DowntimeHistoryView.md)
 - [DowntimeInstanceDetails](docs/DowntimeInstanceDetails.md)
 - [DowntimeListView](docs/DowntimeListView.md)
 - [DowntimeRecurrence](docs/DowntimeRecurrence.md)
 - [DowntimeResponse](docs/DowntimeResponse.md)
 - [DowntimeSpec](docs/DowntimeSpec.md)
 - [DowntimeSpecDTO](docs/DowntimeSpecDTO.md)
 - [DowntimeStatus](docs/DowntimeStatus.md)
 - [DowntimeStatusDetails](docs/DowntimeStatusDetails.md)
 - [DynatraceConnectorDTO](docs/DynatraceConnectorDTO.md)
 - [DynatraceHealthSource](docs/DynatraceHealthSource.md)
 - [DynatraceMetricDefinition](docs/DynatraceMetricDefinition.md)
 - [EC2InstanceDTO](docs/EC2InstanceDTO.md)
 - [EC2InstanceRecommendation](docs/EC2InstanceRecommendation.md)
 - [ECSRecommendationDTO](docs/ECSRecommendationDTO.md)
 - [ELKConnectorDTO](docs/ELKConnectorDTO.md)
 - [ELKHealthSource](docs/ELKHealthSource.md)
 - [ELKHealthSourceQueryDTO](docs/ELKHealthSourceQueryDTO.md)
 - [EcrArtifactSpec](docs/EcrArtifactSpec.md)
 - [EcrArtifactTriggerSpec](docs/EcrArtifactTriggerSpec.md)
 - [EdgeLayoutList](docs/EdgeLayoutList.md)
 - [EditionDefault](docs/EditionDefault.md)
 - [EditionDefaultOrBuilder](docs/EditionDefaultOrBuilder.md)
 - [EmailConfigDTO](docs/EmailConfigDTO.md)
 - [EmbeddedUser](docs/EmbeddedUser.md)
 - [EmbeddedUserDetailsDTO](docs/EmbeddedUserDetailsDTO.md)
 - [EncryptedDataDetail](docs/EncryptedDataDetail.md)
 - [EncryptedDataParams](docs/EncryptedDataParams.md)
 - [EncryptedRecordData](docs/EncryptedRecordData.md)
 - [EncryptionConfig](docs/EncryptionConfig.md)
 - [EnforcementCount](docs/EnforcementCount.md)
 - [EnforcementCountDTO](docs/EnforcementCountDTO.md)
 - [EnforcementCountRequest](docs/EnforcementCountRequest.md)
 - [EnforcementDetails](docs/EnforcementDetails.md)
 - [EntitiesForImport](docs/EntitiesForImport.md)
 - [EntitiesRule](docs/EntitiesRule.md)
 - [EntityDetail](docs/EntityDetail.md)
 - [EntityDetailProtoDTO](docs/EntityDetailProtoDTO.md)
 - [EntityDetails](docs/EntityDetails.md)
 - [EntityGitDetails](docs/EntityGitDetails.md)
 - [EntityGitDetails1](docs/EntityGitDetails1.md)
 - [EntityGitMetadata](docs/EntityGitMetadata.md)
 - [EntityGitMetadataOrBuilder](docs/EntityGitMetadataOrBuilder.md)
 - [EntityIdentifiersRule](docs/EntityIdentifiersRule.md)
 - [EntityInfo](docs/EntityInfo.md)
 - [EntityMetadata](docs/EntityMetadata.md)
 - [EntityReference](docs/EntityReference.md)
 - [EntityReferredByInfraSetupUsageDetail](docs/EntityReferredByInfraSetupUsageDetail.md)
 - [EntityReferredByOverridesSetupUsageDetail](docs/EntityReferredByOverridesSetupUsageDetail.md)
 - [EntityReferredByPipelineSetupUsageDetail](docs/EntityReferredByPipelineSetupUsageDetail.md)
 - [EntityScores](docs/EntityScores.md)
 - [EntityScoresResponse](docs/EntityScoresResponse.md)
 - [EntitySetupUsage](docs/EntitySetupUsage.md)
 - [EntityValue](docs/EntityValue.md)
 - [EnumCheckPayloadKind](docs/EnumCheckPayloadKind.md)
 - [EnumCheckStatus](docs/EnumCheckStatus.md)
 - [EnumContentEncodingType](docs/EnumContentEncodingType.md)
 - [EnumDescriptor](docs/EnumDescriptor.md)
 - [EnumDescriptorProto](docs/EnumDescriptorProto.md)
 - [EnumDescriptorProtoOrBuilder](docs/EnumDescriptorProtoOrBuilder.md)
 - [EnumFileDiffStatus](docs/EnumFileDiffStatus.md)
 - [EnumLabelColor](docs/EnumLabelColor.md)
 - [EnumLabelType](docs/EnumLabelType.md)
 - [EnumMergeCheckStatus](docs/EnumMergeCheckStatus.md)
 - [EnumMergeMethod](docs/EnumMergeMethod.md)
 - [EnumOptions](docs/EnumOptions.md)
 - [EnumOptionsOrBuilder](docs/EnumOptionsOrBuilder.md)
 - [EnumPrincipalType](docs/EnumPrincipalType.md)
 - [EnumPullReqActivityKind](docs/EnumPullReqActivityKind.md)
 - [EnumPullReqActivityType](docs/EnumPullReqActivityType.md)
 - [EnumPullReqCommentStatus](docs/EnumPullReqCommentStatus.md)
 - [EnumPullReqReviewDecision](docs/EnumPullReqReviewDecision.md)
 - [EnumPullReqReviewerType](docs/EnumPullReqReviewerType.md)
 - [EnumPullReqState](docs/EnumPullReqState.md)
 - [EnumRepoState](docs/EnumRepoState.md)
 - [EnumReservedRange](docs/EnumReservedRange.md)
 - [EnumReservedRangeOrBuilder](docs/EnumReservedRangeOrBuilder.md)
 - [EnumRuleState](docs/EnumRuleState.md)
 - [EnumValueDescriptor](docs/EnumValueDescriptor.md)
 - [EnumValueDescriptorProto](docs/EnumValueDescriptorProto.md)
 - [EnumValueDescriptorProtoOrBuilder](docs/EnumValueDescriptorProtoOrBuilder.md)
 - [EnumValueOptions](docs/EnumValueOptions.md)
 - [EnumValueOptionsOrBuilder](docs/EnumValueOptionsOrBuilder.md)
 - [EnumWebhookExecutionResult](docs/EnumWebhookExecutionResult.md)
 - [EnumWebhookParent](docs/EnumWebhookParent.md)
 - [EnumWebhookTrigger](docs/EnumWebhookTrigger.md)
 - [Environment](docs/Environment.md)
 - [Environment1](docs/Environment1.md)
 - [EnvironmentCreateRequest](docs/EnvironmentCreateRequest.md)
 - [EnvironmentGitUpdateResponse](docs/EnvironmentGitUpdateResponse.md)
 - [EnvironmentGroup](docs/EnvironmentGroup.md)
 - [EnvironmentGroupDelete](docs/EnvironmentGroupDelete.md)
 - [EnvironmentGroupRequest](docs/EnvironmentGroupRequest.md)
 - [EnvironmentGroupResponse](docs/EnvironmentGroupResponse.md)
 - [EnvironmentIdentifierResponse](docs/EnvironmentIdentifierResponse.md)
 - [EnvironmentImportResponseDetails](docs/EnvironmentImportResponseDetails.md)
 - [EnvironmentMoveConfigResponse](docs/EnvironmentMoveConfigResponse.md)
 - [EnvironmentPerspective](docs/EnvironmentPerspective.md)
 - [EnvironmentRequest](docs/EnvironmentRequest.md)
 - [EnvironmentResponse](docs/EnvironmentResponse.md)
 - [EnvironmentResponse1](docs/EnvironmentResponse1.md)
 - [EnvironmentResponseDetails](docs/EnvironmentResponseDetails.md)
 - [EnvironmentType](docs/EnvironmentType.md)
 - [EnvironmentType1](docs/EnvironmentType1.md)
 - [EnvironmentUpdateRequest](docs/EnvironmentUpdateRequest.md)
 - [Error](docs/Error.md)
 - [Error1](docs/Error1.md)
 - [ErrorBudgetBurnRateConditionSpec](docs/ErrorBudgetBurnRateConditionSpec.md)
 - [ErrorBudgetRemainingMinutesConditionSpec](docs/ErrorBudgetRemainingMinutesConditionSpec.md)
 - [ErrorBudgetRemainingPercentageConditionSpec](docs/ErrorBudgetRemainingPercentageConditionSpec.md)
 - [ErrorDetail](docs/ErrorDetail.md)
 - [ErrorMetadata](docs/ErrorMetadata.md)
 - [ErrorMetadata1](docs/ErrorMetadata1.md)
 - [ErrorMetadata2](docs/ErrorMetadata2.md)
 - [ErrorNodeSummary](docs/ErrorNodeSummary.md)
 - [ErrorResponse](docs/ErrorResponse.md)
 - [ErrorResultWithIdentifier](docs/ErrorResultWithIdentifier.md)
 - [ErrorTrackingConditionSpec](docs/ErrorTrackingConditionSpec.md)
 - [ErrorTrackingConnectorDTO](docs/ErrorTrackingConnectorDTO.md)
 - [ErrorTrackingHealthSource](docs/ErrorTrackingHealthSource.md)
 - [EulaSignRequest](docs/EulaSignRequest.md)
 - [EulaSignResponse](docs/EulaSignResponse.md)
 - [EvaluateRequestBody](docs/EvaluateRequestBody.md)
 - [EvaluatedPolicy](docs/EvaluatedPolicy.md)
 - [Evaluation](docs/Evaluation.md)
 - [EvaluationCounts](docs/EvaluationCounts.md)
 - [EvaluationDetail](docs/EvaluationDetail.md)
 - [EventLogsSuccessResponse](docs/EventLogsSuccessResponse.md)
 - [EventLogsSuccessResponseResponse](docs/EventLogsSuccessResponseResponse.md)
 - [EventResponse](docs/EventResponse.md)
 - [EventsChartsSuccessResponse](docs/EventsChartsSuccessResponse.md)
 - [EventsChartsSuccessResponseResponse](docs/EventsChartsSuccessResponseResponse.md)
 - [EventsFilter](docs/EventsFilter.md)
 - [ExclusionEntry](docs/ExclusionEntry.md)
 - [ExecutableResponse](docs/ExecutableResponse.md)
 - [Execution](docs/Execution.md)
 - [Execution2](docs/Execution2.md)
 - [ExecutionDetails](docs/ExecutionDetails.md)
 - [ExecutionErrorInfo](docs/ExecutionErrorInfo.md)
 - [ExecutionGraph](docs/ExecutionGraph.md)
 - [ExecutionInfo](docs/ExecutionInfo.md)
 - [ExecutionLogDTO](docs/ExecutionLogDTO.md)
 - [ExecutionMetadata](docs/ExecutionMetadata.md)
 - [ExecutionMetadataOrBuilder](docs/ExecutionMetadataOrBuilder.md)
 - [ExecutionNode](docs/ExecutionNode.md)
 - [ExecutionNodeAdjacencyList](docs/ExecutionNodeAdjacencyList.md)
 - [ExecutionPrincipalInfo](docs/ExecutionPrincipalInfo.md)
 - [ExecutionPrincipalInfoOrBuilder](docs/ExecutionPrincipalInfoOrBuilder.md)
 - [ExecutionResourceCollection](docs/ExecutionResourceCollection.md)
 - [ExecutionSummaryInfo](docs/ExecutionSummaryInfo.md)
 - [ExecutionTriggerInfo](docs/ExecutionTriggerInfo.md)
 - [ExecutionTriggerInfoOrBuilder](docs/ExecutionTriggerInfoOrBuilder.md)
 - [ExecutorInfo](docs/ExecutorInfo.md)
 - [Exemption](docs/Exemption.md)
 - [ExemptionsCreateExemptionResponseBody](docs/ExemptionsCreateExemptionResponseBody.md)
 - [ExemptionsListExemptionsResponseBody](docs/ExemptionsListExemptionsResponseBody.md)
 - [ExportDetails](docs/ExportDetails.md)
 - [Exports](docs/Exports.md)
 - [ExpressionBlock](docs/ExpressionBlock.md)
 - [ExpressionBlockOrBuilder](docs/ExpressionBlockOrBuilder.md)
 - [ExtensionRange](docs/ExtensionRange.md)
 - [ExtensionRangeOptions](docs/ExtensionRangeOptions.md)
 - [ExtensionRangeOptionsOrBuilder](docs/ExtensionRangeOptionsOrBuilder.md)
 - [ExtensionRangeOrBuilder](docs/ExtensionRangeOrBuilder.md)
 - [FQNtoError](docs/FQNtoError.md)
 - [Facets](docs/Facets.md)
 - [FailMetricCustomThresholdSpec](docs/FailMetricCustomThresholdSpec.md)
 - [FailMetricThresholdSpec](docs/FailMetricThresholdSpec.md)
 - [Failure](docs/Failure.md)
 - [FailureInfoCard](docs/FailureInfoCard.md)
 - [FailureInfoDTO](docs/FailureInfoDTO.md)
 - [FavoriteDTO](docs/FavoriteDTO.md)
 - [FavoriteResponse](docs/FavoriteResponse.md)
 - [FavoritesResourceType](docs/FavoritesResourceType.md)
 - [Feature](docs/Feature.md)
 - [FeatureCounts](docs/FeatureCounts.md)
 - [FeatureEnvProperties](docs/FeatureEnvProperties.md)
 - [FeatureFlagAuditEventData](docs/FeatureFlagAuditEventData.md)
 - [FeatureFlagRequestKind](docs/FeatureFlagRequestKind.md)
 - [FeaturePipeline](docs/FeaturePipeline.md)
 - [FeatureResponseMetadata](docs/FeatureResponseMetadata.md)
 - [FeatureResponseMetadataDetails](docs/FeatureResponseMetadataDetails.md)
 - [FeatureResponseMetadataDetailsPipelineMetadata](docs/FeatureResponseMetadataDetailsPipelineMetadata.md)
 - [FeatureSet](docs/FeatureSet.md)
 - [FeatureSetOrBuilder](docs/FeatureSetOrBuilder.md)
 - [FeatureState](docs/FeatureState.md)
 - [FeatureStatus](docs/FeatureStatus.md)
 - [Features](docs/Features.md)
 - [FieldDescriptor](docs/FieldDescriptor.md)
 - [FieldDescriptorProto](docs/FieldDescriptorProto.md)
 - [FieldDescriptorProtoOrBuilder](docs/FieldDescriptorProtoOrBuilder.md)
 - [FieldError](docs/FieldError.md)
 - [FieldFilter](docs/FieldFilter.md)
 - [FieldOptions](docs/FieldOptions.md)
 - [FieldOptionsOrBuilder](docs/FieldOptionsOrBuilder.md)
 - [FieldValues](docs/FieldValues.md)
 - [File](docs/File.md)
 - [FileCertificateInputSpecDTO](docs/FileCertificateInputSpecDTO.md)
 - [FileDescriptor](docs/FileDescriptor.md)
 - [FileDescriptorProto](docs/FileDescriptorProto.md)
 - [FileNode](docs/FileNode.md)
 - [FileOptions](docs/FileOptions.md)
 - [FileOptionsOrBuilder](docs/FileOptionsOrBuilder.md)
 - [FileStoreNode](docs/FileStoreNode.md)
 - [FileStoreRequest](docs/FileStoreRequest.md)
 - [FilesFilterPropertiesDTO](docs/FilesFilterPropertiesDTO.md)
 - [FilesIdentifierBody](docs/FilesIdentifierBody.md)
 - [FilestoreIdentifierBody](docs/FilestoreIdentifierBody.md)
 - [Filter](docs/Filter.md)
 - [FilterObject](docs/FilterObject.md)
 - [FilterProperties](docs/FilterProperties.md)
 - [FilterStats](docs/FilterStats.md)
 - [FilterType](docs/FilterType.md)
 - [FilterValues](docs/FilterValues.md)
 - [FixedSchedule](docs/FixedSchedule.md)
 - [FixedSchedulesListResponse](docs/FixedSchedulesListResponse.md)
 - [FlagBasicInfo](docs/FlagBasicInfo.md)
 - [FlagBasicInfos](docs/FlagBasicInfos.md)
 - [FolderNode](docs/FolderNode.md)
 - [ForMetadata](docs/ForMetadata.md)
 - [ForMetadataOrBuilder](docs/ForMetadataOrBuilder.md)
 - [FormDataContentDisposition](docs/FormDataContentDisposition.md)
 - [FreezeDetailedResponse](docs/FreezeDetailedResponse.md)
 - [FreezeErrorResponseDTO](docs/FreezeErrorResponseDTO.md)
 - [FreezeFilterPropertiesDTO](docs/FreezeFilterPropertiesDTO.md)
 - [FreezeResponse](docs/FreezeResponse.md)
 - [FreezeResponseWrapperDTO](docs/FreezeResponseWrapperDTO.md)
 - [FreezeSummaryResponse](docs/FreezeSummaryResponse.md)
 - [FreezeWindow](docs/FreezeWindow.md)
 - [FrontendExemption](docs/FrontendExemption.md)
 - [FrontendExemptionCounts](docs/FrontendExemptionCounts.md)
 - [FrontendExpiringExemptionsResponseBody](docs/FrontendExpiringExemptionsResponseBody.md)
 - [FrontendIssueCounts](docs/FrontendIssueCounts.md)
 - [FrontendIssueForExemptionResponseBody](docs/FrontendIssueForExemptionResponseBody.md)
 - [FrontendOverviewBaselinesResponseBody](docs/FrontendOverviewBaselinesResponseBody.md)
 - [FrontendOverviewHistoricalCountsResponseBody](docs/FrontendOverviewHistoricalCountsResponseBody.md)
 - [FrontendPipelineSecurityIssuesResponseBody](docs/FrontendPipelineSecurityIssuesResponseBody.md)
 - [FrontendPipelineSecurityStepsResponseBody](docs/FrontendPipelineSecurityStepsResponseBody.md)
 - [FrontendSecurityReviewResponseBody](docs/FrontendSecurityReviewResponseBody.md)
 - [FrontendTestTargetsResponseBody](docs/FrontendTestTargetsResponseBody.md)
 - [FrozenExecutionDetail](docs/FrozenExecutionDetail.md)
 - [FrozenExecutionDetails](docs/FrozenExecutionDetails.md)
 - [FullIssueCounts](docs/FullIssueCounts.md)
 - [GCPViewPreferences](docs/GCPViewPreferences.md)
 - [GatewayAccountRequest](docs/GatewayAccountRequest.md)
 - [GatewayruntimeError](docs/GatewayruntimeError.md)
 - [GcpBillingExportSpecDTO](docs/GcpBillingExportSpecDTO.md)
 - [GcpCloudCostConnectorDTO](docs/GcpCloudCostConnectorDTO.md)
 - [GcpConnector](docs/GcpConnector.md)
 - [GcpConnectorCredential](docs/GcpConnectorCredential.md)
 - [GcpCredentialSpec](docs/GcpCredentialSpec.md)
 - [GcpKmsConnector](docs/GcpKmsConnector.md)
 - [GcpManualDetails](docs/GcpManualDetails.md)
 - [GcpOidcAccessTokenRequest](docs/GcpOidcAccessTokenRequest.md)
 - [GcpOidcDetails](docs/GcpOidcDetails.md)
 - [GcpOidcServiceAccountAccessTokenResponse](docs/GcpOidcServiceAccountAccessTokenResponse.md)
 - [GcpOidcTokenExchangeDetailsForDelegate](docs/GcpOidcTokenExchangeDetailsForDelegate.md)
 - [GcpOidcTokenRequest](docs/GcpOidcTokenRequest.md)
 - [GcpRecommendationAdhocDTO](docs/GcpRecommendationAdhocDTO.md)
 - [GcpSecretManager](docs/GcpSecretManager.md)
 - [GcrArtifactSpec](docs/GcrArtifactSpec.md)
 - [GcrArtifactTriggerSpec](docs/GcrArtifactTriggerSpec.md)
 - [GcsBuildStore](docs/GcsBuildStore.md)
 - [GcsBuildStoreSpec](docs/GcsBuildStoreSpec.md)
 - [GenerateRequestBody](docs/GenerateRequestBody.md)
 - [GenerateYamlRequest](docs/GenerateYamlRequest.md)
 - [GenerateYamlResponse](docs/GenerateYamlResponse.md)
 - [GenerateYamlResponseGeneratedYaml](docs/GenerateYamlResponseGeneratedYaml.md)
 - [GenericSuccessResponse](docs/GenericSuccessResponse.md)
 - [GetAccessPointResponse](docs/GetAccessPointResponse.md)
 - [GetByReferenceIDResponseBody](docs/GetByReferenceIDResponseBody.md)
 - [GetGitXWebhookEventFileValidationResponse](docs/GetGitXWebhookEventFileValidationResponse.md)
 - [GetProviderResponse](docs/GetProviderResponse.md)
 - [GitAuditData](docs/GitAuditData.md)
 - [GitAuthentication](docs/GitAuthentication.md)
 - [GitBlamePart](docs/GitBlamePart.md)
 - [GitBlamePartPrevious](docs/GitBlamePartPrevious.md)
 - [GitBranch](docs/GitBranch.md)
 - [GitBranchList](docs/GitBranchList.md)
 - [GitCommit](docs/GitCommit.md)
 - [GitCommitFileStats](docs/GitCommitFileStats.md)
 - [GitConfig](docs/GitConfig.md)
 - [GitCreateDetails](docs/GitCreateDetails.md)
 - [GitCreateDetails1](docs/GitCreateDetails1.md)
 - [GitDetails](docs/GitDetails.md)
 - [GitDetailsMetadata](docs/GitDetailsMetadata.md)
 - [GitEnabled](docs/GitEnabled.md)
 - [GitErrorResult](docs/GitErrorResult.md)
 - [GitFileAction](docs/GitFileAction.md)
 - [GitFileDiff](docs/GitFileDiff.md)
 - [GitFindDetails](docs/GitFindDetails.md)
 - [GitFullSyncConfig](docs/GitFullSyncConfig.md)
 - [GitFullSyncConfigRequest](docs/GitFullSyncConfigRequest.md)
 - [GitFullSyncEntityInfo](docs/GitFullSyncEntityInfo.md)
 - [GitFullSyncEntityInfoFilter](docs/GitFullSyncEntityInfoFilter.md)
 - [GitHTTPAuthenticationDTO](docs/GitHTTPAuthenticationDTO.md)
 - [GitHttpConnectorSpec](docs/GitHttpConnectorSpec.md)
 - [GitHttpEncryptedConnectorSpec](docs/GitHttpEncryptedConnectorSpec.md)
 - [GitIdentity](docs/GitIdentity.md)
 - [GitImportDetails](docs/GitImportDetails.md)
 - [GitImportInfo](docs/GitImportInfo.md)
 - [GitMetadata](docs/GitMetadata.md)
 - [GitMetadataUpdateRequestBody](docs/GitMetadataUpdateRequestBody.md)
 - [GitMetadataUpdateRequestInfo](docs/GitMetadataUpdateRequestInfo.md)
 - [GitMetadataUpdateResponseBody](docs/GitMetadataUpdateResponseBody.md)
 - [GitMoveDetails](docs/GitMoveDetails.md)
 - [GitPathDetails](docs/GitPathDetails.md)
 - [GitSSHAuthentication](docs/GitSSHAuthentication.md)
 - [GitSignature](docs/GitSignature.md)
 - [GitSshConnectorSpec](docs/GitSshConnectorSpec.md)
 - [GitSyncConfig](docs/GitSyncConfig.md)
 - [GitSyncError](docs/GitSyncError.md)
 - [GitSyncErrorAggregateByCommit](docs/GitSyncErrorAggregateByCommit.md)
 - [GitSyncErrorCount](docs/GitSyncErrorCount.md)
 - [GitSyncErrorDetails](docs/GitSyncErrorDetails.md)
 - [GitSyncFolderConfig](docs/GitSyncFolderConfig.md)
 - [GitSyncPatchOperation](docs/GitSyncPatchOperation.md)
 - [GitSyncSettings](docs/GitSyncSettings.md)
 - [GitUpdateDetails](docs/GitUpdateDetails.md)
 - [GitUpdateDetails1](docs/GitUpdateDetails1.md)
 - [GitXWebhookEventResponse](docs/GitXWebhookEventResponse.md)
 - [GitXWebhookResponse](docs/GitXWebhookResponse.md)
 - [GithubApiAccess](docs/GithubApiAccess.md)
 - [GithubApiAccessSpec](docs/GithubApiAccessSpec.md)
 - [GithubApp](docs/GithubApp.md)
 - [GithubAppSpec](docs/GithubAppSpec.md)
 - [GithubAuthentication](docs/GithubAuthentication.md)
 - [GithubCard](docs/GithubCard.md)
 - [GithubConnector](docs/GithubConnector.md)
 - [GithubCredentials](docs/GithubCredentials.md)
 - [GithubHttpCredentials](docs/GithubHttpCredentials.md)
 - [GithubHttpCredentialsSpec](docs/GithubHttpCredentialsSpec.md)
 - [GithubOauth](docs/GithubOauth.md)
 - [GithubPackageRegistryArtifactSpec](docs/GithubPackageRegistryArtifactSpec.md)
 - [GithubPackageRegistryArtifactTriggerSpec](docs/GithubPackageRegistryArtifactTriggerSpec.md)
 - [GithubSshCredentials](docs/GithubSshCredentials.md)
 - [GithubTokenSpec](docs/GithubTokenSpec.md)
 - [GithubUsernamePassword](docs/GithubUsernamePassword.md)
 - [GithubUsernameToken](docs/GithubUsernameToken.md)
 - [GithubWebhookSpec](docs/GithubWebhookSpec.md)
 - [GithubWebhookTriggerSpec](docs/GithubWebhookTriggerSpec.md)
 - [GitlabApiAccess](docs/GitlabApiAccess.md)
 - [GitlabApiAccessSpec](docs/GitlabApiAccessSpec.md)
 - [GitlabAuthentication](docs/GitlabAuthentication.md)
 - [GitlabConnector](docs/GitlabConnector.md)
 - [GitlabCredentials](docs/GitlabCredentials.md)
 - [GitlabHttpCredentials](docs/GitlabHttpCredentials.md)
 - [GitlabHttpCredentialsSpec](docs/GitlabHttpCredentialsSpec.md)
 - [GitlabKerberos](docs/GitlabKerberos.md)
 - [GitlabOauth](docs/GitlabOauth.md)
 - [GitlabOnPremProviderRequestInfo](docs/GitlabOnPremProviderRequestInfo.md)
 - [GitlabSshCredentials](docs/GitlabSshCredentials.md)
 - [GitlabTokenSpec](docs/GitlabTokenSpec.md)
 - [GitlabUsernamePassword](docs/GitlabUsernamePassword.md)
 - [GitlabUsernameToken](docs/GitlabUsernameToken.md)
 - [GitlabWebhookSpec](docs/GitlabWebhookSpec.md)
 - [GitlabWebhookTriggerSpec](docs/GitlabWebhookTriggerSpec.md)
 - [Gitopsservicev1Namespace](docs/Gitopsservicev1Namespace.md)
 - [Gitopsservicev1NamespaceList](docs/Gitopsservicev1NamespaceList.md)
 - [GoogleArtifactRegistryArtifactSpec](docs/GoogleArtifactRegistryArtifactSpec.md)
 - [GoogleArtifactRegistryArtifactTriggerSpec](docs/GoogleArtifactRegistryArtifactTriggerSpec.md)
 - [GoogleCloudStorageArtifactSpec](docs/GoogleCloudStorageArtifactSpec.md)
 - [GoogleCloudStorageArtifactTriggerSpec](docs/GoogleCloudStorageArtifactTriggerSpec.md)
 - [GovernanceAdhocEnqueueDTOV2](docs/GovernanceAdhocEnqueueDTOV2.md)
 - [GovernanceEnqueueResponseDTO](docs/GovernanceEnqueueResponseDTO.md)
 - [GovernanceJobEnqueueDTO](docs/GovernanceJobEnqueueDTO.md)
 - [GovernanceMetadata](docs/GovernanceMetadata.md)
 - [GovernanceMetadata1](docs/GovernanceMetadata1.md)
 - [GovernanceMetadata2](docs/GovernanceMetadata2.md)
 - [GovernancePromptRule](docs/GovernancePromptRule.md)
 - [GovernanceStatus](docs/GovernanceStatus.md)
 - [GpgkeysGnuPGPublicKey](docs/GpgkeysGnuPGPublicKey.md)
 - [GpgkeysGnuPGPublicKeyCreateRequest](docs/GpgkeysGnuPGPublicKeyCreateRequest.md)
 - [GpgkeysGnuPGPublicKeyCreateResponse](docs/GpgkeysGnuPGPublicKeyCreateResponse.md)
 - [GpgkeysGnuPGPublicKeyList](docs/GpgkeysGnuPGPublicKeyList.md)
 - [GpgkeysGnuPGPublicKeyQuery](docs/GpgkeysGnuPGPublicKeyQuery.md)
 - [GpgkeysGnuPGPublicKeyResponse](docs/GpgkeysGnuPGPublicKeyResponse.md)
 - [GraphLayoutNode](docs/GraphLayoutNode.md)
 - [Group](docs/Group.md)
 - [GroupRequest](docs/GroupRequest.md)
 - [GroupResponse](docs/GroupResponse.md)
 - [GroupServingRule](docs/GroupServingRule.md)
 - [GroupsYamlResponse](docs/GroupsYamlResponse.md)
 - [HTTPProxy](docs/HTTPProxy.md)
 - [HarnessApiAccess](docs/HarnessApiAccess.md)
 - [HarnessApiAccessSpec](docs/HarnessApiAccessSpec.md)
 - [HarnessApprovalActivity](docs/HarnessApprovalActivity.md)
 - [HarnessApprovalActivityRequest](docs/HarnessApprovalActivityRequest.md)
 - [HarnessApprovalActivityRequestBody](docs/HarnessApprovalActivityRequestBody.md)
 - [HarnessApprovalInstanceDetails](docs/HarnessApprovalInstanceDetails.md)
 - [HarnessAuthentication](docs/HarnessAuthentication.md)
 - [HarnessBackstageEntities](docs/HarnessBackstageEntities.md)
 - [HarnessConnector](docs/HarnessConnector.md)
 - [HarnessEntitiesCountResponse](docs/HarnessEntitiesCountResponse.md)
 - [HarnessEntitiesResponse](docs/HarnessEntitiesResponse.md)
 - [HarnessHttpCredentials](docs/HarnessHttpCredentials.md)
 - [HarnessHttpCredentialsSpec](docs/HarnessHttpCredentialsSpec.md)
 - [HarnessIacmActivity](docs/HarnessIacmActivity.md)
 - [HarnessIacmApproval](docs/HarnessIacmApproval.md)
 - [HarnessIacmChangedCosts](docs/HarnessIacmChangedCosts.md)
 - [HarnessIacmChangedOutput](docs/HarnessIacmChangedOutput.md)
 - [HarnessIacmChangedResource](docs/HarnessIacmChangedResource.md)
 - [HarnessIacmChangedResources](docs/HarnessIacmChangedResources.md)
 - [HarnessIacmCostResource](docs/HarnessIacmCostResource.md)
 - [HarnessIacmCostResourcesByType](docs/HarnessIacmCostResourcesByType.md)
 - [HarnessIacmCostSubresource](docs/HarnessIacmCostSubresource.md)
 - [HarnessIacmCostsresources](docs/HarnessIacmCostsresources.md)
 - [HarnessIacmDefaultpipeline](docs/HarnessIacmDefaultpipeline.md)
 - [HarnessIacmDefaultpipeline2](docs/HarnessIacmDefaultpipeline2.md)
 - [HarnessIacmDisablepush](docs/HarnessIacmDisablepush.md)
 - [HarnessIacmExecution](docs/HarnessIacmExecution.md)
 - [HarnessIacmLockinfo](docs/HarnessIacmLockinfo.md)
 - [HarnessIacmModuleRegistryCreateModule](docs/HarnessIacmModuleRegistryCreateModule.md)
 - [HarnessIacmModuleRegistryDownload](docs/HarnessIacmModuleRegistryDownload.md)
 - [HarnessIacmModuleRegistryListVersions](docs/HarnessIacmModuleRegistryListVersions.md)
 - [HarnessIacmModuleRegistryModule](docs/HarnessIacmModuleRegistryModule.md)
 - [HarnessIacmModuleRegistryModuleList](docs/HarnessIacmModuleRegistryModuleList.md)
 - [HarnessIacmModuleRegistryModuleMetadata](docs/HarnessIacmModuleRegistryModuleMetadata.md)
 - [HarnessIacmModuleRegistryServiceDiscovery](docs/HarnessIacmModuleRegistryServiceDiscovery.md)
 - [HarnessIacmModuleRegistryVersionTypes](docs/HarnessIacmModuleRegistryVersionTypes.md)
 - [HarnessIacmModuleRegistryVersions](docs/HarnessIacmModuleRegistryVersions.md)
 - [HarnessIacmMonthlycost](docs/HarnessIacmMonthlycost.md)
 - [HarnessIacmOutput](docs/HarnessIacmOutput.md)
 - [HarnessIacmPluginversion](docs/HarnessIacmPluginversion.md)
 - [HarnessIacmResource](docs/HarnessIacmResource.md)
 - [HarnessIacmResources](docs/HarnessIacmResources.md)
 - [HarnessIacmWorkspace](docs/HarnessIacmWorkspace.md)
 - [HarnessIacmWorkspaceCreateresult](docs/HarnessIacmWorkspaceCreateresult.md)
 - [HarnessIacmWorkspaceTemplate](docs/HarnessIacmWorkspaceTemplate.md)
 - [HarnessIacmWorkspacedata](docs/HarnessIacmWorkspacedata.md)
 - [HarnessIacmWorkspacevariable](docs/HarnessIacmWorkspacevariable.md)
 - [HarnessIacmWorkspacevariableCreateresult](docs/HarnessIacmWorkspacevariableCreateresult.md)
 - [HarnessJWTTokenSpec](docs/HarnessJWTTokenSpec.md)
 - [HarnessTokenSpec](docs/HarnessTokenSpec.md)
 - [HarnessUsernameToken](docs/HarnessUsernameToken.md)
 - [HarnessWebhookSpec](docs/HarnessWebhookSpec.md)
 - [HarnessWebhookTriggerSpec](docs/HarnessWebhookTriggerSpec.md)
 - [HeaderConfig](docs/HeaderConfig.md)
 - [HeaderInfo](docs/HeaderInfo.md)
 - [HealthMonitoringFlagResponse](docs/HealthMonitoringFlagResponse.md)
 - [HealthScoreConditionSpec](docs/HealthScoreConditionSpec.md)
 - [HealthScoreDTO](docs/HealthScoreDTO.md)
 - [HealthSource](docs/HealthSource.md)
 - [HealthSourceDTO](docs/HealthSourceDTO.md)
 - [HealthSourceParamsDTO](docs/HealthSourceParamsDTO.md)
 - [HealthSourceSpec](docs/HealthSourceSpec.md)
 - [HealthSourceSummary](docs/HealthSourceSummary.md)
 - [HelmChartManifestTriggerSpec](docs/HelmChartManifestTriggerSpec.md)
 - [HistogramExp](docs/HistogramExp.md)
 - [HistoricalCounts](docs/HistoricalCounts.md)
 - [HistoricalIssueCounts](docs/HistoricalIssueCounts.md)
 - [HistoricalTrend](docs/HistoricalTrend.md)
 - [HomePageLayoutInfo](docs/HomePageLayoutInfo.md)
 - [HomePageLayoutRequest](docs/HomePageLayoutRequest.md)
 - [HomePageLayoutResponse](docs/HomePageLayoutResponse.md)
 - [HomePageLayoutYamlResponse](docs/HomePageLayoutYamlResponse.md)
 - [HostDTO](docs/HostDTO.md)
 - [HostFilterDTO](docs/HostFilterDTO.md)
 - [HostInfo](docs/HostInfo.md)
 - [HostValidationDTO](docs/HostValidationDTO.md)
 - [HostValidationParams](docs/HostValidationParams.md)
 - [HrepocredsRepoCreds](docs/HrepocredsRepoCreds.md)
 - [HrepocredsRepoCredsCreateRequest](docs/HrepocredsRepoCredsCreateRequest.md)
 - [HrepocredsRepoCredsQuery](docs/HrepocredsRepoCredsQuery.md)
 - [HrepocredsRepoCredsResponse](docs/HrepocredsRepoCredsResponse.md)
 - [HrepocredsRepoCredsUpdateRequest](docs/HrepocredsRepoCredsUpdateRequest.md)
 - [HttpBuildStore](docs/HttpBuildStore.md)
 - [HttpBuildStoreSpec](docs/HttpBuildStoreSpec.md)
 - [HttpHelmAuthCredentials](docs/HttpHelmAuthCredentials.md)
 - [HttpHelmAuthentication](docs/HttpHelmAuthentication.md)
 - [HttpHelmConnector](docs/HttpHelmConnector.md)
 - [HttpHelmUsernamePassword](docs/HttpHelmUsernamePassword.md)
 - [HttpRequestInfo](docs/HttpRequestInfo.md)
 - [IDResult](docs/IDResult.md)
 - [IPAllowlistConfig](docs/IPAllowlistConfig.md)
 - [IPAllowlistConfigRequest](docs/IPAllowlistConfigRequest.md)
 - [IPAllowlistConfigResponse](docs/IPAllowlistConfigResponse.md)
 - [IPAllowlistConfigValidateResponse](docs/IPAllowlistConfigValidateResponse.md)
 - [IaCMAuditEvent](docs/IaCMAuditEvent.md)
 - [IaCMError](docs/IaCMError.md)
 - [IaCMEvaluatedPolicy](docs/IaCMEvaluatedPolicy.md)
 - [IaCMEvaluation](docs/IaCMEvaluation.md)
 - [IaCMEvaluationDetail](docs/IaCMEvaluationDetail.md)
 - [IaCMPolicy](docs/IaCMPolicy.md)
 - [IaCMPolicySet](docs/IaCMPolicySet.md)
 - [IaCMServiceVersion](docs/IaCMServiceVersion.md)
 - [IaCMVariable](docs/IaCMVariable.md)
 - [IdentifierRefProtoDTO](docs/IdentifierRefProtoDTO.md)
 - [IdentifierRefProtoDTOOrBuilder](docs/IdentifierRefProtoDTOOrBuilder.md)
 - [IgnoreMetricThresholdSpec](docs/IgnoreMetricThresholdSpec.md)
 - [ImportEntitiesBase](docs/ImportEntitiesBase.md)
 - [ImportEntitiesResponse](docs/ImportEntitiesResponse.md)
 - [ImporterPipelineOption](docs/ImporterPipelineOption.md)
 - [ImporterProvider](docs/ImporterProvider.md)
 - [ImporterProviderType](docs/ImporterProviderType.md)
 - [IndividualEntitiesImport](docs/IndividualEntitiesImport.md)
 - [InfraDefinitionReferenceProtoDTO](docs/InfraDefinitionReferenceProtoDTO.md)
 - [InfraDefinitionReferenceProtoDTOOrBuilder](docs/InfraDefinitionReferenceProtoDTOOrBuilder.md)
 - [InfraMoveConfigResponse](docs/InfraMoveConfigResponse.md)
 - [Infrastructure](docs/Infrastructure.md)
 - [InfrastructureCreateRequest](docs/InfrastructureCreateRequest.md)
 - [InfrastructureGitUpdateResponse](docs/InfrastructureGitUpdateResponse.md)
 - [InfrastructureImportResponse](docs/InfrastructureImportResponse.md)
 - [InfrastructureRequest](docs/InfrastructureRequest.md)
 - [InfrastructureResponse](docs/InfrastructureResponse.md)
 - [InfrastructureResponse1](docs/InfrastructureResponse1.md)
 - [InfrastructureResponseDTO](docs/InfrastructureResponseDTO.md)
 - [InfrastructureType](docs/InfrastructureType.md)
 - [InfrastructureUpdateRequest](docs/InfrastructureUpdateRequest.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse20010](docs/InlineResponse20010.md)
 - [InlineResponse20011](docs/InlineResponse20011.md)
 - [InlineResponse20011Records](docs/InlineResponse20011Records.md)
 - [InlineResponse20012](docs/InlineResponse20012.md)
 - [InlineResponse20012Fields](docs/InlineResponse20012Fields.md)
 - [InlineResponse20013](docs/InlineResponse20013.md)
 - [InlineResponse20013IntegrationUserIds](docs/InlineResponse20013IntegrationUserIds.md)
 - [InlineResponse20013Metadata](docs/InlineResponse20013Metadata.md)
 - [InlineResponse20013Records](docs/InlineResponse20013Records.md)
 - [InlineResponse20014](docs/InlineResponse20014.md)
 - [InlineResponse20015](docs/InlineResponse20015.md)
 - [InlineResponse20015IntegrationUserDetails](docs/InlineResponse20015IntegrationUserDetails.md)
 - [InlineResponse20015OrgUserDetails](docs/InlineResponse20015OrgUserDetails.md)
 - [InlineResponse20016](docs/InlineResponse20016.md)
 - [InlineResponse20016Records](docs/InlineResponse20016Records.md)
 - [InlineResponse20016WorkItem](docs/InlineResponse20016WorkItem.md)
 - [InlineResponse20017](docs/InlineResponse20017.md)
 - [InlineResponse20017Stats](docs/InlineResponse20017Stats.md)
 - [InlineResponse20017TimeSeries](docs/InlineResponse20017TimeSeries.md)
 - [InlineResponse20017TimeSeriesDay](docs/InlineResponse20017TimeSeriesDay.md)
 - [InlineResponse20018](docs/InlineResponse20018.md)
 - [InlineResponse20018Stats](docs/InlineResponse20018Stats.md)
 - [InlineResponse20019](docs/InlineResponse20019.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse2006](docs/InlineResponse2006.md)
 - [InlineResponse2006Records](docs/InlineResponse2006Records.md)
 - [InlineResponse2007](docs/InlineResponse2007.md)
 - [InlineResponse2007Records](docs/InlineResponse2007Records.md)
 - [InlineResponse2008](docs/InlineResponse2008.md)
 - [InlineResponse2008Records](docs/InlineResponse2008Records.md)
 - [InlineResponse2009](docs/InlineResponse2009.md)
 - [InlineResponse201](docs/InlineResponse201.md)
 - [InlineResponse400](docs/InlineResponse400.md)
 - [InlineResponse404](docs/InlineResponse404.md)
 - [InputDetails](docs/InputDetails.md)
 - [InputSetCreateRequestBody](docs/InputSetCreateRequestBody.md)
 - [InputSetError](docs/InputSetError.md)
 - [InputSetErrorDetails](docs/InputSetErrorDetails.md)
 - [InputSetErrorWrapper](docs/InputSetErrorWrapper.md)
 - [InputSetErrorWrapperDTO](docs/InputSetErrorWrapperDTO.md)
 - [InputSetGitUpdateDetails](docs/InputSetGitUpdateDetails.md)
 - [InputSetGitUpdateResponse](docs/InputSetGitUpdateResponse.md)
 - [InputSetImportRequestBody](docs/InputSetImportRequestBody.md)
 - [InputSetImportRequestDTO](docs/InputSetImportRequestDTO.md)
 - [InputSetImportResponseBody](docs/InputSetImportResponseBody.md)
 - [InputSetMoveConfigRequestBody](docs/InputSetMoveConfigRequestBody.md)
 - [InputSetMoveConfigResponseBody](docs/InputSetMoveConfigResponseBody.md)
 - [InputSetReferenceProtoDTO](docs/InputSetReferenceProtoDTO.md)
 - [InputSetReferenceProtoDTOOrBuilder](docs/InputSetReferenceProtoDTOOrBuilder.md)
 - [InputSetResponse](docs/InputSetResponse.md)
 - [InputSetResponseBody](docs/InputSetResponseBody.md)
 - [InputSetSummaryResponse](docs/InputSetSummaryResponse.md)
 - [InputSetTemplateRequest](docs/InputSetTemplateRequest.md)
 - [InputSetTemplateResponse](docs/InputSetTemplateResponse.md)
 - [InputSetTemplateWithReplacedExpressionsResponse](docs/InputSetTemplateWithReplacedExpressionsResponse.md)
 - [InputSetUpdateRequestBody](docs/InputSetUpdateRequestBody.md)
 - [InputSetValidator](docs/InputSetValidator.md)
 - [InputValue](docs/InputValue.md)
 - [InputsResponseBody](docs/InputsResponseBody.md)
 - [InputsResponseBodyOptions](docs/InputsResponseBodyOptions.md)
 - [InputsResponseBodyOptionsClone](docs/InputsResponseBodyOptionsClone.md)
 - [InputsResponseBodyOptionsCloneRef](docs/InputsResponseBodyOptionsCloneRef.md)
 - [InstanceBasedRoutingData](docs/InstanceBasedRoutingData.md)
 - [InstanceBasedRoutingDataV2](docs/InstanceBasedRoutingDataV2.md)
 - [InstanceTypesPayload](docs/InstanceTypesPayload.md)
 - [InterruptConfig](docs/InterruptConfig.md)
 - [InterruptEffectDTO](docs/InterruptEffectDTO.md)
 - [InterruptResponse](docs/InterruptResponse.md)
 - [IntstrIntOrString](docs/IntstrIntOrString.md)
 - [InvitationSource](docs/InvitationSource.md)
 - [Invite](docs/Invite.md)
 - [Issue](docs/Issue.md)
 - [IssueCommentAzureRepoWebhookSpec](docs/IssueCommentAzureRepoWebhookSpec.md)
 - [IssueCommentGithubWebhookSpec](docs/IssueCommentGithubWebhookSpec.md)
 - [IssueCommentHarnessWebhookSpec](docs/IssueCommentHarnessWebhookSpec.md)
 - [IssueCounts](docs/IssueCounts.md)
 - [IssueCountsWithExecutionInfo](docs/IssueCountsWithExecutionInfo.md)
 - [IssueForExemptionResult](docs/IssueForExemptionResult.md)
 - [IssueInScan](docs/IssueInScan.md)
 - [IssueSummaries](docs/IssueSummaries.md)
 - [IssueSummary](docs/IssueSummary.md)
 - [IssuedBy](docs/IssuedBy.md)
 - [IssuesAugmentRemediationRequestBody](docs/IssuesAugmentRemediationRequestBody.md)
 - [IssuesIssuesAugmentRemediationResponseBody](docs/IssuesIssuesAugmentRemediationResponseBody.md)
 - [IssuesListIssuesResponseBody](docs/IssuesListIssuesResponseBody.md)
 - [JDBCAuthCredentialsDTO](docs/JDBCAuthCredentialsDTO.md)
 - [JDBCAuthenticationDTO](docs/JDBCAuthenticationDTO.md)
 - [JDBCConnector](docs/JDBCConnector.md)
 - [JDBCUserNamePasswordDTO](docs/JDBCUserNamePasswordDTO.md)
 - [JenkinsArtifactSpec](docs/JenkinsArtifactSpec.md)
 - [JenkinsArtifactTriggerSpec](docs/JenkinsArtifactTriggerSpec.md)
 - [JenkinsAuthCredentialsDTO](docs/JenkinsAuthCredentialsDTO.md)
 - [JenkinsAuthentication](docs/JenkinsAuthentication.md)
 - [JenkinsBearerTokenDTO](docs/JenkinsBearerTokenDTO.md)
 - [JenkinsConnector](docs/JenkinsConnector.md)
 - [JenkinsUserNamePasswordDTO](docs/JenkinsUserNamePasswordDTO.md)
 - [JexlCriteriaSpec](docs/JexlCriteriaSpec.md)
 - [JiraApprovalInstanceDetails](docs/JiraApprovalInstanceDetails.md)
 - [JiraAuthCredentials](docs/JiraAuthCredentials.md)
 - [JiraAuthentication](docs/JiraAuthentication.md)
 - [JiraConnector](docs/JiraConnector.md)
 - [JiraIssue](docs/JiraIssue.md)
 - [JiraIssueKeyNG](docs/JiraIssueKeyNG.md)
 - [JiraIssueNG](docs/JiraIssueNG.md)
 - [JiraPATPassword](docs/JiraPATPassword.md)
 - [JiraUserNamePassword](docs/JiraUserNamePassword.md)
 - [JwksPublicKeyDTO](docs/JwksPublicKeyDTO.md)
 - [JwksPublicKeysDTO](docs/JwksPublicKeysDTO.md)
 - [K8sConfigDetails](docs/K8sConfigDetails.md)
 - [K8sLabel](docs/K8sLabel.md)
 - [K8sRecommendationFilterProperties](docs/K8sRecommendationFilterProperties.md)
 - [KerberosConfigDTO](docs/KerberosConfigDTO.md)
 - [KerberosWinRmConfigDTO](docs/KerberosWinRmConfigDTO.md)
 - [KeyValuePair](docs/KeyValuePair.md)
 - [KeyValuesBody](docs/KeyValuesBody.md)
 - [KeyValuesBody1](docs/KeyValuesBody1.md)
 - [KeyValuesCriteriaSpec](docs/KeyValuesCriteriaSpec.md)
 - [KubernetesAuth](docs/KubernetesAuth.md)
 - [KubernetesAuthCredential](docs/KubernetesAuthCredential.md)
 - [KubernetesClientKeyCert](docs/KubernetesClientKeyCert.md)
 - [KubernetesClusterConfig](docs/KubernetesClusterConfig.md)
 - [KubernetesClusterDetails](docs/KubernetesClusterDetails.md)
 - [KubernetesConfig](docs/KubernetesConfig.md)
 - [KubernetesCredential](docs/KubernetesCredential.md)
 - [KubernetesCredentialSpec](docs/KubernetesCredentialSpec.md)
 - [KubernetesDependencyMetadata](docs/KubernetesDependencyMetadata.md)
 - [KubernetesOpenIdConnect](docs/KubernetesOpenIdConnect.md)
 - [KubernetesRequest](docs/KubernetesRequest.md)
 - [KubernetesServiceAccount](docs/KubernetesServiceAccount.md)
 - [KubernetesUserNamePassword](docs/KubernetesUserNamePassword.md)
 - [LDAPSettings](docs/LDAPSettings.md)
 - [Label](docs/Label.md)
 - [LabelOrBuilder](docs/LabelOrBuilder.md)
 - [LabelsKeyBody](docs/LabelsKeyBody.md)
 - [LabelsKeyBody1](docs/LabelsKeyBody1.md)
 - [LastModified](docs/LastModified.md)
 - [LastStreamedCard](docs/LastStreamedCard.md)
 - [LastTriggerExecutionDetails](docs/LastTriggerExecutionDetails.md)
 - [LayoutIngestRequest](docs/LayoutIngestRequest.md)
 - [LayoutRequest](docs/LayoutRequest.md)
 - [LayoutResponse](docs/LayoutResponse.md)
 - [LdapConnectionSettings](docs/LdapConnectionSettings.md)
 - [LdapConnectionSettingsDTO](docs/LdapConnectionSettingsDTO.md)
 - [LdapConnectionSettingsDTO1](docs/LdapConnectionSettingsDTO1.md)
 - [LdapGroupResponse](docs/LdapGroupResponse.md)
 - [LdapGroupResponseDTO](docs/LdapGroupResponseDTO.md)
 - [LdapGroupSettings](docs/LdapGroupSettings.md)
 - [LdapGroupSettingsDTO](docs/LdapGroupSettingsDTO.md)
 - [LdapGroupSettingsDTO1](docs/LdapGroupSettingsDTO1.md)
 - [LdapLdaplogintestBody](docs/LdapLdaplogintestBody.md)
 - [LdapLinkGroupRequest](docs/LdapLinkGroupRequest.md)
 - [LdapResponse](docs/LdapResponse.md)
 - [LdapSettingsDTO](docs/LdapSettingsDTO.md)
 - [LdapSettingsDTO1](docs/LdapSettingsDTO1.md)
 - [LdapSettingsIterations](docs/LdapSettingsIterations.md)
 - [LdapSettingsRequest](docs/LdapSettingsRequest.md)
 - [LdapSettingsResponse](docs/LdapSettingsResponse.md)
 - [LdapTestLoginRequestDTO](docs/LdapTestLoginRequestDTO.md)
 - [LdapTestLoginResponseDTO](docs/LdapTestLoginResponseDTO.md)
 - [LdapUserResponse](docs/LdapUserResponse.md)
 - [LdapUserSettings](docs/LdapUserSettings.md)
 - [LdapUserSettingsDTO](docs/LdapUserSettingsDTO.md)
 - [LdapUserSettingsDTO1](docs/LdapUserSettingsDTO1.md)
 - [LdapValidateResponseDTO](docs/LdapValidateResponseDTO.md)
 - [Level](docs/Level.md)
 - [LevelOrBuilder](docs/LevelOrBuilder.md)
 - [LicenceResponse](docs/LicenceResponse.md)
 - [LicenseUsage](docs/LicenseUsage.md)
 - [LicenseUsageActivity](docs/LicenseUsageActivity.md)
 - [LicenseUsageActivityFilterPropertiesDTO](docs/LicenseUsageActivityFilterPropertiesDTO.md)
 - [LicenseUsageSaveRequest](docs/LicenseUsageSaveRequest.md)
 - [LicenseUsageSaveResponse](docs/LicenseUsageSaveResponse.md)
 - [LinkSSOGroupRequestDTO](docs/LinkSSOGroupRequestDTO.md)
 - [LinkedEnforcements](docs/LinkedEnforcements.md)
 - [LinkedPolicy](docs/LinkedPolicy.md)
 - [Linkedpolicyidentifier](docs/Linkedpolicyidentifier.md)
 - [LinksInfo](docs/LinksInfo.md)
 - [ListAccessPointResponse](docs/ListAccessPointResponse.md)
 - [ListChildAccountsSuccessResponse](docs/ListChildAccountsSuccessResponse.md)
 - [ListCostsResponseBody](docs/ListCostsResponseBody.md)
 - [ListDTO](docs/ListDTO.md)
 - [ListInstanceTypesContent](docs/ListInstanceTypesContent.md)
 - [ListMasterContent](docs/ListMasterContent.md)
 - [ListMasterSuccessResponse](docs/ListMasterSuccessResponse.md)
 - [ListMasterSuccessResponseResponse](docs/ListMasterSuccessResponseResponse.md)
 - [ListMasterSuccessResponseResponseData](docs/ListMasterSuccessResponseResponseData.md)
 - [ListPullRequestsRequestBody](docs/ListPullRequestsRequestBody.md)
 - [ListPullRequestsResult](docs/ListPullRequestsResult.md)
 - [ListSetupsSuccessResponse](docs/ListSetupsSuccessResponse.md)
 - [LiveMonitoringDTO](docs/LiveMonitoringDTO.md)
 - [LocalConnector](docs/LocalConnector.md)
 - [Location](docs/Location.md)
 - [LocationOrBuilder](docs/LocationOrBuilder.md)
 - [LockInfo](docs/LockInfo.md)
 - [LoginTypeResponse](docs/LoginTypeResponse.md)
 - [LwCOConnector](docs/LwCOConnector.md)
 - [LwService](docs/LwService.md)
 - [LwServiceResponse](docs/LwServiceResponse.md)
 - [MRCommentGitlabWebhookSpec](docs/MRCommentGitlabWebhookSpec.md)
 - [MSDropdownResponse](docs/MSDropdownResponse.md)
 - [ManifestAttributes](docs/ManifestAttributes.md)
 - [ManifestConfig](docs/ManifestConfig.md)
 - [ManifestConfigWrapper](docs/ManifestConfigWrapper.md)
 - [ManifestData](docs/ManifestData.md)
 - [ManifestDataOrBuilder](docs/ManifestDataOrBuilder.md)
 - [ManifestTriggerSource](docs/ManifestTriggerSource.md)
 - [ManifestTriggerSpec](docs/ManifestTriggerSpec.md)
 - [ManifestsResponseDTO](docs/ManifestsResponseDTO.md)
 - [ManualIssuer](docs/ManualIssuer.md)
 - [MarkdownCard](docs/MarkdownCard.md)
 - [MatrixMetadata](docs/MatrixMetadata.md)
 - [MatrixMetadataOrBuilder](docs/MatrixMetadataOrBuilder.md)
 - [MergeInputSetRequest](docs/MergeInputSetRequest.md)
 - [MergeInputSetRequestBody](docs/MergeInputSetRequestBody.md)
 - [MergeInputSetResponseBody](docs/MergeInputSetResponseBody.md)
 - [MergeRequestGitlabWebhookSpec](docs/MergeRequestGitlabWebhookSpec.md)
 - [MergedPluginConfigResponse](docs/MergedPluginConfigResponse.md)
 - [MergedPluginConfigs](docs/MergedPluginConfigs.md)
 - [Message](docs/Message.md)
 - [MessageLite](docs/MessageLite.md)
 - [MessageOptions](docs/MessageOptions.md)
 - [MessageOptionsOrBuilder](docs/MessageOptionsOrBuilder.md)
 - [MethodDescriptor](docs/MethodDescriptor.md)
 - [MethodDescriptorProto](docs/MethodDescriptorProto.md)
 - [MethodDescriptorProtoOrBuilder](docs/MethodDescriptorProtoOrBuilder.md)
 - [MethodOptions](docs/MethodOptions.md)
 - [MethodOptionsOrBuilder](docs/MethodOptionsOrBuilder.md)
 - [MetricDTO](docs/MetricDTO.md)
 - [MetricGraph](docs/MetricGraph.md)
 - [MetricLessServiceLevelIndicatorSpec](docs/MetricLessServiceLevelIndicatorSpec.md)
 - [MetricResponseMapping](docs/MetricResponseMapping.md)
 - [MetricThreshold](docs/MetricThreshold.md)
 - [MetricThresholdCriteria](docs/MetricThresholdCriteria.md)
 - [MetricThresholdCriteriaSpec](docs/MetricThresholdCriteriaSpec.md)
 - [MetricThresholdSpec](docs/MetricThresholdSpec.md)
 - [MicroserviceVersionInfo](docs/MicroserviceVersionInfo.md)
 - [MicrosoftTeamsConfigDTO](docs/MicrosoftTeamsConfigDTO.md)
 - [MinimalIssueCounts](docs/MinimalIssueCounts.md)
 - [Module](docs/Module.md)
 - [ModuleData](docs/ModuleData.md)
 - [ModuleData2](docs/ModuleData2.md)
 - [ModuleMetadataRequest](docs/ModuleMetadataRequest.md)
 - [ModuleRegistryCreateModuleResponseBody](docs/ModuleRegistryCreateModuleResponseBody.md)
 - [ModuleRequest](docs/ModuleRequest.md)
 - [ModuleRequest2](docs/ModuleRequest2.md)
 - [ModuleResource](docs/ModuleResource.md)
 - [ModuleResourceCollection](docs/ModuleResourceCollection.md)
 - [ModuleTagRequest](docs/ModuleTagRequest.md)
 - [ModuleTagRequest2](docs/ModuleTagRequest2.md)
 - [ModuleType](docs/ModuleType.md)
 - [ModuleType1](docs/ModuleType1.md)
 - [ModuleUpdate](docs/ModuleUpdate.md)
 - [ModuleUpdate2](docs/ModuleUpdate2.md)
 - [ModuleVersionsResponse](docs/ModuleVersionsResponse.md)
 - [MonitoredService](docs/MonitoredService.md)
 - [MonitoredServiceChangeDetailSLO](docs/MonitoredServiceChangeDetailSLO.md)
 - [MonitoredServiceDetail](docs/MonitoredServiceDetail.md)
 - [MonitoredServiceListItemDTO](docs/MonitoredServiceListItemDTO.md)
 - [MonitoredServicePlatformResponse](docs/MonitoredServicePlatformResponse.md)
 - [MonitoredServiceReference](docs/MonitoredServiceReference.md)
 - [MonitoredServiceResponse](docs/MonitoredServiceResponse.md)
 - [MonitoredServiceWithHealthSources](docs/MonitoredServiceWithHealthSources.md)
 - [MonthlyCalenderSpec](docs/MonthlyCalenderSpec.md)
 - [MoveConfigOperationType](docs/MoveConfigOperationType.md)
 - [MovePerspectiveDTO](docs/MovePerspectiveDTO.md)
 - [MultiRegionArtifactTriggerSource](docs/MultiRegionArtifactTriggerSource.md)
 - [MultiRegionArtifactTriggerSpec](docs/MultiRegionArtifactTriggerSpec.md)
 - [NGAuthSettings](docs/NGAuthSettings.md)
 - [NGLabel](docs/NGLabel.md)
 - [NGLdapSettingsWithEncryptedDataDetails](docs/NGLdapSettingsWithEncryptedDataDetails.md)
 - [NGProcessWebhookResponse](docs/NGProcessWebhookResponse.md)
 - [NGTag](docs/NGTag.md)
 - [NGTriggerDetailsResponseDTO](docs/NGTriggerDetailsResponseDTO.md)
 - [NGTriggerEventHistoryBaseDTO](docs/NGTriggerEventHistoryBaseDTO.md)
 - [NGTriggerEventHistoryDTO](docs/NGTriggerEventHistoryDTO.md)
 - [NGTriggerEventInfo](docs/NGTriggerEventInfo.md)
 - [NGTriggerEventsApiResponse](docs/NGTriggerEventsApiResponse.md)
 - [NGTriggerMetaData](docs/NGTriggerMetaData.md)
 - [NGTriggerResponse](docs/NGTriggerResponse.md)
 - [NGVariable](docs/NGVariable.md)
 - [NGVariable1](docs/NGVariable1.md)
 - [NTLMConfig](docs/NTLMConfig.md)
 - [NamePart](docs/NamePart.md)
 - [NamePartOrBuilder](docs/NamePartOrBuilder.md)
 - [NameValuePairWithDefault](docs/NameValuePairWithDefault.md)
 - [NamespaceInfo](docs/NamespaceInfo.md)
 - [NamespaceResponse](docs/NamespaceResponse.md)
 - [NewRelicConnectorDTO](docs/NewRelicConnectorDTO.md)
 - [NewRelicHealthSource](docs/NewRelicHealthSource.md)
 - [NewRelicMetricDefinition](docs/NewRelicMetricDefinition.md)
 - [NextGenHealthSource](docs/NextGenHealthSource.md)
 - [Nexus2RegistryArtifactSpec](docs/Nexus2RegistryArtifactSpec.md)
 - [Nexus2RegistryArtifactTriggerSpec](docs/Nexus2RegistryArtifactTriggerSpec.md)
 - [Nexus3RegistryArtifactSpec](docs/Nexus3RegistryArtifactSpec.md)
 - [Nexus3RegistryArtifactTriggerSpec](docs/Nexus3RegistryArtifactTriggerSpec.md)
 - [NexusAuthCredentials](docs/NexusAuthCredentials.md)
 - [NexusAuthentication](docs/NexusAuthentication.md)
 - [NexusConnector](docs/NexusConnector.md)
 - [NexusUsernamePasswordAuth](docs/NexusUsernamePasswordAuth.md)
 - [NgSmtp](docs/NgSmtp.md)
 - [NodeErrorInfo](docs/NodeErrorInfo.md)
 - [NodeExecutionDetails](docs/NodeExecutionDetails.md)
 - [NodeExecutionEventData](docs/NodeExecutionEventData.md)
 - [NodeExecutionOutline](docs/NodeExecutionOutline.md)
 - [NodeInfo](docs/NodeInfo.md)
 - [NodePool](docs/NodePool.md)
 - [NodePoolId](docs/NodePoolId.md)
 - [NodeRecommendationDTO](docs/NodeRecommendationDTO.md)
 - [NodeRunInfo](docs/NodeRunInfo.md)
 - [NotFound](docs/NotFound.md)
 - [NotificationRule](docs/NotificationRule.md)
 - [NotificationRuleCondition](docs/NotificationRuleCondition.md)
 - [NotificationRuleConditionSpec](docs/NotificationRuleConditionSpec.md)
 - [NotificationRuleRefDTO](docs/NotificationRuleRefDTO.md)
 - [NotificationRuleResponse](docs/NotificationRuleResponse.md)
 - [NotificationSettingConfig](docs/NotificationSettingConfig.md)
 - [NotificationSettingConfigDTO](docs/NotificationSettingConfigDTO.md)
 - [NotificationSettingConfigDTO1](docs/NotificationSettingConfigDTO1.md)
 - [NumberNGVariable](docs/NumberNGVariable.md)
 - [NumberNGVariable1](docs/NumberNGVariable1.md)
 - [OAuthSettings](docs/OAuthSettings.md)
 - [OCIRepoTypeResponseOCIRepoTypeEnum](docs/OCIRepoTypeResponseOCIRepoTypeEnum.md)
 - [OccurrenceSchedule](docs/OccurrenceSchedule.md)
 - [OciHelmAuthCredentials](docs/OciHelmAuthCredentials.md)
 - [OciHelmAuthentication](docs/OciHelmAuthentication.md)
 - [OciHelmConnector](docs/OciHelmConnector.md)
 - [OciHelmUsernamePassword](docs/OciHelmUsernamePassword.md)
 - [OidcAccessTokenOptions](docs/OidcAccessTokenOptions.md)
 - [OidcChartmuseumGcpConfig](docs/OidcChartmuseumGcpConfig.md)
 - [OidcConfiguration](docs/OidcConfiguration.md)
 - [OidcIdTokenCustomAttributesStructure](docs/OidcIdTokenCustomAttributesStructure.md)
 - [OidcWorkloadAccessTokenRequest](docs/OidcWorkloadAccessTokenRequest.md)
 - [OidcWorkloadAccessTokenResponse](docs/OidcWorkloadAccessTokenResponse.md)
 - [OneofDescriptor](docs/OneofDescriptor.md)
 - [OneofDescriptorProto](docs/OneofDescriptorProto.md)
 - [OneofDescriptorProtoOrBuilder](docs/OneofDescriptorProtoOrBuilder.md)
 - [OneofOptions](docs/OneofOptions.md)
 - [OneofOptionsOrBuilder](docs/OneofOptionsOrBuilder.md)
 - [OnetimeDowntimeSpec](docs/OnetimeDowntimeSpec.md)
 - [OnetimeDurationBasedSpec](docs/OnetimeDurationBasedSpec.md)
 - [OnetimeEndTimeBasedSpec](docs/OnetimeEndTimeBasedSpec.md)
 - [OnetimeSpec](docs/OnetimeSpec.md)
 - [OpaAuditEventData](docs/OpaAuditEventData.md)
 - [OpenapiCalculateCommitDivergenceRequest](docs/OpenapiCalculateCommitDivergenceRequest.md)
 - [OpenapiCommentApplySuggestionstRequest](docs/OpenapiCommentApplySuggestionstRequest.md)
 - [OpenapiCommentCreatePullReqRequest](docs/OpenapiCommentCreatePullReqRequest.md)
 - [OpenapiCommentStatusPullReqRequest](docs/OpenapiCommentStatusPullReqRequest.md)
 - [OpenapiCommentUpdatePullReqRequest](docs/OpenapiCommentUpdatePullReqRequest.md)
 - [OpenapiCommitFilesRequest](docs/OpenapiCommitFilesRequest.md)
 - [OpenapiContent](docs/OpenapiContent.md)
 - [OpenapiContentInfo](docs/OpenapiContentInfo.md)
 - [OpenapiContentType](docs/OpenapiContentType.md)
 - [OpenapiCreateBranchRequest](docs/OpenapiCreateBranchRequest.md)
 - [OpenapiCreatePullReqRequest](docs/OpenapiCreatePullReqRequest.md)
 - [OpenapiCreateRepoWebhookRequest](docs/OpenapiCreateRepoWebhookRequest.md)
 - [OpenapiCreateRepositoryRequest](docs/OpenapiCreateRepositoryRequest.md)
 - [OpenapiCreateTagRequest](docs/OpenapiCreateTagRequest.md)
 - [OpenapiDirContent](docs/OpenapiDirContent.md)
 - [OpenapiFileViewAddPullReqRequest](docs/OpenapiFileViewAddPullReqRequest.md)
 - [OpenapiGeneralSettingsRequest](docs/OpenapiGeneralSettingsRequest.md)
 - [OpenapiGetContentOutput](docs/OpenapiGetContentOutput.md)
 - [OpenapiMergePullReq](docs/OpenapiMergePullReq.md)
 - [OpenapiPathsDetailsRequest](docs/OpenapiPathsDetailsRequest.md)
 - [OpenapiPostRawDiffRequest](docs/OpenapiPostRawDiffRequest.md)
 - [OpenapiPostRawPRDiffRequest](docs/OpenapiPostRawPRDiffRequest.md)
 - [OpenapiPullReqAssignLabelInput](docs/OpenapiPullReqAssignLabelInput.md)
 - [OpenapiRestoreRequest](docs/OpenapiRestoreRequest.md)
 - [OpenapiReviewSubmitPullReqRequest](docs/OpenapiReviewSubmitPullReqRequest.md)
 - [OpenapiReviewerAddPullReqRequest](docs/OpenapiReviewerAddPullReqRequest.md)
 - [OpenapiRule](docs/OpenapiRule.md)
 - [OpenapiRuleDefinition](docs/OpenapiRuleDefinition.md)
 - [OpenapiRuleType](docs/OpenapiRuleType.md)
 - [OpenapiSecuritySettingsRequest](docs/OpenapiSecuritySettingsRequest.md)
 - [OpenapiStatePullReqRequest](docs/OpenapiStatePullReqRequest.md)
 - [OpenapiUpdateDefaultBranchRequest](docs/OpenapiUpdateDefaultBranchRequest.md)
 - [OpenapiUpdatePullReqRequest](docs/OpenapiUpdatePullReqRequest.md)
 - [OpenapiUpdateRepoPublicAccessRequest](docs/OpenapiUpdateRepoPublicAccessRequest.md)
 - [OpenapiUpdateRepoRequest](docs/OpenapiUpdateRepoRequest.md)
 - [OpenapiUpdateRepoWebhookRequest](docs/OpenapiUpdateRepoWebhookRequest.md)
 - [OpenapiUpdateSpaceWebhookRequest](docs/OpenapiUpdateSpaceWebhookRequest.md)
 - [OpenapiWebhookType](docs/OpenapiWebhookType.md)
 - [Opts](docs/Opts.md)
 - [OrchestrationMap](docs/OrchestrationMap.md)
 - [OrgCategoriesBody](docs/OrgCategoriesBody.md)
 - [OrgUnitsBody](docs/OrgUnitsBody.md)
 - [OrgUnitsBody1](docs/OrgUnitsBody1.md)
 - [OrgUsersBody](docs/OrgUsersBody.md)
 - [Organization](docs/Organization.md)
 - [Organization1](docs/Organization1.md)
 - [OrganizationDictionary](docs/OrganizationDictionary.md)
 - [OrganizationRequest](docs/OrganizationRequest.md)
 - [OrganizationResponse](docs/OrganizationResponse.md)
 - [OrganizationResponse1](docs/OrganizationResponse1.md)
 - [OutputCollection](docs/OutputCollection.md)
 - [OutputCollection2](docs/OutputCollection2.md)
 - [OutputMetadata](docs/OutputMetadata.md)
 - [OverlayInputSetResponse](docs/OverlayInputSetResponse.md)
 - [OverrideRequest](docs/OverrideRequest.md)
 - [OverrideResponse](docs/OverrideResponse.md)
 - [PMSGitUpdateResponse](docs/PMSGitUpdateResponse.md)
 - [PMSPipelineResponse](docs/PMSPipelineResponse.md)
 - [PMSPipelineSummaryResponse](docs/PMSPipelineSummaryResponse.md)
 - [PRCommentBitbucketWebhookSpec](docs/PRCommentBitbucketWebhookSpec.md)
 - [PageActiveMonitoredService](docs/PageActiveMonitoredService.md)
 - [PageFile](docs/PageFile.md)
 - [PageNGTriggerEventHistoryBaseDTO](docs/PageNGTriggerEventHistoryBaseDTO.md)
 - [PageNGTriggerEventHistoryDTO](docs/PageNGTriggerEventHistoryDTO.md)
 - [PageNGTriggerEventsApiResponse](docs/PageNGTriggerEventsApiResponse.md)
 - [PagePMSPipelineSummaryResponse](docs/PagePMSPipelineSummaryResponse.md)
 - [PagePipelineExecutionIdentifierSummary](docs/PagePipelineExecutionIdentifierSummary.md)
 - [PagePipelineExecutionSummary](docs/PagePipelineExecutionSummary.md)
 - [PageResponseApiKeyAggregate](docs/PageResponseApiKeyAggregate.md)
 - [PageResponseAuditEvent](docs/PageResponseAuditEvent.md)
 - [PageResponseCVNGLog](docs/PageResponseCVNGLog.md)
 - [PageResponseCcmK8sConnectorResponse](docs/PageResponseCcmK8sConnectorResponse.md)
 - [PageResponseClusterResponse](docs/PageResponseClusterResponse.md)
 - [PageResponseConnectorResponse](docs/PageResponseConnectorResponse.md)
 - [PageResponseDowntimeHistoryView](docs/PageResponseDowntimeHistoryView.md)
 - [PageResponseDowntimeListView](docs/PageResponseDowntimeListView.md)
 - [PageResponseEntitySetupUsage](docs/PageResponseEntitySetupUsage.md)
 - [PageResponseEnvironmentGroup](docs/PageResponseEnvironmentGroup.md)
 - [PageResponseEnvironmentIdentifierResponse](docs/PageResponseEnvironmentIdentifierResponse.md)
 - [PageResponseEnvironmentResponse](docs/PageResponseEnvironmentResponse.md)
 - [PageResponseFilter](docs/PageResponseFilter.md)
 - [PageResponseFreezeSummaryResponse](docs/PageResponseFreezeSummaryResponse.md)
 - [PageResponseGitBranch](docs/PageResponseGitBranch.md)
 - [PageResponseGitFullSyncEntityInfo](docs/PageResponseGitFullSyncEntityInfo.md)
 - [PageResponseGitSyncError](docs/PageResponseGitSyncError.md)
 - [PageResponseGitSyncErrorAggregateByCommit](docs/PageResponseGitSyncErrorAggregateByCommit.md)
 - [PageResponseHostDTO](docs/PageResponseHostDTO.md)
 - [PageResponseInfrastructureResponse](docs/PageResponseInfrastructureResponse.md)
 - [PageResponseInputSetSummaryResponse](docs/PageResponseInputSetSummaryResponse.md)
 - [PageResponseInvite](docs/PageResponseInvite.md)
 - [PageResponseMSDropdownResponse](docs/PageResponseMSDropdownResponse.md)
 - [PageResponseMonitoredServiceListItemDTO](docs/PageResponseMonitoredServiceListItemDTO.md)
 - [PageResponseMonitoredServicePlatformResponse](docs/PageResponseMonitoredServicePlatformResponse.md)
 - [PageResponseMonitoredServiceReference](docs/PageResponseMonitoredServiceReference.md)
 - [PageResponseMonitoredServiceResponse](docs/PageResponseMonitoredServiceResponse.md)
 - [PageResponseNGTriggerDetailsResponseDTO](docs/PageResponseNGTriggerDetailsResponseDTO.md)
 - [PageResponseNotificationRuleResponse](docs/PageResponseNotificationRuleResponse.md)
 - [PageResponseOrganizationResponse](docs/PageResponseOrganizationResponse.md)
 - [PageResponseProjectResponse](docs/PageResponseProjectResponse.md)
 - [PageResponseResourceGroupV2Response](docs/PageResponseResourceGroupV2Response.md)
 - [PageResponseRoleAssignmentAggregate](docs/PageResponseRoleAssignmentAggregate.md)
 - [PageResponseRoleAssignmentResponse](docs/PageResponseRoleAssignmentResponse.md)
 - [PageResponseRoleWithPrincipalCountResponse](docs/PageResponseRoleWithPrincipalCountResponse.md)
 - [PageResponseSLOConsumptionBreakdown](docs/PageResponseSLOConsumptionBreakdown.md)
 - [PageResponseSLOHealthListView](docs/PageResponseSLOHealthListView.md)
 - [PageResponseSecretResponse](docs/PageResponseSecretResponse.md)
 - [PageResponseServiceAccountAggregate](docs/PageResponseServiceAccountAggregate.md)
 - [PageResponseServiceLevelObjectiveV2Response](docs/PageResponseServiceLevelObjectiveV2Response.md)
 - [PageResponseServiceOverrideResponse](docs/PageResponseServiceOverrideResponse.md)
 - [PageResponseServiceResponse](docs/PageResponseServiceResponse.md)
 - [PageResponseTokenAggregate](docs/PageResponseTokenAggregate.md)
 - [PageResponseUserAggregate](docs/PageResponseUserAggregate.md)
 - [PageResponseUserGroup](docs/PageResponseUserGroup.md)
 - [PageResponseUserMetadata](docs/PageResponseUserMetadata.md)
 - [PageResponseVariableResponseDTO](docs/PageResponseVariableResponseDTO.md)
 - [PageTemplateMetadataSummaryResponse](docs/PageTemplateMetadataSummaryResponse.md)
 - [Pageable](docs/Pageable.md)
 - [PagerDutyConfigDTO](docs/PagerDutyConfigDTO.md)
 - [PagerDutyConnectorDTO](docs/PagerDutyConnectorDTO.md)
 - [PaginatedIssueSummaries](docs/PaginatedIssueSummaries.md)
 - [Pagination](docs/Pagination.md)
 - [PaginationInput](docs/PaginationInput.md)
 - [ParameterFieldDouble](docs/ParameterFieldDouble.md)
 - [ParameterFieldListString](docs/ParameterFieldListString.md)
 - [ParameterFieldSecretRefData](docs/ParameterFieldSecretRefData.md)
 - [ParameterFieldStoreConfigWrapper](docs/ParameterFieldStoreConfigWrapper.md)
 - [ParameterFieldString](docs/ParameterFieldString.md)
 - [ParentStageInfo](docs/ParentStageInfo.md)
 - [ParsedPayload](docs/ParsedPayload.md)
 - [ParsedPayloadOrBuilder](docs/ParsedPayloadOrBuilder.md)
 - [Parser](docs/Parser.md)
 - [ParserAmbiance](docs/ParserAmbiance.md)
 - [ParserArtifactData](docs/ParserArtifactData.md)
 - [ParserAsyncChainExecutableResponse](docs/ParserAsyncChainExecutableResponse.md)
 - [ParserAsyncExecutableResponse](docs/ParserAsyncExecutableResponse.md)
 - [ParserBranchHook](docs/ParserBranchHook.md)
 - [ParserBuildInfo](docs/ParserBuildInfo.md)
 - [ParserChild](docs/ParserChild.md)
 - [ParserChildChainExecutableResponse](docs/ParserChildChainExecutableResponse.md)
 - [ParserChildExecutableResponse](docs/ParserChildExecutableResponse.md)
 - [ParserChildrenExecutableResponse](docs/ParserChildrenExecutableResponse.md)
 - [ParserCommit](docs/ParserCommit.md)
 - [ParserDeclaration](docs/ParserDeclaration.md)
 - [ParserDescriptorProto](docs/ParserDescriptorProto.md)
 - [ParserEditionDefault](docs/ParserEditionDefault.md)
 - [ParserEntityDetailProtoDTO](docs/ParserEntityDetailProtoDTO.md)
 - [ParserEntityGitMetadata](docs/ParserEntityGitMetadata.md)
 - [ParserEnumDescriptorProto](docs/ParserEnumDescriptorProto.md)
 - [ParserEnumOptions](docs/ParserEnumOptions.md)
 - [ParserEnumReservedRange](docs/ParserEnumReservedRange.md)
 - [ParserEnumValueDescriptorProto](docs/ParserEnumValueDescriptorProto.md)
 - [ParserEnumValueOptions](docs/ParserEnumValueOptions.md)
 - [ParserExecutableResponse](docs/ParserExecutableResponse.md)
 - [ParserExecutionErrorInfo](docs/ParserExecutionErrorInfo.md)
 - [ParserExecutionMetadata](docs/ParserExecutionMetadata.md)
 - [ParserExecutionPrincipalInfo](docs/ParserExecutionPrincipalInfo.md)
 - [ParserExecutionTriggerInfo](docs/ParserExecutionTriggerInfo.md)
 - [ParserExpressionBlock](docs/ParserExpressionBlock.md)
 - [ParserExtensionRange](docs/ParserExtensionRange.md)
 - [ParserExtensionRangeOptions](docs/ParserExtensionRangeOptions.md)
 - [ParserFeatureSet](docs/ParserFeatureSet.md)
 - [ParserFieldDescriptorProto](docs/ParserFieldDescriptorProto.md)
 - [ParserFieldOptions](docs/ParserFieldOptions.md)
 - [ParserFileDescriptorProto](docs/ParserFileDescriptorProto.md)
 - [ParserFileOptions](docs/ParserFileOptions.md)
 - [ParserForMetadata](docs/ParserForMetadata.md)
 - [ParserGovernanceMetadata](docs/ParserGovernanceMetadata.md)
 - [ParserIdentifierRefProtoDTO](docs/ParserIdentifierRefProtoDTO.md)
 - [ParserInfraDefinitionReferenceProtoDTO](docs/ParserInfraDefinitionReferenceProtoDTO.md)
 - [ParserInputSetReferenceProtoDTO](docs/ParserInputSetReferenceProtoDTO.md)
 - [ParserLabel](docs/ParserLabel.md)
 - [ParserLevel](docs/ParserLevel.md)
 - [ParserLocation](docs/ParserLocation.md)
 - [ParserManifestData](docs/ParserManifestData.md)
 - [ParserMatrixMetadata](docs/ParserMatrixMetadata.md)
 - [ParserMessage](docs/ParserMessage.md)
 - [ParserMessageLite](docs/ParserMessageLite.md)
 - [ParserMessageOptions](docs/ParserMessageOptions.md)
 - [ParserMethodDescriptorProto](docs/ParserMethodDescriptorProto.md)
 - [ParserMethodOptions](docs/ParserMethodOptions.md)
 - [ParserNamePart](docs/ParserNamePart.md)
 - [ParserNodeRunInfo](docs/ParserNodeRunInfo.md)
 - [ParserOneofDescriptorProto](docs/ParserOneofDescriptorProto.md)
 - [ParserOneofOptions](docs/ParserOneofOptions.md)
 - [ParserParsedPayload](docs/ParserParsedPayload.md)
 - [ParserPerm](docs/ParserPerm.md)
 - [ParserPipelineStageInfo](docs/ParserPipelineStageInfo.md)
 - [ParserPolicyMetadata](docs/ParserPolicyMetadata.md)
 - [ParserPolicySetMetadata](docs/ParserPolicySetMetadata.md)
 - [ParserPostExecutionRollbackInfo](docs/ParserPostExecutionRollbackInfo.md)
 - [ParserPullRequest](docs/ParserPullRequest.md)
 - [ParserPullRequestHook](docs/ParserPullRequestHook.md)
 - [ParserPushHook](docs/ParserPushHook.md)
 - [ParserReference](docs/ParserReference.md)
 - [ParserRelease](docs/ParserRelease.md)
 - [ParserReleaseHook](docs/ParserReleaseHook.md)
 - [ParserRepository](docs/ParserRepository.md)
 - [ParserRerunInfo](docs/ParserRerunInfo.md)
 - [ParserReservedRange](docs/ParserReservedRange.md)
 - [ParserRetryExecutionInfo](docs/ParserRetryExecutionInfo.md)
 - [ParserServiceDescriptorProto](docs/ParserServiceDescriptorProto.md)
 - [ParserServiceOptions](docs/ParserServiceOptions.md)
 - [ParserSignature](docs/ParserSignature.md)
 - [ParserSkipInfo](docs/ParserSkipInfo.md)
 - [ParserSkipTaskExecutableResponse](docs/ParserSkipTaskExecutableResponse.md)
 - [ParserSourceCodeInfo](docs/ParserSourceCodeInfo.md)
 - [ParserStepType](docs/ParserStepType.md)
 - [ParserStrategyInfo](docs/ParserStrategyInfo.md)
 - [ParserStrategyMetadata](docs/ParserStrategyMetadata.md)
 - [ParserStringValue](docs/ParserStringValue.md)
 - [ParserSyncExecutableResponse](docs/ParserSyncExecutableResponse.md)
 - [ParserTagHook](docs/ParserTagHook.md)
 - [ParserTaskChainExecutableResponse](docs/ParserTaskChainExecutableResponse.md)
 - [ParserTaskExecutableResponse](docs/ParserTaskExecutableResponse.md)
 - [ParserTemplateReferenceProtoDTO](docs/ParserTemplateReferenceProtoDTO.md)
 - [ParserTimestamp](docs/ParserTimestamp.md)
 - [ParserTriggerPayload](docs/ParserTriggerPayload.md)
 - [ParserTriggerReferenceProtoDTO](docs/ParserTriggerReferenceProtoDTO.md)
 - [ParserTriggeredBy](docs/ParserTriggeredBy.md)
 - [ParserUninterpretedOption](docs/ParserUninterpretedOption.md)
 - [ParserUnitProgress](docs/ParserUnitProgress.md)
 - [ParserUser](docs/ParserUser.md)
 - [PasswordChange](docs/PasswordChange.md)
 - [PasswordStrengthPolicy](docs/PasswordStrengthPolicy.md)
 - [PatchInstruction](docs/PatchInstruction.md)
 - [PatchInstructionInner](docs/PatchInstructionInner.md)
 - [PatchTargetRequestBody](docs/PatchTargetRequestBody.md)
 - [PendingChanges](docs/PendingChanges.md)
 - [Perm](docs/Perm.md)
 - [PermOrBuilder](docs/PermOrBuilder.md)
 - [Permission](docs/Permission.md)
 - [PermissionCheck](docs/PermissionCheck.md)
 - [PermissionResponse](docs/PermissionResponse.md)
 - [PerpetualTaskInfoForTriggers](docs/PerpetualTaskInfoForTriggers.md)
 - [Perspective](docs/Perspective.md)
 - [PerspectiveAnomalyData](docs/PerspectiveAnomalyData.md)
 - [PerspectiveAnomalyFilterDTO](docs/PerspectiveAnomalyFilterDTO.md)
 - [PerspectiveBudgetScope](docs/PerspectiveBudgetScope.md)
 - [PerspectiveData](docs/PerspectiveData.md)
 - [PerspectiveEntityStatsData](docs/PerspectiveEntityStatsData.md)
 - [PerspectiveQueryDTO](docs/PerspectiveQueryDTO.md)
 - [PerspectiveTimeSeriesData](docs/PerspectiveTimeSeriesData.md)
 - [PhysicalDataCenterConnectorDTO](docs/PhysicalDataCenterConnectorDTO.md)
 - [PipelineCount](docs/PipelineCount.md)
 - [PipelineCreateRequestBody](docs/PipelineCreateRequestBody.md)
 - [PipelineCreateResponseBody](docs/PipelineCreateResponseBody.md)
 - [PipelineEntityGitDetails](docs/PipelineEntityGitDetails.md)
 - [PipelineError](docs/PipelineError.md)
 - [PipelineErrorMetadata](docs/PipelineErrorMetadata.md)
 - [PipelineExecuteRequestBody](docs/PipelineExecuteRequestBody.md)
 - [PipelineExecuteResponseBody](docs/PipelineExecuteResponseBody.md)
 - [PipelineExecution](docs/PipelineExecution.md)
 - [PipelineExecutionCountInfo](docs/PipelineExecutionCountInfo.md)
 - [PipelineExecutionDetail](docs/PipelineExecutionDetail.md)
 - [PipelineExecutionIdentifierSummary](docs/PipelineExecutionIdentifierSummary.md)
 - [PipelineExecutionNotes](docs/PipelineExecutionNotes.md)
 - [PipelineExecutionOutline](docs/PipelineExecutionOutline.md)
 - [PipelineExecutionOutlineFilterDTO](docs/PipelineExecutionOutlineFilterDTO.md)
 - [PipelineExecutionSummary](docs/PipelineExecutionSummary.md)
 - [PipelineFilterProperties](docs/PipelineFilterProperties.md)
 - [PipelineFilterPropertiesModuleProperties](docs/PipelineFilterPropertiesModuleProperties.md)
 - [PipelineGetResponseBody](docs/PipelineGetResponseBody.md)
 - [PipelineGovernanceMetadata](docs/PipelineGovernanceMetadata.md)
 - [PipelineImportRequest](docs/PipelineImportRequest.md)
 - [PipelineImportRequestBody](docs/PipelineImportRequestBody.md)
 - [PipelineImportRequestDTO](docs/PipelineImportRequestDTO.md)
 - [PipelineInputSetError](docs/PipelineInputSetError.md)
 - [PipelineInputsSchemaRequestBody](docs/PipelineInputsSchemaRequestBody.md)
 - [PipelineListResponseBody](docs/PipelineListResponseBody.md)
 - [PipelineMoveConfigRequestBody](docs/PipelineMoveConfigRequestBody.md)
 - [PipelineMoveConfigResponseBody](docs/PipelineMoveConfigResponseBody.md)
 - [PipelineNodeInfo](docs/PipelineNodeInfo.md)
 - [PipelinePatchRequestBody](docs/PipelinePatchRequestBody.md)
 - [PipelinePolicyMetadata](docs/PipelinePolicyMetadata.md)
 - [PipelinePolicySetMetadata](docs/PipelinePolicySetMetadata.md)
 - [PipelinePolicySetMetadataOrBuilder](docs/PipelinePolicySetMetadataOrBuilder.md)
 - [PipelineSaveResponse](docs/PipelineSaveResponse.md)
 - [PipelineSaveResponseBody](docs/PipelineSaveResponseBody.md)
 - [PipelineScope](docs/PipelineScope.md)
 - [PipelineSecurityCounts](docs/PipelineSecurityCounts.md)
 - [PipelineSecurityIssuesResult](docs/PipelineSecurityIssuesResult.md)
 - [PipelineSecurityStepsResult](docs/PipelineSecurityStepsResult.md)
 - [PipelineStageInfo](docs/PipelineStageInfo.md)
 - [PipelineStageInfoOrBuilder](docs/PipelineStageInfoOrBuilder.md)
 - [PipelineTemplateResponse](docs/PipelineTemplateResponse.md)
 - [PipelineUpdateRequestBody](docs/PipelineUpdateRequestBody.md)
 - [PipelineUser](docs/PipelineUser.md)
 - [PlanExecution](docs/PlanExecution.md)
 - [PlanExecutionResponse](docs/PlanExecutionResponse.md)
 - [PluginDetailedInfo](docs/PluginDetailedInfo.md)
 - [PluginDetailedInfoResponse](docs/PluginDetailedInfoResponse.md)
 - [PluginDetails](docs/PluginDetails.md)
 - [PluginInfo](docs/PluginInfo.md)
 - [PluginInfoResponse](docs/PluginInfoResponse.md)
 - [PluginRequestResponseList](docs/PluginRequestResponseList.md)
 - [PmsStepDetails](docs/PmsStepDetails.md)
 - [Point](docs/Point.md)
 - [Policy](docs/Policy.md)
 - [PolicyExample](docs/PolicyExample.md)
 - [PolicyHealth](docs/PolicyHealth.md)
 - [PolicyManagementError](docs/PolicyManagementError.md)
 - [PolicyManagementPolicy](docs/PolicyManagementPolicy.md)
 - [PolicyManagementPolicySet](docs/PolicyManagementPolicySet.md)
 - [PolicyManagementResourceGroup](docs/PolicyManagementResourceGroup.md)
 - [PolicyMetadata](docs/PolicyMetadata.md)
 - [PolicyMetadata1](docs/PolicyMetadata1.md)
 - [PolicyMetadataOrBuilder](docs/PolicyMetadataOrBuilder.md)
 - [PolicySample](docs/PolicySample.md)
 - [PolicySet](docs/PolicySet.md)
 - [PolicySetMetadata](docs/PolicySetMetadata.md)
 - [PolicySetMetadata1](docs/PolicySetMetadata1.md)
 - [PolicySetMetadataOrBuilder](docs/PolicySetMetadataOrBuilder.md)
 - [PolicyViolationError](docs/PolicyViolationError.md)
 - [PolledResponse](docs/PolledResponse.md)
 - [PollingInfoForTriggers](docs/PollingInfoForTriggers.md)
 - [PollingSubscriptionStatus](docs/PollingSubscriptionStatus.md)
 - [PortConfig](docs/PortConfig.md)
 - [PostExecutionRollbackInfo](docs/PostExecutionRollbackInfo.md)
 - [PostProdRollbackCheckDTO](docs/PostProdRollbackCheckDTO.md)
 - [PostProdRollbackRequestDTO](docs/PostProdRollbackRequestDTO.md)
 - [PostProdRollbackResponseDTO](docs/PostProdRollbackResponseDTO.md)
 - [PostProdRollbackSwimLaneInfo](docs/PostProdRollbackSwimLaneInfo.md)
 - [Prerequisite](docs/Prerequisite.md)
 - [Principal](docs/Principal.md)
 - [Principal1](docs/Principal1.md)
 - [Principal2](docs/Principal2.md)
 - [PrincipalType](docs/PrincipalType.md)
 - [PrincipalV2](docs/PrincipalV2.md)
 - [Product](docs/Product.md)
 - [ProductsListProductsResponseBody](docs/ProductsListProductsResponseBody.md)
 - [Project](docs/Project.md)
 - [Project1](docs/Project1.md)
 - [ProjectDictionary](docs/ProjectDictionary.md)
 - [ProjectParams](docs/ProjectParams.md)
 - [ProjectRequest](docs/ProjectRequest.md)
 - [ProjectRequest1](docs/ProjectRequest1.md)
 - [ProjectResponse](docs/ProjectResponse.md)
 - [ProjectResponse1](docs/ProjectResponse1.md)
 - [ProjectsEmptyResponse](docs/ProjectsEmptyResponse.md)
 - [ProjectsProjectCreateRequest](docs/ProjectsProjectCreateRequest.md)
 - [ProjectsProjectQuery](docs/ProjectsProjectQuery.md)
 - [ProjectsProjectUpdateRequest](docs/ProjectsProjectUpdateRequest.md)
 - [PrometheusConnectorDTO](docs/PrometheusConnectorDTO.md)
 - [PrometheusFilter](docs/PrometheusFilter.md)
 - [PrometheusHealthSource](docs/PrometheusHealthSource.md)
 - [PrometheusMetricDefinition](docs/PrometheusMetricDefinition.md)
 - [PropertyValue](docs/PropertyValue.md)
 - [ProtectionBranch](docs/ProtectionBranch.md)
 - [ProtectionDefApprovals](docs/ProtectionDefApprovals.md)
 - [ProtectionDefBypass](docs/ProtectionDefBypass.md)
 - [ProtectionDefComments](docs/ProtectionDefComments.md)
 - [ProtectionDefLifecycle](docs/ProtectionDefLifecycle.md)
 - [ProtectionDefMerge](docs/ProtectionDefMerge.md)
 - [ProtectionDefPullReq](docs/ProtectionDefPullReq.md)
 - [ProtectionDefStatusChecks](docs/ProtectionDefStatusChecks.md)
 - [ProtectionPattern](docs/ProtectionPattern.md)
 - [ProtobufAny](docs/ProtobufAny.md)
 - [ProtobufFieldMask](docs/ProtobufFieldMask.md)
 - [ProtobufNullValue](docs/ProtobufNullValue.md)
 - [ProtocolStringList](docs/ProtocolStringList.md)
 - [ProviderMetadata](docs/ProviderMetadata.md)
 - [ProviderRequestInfo](docs/ProviderRequestInfo.md)
 - [ProviderResponseInfo](docs/ProviderResponseInfo.md)
 - [Proxy](docs/Proxy.md)
 - [ProxyHostDetail](docs/ProxyHostDetail.md)
 - [ProxyKey](docs/ProxyKey.md)
 - [ProxyKeyInstruction](docs/ProxyKeyInstruction.md)
 - [ProxyKeyInstructionInstructions](docs/ProxyKeyInstructionInstructions.md)
 - [ProxyKeyInstructionInstructionsUpdateConfig](docs/ProxyKeyInstructionInstructionsUpdateConfig.md)
 - [ProxyKeyProject](docs/ProxyKeyProject.md)
 - [ProxyKeys](docs/ProxyKeys.md)
 - [PublicAccessRequest](docs/PublicAccessRequest.md)
 - [PublicAccessResponse](docs/PublicAccessResponse.md)
 - [PullRequest](docs/PullRequest.md)
 - [PullRequestAzureRepoWebhookSpec](docs/PullRequestAzureRepoWebhookSpec.md)
 - [PullRequestBitbucketWebhookSpec](docs/PullRequestBitbucketWebhookSpec.md)
 - [PullRequestCorrelationResult](docs/PullRequestCorrelationResult.md)
 - [PullRequestGithubWebhookSpec](docs/PullRequestGithubWebhookSpec.md)
 - [PullRequestHarnessWebhookSpec](docs/PullRequestHarnessWebhookSpec.md)
 - [PullRequestHook](docs/PullRequestHook.md)
 - [PullRequestHookOrBuilder](docs/PullRequestHookOrBuilder.md)
 - [PullRequestOrBuilder](docs/PullRequestOrBuilder.md)
 - [PullRequestResult](docs/PullRequestResult.md)
 - [PullRequestsGetPullRequestCorrelationResponseBody](docs/PullRequestsGetPullRequestCorrelationResponseBody.md)
 - [PullRequestsListPullRequestsResponseBody](docs/PullRequestsListPullRequestsResponseBody.md)
 - [PullreqCommentApplySuggestionsOutput](docs/PullreqCommentApplySuggestionsOutput.md)
 - [PullreqNumberBranchBody](docs/PullreqNumberBranchBody.md)
 - [PullreqSuggestionReference](docs/PullreqSuggestionReference.md)
 - [PushAwsCodeCommitWebhookTriggerSpec](docs/PushAwsCodeCommitWebhookTriggerSpec.md)
 - [PushAzureRepoWebhookSpec](docs/PushAzureRepoWebhookSpec.md)
 - [PushBitbucketWebhookSpec](docs/PushBitbucketWebhookSpec.md)
 - [PushGithubWebhookSpec](docs/PushGithubWebhookSpec.md)
 - [PushGitlabWebhookSpec](docs/PushGitlabWebhookSpec.md)
 - [PushHarnessWebhookSpec](docs/PushHarnessWebhookSpec.md)
 - [PushHook](docs/PushHook.md)
 - [PushHookOrBuilder](docs/PushHookOrBuilder.md)
 - [QLCEViewEntityStatsDataPoint](docs/QLCEViewEntityStatsDataPoint.md)
 - [QLCEViewFieldInput](docs/QLCEViewFieldInput.md)
 - [QLCEViewFilter](docs/QLCEViewFilter.md)
 - [QLCEViewFilterWrapper](docs/QLCEViewFilterWrapper.md)
 - [QLCEViewGroupBy](docs/QLCEViewGroupBy.md)
 - [QLCEViewMetadataFilter](docs/QLCEViewMetadataFilter.md)
 - [QLCEViewRule](docs/QLCEViewRule.md)
 - [QLCEViewTimeFilter](docs/QLCEViewTimeFilter.md)
 - [QLCEViewTimeTruncGroupBy](docs/QLCEViewTimeTruncGroupBy.md)
 - [QuarterlyCalenderSpec](docs/QuarterlyCalenderSpec.md)
 - [QueryDefinition](docs/QueryDefinition.md)
 - [QueryParamsDTO](docs/QueryParamsDTO.md)
 - [RDSDatabase](docs/RDSDatabase.md)
 - [RancherAuthentication](docs/RancherAuthentication.md)
 - [RancherConnector](docs/RancherConnector.md)
 - [RancherConnectorBearerTokenAuthentication](docs/RancherConnectorBearerTokenAuthentication.md)
 - [RancherConnectorConfig](docs/RancherConnectorConfig.md)
 - [RancherConnectorConfigAuth](docs/RancherConnectorConfigAuth.md)
 - [RancherConnectorConfigAuthentication](docs/RancherConnectorConfigAuthentication.md)
 - [RatioSLIMetricSpec](docs/RatioSLIMetricSpec.md)
 - [RecentExecutionInfo](docs/RecentExecutionInfo.md)
 - [RecentlyVisitedCard](docs/RecentlyVisitedCard.md)
 - [RecommendClusterRequest](docs/RecommendClusterRequest.md)
 - [RecommendationAdhocDTO](docs/RecommendationAdhocDTO.md)
 - [RecommendationAzureVmId](docs/RecommendationAzureVmId.md)
 - [RecommendationDetailsDTO](docs/RecommendationDetailsDTO.md)
 - [RecommendationEC2InstanceId](docs/RecommendationEC2InstanceId.md)
 - [RecommendationECSServiceId](docs/RecommendationECSServiceId.md)
 - [RecommendationGovernanceRuleId](docs/RecommendationGovernanceRuleId.md)
 - [RecommendationItem](docs/RecommendationItem.md)
 - [RecommendationNodepoolId](docs/RecommendationNodepoolId.md)
 - [RecommendationOverviewStats](docs/RecommendationOverviewStats.md)
 - [RecommendationResourceTypeStats](docs/RecommendationResourceTypeStats.md)
 - [RecommendationResponse](docs/RecommendationResponse.md)
 - [RecommendationTagDTO](docs/RecommendationTagDTO.md)
 - [RecommendationWorkloadId](docs/RecommendationWorkloadId.md)
 - [Recommendations](docs/Recommendations.md)
 - [RecommendationsIgnoreList](docs/RecommendationsIgnoreList.md)
 - [RecommendationsIgnoreResourcesDTO](docs/RecommendationsIgnoreResourcesDTO.md)
 - [ReconcilerReconcileCountsResponse](docs/ReconcilerReconcileCountsResponse.md)
 - [Recurrence](docs/Recurrence.md)
 - [RecurrenceSpec](docs/RecurrenceSpec.md)
 - [RecurringDowntimeSpec](docs/RecurringDowntimeSpec.md)
 - [Reference](docs/Reference.md)
 - [ReferenceDTO](docs/ReferenceDTO.md)
 - [ReferenceOrBuilder](docs/ReferenceOrBuilder.md)
 - [ReferencedByDTO](docs/ReferencedByDTO.md)
 - [RefreshRequestDTO](docs/RefreshRequestDTO.md)
 - [RefreshResponse](docs/RefreshResponse.md)
 - [Release](docs/Release.md)
 - [ReleaseDetailsRequest](docs/ReleaseDetailsRequest.md)
 - [ReleaseDetailsResponse](docs/ReleaseDetailsResponse.md)
 - [ReleaseEnvDetails](docs/ReleaseEnvDetails.md)
 - [ReleaseGithubWebhookSpec](docs/ReleaseGithubWebhookSpec.md)
 - [ReleaseHook](docs/ReleaseHook.md)
 - [ReleaseHookOrBuilder](docs/ReleaseHookOrBuilder.md)
 - [ReleaseOrBuilder](docs/ReleaseOrBuilder.md)
 - [ReleaseServiceDetails](docs/ReleaseServiceDetails.md)
 - [RepoCommitDivergence](docs/RepoCommitDivergence.md)
 - [RepoCommitDivergenceRequest](docs/RepoCommitDivergenceRequest.md)
 - [RepoCommitFileAction](docs/RepoCommitFileAction.md)
 - [RepoCommitTag](docs/RepoCommitTag.md)
 - [RepoContent](docs/RepoContent.md)
 - [RepoContentInfo](docs/RepoContentInfo.md)
 - [RepoContentType](docs/RepoContentType.md)
 - [RepoFileContent](docs/RepoFileContent.md)
 - [RepoIdentifierLabelsBody](docs/RepoIdentifierLabelsBody.md)
 - [RepoIdentifierLabelsBody1](docs/RepoIdentifierLabelsBody1.md)
 - [RepoIdentifierRebaseBody](docs/RepoIdentifierRebaseBody.md)
 - [RepoIdentifierRulesBody](docs/RepoIdentifierRulesBody.md)
 - [RepoIdentifierSquashBody](docs/RepoIdentifierSquashBody.md)
 - [RepoListPathsOutput](docs/RepoListPathsOutput.md)
 - [RepoListReqRepoSortByOptions](docs/RepoListReqRepoSortByOptions.md)
 - [RepoMergeCheck](docs/RepoMergeCheck.md)
 - [RepoPathsDetailsOutput](docs/RepoPathsDetailsOutput.md)
 - [RepoRepositoryOutput](docs/RepoRepositoryOutput.md)
 - [RepoSoftDeleteResponse](docs/RepoSoftDeleteResponse.md)
 - [RepoSubmoduleContent](docs/RepoSubmoduleContent.md)
 - [RepoSymlinkContent](docs/RepoSymlinkContent.md)
 - [ReposImportBody](docs/ReposImportBody.md)
 - [ReposettingsGeneralSettings](docs/ReposettingsGeneralSettings.md)
 - [ReposettingsSecuritySettings](docs/ReposettingsSecuritySettings.md)
 - [RepositoriesAWSSecretRef](docs/RepositoriesAWSSecretRef.md)
 - [RepositoriesAppInfo](docs/RepositoriesAppInfo.md)
 - [RepositoriesCheckESOResponse](docs/RepositoriesCheckESOResponse.md)
 - [RepositoriesDirectoryAppSpec](docs/RepositoriesDirectoryAppSpec.md)
 - [RepositoriesECRAuthorizationTokenGenerator](docs/RepositoriesECRAuthorizationTokenGenerator.md)
 - [RepositoriesESOGeneratorResponse](docs/RepositoriesESOGeneratorResponse.md)
 - [RepositoriesESOGeneratorType](docs/RepositoriesESOGeneratorType.md)
 - [RepositoriesGCRAccessTokenGenerator](docs/RepositoriesGCRAccessTokenGenerator.md)
 - [RepositoriesGCRWorkloadIdentity](docs/RepositoriesGCRWorkloadIdentity.md)
 - [RepositoriesHelmAppSpec](docs/RepositoriesHelmAppSpec.md)
 - [RepositoriesHelmChart](docs/RepositoriesHelmChart.md)
 - [RepositoriesHelmChartsResponse](docs/RepositoriesHelmChartsResponse.md)
 - [RepositoriesKsonnetAppSpec](docs/RepositoriesKsonnetAppSpec.md)
 - [RepositoriesKsonnetEnvironment](docs/RepositoriesKsonnetEnvironment.md)
 - [RepositoriesKsonnetEnvironmentDestination](docs/RepositoriesKsonnetEnvironmentDestination.md)
 - [RepositoriesKustomizeAppSpec](docs/RepositoriesKustomizeAppSpec.md)
 - [RepositoriesManifestResponse](docs/RepositoriesManifestResponse.md)
 - [RepositoriesRefs](docs/RepositoriesRefs.md)
 - [RepositoriesRepoAccessQuery](docs/RepositoriesRepoAccessQuery.md)
 - [RepositoriesRepoAppDetailsQuery](docs/RepositoriesRepoAppDetailsQuery.md)
 - [RepositoriesRepoAppDetailsResponse](docs/RepositoriesRepoAppDetailsResponse.md)
 - [RepositoriesRepoAppsQuery](docs/RepositoriesRepoAppsQuery.md)
 - [RepositoriesRepoAppsResponse](docs/RepositoriesRepoAppsResponse.md)
 - [RepositoriesRepoCreateRequest](docs/RepositoriesRepoCreateRequest.md)
 - [RepositoriesRepoQuery](docs/RepositoriesRepoQuery.md)
 - [RepositoriesRepoResponse](docs/RepositoriesRepoResponse.md)
 - [RepositoriesRepoUpdateRequest](docs/RepositoriesRepoUpdateRequest.md)
 - [RepositoriesRepository](docs/RepositoriesRepository.md)
 - [RepositoriesRepositoryList](docs/RepositoriesRepositoryList.md)
 - [RepositoriesRevisionMetadata](docs/RepositoriesRevisionMetadata.md)
 - [RepositoriesServiceAccountSelector](docs/RepositoriesServiceAccountSelector.md)
 - [Repository](docs/Repository.md)
 - [RepositoryOrBuilder](docs/RepositoryOrBuilder.md)
 - [RequestBasedServiceLevelIndicatorSpec](docs/RequestBasedServiceLevelIndicatorSpec.md)
 - [RequestMetadata](docs/RequestMetadata.md)
 - [RequestPlugin](docs/RequestPlugin.md)
 - [RerunInfo](docs/RerunInfo.md)
 - [RerunInfoOrBuilder](docs/RerunInfoOrBuilder.md)
 - [RerunPipelineRequest](docs/RerunPipelineRequest.md)
 - [ReservationsData](docs/ReservationsData.md)
 - [ReservationsDataManaged](docs/ReservationsDataManaged.md)
 - [ReservationsDataUnmanaged](docs/ReservationsDataUnmanaged.md)
 - [ReservedRange](docs/ReservedRange.md)
 - [ReservedRangeOrBuilder](docs/ReservedRangeOrBuilder.md)
 - [ResolvedEnvVariable](docs/ResolvedEnvVariable.md)
 - [ResolvedEnvVariableResponse](docs/ResolvedEnvVariableResponse.md)
 - [Resource](docs/Resource.md)
 - [ResourceCollection](docs/ResourceCollection.md)
 - [ResourceDTO](docs/ResourceDTO.md)
 - [ResourceFilter](docs/ResourceFilter.md)
 - [ResourceGroup](docs/ResourceGroup.md)
 - [ResourceGroupFilter](docs/ResourceGroupFilter.md)
 - [ResourceGroupFilterRequestBody](docs/ResourceGroupFilterRequestBody.md)
 - [ResourceGroupIdentifier](docs/ResourceGroupIdentifier.md)
 - [ResourceGroupScope](docs/ResourceGroupScope.md)
 - [ResourceGroupV2](docs/ResourceGroupV2.md)
 - [ResourceGroupV2Request](docs/ResourceGroupV2Request.md)
 - [ResourceGroupV2Response](docs/ResourceGroupV2Response.md)
 - [ResourceGroupsResponse](docs/ResourceGroupsResponse.md)
 - [ResourceMetadata](docs/ResourceMetadata.md)
 - [ResourceQuantity](docs/ResourceQuantity.md)
 - [ResourceRequirement](docs/ResourceRequirement.md)
 - [ResourceScope](docs/ResourceScope.md)
 - [ResourceScopeDTO](docs/ResourceScopeDTO.md)
 - [ResourceSelectorFilter](docs/ResourceSelectorFilter.md)
 - [ResourceSelectorV2](docs/ResourceSelectorV2.md)
 - [ResourceType](docs/ResourceType.md)
 - [ResourcegroupError](docs/ResourcegroupError.md)
 - [ResourcegroupErrorMetadata](docs/ResourcegroupErrorMetadata.md)
 - [ResourcegroupResourceFilter](docs/ResourcegroupResourceFilter.md)
 - [ResourcegroupResourceGroupV2](docs/ResourcegroupResourceGroupV2.md)
 - [ResourcegroupResourceSelectorFilter](docs/ResourcegroupResourceSelectorFilter.md)
 - [ResponseDTOAccessCheckResponse](docs/ResponseDTOAccessCheckResponse.md)
 - [ResponseDTOAccount](docs/ResponseDTOAccount.md)
 - [ResponseDTOAccountSettingResponse](docs/ResponseDTOAccountSettingResponse.md)
 - [ResponseDTOAddUsersResponse](docs/ResponseDTOAddUsersResponse.md)
 - [ResponseDTOApiKey](docs/ResponseDTOApiKey.md)
 - [ResponseDTOApiKeyAggregate](docs/ResponseDTOApiKeyAggregate.md)
 - [ResponseDTOApprovalInstanceResponse](docs/ResponseDTOApprovalInstanceResponse.md)
 - [ResponseDTOAwsOidcCredentialResponseDto](docs/ResponseDTOAwsOidcCredentialResponseDto.md)
 - [ResponseDTOAzureVmRecommendation](docs/ResponseDTOAzureVmRecommendation.md)
 - [ResponseDTOBoolean](docs/ResponseDTOBoolean.md)
 - [ResponseDTOBudget](docs/ResponseDTOBudget.md)
 - [ResponseDTOBudgetData](docs/ResponseDTOBudgetData.md)
 - [ResponseDTOBudgetGroup](docs/ResponseDTOBudgetGroup.md)
 - [ResponseDTOCCMJiraDetails](docs/ResponseDTOCCMJiraDetails.md)
 - [ResponseDTOCCMOverview](docs/ResponseDTOCCMOverview.md)
 - [ResponseDTOCCMServiceNowDetails](docs/ResponseDTOCCMServiceNowDetails.md)
 - [ResponseDTOCEView](docs/ResponseDTOCEView.md)
 - [ResponseDTOCEViewFolder](docs/ResponseDTOCEViewFolder.md)
 - [ResponseDTOCannyBoardsResponse](docs/ResponseDTOCannyBoardsResponse.md)
 - [ResponseDTOCannyCategoriesResponse](docs/ResponseDTOCannyCategoriesResponse.md)
 - [ResponseDTOCannyResponse](docs/ResponseDTOCannyResponse.md)
 - [ResponseDTOCcmK8sMetaInfoResponseDTO](docs/ResponseDTOCcmK8sMetaInfoResponseDTO.md)
 - [ResponseDTOClusterBatchResponse](docs/ResponseDTOClusterBatchResponse.md)
 - [ResponseDTOClusterResponse](docs/ResponseDTOClusterResponse.md)
 - [ResponseDTOConnectorCatalogueResponse](docs/ResponseDTOConnectorCatalogueResponse.md)
 - [ResponseDTOConnectorResponse](docs/ResponseDTOConnectorResponse.md)
 - [ResponseDTOConnectorStatistics](docs/ResponseDTOConnectorStatistics.md)
 - [ResponseDTOConnectorValidationResult](docs/ResponseDTOConnectorValidationResult.md)
 - [ResponseDTOCostOverview](docs/ResponseDTOCostOverview.md)
 - [ResponseDTOCoveoResponseDTO](docs/ResponseDTOCoveoResponseDTO.md)
 - [ResponseDTOCreateProviderResponse](docs/ResponseDTOCreateProviderResponse.md)
 - [ResponseDTOCustomDeploymentInfraResponseDTO](docs/ResponseDTOCustomDeploymentInfraResponseDTO.md)
 - [ResponseDTOCustomDeploymentRefreshYamlDTO](docs/ResponseDTOCustomDeploymentRefreshYamlDTO.md)
 - [ResponseDTOCustomDeploymentVariableResponseDTO](docs/ResponseDTOCustomDeploymentVariableResponseDTO.md)
 - [ResponseDTOCustomPagePipelineExecutionOutline](docs/ResponseDTOCustomPagePipelineExecutionOutline.md)
 - [ResponseDTODashboardPipelineExecution](docs/ResponseDTODashboardPipelineExecution.md)
 - [ResponseDTODeleteProviderResponse](docs/ResponseDTODeleteProviderResponse.md)
 - [ResponseDTODouble](docs/ResponseDTODouble.md)
 - [ResponseDTOEC2InstanceRecommendation](docs/ResponseDTOEC2InstanceRecommendation.md)
 - [ResponseDTOECSRecommendationDTO](docs/ResponseDTOECSRecommendationDTO.md)
 - [ResponseDTOEnforcementCount](docs/ResponseDTOEnforcementCount.md)
 - [ResponseDTOEnforcementDetails](docs/ResponseDTOEnforcementDetails.md)
 - [ResponseDTOEnvironmentGitUpdateResponse](docs/ResponseDTOEnvironmentGitUpdateResponse.md)
 - [ResponseDTOEnvironmentGroup](docs/ResponseDTOEnvironmentGroup.md)
 - [ResponseDTOEnvironmentGroupDelete](docs/ResponseDTOEnvironmentGroupDelete.md)
 - [ResponseDTOEnvironmentImportResponseDetails](docs/ResponseDTOEnvironmentImportResponseDetails.md)
 - [ResponseDTOEnvironmentMoveConfigResponse](docs/ResponseDTOEnvironmentMoveConfigResponse.md)
 - [ResponseDTOEnvironmentResponse](docs/ResponseDTOEnvironmentResponse.md)
 - [ResponseDTOFieldValues](docs/ResponseDTOFieldValues.md)
 - [ResponseDTOFile](docs/ResponseDTOFile.md)
 - [ResponseDTOFilter](docs/ResponseDTOFilter.md)
 - [ResponseDTOFilterValues](docs/ResponseDTOFilterValues.md)
 - [ResponseDTOFolderNode](docs/ResponseDTOFolderNode.md)
 - [ResponseDTOFreezeDetailedResponse](docs/ResponseDTOFreezeDetailedResponse.md)
 - [ResponseDTOFreezeResponse](docs/ResponseDTOFreezeResponse.md)
 - [ResponseDTOFreezeResponseWrapperDTO](docs/ResponseDTOFreezeResponseWrapperDTO.md)
 - [ResponseDTOFrozenExecutionDetails](docs/ResponseDTOFrozenExecutionDetails.md)
 - [ResponseDTOGcpOidcServiceAccountAccessTokenResponse](docs/ResponseDTOGcpOidcServiceAccountAccessTokenResponse.md)
 - [ResponseDTOGetProviderResponse](docs/ResponseDTOGetProviderResponse.md)
 - [ResponseDTOGitBranchList](docs/ResponseDTOGitBranchList.md)
 - [ResponseDTOGitFullSyncConfig](docs/ResponseDTOGitFullSyncConfig.md)
 - [ResponseDTOGitSyncErrorCount](docs/ResponseDTOGitSyncErrorCount.md)
 - [ResponseDTOGitSyncSettings](docs/ResponseDTOGitSyncSettings.md)
 - [ResponseDTOGovernanceEnqueueResponseDTO](docs/ResponseDTOGovernanceEnqueueResponseDTO.md)
 - [ResponseDTOHealthScoreDTO](docs/ResponseDTOHealthScoreDTO.md)
 - [ResponseDTOHistoricalTrend](docs/ResponseDTOHistoricalTrend.md)
 - [ResponseDTOInfraMoveConfigResponse](docs/ResponseDTOInfraMoveConfigResponse.md)
 - [ResponseDTOInfrastructureGitUpdateResponse](docs/ResponseDTOInfrastructureGitUpdateResponse.md)
 - [ResponseDTOInfrastructureImportResponse](docs/ResponseDTOInfrastructureImportResponse.md)
 - [ResponseDTOInfrastructureResponse](docs/ResponseDTOInfrastructureResponse.md)
 - [ResponseDTOInputSetGitUpdateResponse](docs/ResponseDTOInputSetGitUpdateResponse.md)
 - [ResponseDTOInputSetResponse](docs/ResponseDTOInputSetResponse.md)
 - [ResponseDTOInputSetTemplateResponse](docs/ResponseDTOInputSetTemplateResponse.md)
 - [ResponseDTOInputSetTemplateWithReplacedExpressionsResponse](docs/ResponseDTOInputSetTemplateWithReplacedExpressionsResponse.md)
 - [ResponseDTOInteger](docs/ResponseDTOInteger.md)
 - [ResponseDTOInterruptResponse](docs/ResponseDTOInterruptResponse.md)
 - [ResponseDTOInvite](docs/ResponseDTOInvite.md)
 - [ResponseDTOLicenseUsage](docs/ResponseDTOLicenseUsage.md)
 - [ResponseDTOListAccountSettings](docs/ResponseDTOListAccountSettings.md)
 - [ResponseDTOListAnomalyData](docs/ResponseDTOListAnomalyData.md)
 - [ResponseDTOListAnomalySummary](docs/ResponseDTOListAnomalySummary.md)
 - [ResponseDTOListApiKey](docs/ResponseDTOListApiKey.md)
 - [ResponseDTOListBIDashboardSummary](docs/ResponseDTOListBIDashboardSummary.md)
 - [ResponseDTOListBudget](docs/ResponseDTOListBudget.md)
 - [ResponseDTOListBudgetGroup](docs/ResponseDTOListBudgetGroup.md)
 - [ResponseDTOListBudgetSummary](docs/ResponseDTOListBudgetSummary.md)
 - [ResponseDTOListCEReportSchedule](docs/ResponseDTOListCEReportSchedule.md)
 - [ResponseDTOListCEView](docs/ResponseDTOListCEView.md)
 - [ResponseDTOListCEViewFolder](docs/ResponseDTOListCEViewFolder.md)
 - [ResponseDTOListClusterCostDetails](docs/ResponseDTOListClusterCostDetails.md)
 - [ResponseDTOListConnectorResponse](docs/ResponseDTOListConnectorResponse.md)
 - [ResponseDTOListEntityDetailProtoDTO](docs/ResponseDTOListEntityDetailProtoDTO.md)
 - [ResponseDTOListEntityType](docs/ResponseDTOListEntityType.md)
 - [ResponseDTOListEnvironmentResponse](docs/ResponseDTOListEnvironmentResponse.md)
 - [ResponseDTOListFilterStats](docs/ResponseDTOListFilterStats.md)
 - [ResponseDTOListGetProviderResponse](docs/ResponseDTOListGetProviderResponse.md)
 - [ResponseDTOListGovernancePromptRule](docs/ResponseDTOListGovernancePromptRule.md)
 - [ResponseDTOListHostValidationDTO](docs/ResponseDTOListHostValidationDTO.md)
 - [ResponseDTOListMonitoredServiceWithHealthSources](docs/ResponseDTOListMonitoredServiceWithHealthSources.md)
 - [ResponseDTOListPermissionResponse](docs/ResponseDTOListPermissionResponse.md)
 - [ResponseDTOListPerspective](docs/ResponseDTOListPerspective.md)
 - [ResponseDTOListPerspectiveAnomalyData](docs/ResponseDTOListPerspectiveAnomalyData.md)
 - [ResponseDTOListRecommendationResourceTypeStats](docs/ResponseDTOListRecommendationResourceTypeStats.md)
 - [ResponseDTOListRoleAssignmentResponse](docs/ResponseDTOListRoleAssignmentResponse.md)
 - [ResponseDTOListRuleEnforcement](docs/ResponseDTOListRuleEnforcement.md)
 - [ResponseDTOListRuleExecution](docs/ResponseDTOListRuleExecution.md)
 - [ResponseDTOListScopeName](docs/ResponseDTOListScopeName.md)
 - [ResponseDTOListSecondaryEventsResponse](docs/ResponseDTOListSecondaryEventsResponse.md)
 - [ResponseDTOListServiceAccount](docs/ResponseDTOListServiceAccount.md)
 - [ResponseDTOListServiceResponse](docs/ResponseDTOListServiceResponse.md)
 - [ResponseDTOListSettingResponseDTO](docs/ResponseDTOListSettingResponseDTO.md)
 - [ResponseDTOListSettingUpdateResponseDTO](docs/ResponseDTOListSettingUpdateResponseDTO.md)
 - [ResponseDTOListSourceCodeManager](docs/ResponseDTOListSourceCodeManager.md)
 - [ResponseDTOListString](docs/ResponseDTOListString.md)
 - [ResponseDTOListSubRuleResponseDetails](docs/ResponseDTOListSubRuleResponseDetails.md)
 - [ResponseDTOListUserGroup](docs/ResponseDTOListUserGroup.md)
 - [ResponseDTOListUserSettingResponseDTO](docs/ResponseDTOListUserSettingResponseDTO.md)
 - [ResponseDTOListUserSettingUpdateResponseDTO](docs/ResponseDTOListUserSettingUpdateResponseDTO.md)
 - [ResponseDTOListValueDataPoint](docs/ResponseDTOListValueDataPoint.md)
 - [ResponseDTOLong](docs/ResponseDTOLong.md)
 - [ResponseDTOMapStringDouble](docs/ResponseDTOMapStringDouble.md)
 - [ResponseDTOMapStringMapStringInteger](docs/ResponseDTOMapStringMapStringInteger.md)
 - [ResponseDTOMapStringString](docs/ResponseDTOMapStringString.md)
 - [ResponseDTOMonitoredServiceResponse](docs/ResponseDTOMonitoredServiceResponse.md)
 - [ResponseDTONGLdapSettingsWithEncryptedDataDetails](docs/ResponseDTONGLdapSettingsWithEncryptedDataDetails.md)
 - [ResponseDTONGProcessWebhookResponse](docs/ResponseDTONGProcessWebhookResponse.md)
 - [ResponseDTONGTriggerDetailsResponseDTO](docs/ResponseDTONGTriggerDetailsResponseDTO.md)
 - [ResponseDTONGTriggerResponse](docs/ResponseDTONGTriggerResponse.md)
 - [ResponseDTONgSmtp](docs/ResponseDTONgSmtp.md)
 - [ResponseDTONodeExecutionDetails](docs/ResponseDTONodeExecutionDetails.md)
 - [ResponseDTONodeRecommendationDTO](docs/ResponseDTONodeRecommendationDTO.md)
 - [ResponseDTOOidcWorkloadAccessTokenResponse](docs/ResponseDTOOidcWorkloadAccessTokenResponse.md)
 - [ResponseDTOOptionalInvite](docs/ResponseDTOOptionalInvite.md)
 - [ResponseDTOOrganizationResponse](docs/ResponseDTOOrganizationResponse.md)
 - [ResponseDTOOverlayInputSetResponse](docs/ResponseDTOOverlayInputSetResponse.md)
 - [ResponseDTOOverrideResponse](docs/ResponseDTOOverrideResponse.md)
 - [ResponseDTOPMSGitUpdateResponse](docs/ResponseDTOPMSGitUpdateResponse.md)
 - [ResponseDTOPMSPipelineResponse](docs/ResponseDTOPMSPipelineResponse.md)
 - [ResponseDTOPMSPipelineSummaryResponse](docs/ResponseDTOPMSPipelineSummaryResponse.md)
 - [ResponseDTOPageActiveMonitoredService](docs/ResponseDTOPageActiveMonitoredService.md)
 - [ResponseDTOPageFile](docs/ResponseDTOPageFile.md)
 - [ResponseDTOPageNGTriggerEventHistoryBaseDTO](docs/ResponseDTOPageNGTriggerEventHistoryBaseDTO.md)
 - [ResponseDTOPageNGTriggerEventHistoryDTO](docs/ResponseDTOPageNGTriggerEventHistoryDTO.md)
 - [ResponseDTOPageNGTriggerEventsApiResponse](docs/ResponseDTOPageNGTriggerEventsApiResponse.md)
 - [ResponseDTOPagePMSPipelineSummaryResponse](docs/ResponseDTOPagePMSPipelineSummaryResponse.md)
 - [ResponseDTOPagePipelineExecutionIdentifierSummary](docs/ResponseDTOPagePipelineExecutionIdentifierSummary.md)
 - [ResponseDTOPagePipelineExecutionSummary](docs/ResponseDTOPagePipelineExecutionSummary.md)
 - [ResponseDTOPageResponseApiKeyAggregate](docs/ResponseDTOPageResponseApiKeyAggregate.md)
 - [ResponseDTOPageResponseAuditEvent](docs/ResponseDTOPageResponseAuditEvent.md)
 - [ResponseDTOPageResponseCcmK8sConnectorResponse](docs/ResponseDTOPageResponseCcmK8sConnectorResponse.md)
 - [ResponseDTOPageResponseClusterResponse](docs/ResponseDTOPageResponseClusterResponse.md)
 - [ResponseDTOPageResponseConnectorResponse](docs/ResponseDTOPageResponseConnectorResponse.md)
 - [ResponseDTOPageResponseDowntimeHistoryView](docs/ResponseDTOPageResponseDowntimeHistoryView.md)
 - [ResponseDTOPageResponseDowntimeListView](docs/ResponseDTOPageResponseDowntimeListView.md)
 - [ResponseDTOPageResponseEntitySetupUsage](docs/ResponseDTOPageResponseEntitySetupUsage.md)
 - [ResponseDTOPageResponseEnvironmentGroup](docs/ResponseDTOPageResponseEnvironmentGroup.md)
 - [ResponseDTOPageResponseEnvironmentIdentifierResponse](docs/ResponseDTOPageResponseEnvironmentIdentifierResponse.md)
 - [ResponseDTOPageResponseEnvironmentResponse](docs/ResponseDTOPageResponseEnvironmentResponse.md)
 - [ResponseDTOPageResponseFilter](docs/ResponseDTOPageResponseFilter.md)
 - [ResponseDTOPageResponseFreezeSummaryResponse](docs/ResponseDTOPageResponseFreezeSummaryResponse.md)
 - [ResponseDTOPageResponseGitFullSyncEntityInfo](docs/ResponseDTOPageResponseGitFullSyncEntityInfo.md)
 - [ResponseDTOPageResponseGitSyncError](docs/ResponseDTOPageResponseGitSyncError.md)
 - [ResponseDTOPageResponseGitSyncErrorAggregateByCommit](docs/ResponseDTOPageResponseGitSyncErrorAggregateByCommit.md)
 - [ResponseDTOPageResponseHostDTO](docs/ResponseDTOPageResponseHostDTO.md)
 - [ResponseDTOPageResponseInfrastructureResponse](docs/ResponseDTOPageResponseInfrastructureResponse.md)
 - [ResponseDTOPageResponseInputSetSummaryResponse](docs/ResponseDTOPageResponseInputSetSummaryResponse.md)
 - [ResponseDTOPageResponseInvite](docs/ResponseDTOPageResponseInvite.md)
 - [ResponseDTOPageResponseMSDropdownResponse](docs/ResponseDTOPageResponseMSDropdownResponse.md)
 - [ResponseDTOPageResponseMonitoredServiceListItemDTO](docs/ResponseDTOPageResponseMonitoredServiceListItemDTO.md)
 - [ResponseDTOPageResponseMonitoredServicePlatformResponse](docs/ResponseDTOPageResponseMonitoredServicePlatformResponse.md)
 - [ResponseDTOPageResponseMonitoredServiceResponse](docs/ResponseDTOPageResponseMonitoredServiceResponse.md)
 - [ResponseDTOPageResponseNGTriggerDetailsResponseDTO](docs/ResponseDTOPageResponseNGTriggerDetailsResponseDTO.md)
 - [ResponseDTOPageResponseNotificationRuleResponse](docs/ResponseDTOPageResponseNotificationRuleResponse.md)
 - [ResponseDTOPageResponseOrganizationResponse](docs/ResponseDTOPageResponseOrganizationResponse.md)
 - [ResponseDTOPageResponseProjectResponse](docs/ResponseDTOPageResponseProjectResponse.md)
 - [ResponseDTOPageResponseResourceGroupV2Response](docs/ResponseDTOPageResponseResourceGroupV2Response.md)
 - [ResponseDTOPageResponseRoleAssignmentAggregate](docs/ResponseDTOPageResponseRoleAssignmentAggregate.md)
 - [ResponseDTOPageResponseRoleAssignmentResponse](docs/ResponseDTOPageResponseRoleAssignmentResponse.md)
 - [ResponseDTOPageResponseRoleWithPrincipalCountResponse](docs/ResponseDTOPageResponseRoleWithPrincipalCountResponse.md)
 - [ResponseDTOPageResponseSLOConsumptionBreakdown](docs/ResponseDTOPageResponseSLOConsumptionBreakdown.md)
 - [ResponseDTOPageResponseSLOHealthListView](docs/ResponseDTOPageResponseSLOHealthListView.md)
 - [ResponseDTOPageResponseSecretResponse](docs/ResponseDTOPageResponseSecretResponse.md)
 - [ResponseDTOPageResponseServiceAccountAggregate](docs/ResponseDTOPageResponseServiceAccountAggregate.md)
 - [ResponseDTOPageResponseServiceLevelObjectiveV2Response](docs/ResponseDTOPageResponseServiceLevelObjectiveV2Response.md)
 - [ResponseDTOPageResponseServiceOverrideResponse](docs/ResponseDTOPageResponseServiceOverrideResponse.md)
 - [ResponseDTOPageResponseServiceResponse](docs/ResponseDTOPageResponseServiceResponse.md)
 - [ResponseDTOPageResponseTokenAggregate](docs/ResponseDTOPageResponseTokenAggregate.md)
 - [ResponseDTOPageResponseUserAggregate](docs/ResponseDTOPageResponseUserAggregate.md)
 - [ResponseDTOPageResponseUserGroup](docs/ResponseDTOPageResponseUserGroup.md)
 - [ResponseDTOPageResponseUserMetadata](docs/ResponseDTOPageResponseUserMetadata.md)
 - [ResponseDTOPageResponseVariableResponseDTO](docs/ResponseDTOPageResponseVariableResponseDTO.md)
 - [ResponseDTOPageTemplateMetadataSummaryResponse](docs/ResponseDTOPageTemplateMetadataSummaryResponse.md)
 - [ResponseDTOPasswordChangeResponse](docs/ResponseDTOPasswordChangeResponse.md)
 - [ResponseDTOPerspectiveData](docs/ResponseDTOPerspectiveData.md)
 - [ResponseDTOPerspectiveEntityStatsData](docs/ResponseDTOPerspectiveEntityStatsData.md)
 - [ResponseDTOPerspectiveTimeSeriesData](docs/ResponseDTOPerspectiveTimeSeriesData.md)
 - [ResponseDTOPipelineExecutionCountInfo](docs/ResponseDTOPipelineExecutionCountInfo.md)
 - [ResponseDTOPipelineExecutionDetail](docs/ResponseDTOPipelineExecutionDetail.md)
 - [ResponseDTOPipelineExecutionNotes](docs/ResponseDTOPipelineExecutionNotes.md)
 - [ResponseDTOPipelineSaveResponse](docs/ResponseDTOPipelineSaveResponse.md)
 - [ResponseDTOPlanExecutionResponse](docs/ResponseDTOPlanExecutionResponse.md)
 - [ResponseDTOPollingInfoForTriggers](docs/ResponseDTOPollingInfoForTriggers.md)
 - [ResponseDTOPostProdRollbackCheckDTO](docs/ResponseDTOPostProdRollbackCheckDTO.md)
 - [ResponseDTOPostProdRollbackResponseDTO](docs/ResponseDTOPostProdRollbackResponseDTO.md)
 - [ResponseDTOProjectResponse](docs/ResponseDTOProjectResponse.md)
 - [ResponseDTORecommendationOverviewStats](docs/ResponseDTORecommendationOverviewStats.md)
 - [ResponseDTORecommendationTagDTO](docs/ResponseDTORecommendationTagDTO.md)
 - [ResponseDTORecommendations](docs/ResponseDTORecommendations.md)
 - [ResponseDTORecommendationsIgnoreList](docs/ResponseDTORecommendationsIgnoreList.md)
 - [ResponseDTORefreshResponse](docs/ResponseDTORefreshResponse.md)
 - [ResponseDTOResourceGroupV2Response](docs/ResponseDTOResourceGroupV2Response.md)
 - [ResponseDTOResourceType](docs/ResponseDTOResourceType.md)
 - [ResponseDTORetryHistoryResponse](docs/ResponseDTORetryHistoryResponse.md)
 - [ResponseDTORoleAssignmentAggregateResponse](docs/ResponseDTORoleAssignmentAggregateResponse.md)
 - [ResponseDTORoleAssignmentDeleteResponseDTO](docs/ResponseDTORoleAssignmentDeleteResponseDTO.md)
 - [ResponseDTORoleAssignmentResponse](docs/ResponseDTORoleAssignmentResponse.md)
 - [ResponseDTORoleAssignmentValidationResponse](docs/ResponseDTORoleAssignmentValidationResponse.md)
 - [ResponseDTORoleResponse](docs/ResponseDTORoleResponse.md)
 - [ResponseDTORule](docs/ResponseDTORule.md)
 - [ResponseDTORuleEnforcement](docs/ResponseDTORuleEnforcement.md)
 - [ResponseDTORuleExecutionList](docs/ResponseDTORuleExecutionList.md)
 - [ResponseDTORuleList](docs/ResponseDTORuleList.md)
 - [ResponseDTORuleSet](docs/ResponseDTORuleSet.md)
 - [ResponseDTORuleSetList](docs/ResponseDTORuleSetList.md)
 - [ResponseDTOSLODashboardDetail](docs/ResponseDTOSLODashboardDetail.md)
 - [ResponseDTOSLORiskCountResponse](docs/ResponseDTOSLORiskCountResponse.md)
 - [ResponseDTOSRMLicenseUsageDTO](docs/ResponseDTOSRMLicenseUsageDTO.md)
 - [ResponseDTOSecondaryEventDetailsResponse](docs/ResponseDTOSecondaryEventDetailsResponse.md)
 - [ResponseDTOSecretManagerMetadataDTO](docs/ResponseDTOSecretManagerMetadataDTO.md)
 - [ResponseDTOSecretResponse](docs/ResponseDTOSecretResponse.md)
 - [ResponseDTOSecretValidationResult](docs/ResponseDTOSecretValidationResult.md)
 - [ResponseDTOServiceAccount](docs/ResponseDTOServiceAccount.md)
 - [ResponseDTOServiceAccountAggregate](docs/ResponseDTOServiceAccountAggregate.md)
 - [ResponseDTOServiceGitUpdateResponse](docs/ResponseDTOServiceGitUpdateResponse.md)
 - [ResponseDTOServiceImportResponse](docs/ResponseDTOServiceImportResponse.md)
 - [ResponseDTOServiceInstanceUsageDTO](docs/ResponseDTOServiceInstanceUsageDTO.md)
 - [ResponseDTOServiceMoveConfigResponse](docs/ResponseDTOServiceMoveConfigResponse.md)
 - [ResponseDTOServiceOverrideGitUpdateResponse](docs/ResponseDTOServiceOverrideGitUpdateResponse.md)
 - [ResponseDTOServiceOverrideMoveConfigResponse](docs/ResponseDTOServiceOverrideMoveConfigResponse.md)
 - [ResponseDTOServiceOverrideResponse](docs/ResponseDTOServiceOverrideResponse.md)
 - [ResponseDTOServiceOverrideResponseV2](docs/ResponseDTOServiceOverrideResponseV2.md)
 - [ResponseDTOServiceResponse](docs/ResponseDTOServiceResponse.md)
 - [ResponseDTOServiceUsageDTO](docs/ResponseDTOServiceUsageDTO.md)
 - [ResponseDTOSetEmbeddedUserDetailsDTO](docs/ResponseDTOSetEmbeddedUserDetailsDTO.md)
 - [ResponseDTOSetK8sCommandFlagType](docs/ResponseDTOSetK8sCommandFlagType.md)
 - [ResponseDTOSetKustomizeCommandFlagType](docs/ResponseDTOSetKustomizeCommandFlagType.md)
 - [ResponseDTOSetServiceHookAction](docs/ResponseDTOSetServiceHookAction.md)
 - [ResponseDTOSetString](docs/ResponseDTOSetString.md)
 - [ResponseDTOSettingValueResponseDTO](docs/ResponseDTOSettingValueResponseDTO.md)
 - [ResponseDTOSourceCodeManager](docs/ResponseDTOSourceCodeManager.md)
 - [ResponseDTOString](docs/ResponseDTOString.md)
 - [ResponseDTOTemplateMoveConfigResponse](docs/ResponseDTOTemplateMoveConfigResponse.md)
 - [ResponseDTOTemplateResponse](docs/ResponseDTOTemplateResponse.md)
 - [ResponseDTOTemplateUpdateGitDetailsResponse](docs/ResponseDTOTemplateUpdateGitDetailsResponse.md)
 - [ResponseDTOTemplateWrapperResponse](docs/ResponseDTOTemplateWrapperResponse.md)
 - [ResponseDTOToken](docs/ResponseDTOToken.md)
 - [ResponseDTOTriggerCatalogResponse](docs/ResponseDTOTriggerCatalogResponse.md)
 - [ResponseDTOTriggerGitFullSyncResponse](docs/ResponseDTOTriggerGitFullSyncResponse.md)
 - [ResponseDTOTwoFactorAuthSettingsInfo](docs/ResponseDTOTwoFactorAuthSettingsInfo.md)
 - [ResponseDTOUpdateProviderResponse](docs/ResponseDTOUpdateProviderResponse.md)
 - [ResponseDTOUserAggregate](docs/ResponseDTOUserAggregate.md)
 - [ResponseDTOUserGroup](docs/ResponseDTOUserGroup.md)
 - [ResponseDTOUserGroupResponseV2](docs/ResponseDTOUserGroupResponseV2.md)
 - [ResponseDTOUserInfo](docs/ResponseDTOUserInfo.md)
 - [ResponseDTOValidateTemplateInputsResponseDTO](docs/ResponseDTOValidateTemplateInputsResponseDTO.md)
 - [ResponseDTOValidationResult](docs/ResponseDTOValidationResult.md)
 - [ResponseDTOVariableResponseDTO](docs/ResponseDTOVariableResponseDTO.md)
 - [ResponseDTOVoid](docs/ResponseDTOVoid.md)
 - [ResponseDTOWebhookEventProcessingDetails](docs/ResponseDTOWebhookEventProcessingDetails.md)
 - [ResponseDTOWebhookExecutionDetails](docs/ResponseDTOWebhookExecutionDetails.md)
 - [ResponseDTOWorkloadRecommendationDTO](docs/ResponseDTOWorkloadRecommendationDTO.md)
 - [ResponseDTOYamlDiffRecord](docs/ResponseDTOYamlDiffRecord.md)
 - [ResponseDTOZendeskResponseDTO](docs/ResponseDTOZendeskResponseDTO.md)
 - [ResponseMessage](docs/ResponseMessage.md)
 - [ResponseMessageException](docs/ResponseMessageException.md)
 - [ResponseMessageExceptionStackTrace](docs/ResponseMessageExceptionStackTrace.md)
 - [ResponseMessageExceptionSuppressed](docs/ResponseMessageExceptionSuppressed.md)
 - [RestResponseAgentMtlsEndpointDetails](docs/RestResponseAgentMtlsEndpointDetails.md)
 - [RestResponseAnomaliesSummaryDTO](docs/RestResponseAnomaliesSummaryDTO.md)
 - [RestResponseAuthenticationSettingsResponse](docs/RestResponseAuthenticationSettingsResponse.md)
 - [RestResponseBoolean](docs/RestResponseBoolean.md)
 - [RestResponseBusinessMapping](docs/RestResponseBusinessMapping.md)
 - [RestResponseBusinessMappingListDTO](docs/RestResponseBusinessMappingListDTO.md)
 - [RestResponseCollectionLdapGroupResponse](docs/RestResponseCollectionLdapGroupResponse.md)
 - [RestResponseCostCategoryDeleteDTO](docs/RestResponseCostCategoryDeleteDTO.md)
 - [RestResponseDelegateDeleteResponse](docs/RestResponseDelegateDeleteResponse.md)
 - [RestResponseDelegateGroupDTO](docs/RestResponseDelegateGroupDTO.md)
 - [RestResponseDelegateGroupListing](docs/RestResponseDelegateGroupListing.md)
 - [RestResponseDelegateTokenDetails](docs/RestResponseDelegateTokenDetails.md)
 - [RestResponseDowntimeResponse](docs/RestResponseDowntimeResponse.md)
 - [RestResponseHealthMonitoringFlagResponse](docs/RestResponseHealthMonitoringFlagResponse.md)
 - [RestResponseInteger](docs/RestResponseInteger.md)
 - [RestResponseLDAPSettings](docs/RestResponseLDAPSettings.md)
 - [RestResponseLdapResponse](docs/RestResponseLdapResponse.md)
 - [RestResponseListDelegateGroupDTO](docs/RestResponseListDelegateGroupDTO.md)
 - [RestResponseListDelegateListResponse](docs/RestResponseListDelegateListResponse.md)
 - [RestResponseListDelegateTokenDetails](docs/RestResponseListDelegateTokenDetails.md)
 - [RestResponseListHealthSourceDTO](docs/RestResponseListHealthSourceDTO.md)
 - [RestResponseListMetricDTO](docs/RestResponseListMetricDTO.md)
 - [RestResponseListMonitoredServiceChangeDetailSLO](docs/RestResponseListMonitoredServiceChangeDetailSLO.md)
 - [RestResponseListMonitoredServiceDetail](docs/RestResponseListMonitoredServiceDetail.md)
 - [RestResponseListSLOErrorBudgetReset](docs/RestResponseListSLOErrorBudgetReset.md)
 - [RestResponseLoginTypeResponse](docs/RestResponseLoginTypeResponse.md)
 - [RestResponseMonitoredServiceResponse](docs/RestResponseMonitoredServiceResponse.md)
 - [RestResponseNotificationRuleResponse](docs/RestResponseNotificationRuleResponse.md)
 - [RestResponsePageResponseCVNGLog](docs/RestResponsePageResponseCVNGLog.md)
 - [RestResponsePageResponseMonitoredServiceReference](docs/RestResponsePageResponseMonitoredServiceReference.md)
 - [RestResponsePasswordStrengthPolicy](docs/RestResponsePasswordStrengthPolicy.md)
 - [RestResponseSLOErrorBudgetReset](docs/RestResponseSLOErrorBudgetReset.md)
 - [RestResponseSSOConfig](docs/RestResponseSSOConfig.md)
 - [RestResponseServiceLevelObjectiveV2Response](docs/RestResponseServiceLevelObjectiveV2Response.md)
 - [RestResponseString](docs/RestResponseString.md)
 - [RestResponseSupportedDelegateVersion](docs/RestResponseSupportedDelegateVersion.md)
 - [RestResponseTimeGraphResponse](docs/RestResponseTimeGraphResponse.md)
 - [RestResponseUserGroup](docs/RestResponseUserGroup.md)
 - [Results](docs/Results.md)
 - [RetryExecutionInfo](docs/RetryExecutionInfo.md)
 - [RetryExecutionInfoOrBuilder](docs/RetryExecutionInfoOrBuilder.md)
 - [RetryExecutionMetadata](docs/RetryExecutionMetadata.md)
 - [RetryHistoryResponse](docs/RetryHistoryResponse.md)
 - [RetryInterruptConfig](docs/RetryInterruptConfig.md)
 - [RetryNodeMetadata](docs/RetryNodeMetadata.md)
 - [RetryStagesMetadata](docs/RetryStagesMetadata.md)
 - [RiskCount](docs/RiskCount.md)
 - [RiskData](docs/RiskData.md)
 - [RiskProfile](docs/RiskProfile.md)
 - [Role](docs/Role.md)
 - [RoleAssignment](docs/RoleAssignment.md)
 - [RoleAssignmentAggregate](docs/RoleAssignmentAggregate.md)
 - [RoleAssignmentAggregateResponse](docs/RoleAssignmentAggregateResponse.md)
 - [RoleAssignmentCreateRequest](docs/RoleAssignmentCreateRequest.md)
 - [RoleAssignmentDeleteResponseDTO](docs/RoleAssignmentDeleteResponseDTO.md)
 - [RoleAssignmentErrorResponseDTO](docs/RoleAssignmentErrorResponseDTO.md)
 - [RoleAssignmentFilter](docs/RoleAssignmentFilter.md)
 - [RoleAssignmentFilterV2](docs/RoleAssignmentFilterV2.md)
 - [RoleAssignmentMetadata](docs/RoleAssignmentMetadata.md)
 - [RoleAssignmentResponse](docs/RoleAssignmentResponse.md)
 - [RoleAssignmentValidationRequest](docs/RoleAssignmentValidationRequest.md)
 - [RoleAssignmentValidationResponse](docs/RoleAssignmentValidationResponse.md)
 - [RoleBinding](docs/RoleBinding.md)
 - [RoleReference](docs/RoleReference.md)
 - [RoleResponse](docs/RoleResponse.md)
 - [RoleScope](docs/RoleScope.md)
 - [RoleWithPrincipalCountResponse](docs/RoleWithPrincipalCountResponse.md)
 - [RolesResponse](docs/RolesResponse.md)
 - [RollingSLOTargetSpec](docs/RollingSLOTargetSpec.md)
 - [RoutingData](docs/RoutingData.md)
 - [RoutingDataK8s](docs/RoutingDataK8s.md)
 - [RoutingDataV2](docs/RoutingDataV2.md)
 - [RoutingRule](docs/RoutingRule.md)
 - [Rule](docs/Rule.md)
 - [RuleClone](docs/RuleClone.md)
 - [RuleEnforcement](docs/RuleEnforcement.md)
 - [RuleExecution](docs/RuleExecution.md)
 - [RuleExecutionFilter](docs/RuleExecutionFilter.md)
 - [RuleExecutionList](docs/RuleExecutionList.md)
 - [RuleList](docs/RuleList.md)
 - [RuleRequest](docs/RuleRequest.md)
 - [RuleSet](docs/RuleSet.md)
 - [RuleSetList](docs/RuleSetList.md)
 - [RuleSetRequest](docs/RuleSetRequest.md)
 - [RulesRuleUidBody](docs/RulesRuleUidBody.md)
 - [RunStageRequest](docs/RunStageRequest.md)
 - [RunStageRequestBody](docs/RunStageRequestBody.md)
 - [RuntimeStreamError](docs/RuntimeStreamError.md)
 - [S3BuildStore](docs/S3BuildStore.md)
 - [S3BuildStoreSpec](docs/S3BuildStoreSpec.md)
 - [SLIDTO](docs/SLIDTO.md)
 - [SLIEvaluationType](docs/SLIEvaluationType.md)
 - [SLIMetricSpec](docs/SLIMetricSpec.md)
 - [SLOConsumptionBreakdown](docs/SLOConsumptionBreakdown.md)
 - [SLODashboardApiFilter](docs/SLODashboardApiFilter.md)
 - [SLODashboardDetail](docs/SLODashboardDetail.md)
 - [SLODashboardWidget](docs/SLODashboardWidget.md)
 - [SLOError](docs/SLOError.md)
 - [SLOErrorBudgetReset](docs/SLOErrorBudgetReset.md)
 - [SLOErrorBudgetResetInstanceDetails](docs/SLOErrorBudgetResetInstanceDetails.md)
 - [SLOHealthListView](docs/SLOHealthListView.md)
 - [SLORiskCountResponse](docs/SLORiskCountResponse.md)
 - [SLOTargetDTO](docs/SLOTargetDTO.md)
 - [SLOTargetFilterDTO](docs/SLOTargetFilterDTO.md)
 - [SLOTargetSpec](docs/SLOTargetSpec.md)
 - [SLOTargetType](docs/SLOTargetType.md)
 - [SRMAnalysisStepInstanceDetails](docs/SRMAnalysisStepInstanceDetails.md)
 - [SRMAnalysisStepInstanceDetailsAnalysisDuration](docs/SRMAnalysisStepInstanceDetailsAnalysisDuration.md)
 - [SRMAnalysisStepInstanceDetailsAnalysisDurationUnits](docs/SRMAnalysisStepInstanceDetailsAnalysisDurationUnits.md)
 - [SRMLicenseUsageDTO](docs/SRMLicenseUsageDTO.md)
 - [SSHAuth](docs/SSHAuth.md)
 - [SSHConfig](docs/SSHConfig.md)
 - [SSHCredentialSpec](docs/SSHCredentialSpec.md)
 - [SSHKerberosTGTKeyTabFileSpec](docs/SSHKerberosTGTKeyTabFileSpec.md)
 - [SSHKerberosTGTPasswordSpec](docs/SSHKerberosTGTPasswordSpec.md)
 - [SSHKeyPathCredential](docs/SSHKeyPathCredential.md)
 - [SSHKeyPathSpec](docs/SSHKeyPathSpec.md)
 - [SSHKeyReferenceCredentialDTO](docs/SSHKeyReferenceCredentialDTO.md)
 - [SSHKeyReferenceSpec](docs/SSHKeyReferenceSpec.md)
 - [SSHKeySpec](docs/SSHKeySpec.md)
 - [SSHPasswordCredentialDTO](docs/SSHPasswordCredentialDTO.md)
 - [SSHPasswordSpec](docs/SSHPasswordSpec.md)
 - [SSOConfig](docs/SSOConfig.md)
 - [SSORequest](docs/SSORequest.md)
 - [SSOSettings](docs/SSOSettings.md)
 - [SamlLinkGroupRequest](docs/SamlLinkGroupRequest.md)
 - [SamlmetadatauploadSamlSSOIdBody](docs/SamlmetadatauploadSamlSSOIdBody.md)
 - [SampleEntitiesImport](docs/SampleEntitiesImport.md)
 - [SaveServiceRequest](docs/SaveServiceRequest.md)
 - [SaveServiceRequestV2](docs/SaveServiceRequestV2.md)
 - [SaveStaticSchedulesRequest](docs/SaveStaticSchedulesRequest.md)
 - [SavingsDetails](docs/SavingsDetails.md)
 - [SavingsOverviewResponse](docs/SavingsOverviewResponse.md)
 - [SavingsOverviewResponseResponse](docs/SavingsOverviewResponseResponse.md)
 - [SavingsOverviewResponseResponseReservedInstances](docs/SavingsOverviewResponseResponseReservedInstances.md)
 - [SavingsOverviewResponseResponseSavingsPlans](docs/SavingsOverviewResponseResponseSavingsPlans.md)
 - [SavingsPlansData](docs/SavingsPlansData.md)
 - [SavingsPlansDataManaged](docs/SavingsPlansDataManaged.md)
 - [SavingsPlansDataUnmanaged](docs/SavingsPlansDataUnmanaged.md)
 - [SavingsRateResponse](docs/SavingsRateResponse.md)
 - [SavingsRateResponseResponse](docs/SavingsRateResponseResponse.md)
 - [Scan](docs/Scan.md)
 - [ScanIssuesResult](docs/ScanIssuesResult.md)
 - [ScansListScansResponseBody](docs/ScansListScansResponseBody.md)
 - [ScansScanIssueCountsResponseBody](docs/ScansScanIssueCountsResponseBody.md)
 - [ScansScanIssueResponseBody](docs/ScansScanIssueResponseBody.md)
 - [ScansScanIssuesResponseBody](docs/ScansScanIssuesResponseBody.md)
 - [ScheduleReportRequestBody](docs/ScheduleReportRequestBody.md)
 - [ScheduleReportResponse](docs/ScheduleReportResponse.md)
 - [ScheduleReportResponseBody](docs/ScheduleReportResponseBody.md)
 - [ScheduledApproval](docs/ScheduledApproval.md)
 - [ScheduledTriggerSource](docs/ScheduledTriggerSource.md)
 - [ScheduledTriggerSpec](docs/ScheduledTriggerSpec.md)
 - [ScmConfig](docs/ScmConfig.md)
 - [ScmRequest](docs/ScmRequest.md)
 - [Scope](docs/Scope.md)
 - [Scope1](docs/Scope1.md)
 - [ScopeName](docs/ScopeName.md)
 - [ScopeResponse](docs/ScopeResponse.md)
 - [ScopeSelector](docs/ScopeSelector.md)
 - [ScopedExecutionID](docs/ScopedExecutionID.md)
 - [ScopedIdentifier](docs/ScopedIdentifier.md)
 - [ScopedKey](docs/ScopedKey.md)
 - [ScopedPipelineID](docs/ScopedPipelineID.md)
 - [ScopedPipelines](docs/ScopedPipelines.md)
 - [ScopedPipelines2](docs/ScopedPipelines2.md)
 - [ScopedSpeculativePlanIdentifier](docs/ScopedSpeculativePlanIdentifier.md)
 - [ScopedWorkspaceDataIdentifier](docs/ScopedWorkspaceDataIdentifier.md)
 - [Scorecard](docs/Scorecard.md)
 - [ScorecardChecks](docs/ScorecardChecks.md)
 - [ScorecardChecksDetails](docs/ScorecardChecksDetails.md)
 - [ScorecardDetails](docs/ScorecardDetails.md)
 - [ScorecardDetailsRequest](docs/ScorecardDetailsRequest.md)
 - [ScorecardDetailsResponse](docs/ScorecardDetailsResponse.md)
 - [ScorecardFilter](docs/ScorecardFilter.md)
 - [ScorecardRecalibrateIdentifiers](docs/ScorecardRecalibrateIdentifiers.md)
 - [ScorecardRecalibrateInfo](docs/ScorecardRecalibrateInfo.md)
 - [ScorecardRecalibrateRequest](docs/ScorecardRecalibrateRequest.md)
 - [ScorecardRecalibrateResponse](docs/ScorecardRecalibrateResponse.md)
 - [ScorecardRecalibrateResponseV2](docs/ScorecardRecalibrateResponseV2.md)
 - [ScorecardResponse](docs/ScorecardResponse.md)
 - [ScorecardScore](docs/ScorecardScore.md)
 - [ScorecardScoreResponse](docs/ScorecardScoreResponse.md)
 - [ScorecardStats](docs/ScorecardStats.md)
 - [ScorecardStatsResponse](docs/ScorecardStatsResponse.md)
 - [ScorecardSummaryInfo](docs/ScorecardSummaryInfo.md)
 - [ScorecardSummaryResponse](docs/ScorecardSummaryResponse.md)
 - [SecondaryEventDetails](docs/SecondaryEventDetails.md)
 - [SecondaryEventDetailsResponse](docs/SecondaryEventDetailsResponse.md)
 - [SecondaryEventsResponse](docs/SecondaryEventsResponse.md)
 - [Secret](docs/Secret.md)
 - [Secret1](docs/Secret1.md)
 - [SecretFileSpec](docs/SecretFileSpec.md)
 - [SecretFileSpec1](docs/SecretFileSpec1.md)
 - [SecretFilterProperties](docs/SecretFilterProperties.md)
 - [SecretManagerMetadataDTO](docs/SecretManagerMetadataDTO.md)
 - [SecretManagerMetadataRequest](docs/SecretManagerMetadataRequest.md)
 - [SecretManagerMetadataRequestSpecDTO](docs/SecretManagerMetadataRequestSpecDTO.md)
 - [SecretManagerMetadataSpecDTO](docs/SecretManagerMetadataSpecDTO.md)
 - [SecretNGVariable](docs/SecretNGVariable.md)
 - [SecretReferredByConnectorSetupUsageDetail](docs/SecretReferredByConnectorSetupUsageDetail.md)
 - [SecretRequest](docs/SecretRequest.md)
 - [SecretRequestWrapper](docs/SecretRequestWrapper.md)
 - [SecretResourceFilter](docs/SecretResourceFilter.md)
 - [SecretResponse](docs/SecretResponse.md)
 - [SecretResponse1](docs/SecretResponse1.md)
 - [SecretSpec](docs/SecretSpec.md)
 - [SecretSpec1](docs/SecretSpec1.md)
 - [SecretTextSpec](docs/SecretTextSpec.md)
 - [SecretTextSpec1](docs/SecretTextSpec1.md)
 - [SecretTextSpecAdditionalMetadata](docs/SecretTextSpecAdditionalMetadata.md)
 - [SecretUniqueIdentifier](docs/SecretUniqueIdentifier.md)
 - [SecretValidationMetaData](docs/SecretValidationMetaData.md)
 - [SecretValidationMetadata](docs/SecretValidationMetadata.md)
 - [SecretValidationResponse](docs/SecretValidationResponse.md)
 - [SecretValidationResult](docs/SecretValidationResult.md)
 - [SecretsFilesBody](docs/SecretsFilesBody.md)
 - [SecurityReviewResult](docs/SecurityReviewResult.md)
 - [Segment](docs/Segment.md)
 - [SegmentFlag](docs/SegmentFlag.md)
 - [Segments](docs/Segments.md)
 - [SelfServiceCard](docs/SelfServiceCard.md)
 - [Serve](docs/Serve.md)
 - [Service](docs/Service.md)
 - [ServiceAccount](docs/ServiceAccount.md)
 - [ServiceAccountAggregate](docs/ServiceAccountAggregate.md)
 - [ServiceAccountConfig](docs/ServiceAccountConfig.md)
 - [ServiceCreateRequest](docs/ServiceCreateRequest.md)
 - [ServiceDep](docs/ServiceDep.md)
 - [ServiceDepTree](docs/ServiceDepTree.md)
 - [ServiceDependencyDTO](docs/ServiceDependencyDTO.md)
 - [ServiceDependencyMetadata](docs/ServiceDependencyMetadata.md)
 - [ServiceDescriptor](docs/ServiceDescriptor.md)
 - [ServiceDescriptorProto](docs/ServiceDescriptorProto.md)
 - [ServiceDescriptorProtoOrBuilder](docs/ServiceDescriptorProtoOrBuilder.md)
 - [ServiceDiagnostics](docs/ServiceDiagnostics.md)
 - [ServiceDiagnosticsResponse](docs/ServiceDiagnosticsResponse.md)
 - [ServiceDiscoveryAuditEventData](docs/ServiceDiscoveryAuditEventData.md)
 - [ServiceError](docs/ServiceError.md)
 - [ServiceGitUpdateResponse](docs/ServiceGitUpdateResponse.md)
 - [ServiceHealthResponse](docs/ServiceHealthResponse.md)
 - [ServiceImportResponse](docs/ServiceImportResponse.md)
 - [ServiceInstanceUsageDTO](docs/ServiceInstanceUsageDTO.md)
 - [ServiceLevelIndicatorDTO](docs/ServiceLevelIndicatorDTO.md)
 - [ServiceLevelIndicatorSpec](docs/ServiceLevelIndicatorSpec.md)
 - [ServiceLevelObjectiveDetailsDTO](docs/ServiceLevelObjectiveDetailsDTO.md)
 - [ServiceLevelObjectiveSpec](docs/ServiceLevelObjectiveSpec.md)
 - [ServiceLevelObjectiveType](docs/ServiceLevelObjectiveType.md)
 - [ServiceLevelObjectiveV2Response](docs/ServiceLevelObjectiveV2Response.md)
 - [ServiceMetadata](docs/ServiceMetadata.md)
 - [ServiceMetadataAutostoppingProxyConfig](docs/ServiceMetadataAutostoppingProxyConfig.md)
 - [ServiceMetadataCloudProviderDetails](docs/ServiceMetadataCloudProviderDetails.md)
 - [ServiceMoveConfigResponse](docs/ServiceMoveConfigResponse.md)
 - [ServiceNowADFS](docs/ServiceNowADFS.md)
 - [ServiceNowApprovalInstanceDetails](docs/ServiceNowApprovalInstanceDetails.md)
 - [ServiceNowAuthCredentials](docs/ServiceNowAuthCredentials.md)
 - [ServiceNowAuthentication](docs/ServiceNowAuthentication.md)
 - [ServiceNowChangeWindowSpec](docs/ServiceNowChangeWindowSpec.md)
 - [ServiceNowConnector](docs/ServiceNowConnector.md)
 - [ServiceNowFieldValueNG](docs/ServiceNowFieldValueNG.md)
 - [ServiceNowRefreshToken](docs/ServiceNowRefreshToken.md)
 - [ServiceNowTicketKeyNG](docs/ServiceNowTicketKeyNG.md)
 - [ServiceNowTicketNG](docs/ServiceNowTicketNG.md)
 - [ServiceNowUserNamePassword](docs/ServiceNowUserNamePassword.md)
 - [ServiceOptions](docs/ServiceOptions.md)
 - [ServiceOptionsOrBuilder](docs/ServiceOptionsOrBuilder.md)
 - [ServiceOverrideGitUpdateResponse](docs/ServiceOverrideGitUpdateResponse.md)
 - [ServiceOverrideMoveConfigResponse](docs/ServiceOverrideMoveConfigResponse.md)
 - [ServiceOverrideRequest](docs/ServiceOverrideRequest.md)
 - [ServiceOverrideRequestV2](docs/ServiceOverrideRequestV2.md)
 - [ServiceOverrideResponse](docs/ServiceOverrideResponse.md)
 - [ServiceOverrideResponseV2](docs/ServiceOverrideResponseV2.md)
 - [ServiceOverrideSpec](docs/ServiceOverrideSpec.md)
 - [ServiceRequest](docs/ServiceRequest.md)
 - [ServiceResponse](docs/ServiceResponse.md)
 - [ServiceResponse1](docs/ServiceResponse1.md)
 - [ServiceResponseDetails](docs/ServiceResponseDetails.md)
 - [ServiceUpdateRequest](docs/ServiceUpdateRequest.md)
 - [ServiceUsageDTO](docs/ServiceUsageDTO.md)
 - [ServiceUsageRecord](docs/ServiceUsageRecord.md)
 - [ServiceV2](docs/ServiceV2.md)
 - [ServiceVersion](docs/ServiceVersion.md)
 - [ServicesResponse](docs/ServicesResponse.md)
 - [Servicev1AppProjectMapping](docs/Servicev1AppProjectMapping.md)
 - [Servicev1Application](docs/Servicev1Application.md)
 - [Servicev1ApplicationDeleteRequestOptions](docs/Servicev1ApplicationDeleteRequestOptions.md)
 - [Servicev1ApplicationPatchRequest](docs/Servicev1ApplicationPatchRequest.md)
 - [Servicev1ApplicationQuery](docs/Servicev1ApplicationQuery.md)
 - [Servicev1ApplicationSetList](docs/Servicev1ApplicationSetList.md)
 - [Servicev1Applicationlist](docs/Servicev1Applicationlist.md)
 - [Servicev1Cluster](docs/Servicev1Cluster.md)
 - [Servicev1ClusterQuery](docs/Servicev1ClusterQuery.md)
 - [Servicev1Empty](docs/Servicev1Empty.md)
 - [Servicev1GnuPGPublicKeyList](docs/Servicev1GnuPGPublicKeyList.md)
 - [Servicev1HealthStatus](docs/Servicev1HealthStatus.md)
 - [Servicev1Project](docs/Servicev1Project.md)
 - [Servicev1ReconcilerFilter](docs/Servicev1ReconcilerFilter.md)
 - [Servicev1Repository](docs/Servicev1Repository.md)
 - [Servicev1RepositoryCertificate](docs/Servicev1RepositoryCertificate.md)
 - [Servicev1RepositoryCredentials](docs/Servicev1RepositoryCredentials.md)
 - [Servicev1RepositoryCredentialsList](docs/Servicev1RepositoryCredentialsList.md)
 - [ServingRule](docs/ServingRule.md)
 - [SessionTimeoutSettings](docs/SessionTimeoutSettings.md)
 - [SettingDTO](docs/SettingDTO.md)
 - [SettingRequestDTO](docs/SettingRequestDTO.md)
 - [SettingResponseDTO](docs/SettingResponseDTO.md)
 - [SettingUpdateResponseDTO](docs/SettingUpdateResponseDTO.md)
 - [SettingValueResponseDTO](docs/SettingValueResponseDTO.md)
 - [SettingsVulnerabilityScanningMode](docs/SettingsVulnerabilityScanningMode.md)
 - [SetupInstanceTypesSuccessResponse](docs/SetupInstanceTypesSuccessResponse.md)
 - [SetupInstanceTypesSuccessResponseResponse](docs/SetupInstanceTypesSuccessResponseResponse.md)
 - [SetupUsageDetail](docs/SetupUsageDetail.md)
 - [SetupValidateSuccessResponse](docs/SetupValidateSuccessResponse.md)
 - [SetupValidateSuccessResponseResponse](docs/SetupValidateSuccessResponseResponse.md)
 - [ShaSHA](docs/ShaSHA.md)
 - [SharedCost](docs/SharedCost.md)
 - [SharedCostSplit](docs/SharedCostSplit.md)
 - [ShowWorkspaceVariableResponse](docs/ShowWorkspaceVariableResponse.md)
 - [SignalFXConnectorDTO](docs/SignalFXConnectorDTO.md)
 - [Signature](docs/Signature.md)
 - [SignatureOrBuilder](docs/SignatureOrBuilder.md)
 - [SimpleServiceLevelObjectiveSpec](docs/SimpleServiceLevelObjectiveSpec.md)
 - [SkipInfo](docs/SkipInfo.md)
 - [SkipTaskExecutableResponse](docs/SkipTaskExecutableResponse.md)
 - [SkipTaskExecutableResponseOrBuilder](docs/SkipTaskExecutableResponseOrBuilder.md)
 - [SlackConfigDTO](docs/SlackConfigDTO.md)
 - [SloHealthIndicatorDTO](docs/SloHealthIndicatorDTO.md)
 - [SmtpConfig](docs/SmtpConfig.md)
 - [Sort](docs/Sort.md)
 - [SortOrder](docs/SortOrder.md)
 - [Source](docs/Source.md)
 - [SourceCodeInfo](docs/SourceCodeInfo.md)
 - [SourceCodeInfoOrBuilder](docs/SourceCodeInfoOrBuilder.md)
 - [SourceCodeManager](docs/SourceCodeManager.md)
 - [SourceCodeManagerAuthentication](docs/SourceCodeManagerAuthentication.md)
 - [Sources](docs/Sources.md)
 - [SpeculativePlan](docs/SpeculativePlan.md)
 - [SpendBreakdownFilter](docs/SpendBreakdownFilter.md)
 - [SpendBreakdownResponse](docs/SpendBreakdownResponse.md)
 - [SpendBreakdownResponseResponse](docs/SpendBreakdownResponseResponse.md)
 - [SpendDetailed](docs/SpendDetailed.md)
 - [SplunkConnector](docs/SplunkConnector.md)
 - [SplunkHealthSource](docs/SplunkHealthSource.md)
 - [SplunkHealthSourceQueryDTO](docs/SplunkHealthSourceQueryDTO.md)
 - [SplunkMetricDefinition](docs/SplunkMetricDefinition.md)
 - [SplunkMetricHealthSource](docs/SplunkMetricHealthSource.md)
 - [SpotConnector](docs/SpotConnector.md)
 - [SpotCredential](docs/SpotCredential.md)
 - [SpotCredentialSpec](docs/SpotCredentialSpec.md)
 - [SpotPermanentTokenConfigSpec](docs/SpotPermanentTokenConfigSpec.md)
 - [SscaExecutionArtifactSummaryRequestBody](docs/SscaExecutionArtifactSummaryRequestBody.md)
 - [SscaExecutionIssueCountsRequestBody](docs/SscaExecutionIssueCountsRequestBody.md)
 - [StackdriverDefinition](docs/StackdriverDefinition.md)
 - [StackdriverLogHealthSource](docs/StackdriverLogHealthSource.md)
 - [StackdriverLogHealthSourceQueryDTO](docs/StackdriverLogHealthSourceQueryDTO.md)
 - [StackdriverMetricHealthSource](docs/StackdriverMetricHealthSource.md)
 - [StageExecutionResponseBody](docs/StageExecutionResponseBody.md)
 - [StageStepID](docs/StageStepID.md)
 - [StagesExecutionMetadata](docs/StagesExecutionMetadata.md)
 - [StarredEntitiesCard](docs/StarredEntitiesCard.md)
 - [StaticAuditFilter](docs/StaticAuditFilter.md)
 - [StaticScheduleResource](docs/StaticScheduleResource.md)
 - [Status](docs/Status.md)
 - [StatusInfo](docs/StatusInfo.md)
 - [StatusInfoRequest](docs/StatusInfoRequest.md)
 - [StatusInfoResponse](docs/StatusInfoResponse.md)
 - [StatusInfoV2](docs/StatusInfoV2.md)
 - [StatusWiseCount](docs/StatusWiseCount.md)
 - [StepData](docs/StepData.md)
 - [StepInfo](docs/StepInfo.md)
 - [StepPalleteFilterRequestBody](docs/StepPalleteFilterRequestBody.md)
 - [StepPalleteModuleInfo](docs/StepPalleteModuleInfo.md)
 - [StepType](docs/StepType.md)
 - [StepTypeOrBuilder](docs/StepTypeOrBuilder.md)
 - [StepsDataResponseBody](docs/StepsDataResponseBody.md)
 - [StoPagination](docs/StoPagination.md)
 - [StoTarget](docs/StoTarget.md)
 - [StoreConfig](docs/StoreConfig.md)
 - [StoreConfigWrapper](docs/StoreConfigWrapper.md)
 - [StrategyInfo](docs/StrategyInfo.md)
 - [StrategyInfoOrBuilder](docs/StrategyInfoOrBuilder.md)
 - [StrategyMetadata](docs/StrategyMetadata.md)
 - [StrategyMetadataOrBuilder](docs/StrategyMetadataOrBuilder.md)
 - [StreamResultOfApplicationsApplicationTree](docs/StreamResultOfApplicationsApplicationTree.md)
 - [StreamResultOfApplicationsApplicationWatchEvent](docs/StreamResultOfApplicationsApplicationWatchEvent.md)
 - [StreamResultOfApplicationsLogEntry](docs/StreamResultOfApplicationsLogEntry.md)
 - [StreamResultOfV1DownloadResponse](docs/StreamResultOfV1DownloadResponse.md)
 - [StreamingDestinationAggregateDTO](docs/StreamingDestinationAggregateDTO.md)
 - [StreamingDestinationCards](docs/StreamingDestinationCards.md)
 - [StreamingDestinationDTO](docs/StreamingDestinationDTO.md)
 - [StreamingDestinationResponse](docs/StreamingDestinationResponse.md)
 - [StreamingDestinationSpecDTO](docs/StreamingDestinationSpecDTO.md)
 - [StreamingDestinationStatus](docs/StreamingDestinationStatus.md)
 - [StringNGVariable](docs/StringNGVariable.md)
 - [StringNGVariable1](docs/StringNGVariable1.md)
 - [StringValue](docs/StringValue.md)
 - [StringValueOrBuilder](docs/StringValueOrBuilder.md)
 - [StringVariableConfigDTO](docs/StringVariableConfigDTO.md)
 - [SubRuleExecutionDetails](docs/SubRuleExecutionDetails.md)
 - [SubRulePolicyDetails](docs/SubRulePolicyDetails.md)
 - [SubRuleResponseDetails](docs/SubRuleResponseDetails.md)
 - [SumoLogicConnectorDTO](docs/SumoLogicConnectorDTO.md)
 - [SupportedDelegateVersion](docs/SupportedDelegateVersion.md)
 - [SyncExecutableResponse](docs/SyncExecutableResponse.md)
 - [SyncExecutableResponseOrBuilder](docs/SyncExecutableResponseOrBuilder.md)
 - [SystemIssuer](docs/SystemIssuer.md)
 - [TCPProxy](docs/TCPProxy.md)
 - [TGTGenerationSpecDTO](docs/TGTGenerationSpecDTO.md)
 - [TGTKeyTabFilePathSpecDTO](docs/TGTKeyTabFilePathSpecDTO.md)
 - [TGTPasswordSpecDTO](docs/TGTPasswordSpecDTO.md)
 - [Tag](docs/Tag.md)
 - [TagHook](docs/TagHook.md)
 - [TagHookOrBuilder](docs/TagHookOrBuilder.md)
 - [TagResponseMetadata](docs/TagResponseMetadata.md)
 - [Tags](docs/Tags.md)
 - [Target](docs/Target.md)
 - [TargetAndVariantName](docs/TargetAndVariantName.md)
 - [TargetAndVariantNameRequired](docs/TargetAndVariantNameRequired.md)
 - [TargetDetail](docs/TargetDetail.md)
 - [TargetDetailSegment](docs/TargetDetailSegment.md)
 - [TargetExecutionSummary](docs/TargetExecutionSummary.md)
 - [TargetGroupMinimal](docs/TargetGroupMinimal.md)
 - [TargetMap](docs/TargetMap.md)
 - [TargetRulesUpdate](docs/TargetRulesUpdate.md)
 - [TargetVariant](docs/TargetVariant.md)
 - [TargetVariantsListTargetVariantsResponseBody](docs/TargetVariantsListTargetVariantsResponseBody.md)
 - [Targets](docs/Targets.md)
 - [TargetsListTargetsResponseBody](docs/TargetsListTargetsResponseBody.md)
 - [TargetsUploadBody](docs/TargetsUploadBody.md)
 - [TasConnector](docs/TasConnector.md)
 - [TasCredential](docs/TasCredential.md)
 - [TasCredentialSpec](docs/TasCredentialSpec.md)
 - [TasManualDetails](docs/TasManualDetails.md)
 - [TaskChainExecutableResponse](docs/TaskChainExecutableResponse.md)
 - [TaskChainExecutableResponseOrBuilder](docs/TaskChainExecutableResponseOrBuilder.md)
 - [TaskExecutableResponse](docs/TaskExecutableResponse.md)
 - [TaskExecutableResponseOrBuilder](docs/TaskExecutableResponseOrBuilder.md)
 - [TemplateCreateRequestBody](docs/TemplateCreateRequestBody.md)
 - [TemplateDTO](docs/TemplateDTO.md)
 - [TemplateEntityGitDetails](docs/TemplateEntityGitDetails.md)
 - [TemplateError](docs/TemplateError.md)
 - [TemplateErrorMetadata](docs/TemplateErrorMetadata.md)
 - [TemplateErrorNodeSummary](docs/TemplateErrorNodeSummary.md)
 - [TemplateEventData](docs/TemplateEventData.md)
 - [TemplateFilterProperties](docs/TemplateFilterProperties.md)
 - [TemplateGovernanceMetadata](docs/TemplateGovernanceMetadata.md)
 - [TemplateImportRequestBody](docs/TemplateImportRequestBody.md)
 - [TemplateImportRequestDTO](docs/TemplateImportRequestDTO.md)
 - [TemplateImportResponseBody](docs/TemplateImportResponseBody.md)
 - [TemplateInfo](docs/TemplateInfo.md)
 - [TemplateLinkConfigForCustomSecretManager](docs/TemplateLinkConfigForCustomSecretManager.md)
 - [TemplateMetaDataList](docs/TemplateMetaDataList.md)
 - [TemplateMetadataSummaryResponse](docs/TemplateMetadataSummaryResponse.md)
 - [TemplateMoveConfigResponse](docs/TemplateMoveConfigResponse.md)
 - [TemplateNodeInfo](docs/TemplateNodeInfo.md)
 - [TemplatePolicyMetadata](docs/TemplatePolicyMetadata.md)
 - [TemplatePolicySetMetadata](docs/TemplatePolicySetMetadata.md)
 - [TemplatePolicySetMetadataOrBuilder](docs/TemplatePolicySetMetadataOrBuilder.md)
 - [TemplateReferenceProtoDTO](docs/TemplateReferenceProtoDTO.md)
 - [TemplateReferenceProtoDTOOrBuilder](docs/TemplateReferenceProtoDTOOrBuilder.md)
 - [TemplateResponse](docs/TemplateResponse.md)
 - [TemplateResponseDTOValidateTemplateInputsResponseDTO](docs/TemplateResponseDTOValidateTemplateInputsResponseDTO.md)
 - [TemplateSchemaResponse](docs/TemplateSchemaResponse.md)
 - [TemplateScope](docs/TemplateScope.md)
 - [TemplateTemplateMetadataSummaryResponse](docs/TemplateTemplateMetadataSummaryResponse.md)
 - [TemplateTemplateResponse](docs/TemplateTemplateResponse.md)
 - [TemplateUpdateGitDetailsRequest](docs/TemplateUpdateGitDetailsRequest.md)
 - [TemplateUpdateGitDetailsResponse](docs/TemplateUpdateGitDetailsResponse.md)
 - [TemplateUpdateGitMetadataRequest](docs/TemplateUpdateGitMetadataRequest.md)
 - [TemplateUpdateRequestBody](docs/TemplateUpdateRequestBody.md)
 - [TemplateUpdateStableResponse](docs/TemplateUpdateStableResponse.md)
 - [TemplateValidationResponseBody](docs/TemplateValidationResponseBody.md)
 - [TemplateWithInputsResponse](docs/TemplateWithInputsResponse.md)
 - [TemplateWrapperResponse](docs/TemplateWrapperResponse.md)
 - [TerraformCloudConnector](docs/TerraformCloudConnector.md)
 - [TerraformCloudCredential](docs/TerraformCloudCredential.md)
 - [TerraformCloudCredentialSpec](docs/TerraformCloudCredentialSpec.md)
 - [TerraformCloudTokenCredentials](docs/TerraformCloudTokenCredentials.md)
 - [TestErrorMetadata](docs/TestErrorMetadata.md)
 - [TestTarget](docs/TestTarget.md)
 - [TestTargetResult](docs/TestTargetResult.md)
 - [TestTargetVariant](docs/TestTargetVariant.md)
 - [TextCertificateInputSpecDTO](docs/TextCertificateInputSpecDTO.md)
 - [ThresholdSLIMetricSpec](docs/ThresholdSLIMetricSpec.md)
 - [TimeGraphResponse](docs/TimeGraphResponse.md)
 - [TimeInDay](docs/TimeInDay.md)
 - [TimeRange](docs/TimeRange.md)
 - [TimeRangeFilter](docs/TimeRangeFilter.md)
 - [TimeRangeParams](docs/TimeRangeParams.md)
 - [TimeSchedule](docs/TimeSchedule.md)
 - [TimeScheduleDays](docs/TimeScheduleDays.md)
 - [TimeSchedulePeriod](docs/TimeSchedulePeriod.md)
 - [TimeSeriesDataPoints](docs/TimeSeriesDataPoints.md)
 - [TimeSeriesMetricPackDTO](docs/TimeSeriesMetricPackDTO.md)
 - [TimeoutIssuer](docs/TimeoutIssuer.md)
 - [Timestamp](docs/Timestamp.md)
 - [TimestampInfo](docs/TimestampInfo.md)
 - [TimestampOrBuilder](docs/TimestampOrBuilder.md)
 - [Token](docs/Token.md)
 - [TokenAggregate](docs/TokenAggregate.md)
 - [TokenResponse](docs/TokenResponse.md)
 - [TopVisitedCard](docs/TopVisitedCard.md)
 - [TotalResourceUsage](docs/TotalResourceUsage.md)
 - [TriggerBody](docs/TriggerBody.md)
 - [TriggerCatalogItem](docs/TriggerCatalogItem.md)
 - [TriggerCatalogResponse](docs/TriggerCatalogResponse.md)
 - [TriggerConditions](docs/TriggerConditions.md)
 - [TriggerEventStatus](docs/TriggerEventStatus.md)
 - [TriggerFilterProperties](docs/TriggerFilterProperties.md)
 - [TriggerGetResponseBody](docs/TriggerGetResponseBody.md)
 - [TriggerGitFullSyncResponse](docs/TriggerGitFullSyncResponse.md)
 - [TriggerIssuer](docs/TriggerIssuer.md)
 - [TriggerPayload](docs/TriggerPayload.md)
 - [TriggerReferenceProtoDTO](docs/TriggerReferenceProtoDTO.md)
 - [TriggerReferenceProtoDTOOrBuilder](docs/TriggerReferenceProtoDTOOrBuilder.md)
 - [TriggerRequestBody](docs/TriggerRequestBody.md)
 - [TriggerResponseBody](docs/TriggerResponseBody.md)
 - [TriggerSource](docs/TriggerSource.md)
 - [TriggerStatus](docs/TriggerStatus.md)
 - [TriggeredBy](docs/TriggeredBy.md)
 - [TriggeredByInfoAuditDetails](docs/TriggeredByInfoAuditDetails.md)
 - [TriggeredByOrBuilder](docs/TriggeredByOrBuilder.md)
 - [TwoFactorAdminOverrideSettings](docs/TwoFactorAdminOverrideSettings.md)
 - [TwoFactorAuthSettingsInfo](docs/TwoFactorAuthSettingsInfo.md)
 - [TypesBranch](docs/TypesBranch.md)
 - [TypesChangeStats](docs/TypesChangeStats.md)
 - [TypesCheck](docs/TypesCheck.md)
 - [TypesCheckPayload](docs/TypesCheckPayload.md)
 - [TypesCodeCommentFields](docs/TypesCodeCommentFields.md)
 - [TypesCodeOwnerEvaluation](docs/TypesCodeOwnerEvaluation.md)
 - [TypesCodeOwnerEvaluationEntry](docs/TypesCodeOwnerEvaluationEntry.md)
 - [TypesCommit](docs/TypesCommit.md)
 - [TypesCommitFileStats](docs/TypesCommitFileStats.md)
 - [TypesCommitFilesResponse](docs/TypesCommitFilesResponse.md)
 - [TypesCommitStats](docs/TypesCommitStats.md)
 - [TypesCreateBranchOutput](docs/TypesCreateBranchOutput.md)
 - [TypesDeleteBranchOutput](docs/TypesDeleteBranchOutput.md)
 - [TypesDiffStats](docs/TypesDiffStats.md)
 - [TypesIdentity](docs/TypesIdentity.md)
 - [TypesLabel](docs/TypesLabel.md)
 - [TypesLabelAssignment](docs/TypesLabelAssignment.md)
 - [TypesLabelPullReqAssignmentInfo](docs/TypesLabelPullReqAssignmentInfo.md)
 - [TypesLabelValue](docs/TypesLabelValue.md)
 - [TypesLabelValueInfo](docs/TypesLabelValueInfo.md)
 - [TypesLabelWithValues](docs/TypesLabelWithValues.md)
 - [TypesListCommitResponse](docs/TypesListCommitResponse.md)
 - [TypesMergeResponse](docs/TypesMergeResponse.md)
 - [TypesMergeViolations](docs/TypesMergeViolations.md)
 - [TypesOwnerEvaluation](docs/TypesOwnerEvaluation.md)
 - [TypesPrincipalInfo](docs/TypesPrincipalInfo.md)
 - [TypesPullReq](docs/TypesPullReq.md)
 - [TypesPullReqActivity](docs/TypesPullReqActivity.md)
 - [TypesPullReqActivityMentionsMetadata](docs/TypesPullReqActivityMentionsMetadata.md)
 - [TypesPullReqActivityMetadata](docs/TypesPullReqActivityMetadata.md)
 - [TypesPullReqActivitySuggestionsMetadata](docs/TypesPullReqActivitySuggestionsMetadata.md)
 - [TypesPullReqCheck](docs/TypesPullReqCheck.md)
 - [TypesPullReqChecks](docs/TypesPullReqChecks.md)
 - [TypesPullReqFileView](docs/TypesPullReqFileView.md)
 - [TypesPullReqLabel](docs/TypesPullReqLabel.md)
 - [TypesPullReqReviewer](docs/TypesPullReqReviewer.md)
 - [TypesPullReqStats](docs/TypesPullReqStats.md)
 - [TypesRebaseResponse](docs/TypesRebaseResponse.md)
 - [TypesRenameDetails](docs/TypesRenameDetails.md)
 - [TypesRepository](docs/TypesRepository.md)
 - [TypesRepositoryPullReqSummary](docs/TypesRepositoryPullReqSummary.md)
 - [TypesRepositorySummary](docs/TypesRepositorySummary.md)
 - [TypesRuleInfo](docs/TypesRuleInfo.md)
 - [TypesRuleType](docs/TypesRuleType.md)
 - [TypesRuleViolations](docs/TypesRuleViolations.md)
 - [TypesRulesViolations](docs/TypesRulesViolations.md)
 - [TypesSaveLabelInput](docs/TypesSaveLabelInput.md)
 - [TypesSaveLabelValueInput](docs/TypesSaveLabelValueInput.md)
 - [TypesScopeData](docs/TypesScopeData.md)
 - [TypesScopesLabels](docs/TypesScopesLabels.md)
 - [TypesSignature](docs/TypesSignature.md)
 - [TypesSpace](docs/TypesSpace.md)
 - [TypesSquashResponse](docs/TypesSquashResponse.md)
 - [TypesUserGroupInfo](docs/TypesUserGroupInfo.md)
 - [TypesUserGroupOwnerEvaluation](docs/TypesUserGroupOwnerEvaluation.md)
 - [TypesViolation](docs/TypesViolation.md)
 - [TypesWebhookCreateInput](docs/TypesWebhookCreateInput.md)
 - [TypesWebhookExecution](docs/TypesWebhookExecution.md)
 - [TypesWebhookExecutionRequest](docs/TypesWebhookExecutionRequest.md)
 - [TypesWebhookExecutionResponse](docs/TypesWebhookExecutionResponse.md)
 - [UnallocatedCost](docs/UnallocatedCost.md)
 - [UninterpretedOption](docs/UninterpretedOption.md)
 - [UninterpretedOptionOrBuilder](docs/UninterpretedOptionOrBuilder.md)
 - [UnitProgress](docs/UnitProgress.md)
 - [UnitsListBody](docs/UnitsListBody.md)
 - [UnitsListBody1](docs/UnitsListBody1.md)
 - [UnknownFieldSet](docs/UnknownFieldSet.md)
 - [UnlinkSSOGroupRequestDTO](docs/UnlinkSSOGroupRequestDTO.md)
 - [UpdateApprovalRequest](docs/UpdateApprovalRequest.md)
 - [UpdateExemptionRequestBody](docs/UpdateExemptionRequestBody.md)
 - [UpdateGitXWebhookEventRequest](docs/UpdateGitXWebhookEventRequest.md)
 - [UpdateGitXWebhookRequest](docs/UpdateGitXWebhookRequest.md)
 - [UpdateGitXWebhookResponse](docs/UpdateGitXWebhookResponse.md)
 - [UpdateIssueRequestBody](docs/UpdateIssueRequestBody.md)
 - [UpdateOrganizationRequest](docs/UpdateOrganizationRequest.md)
 - [UpdateProjectRequest](docs/UpdateProjectRequest.md)
 - [UpdateProviderRequestDTO](docs/UpdateProviderRequestDTO.md)
 - [UpdateProviderResponse](docs/UpdateProviderResponse.md)
 - [UpdatePullRequestRequestBody](docs/UpdatePullRequestRequestBody.md)
 - [UpdateRequestBody](docs/UpdateRequestBody.md)
 - [UpdateRequestBody2](docs/UpdateRequestBody2.md)
 - [UpdateScanRequestBody](docs/UpdateScanRequestBody.md)
 - [UpdateTargetRequestBody](docs/UpdateTargetRequestBody.md)
 - [UpdateTargetVariantRequestBody](docs/UpdateTargetVariantRequestBody.md)
 - [UpdateWorkspaceResponseBody](docs/UpdateWorkspaceResponseBody.md)
 - [UpdateWorkspaceTemplateRequest](docs/UpdateWorkspaceTemplateRequest.md)
 - [UpdateWorkspaceTemplateResponse](docs/UpdateWorkspaceTemplateResponse.md)
 - [UpdateWorkspaceVariableRequest](docs/UpdateWorkspaceVariableRequest.md)
 - [UpdateWorkspaceVariableResponse](docs/UpdateWorkspaceVariableResponse.md)
 - [UploadInfo](docs/UploadInfo.md)
 - [UploadResult](docs/UploadResult.md)
 - [Usage](docs/Usage.md)
 - [UsageAllAccountsResult](docs/UsageAllAccountsResult.md)
 - [UsageData](docs/UsageData.md)
 - [UsageDataDTO](docs/UsageDataDTO.md)
 - [UsageReportUsageResponseBody](docs/UsageReportUsageResponseBody.md)
 - [UsageResponse](docs/UsageResponse.md)
 - [UsageResponse1](docs/UsageResponse1.md)
 - [UsageResponse1Metadata](docs/UsageResponse1Metadata.md)
 - [UsageResponse1Records](docs/UsageResponse1Records.md)
 - [UsageResult](docs/UsageResult.md)
 - [UsageUsageAllAccountsResponseBody](docs/UsageUsageAllAccountsResponseBody.md)
 - [User](docs/User.md)
 - [UserAddToUserGroupDTO](docs/UserAddToUserGroupDTO.md)
 - [UserAggregate](docs/UserAggregate.md)
 - [UserFilter](docs/UserFilter.md)
 - [UserGroup](docs/UserGroup.md)
 - [UserGroupDTO](docs/UserGroupDTO.md)
 - [UserGroupFilter](docs/UserGroupFilter.md)
 - [UserGroupRequestV2](docs/UserGroupRequestV2.md)
 - [UserGroupResponseV2](docs/UserGroupResponseV2.md)
 - [UserInfo](docs/UserInfo.md)
 - [UserInfoUpdateDTO](docs/UserInfoUpdateDTO.md)
 - [UserInvitationAuditEventData](docs/UserInvitationAuditEventData.md)
 - [UserInviteAuditEventData](docs/UserInviteAuditEventData.md)
 - [UserJourney](docs/UserJourney.md)
 - [UserJourneyDTO](docs/UserJourneyDTO.md)
 - [UserMembershipAuditEventData](docs/UserMembershipAuditEventData.md)
 - [UserMetadata](docs/UserMetadata.md)
 - [UserOrBuilder](docs/UserOrBuilder.md)
 - [UserSettingDTO](docs/UserSettingDTO.md)
 - [UserSettingFromInvite](docs/UserSettingFromInvite.md)
 - [UserSettingRequestDTO](docs/UserSettingRequestDTO.md)
 - [UserSettingResponseDTO](docs/UserSettingResponseDTO.md)
 - [UserSettingUpdateResponseDTO](docs/UserSettingUpdateResponseDTO.md)
 - [UsererrorError](docs/UsererrorError.md)
 - [UsersListBody](docs/UsersListBody.md)
 - [UtilizationOverviewRequestFilters](docs/UtilizationOverviewRequestFilters.md)
 - [UtilizationOverviewResponse](docs/UtilizationOverviewResponse.md)
 - [UtilizationOverviewResponseResponse](docs/UtilizationOverviewResponseResponse.md)
 - [UtmInfo](docs/UtmInfo.md)
 - [V1AWSElasticBlockStoreVolumeSource](docs/V1AWSElasticBlockStoreVolumeSource.md)
 - [V1Affinity](docs/V1Affinity.md)
 - [V1Agent](docs/V1Agent.md)
 - [V1AgentComponentHealth](docs/V1AgentComponentHealth.md)
 - [V1AgentCredentials](docs/V1AgentCredentials.md)
 - [V1AgentHealth](docs/V1AgentHealth.md)
 - [V1AgentList](docs/V1AgentList.md)
 - [V1AgentMetadata](docs/V1AgentMetadata.md)
 - [V1AgentOperator](docs/V1AgentOperator.md)
 - [V1AgentQuery](docs/V1AgentQuery.md)
 - [V1AgentScaleRequest](docs/V1AgentScaleRequest.md)
 - [V1AgentScope](docs/V1AgentScope.md)
 - [V1AgentSetPrimaryNodeRequest](docs/V1AgentSetPrimaryNodeRequest.md)
 - [V1AgentType](docs/V1AgentType.md)
 - [V1AgentYamlQuery](docs/V1AgentYamlQuery.md)
 - [V1AnalysisRunArgument](docs/V1AnalysisRunArgument.md)
 - [V1AnalysisRunMetadata](docs/V1AnalysisRunMetadata.md)
 - [V1AppProjectMappingCreateRequestV2](docs/V1AppProjectMappingCreateRequestV2.md)
 - [V1AppProjectMappingQueryV2](docs/V1AppProjectMappingQueryV2.md)
 - [V1AppProjectMappingV2](docs/V1AppProjectMappingV2.md)
 - [V1AppProjectMappingV2List](docs/V1AppProjectMappingV2List.md)
 - [V1ApplicationAttributes](docs/V1ApplicationAttributes.md)
 - [V1ApplicationAttributesList](docs/V1ApplicationAttributesList.md)
 - [V1ApplicationSetListItem](docs/V1ApplicationSetListItem.md)
 - [V1ApplicationStatusCounts](docs/V1ApplicationStatusCounts.md)
 - [V1ApplicationSyncStatus](docs/V1ApplicationSyncStatus.md)
 - [V1ApplicationSyncStatusQuery](docs/V1ApplicationSyncStatusQuery.md)
 - [V1ApplicationSyncStatuslist](docs/V1ApplicationSyncStatuslist.md)
 - [V1ArgumentValueFrom](docs/V1ArgumentValueFrom.md)
 - [V1AzureDiskVolumeSource](docs/V1AzureDiskVolumeSource.md)
 - [V1AzureFileVolumeSource](docs/V1AzureFileVolumeSource.md)
 - [V1CSIVolumeSource](docs/V1CSIVolumeSource.md)
 - [V1CanaryStep](docs/V1CanaryStep.md)
 - [V1Capabilities](docs/V1Capabilities.md)
 - [V1CephFSVolumeSource](docs/V1CephFSVolumeSource.md)
 - [V1Certificatelist](docs/V1Certificatelist.md)
 - [V1CinderVolumeSource](docs/V1CinderVolumeSource.md)
 - [V1ClaimSource](docs/V1ClaimSource.md)
 - [V1CloudWatchMetric](docs/V1CloudWatchMetric.md)
 - [V1CloudWatchMetricDataQuery](docs/V1CloudWatchMetricDataQuery.md)
 - [V1CloudWatchMetricStat](docs/V1CloudWatchMetricStat.md)
 - [V1CloudWatchMetricStatMetric](docs/V1CloudWatchMetricStatMetric.md)
 - [V1CloudWatchMetricStatMetricDimension](docs/V1CloudWatchMetricStatMetricDimension.md)
 - [V1ClusterInfraType](docs/V1ClusterInfraType.md)
 - [V1Clusterlist](docs/V1Clusterlist.md)
 - [V1ConfigMapEnvSource](docs/V1ConfigMapEnvSource.md)
 - [V1ConfigMapKeySelector](docs/V1ConfigMapKeySelector.md)
 - [V1ConfigMapProjection](docs/V1ConfigMapProjection.md)
 - [V1ConfigMapVolumeSource](docs/V1ConfigMapVolumeSource.md)
 - [V1ConnectedStatus](docs/V1ConnectedStatus.md)
 - [V1Container](docs/V1Container.md)
 - [V1ContainerPort](docs/V1ContainerPort.md)
 - [V1DashboardOverview](docs/V1DashboardOverview.md)
 - [V1DatadogMetric](docs/V1DatadogMetric.md)
 - [V1DeploymentsDetails](docs/V1DeploymentsDetails.md)
 - [V1DisasterRecoveryNode](docs/V1DisasterRecoveryNode.md)
 - [V1DisasterRecoveryType](docs/V1DisasterRecoveryType.md)
 - [V1DownloadResponse](docs/V1DownloadResponse.md)
 - [V1DownwardAPIProjection](docs/V1DownwardAPIProjection.md)
 - [V1DownwardAPIVolumeFile](docs/V1DownwardAPIVolumeFile.md)
 - [V1DownwardAPIVolumeSource](docs/V1DownwardAPIVolumeSource.md)
 - [V1DryRun](docs/V1DryRun.md)
 - [V1EmptyDirVolumeSource](docs/V1EmptyDirVolumeSource.md)
 - [V1Enabled](docs/V1Enabled.md)
 - [V1EnvFromSource](docs/V1EnvFromSource.md)
 - [V1EnvVar](docs/V1EnvVar.md)
 - [V1EnvVarSource](docs/V1EnvVarSource.md)
 - [V1EphemeralContainer](docs/V1EphemeralContainer.md)
 - [V1EphemeralContainerCommon](docs/V1EphemeralContainerCommon.md)
 - [V1EphemeralVolumeSource](docs/V1EphemeralVolumeSource.md)
 - [V1ExecAction](docs/V1ExecAction.md)
 - [V1FCVolumeSource](docs/V1FCVolumeSource.md)
 - [V1FieldRef](docs/V1FieldRef.md)
 - [V1FieldsV1](docs/V1FieldsV1.md)
 - [V1FlexVolumeSource](docs/V1FlexVolumeSource.md)
 - [V1FlockerVolumeSource](docs/V1FlockerVolumeSource.md)
 - [V1GCEPersistentDiskVolumeSource](docs/V1GCEPersistentDiskVolumeSource.md)
 - [V1GRPCAction](docs/V1GRPCAction.md)
 - [V1GitRepoVolumeSource](docs/V1GitRepoVolumeSource.md)
 - [V1GlusterfsVolumeSource](docs/V1GlusterfsVolumeSource.md)
 - [V1Gnupg](docs/V1Gnupg.md)
 - [V1GraphiteMetric](docs/V1GraphiteMetric.md)
 - [V1GroupKind](docs/V1GroupKind.md)
 - [V1HTTPGetAction](docs/V1HTTPGetAction.md)
 - [V1HTTPHeader](docs/V1HTTPHeader.md)
 - [V1HeaderRoutingMatch](docs/V1HeaderRoutingMatch.md)
 - [V1HealthStatusCounts](docs/V1HealthStatusCounts.md)
 - [V1HostAlias](docs/V1HostAlias.md)
 - [V1HostPathVolumeSource](docs/V1HostPathVolumeSource.md)
 - [V1ISCSIVolumeSource](docs/V1ISCSIVolumeSource.md)
 - [V1InfluxdbMetric](docs/V1InfluxdbMetric.md)
 - [V1JobMetric](docs/V1JobMetric.md)
 - [V1JobSpec](docs/V1JobSpec.md)
 - [V1KayentaMetric](docs/V1KayentaMetric.md)
 - [V1KayentaScope](docs/V1KayentaScope.md)
 - [V1KayentaThreshold](docs/V1KayentaThreshold.md)
 - [V1KeyToPath](docs/V1KeyToPath.md)
 - [V1LabelSelector](docs/V1LabelSelector.md)
 - [V1LabelSelectorRequirement](docs/V1LabelSelectorRequirement.md)
 - [V1LabelsBody](docs/V1LabelsBody.md)
 - [V1LabelsBody1](docs/V1LabelsBody1.md)
 - [V1Lifecycle](docs/V1Lifecycle.md)
 - [V1LifecycleHandler](docs/V1LifecycleHandler.md)
 - [V1ListMeta](docs/V1ListMeta.md)
 - [V1LoadBalancerIngress](docs/V1LoadBalancerIngress.md)
 - [V1LocalObjectReference](docs/V1LocalObjectReference.md)
 - [V1ManagedFieldsEntry](docs/V1ManagedFieldsEntry.md)
 - [V1MeasurementRetention](docs/V1MeasurementRetention.md)
 - [V1Metric](docs/V1Metric.md)
 - [V1MetricProvider](docs/V1MetricProvider.md)
 - [V1MicroTime](docs/V1MicroTime.md)
 - [V1NFSVolumeSource](docs/V1NFSVolumeSource.md)
 - [V1NewRelicMetric](docs/V1NewRelicMetric.md)
 - [V1NodeAffinity](docs/V1NodeAffinity.md)
 - [V1NodeSelector](docs/V1NodeSelector.md)
 - [V1NodeSelectorRequirement](docs/V1NodeSelectorRequirement.md)
 - [V1NodeSelectorTerm](docs/V1NodeSelectorTerm.md)
 - [V1NodeSystemInfo](docs/V1NodeSystemInfo.md)
 - [V1OCIRepoType](docs/V1OCIRepoType.md)
 - [V1OCIRepoTypeResponse](docs/V1OCIRepoTypeResponse.md)
 - [V1ObjectFieldSelector](docs/V1ObjectFieldSelector.md)
 - [V1ObjectMeta](docs/V1ObjectMeta.md)
 - [V1OperationPhase](docs/V1OperationPhase.md)
 - [V1OwnerReference](docs/V1OwnerReference.md)
 - [V1PersistentVolumeClaimSpec](docs/V1PersistentVolumeClaimSpec.md)
 - [V1PersistentVolumeClaimTemplate](docs/V1PersistentVolumeClaimTemplate.md)
 - [V1PersistentVolumeClaimVolumeSource](docs/V1PersistentVolumeClaimVolumeSource.md)
 - [V1PhotonPersistentDiskVolumeSource](docs/V1PhotonPersistentDiskVolumeSource.md)
 - [V1PodAffinity](docs/V1PodAffinity.md)
 - [V1PodAffinityTerm](docs/V1PodAffinityTerm.md)
 - [V1PodAntiAffinity](docs/V1PodAntiAffinity.md)
 - [V1PodDNSConfig](docs/V1PodDNSConfig.md)
 - [V1PodDNSConfigOption](docs/V1PodDNSConfigOption.md)
 - [V1PodFailurePolicy](docs/V1PodFailurePolicy.md)
 - [V1PodFailurePolicyOnExitCodesRequirement](docs/V1PodFailurePolicyOnExitCodesRequirement.md)
 - [V1PodFailurePolicyOnPodConditionsPattern](docs/V1PodFailurePolicyOnPodConditionsPattern.md)
 - [V1PodFailurePolicyRule](docs/V1PodFailurePolicyRule.md)
 - [V1PodOS](docs/V1PodOS.md)
 - [V1PodReadinessGate](docs/V1PodReadinessGate.md)
 - [V1PodResourceClaim](docs/V1PodResourceClaim.md)
 - [V1PodSchedulingGate](docs/V1PodSchedulingGate.md)
 - [V1PodSecurityContext](docs/V1PodSecurityContext.md)
 - [V1PodSpec](docs/V1PodSpec.md)
 - [V1PodTemplateMetadata](docs/V1PodTemplateMetadata.md)
 - [V1PodTemplateSpec](docs/V1PodTemplateSpec.md)
 - [V1PortStatus](docs/V1PortStatus.md)
 - [V1PortworxVolumeSource](docs/V1PortworxVolumeSource.md)
 - [V1PreferredSchedulingTerm](docs/V1PreferredSchedulingTerm.md)
 - [V1Probe](docs/V1Probe.md)
 - [V1ProbeHandler](docs/V1ProbeHandler.md)
 - [V1ProjectedVolumeSource](docs/V1ProjectedVolumeSource.md)
 - [V1PrometheusAuth](docs/V1PrometheusAuth.md)
 - [V1PrometheusMetric](docs/V1PrometheusMetric.md)
 - [V1Proxy](docs/V1Proxy.md)
 - [V1QuobyteVolumeSource](docs/V1QuobyteVolumeSource.md)
 - [V1RBDVolumeSource](docs/V1RBDVolumeSource.md)
 - [V1RecentDeploymentQuery](docs/V1RecentDeploymentQuery.md)
 - [V1RecentDeploymentsDetailsList](docs/V1RecentDeploymentsDetailsList.md)
 - [V1RecentlyCreatedCount](docs/V1RecentlyCreatedCount.md)
 - [V1RecentlyCreatedOverview](docs/V1RecentlyCreatedOverview.md)
 - [V1RepoByUrlRespList](docs/V1RepoByUrlRespList.md)
 - [V1RepoListReq](docs/V1RepoListReq.md)
 - [V1RepositoryCredentialsQuery](docs/V1RepositoryCredentialsQuery.md)
 - [V1Repositorylist](docs/V1Repositorylist.md)
 - [V1ResourceClaim](docs/V1ResourceClaim.md)
 - [V1ResourceFieldSelector](docs/V1ResourceFieldSelector.md)
 - [V1ResourceRequirements](docs/V1ResourceRequirements.md)
 - [V1RolloutAnalysis](docs/V1RolloutAnalysis.md)
 - [V1RolloutAnalysisRunInfo](docs/V1RolloutAnalysisRunInfo.md)
 - [V1RolloutAnalysisTemplate](docs/V1RolloutAnalysisTemplate.md)
 - [V1RolloutContainerInfo](docs/V1RolloutContainerInfo.md)
 - [V1RolloutExperimentInfo](docs/V1RolloutExperimentInfo.md)
 - [V1RolloutExperimentStep](docs/V1RolloutExperimentStep.md)
 - [V1RolloutExperimentStepAnalysisTemplateRef](docs/V1RolloutExperimentStepAnalysisTemplateRef.md)
 - [V1RolloutExperimentTemplate](docs/V1RolloutExperimentTemplate.md)
 - [V1RolloutInfo](docs/V1RolloutInfo.md)
 - [V1RolloutJobInfo](docs/V1RolloutJobInfo.md)
 - [V1RolloutNonJobInfo](docs/V1RolloutNonJobInfo.md)
 - [V1RolloutPause](docs/V1RolloutPause.md)
 - [V1RolloutPodInfo](docs/V1RolloutPodInfo.md)
 - [V1RolloutReplicaSetInfo](docs/V1RolloutReplicaSetInfo.md)
 - [V1RouteMatch](docs/V1RouteMatch.md)
 - [V1SELinuxOptions](docs/V1SELinuxOptions.md)
 - [V1ScaleIOVolumeSource](docs/V1ScaleIOVolumeSource.md)
 - [V1ScopeDetail](docs/V1ScopeDetail.md)
 - [V1SeccompProfile](docs/V1SeccompProfile.md)
 - [V1SecretEnvSource](docs/V1SecretEnvSource.md)
 - [V1SecretKeySelector](docs/V1SecretKeySelector.md)
 - [V1SecretProjection](docs/V1SecretProjection.md)
 - [V1SecretVolumeSource](docs/V1SecretVolumeSource.md)
 - [V1SecurityContext](docs/V1SecurityContext.md)
 - [V1SemanticVersion](docs/V1SemanticVersion.md)
 - [V1ServiceAccountTokenProjection](docs/V1ServiceAccountTokenProjection.md)
 - [V1SetCanaryScale](docs/V1SetCanaryScale.md)
 - [V1SetHeaderRoute](docs/V1SetHeaderRoute.md)
 - [V1SetMirrorRoute](docs/V1SetMirrorRoute.md)
 - [V1Sigv4Config](docs/V1Sigv4Config.md)
 - [V1SkyWalkingMetric](docs/V1SkyWalkingMetric.md)
 - [V1SortOrderOptions](docs/V1SortOrderOptions.md)
 - [V1StorageOSVolumeSource](docs/V1StorageOSVolumeSource.md)
 - [V1StringMatch](docs/V1StringMatch.md)
 - [V1SyncStatusCounts](docs/V1SyncStatusCounts.md)
 - [V1Sysctl](docs/V1Sysctl.md)
 - [V1TCPSocketAction](docs/V1TCPSocketAction.md)
 - [V1TemplateService](docs/V1TemplateService.md)
 - [V1Time](docs/V1Time.md)
 - [V1Toleration](docs/V1Toleration.md)
 - [V1TopApplicationPhaseStats](docs/V1TopApplicationPhaseStats.md)
 - [V1TopApplicationPhaseStatsList](docs/V1TopApplicationPhaseStatsList.md)
 - [V1TopologySpreadConstraint](docs/V1TopologySpreadConstraint.md)
 - [V1TypedLocalObjectReference](docs/V1TypedLocalObjectReference.md)
 - [V1TypedObjectReference](docs/V1TypedObjectReference.md)
 - [V1UniqueMessage](docs/V1UniqueMessage.md)
 - [V1User](docs/V1User.md)
 - [V1VersionUpgradeResponse](docs/V1VersionUpgradeResponse.md)
 - [V1Volume](docs/V1Volume.md)
 - [V1VolumeDevice](docs/V1VolumeDevice.md)
 - [V1VolumeMount](docs/V1VolumeMount.md)
 - [V1VolumeProjection](docs/V1VolumeProjection.md)
 - [V1VolumeSource](docs/V1VolumeSource.md)
 - [V1VsphereVirtualDiskVolumeSource](docs/V1VsphereVirtualDiskVolumeSource.md)
 - [V1WavefrontMetric](docs/V1WavefrontMetric.md)
 - [V1WebMetric](docs/V1WebMetric.md)
 - [V1WebMetricHeader](docs/V1WebMetricHeader.md)
 - [V1WeightedPodAffinityTerm](docs/V1WeightedPodAffinityTerm.md)
 - [V1WindowsSecurityContextOptions](docs/V1WindowsSecurityContextOptions.md)
 - [V1doradeploymentFrequencyFilter](docs/V1doradeploymentFrequencyFilter.md)
 - [V1doradeploymentFrequencyFilterTimeRange](docs/V1doradeploymentFrequencyFilterTimeRange.md)
 - [V1doraleadtimeFilter](docs/V1doraleadtimeFilter.md)
 - [V1doraleadtimeFilterJiraIssueResolvedAt](docs/V1doraleadtimeFilterJiraIssueResolvedAt.md)
 - [V1dorameantimeFilter](docs/V1dorameantimeFilter.md)
 - [V1orgunitsIntegrations](docs/V1orgunitsIntegrations.md)
 - [V1orgunitsSections](docs/V1orgunitsSections.md)
 - [V1orgunitslistFilter](docs/V1orgunitslistFilter.md)
 - [V1orgworkspacesunitslistFilter](docs/V1orgworkspacesunitslistFilter.md)
 - [ValidateTemplateInputsResponseDTO](docs/ValidateTemplateInputsResponseDTO.md)
 - [ValidationError](docs/ValidationError.md)
 - [ValidationResult](docs/ValidationResult.md)
 - [ValidationStatus](docs/ValidationStatus.md)
 - [ValueChange](docs/ValueChange.md)
 - [ValueDataPoint](docs/ValueDataPoint.md)
 - [ValuesValueBody](docs/ValuesValueBody.md)
 - [ValuesValueBody1](docs/ValuesValueBody1.md)
 - [Variable](docs/Variable.md)
 - [VariableConfigDTO](docs/VariableConfigDTO.md)
 - [VariableDTO](docs/VariableDTO.md)
 - [VariableListRequestDTO](docs/VariableListRequestDTO.md)
 - [VariableMetadata](docs/VariableMetadata.md)
 - [VariableRequestDTO](docs/VariableRequestDTO.md)
 - [VariableResource](docs/VariableResource.md)
 - [VariableResponseDTO](docs/VariableResponseDTO.md)
 - [Variation](docs/Variation.md)
 - [VariationMap](docs/VariationMap.md)
 - [VaultConnector](docs/VaultConnector.md)
 - [VideoCard](docs/VideoCard.md)
 - [ViewCondition](docs/ViewCondition.md)
 - [ViewField](docs/ViewField.md)
 - [ViewIdCondition](docs/ViewIdCondition.md)
 - [ViewPreferences](docs/ViewPreferences.md)
 - [ViewRule](docs/ViewRule.md)
 - [ViewTimeRange](docs/ViewTimeRange.md)
 - [ViewVisualization](docs/ViewVisualization.md)
 - [VirtualMachine](docs/VirtualMachine.md)
 - [WarmUpOption](docs/WarmUpOption.md)
 - [WebhookAutoRegistrationStatus](docs/WebhookAutoRegistrationStatus.md)
 - [WebhookDetails](docs/WebhookDetails.md)
 - [WebhookEventProcessingDetails](docs/WebhookEventProcessingDetails.md)
 - [WebhookExecutionDetails](docs/WebhookExecutionDetails.md)
 - [WebhookInfo](docs/WebhookInfo.md)
 - [WebhookTriggerSource](docs/WebhookTriggerSource.md)
 - [WebhookTriggerSpec](docs/WebhookTriggerSpec.md)
 - [WeeklyCalendarSpec](docs/WeeklyCalendarSpec.md)
 - [WeightedVariation](docs/WeightedVariation.md)
 - [WinRmAuth](docs/WinRmAuth.md)
 - [WinRmCommandParameter](docs/WinRmCommandParameter.md)
 - [WinRmCredentialsSpec](docs/WinRmCredentialsSpec.md)
 - [WinRmNTLMSpec](docs/WinRmNTLMSpec.md)
 - [WinRmTGTKeyTabFileSpec](docs/WinRmTGTKeyTabFileSpec.md)
 - [WinRmTGTPasswordSpec](docs/WinRmTGTPasswordSpec.md)
 - [WindowBasedServiceLevelIndicatorSpec](docs/WindowBasedServiceLevelIndicatorSpec.md)
 - [WorkflowsInfo](docs/WorkflowsInfo.md)
 - [WorkflowsInfoResponse](docs/WorkflowsInfoResponse.md)
 - [WorkloadRecommendationDTO](docs/WorkloadRecommendationDTO.md)
 - [Workspace](docs/Workspace.md)
 - [Workspace2](docs/Workspace2.md)
 - [WorkspaceData](docs/WorkspaceData.md)
 - [WorkspaceDataInfo](docs/WorkspaceDataInfo.md)
 - [WorkspaceDataPolicyEvaluation](docs/WorkspaceDataPolicyEvaluation.md)
 - [WorkspaceDataResourceCollection](docs/WorkspaceDataResourceCollection.md)
 - [WorkspaceEvent](docs/WorkspaceEvent.md)
 - [WorkspaceEvent2](docs/WorkspaceEvent2.md)
 - [WorkspaceResourceSummary](docs/WorkspaceResourceSummary.md)
 - [WorkspaceResourceSummaryCollection](docs/WorkspaceResourceSummaryCollection.md)
 - [WorkspaceTerraformVariableFiles](docs/WorkspaceTerraformVariableFiles.md)
 - [WorkspaceUpdate](docs/WorkspaceUpdate.md)
 - [WorkspaceUpdate2](docs/WorkspaceUpdate2.md)
 - [WorkspaceVariable](docs/WorkspaceVariable.md)
 - [WorkspaceVariableResourceCollection](docs/WorkspaceVariableResourceCollection.md)
 - [WorkspacesCreateWorkspaceResponseBody](docs/WorkspacesCreateWorkspaceResponseBody.md)
 - [WorkspacesShowWorkspaceResponseBody](docs/WorkspacesShowWorkspaceResponseBody.md)
 - [YAMLSchemaErrorWrapper](docs/YAMLSchemaErrorWrapper.md)
 - [YamlDiffRecord](docs/YamlDiffRecord.md)
 - [YamlDiffRecordDTO](docs/YamlDiffRecordDTO.md)
 - [YamlSchemaErrorDTO](docs/YamlSchemaErrorDTO.md)
 - [YamlSchemaErrorWrapperDTO](docs/YamlSchemaErrorWrapperDTO.md)
 - [ZendeskResponseDTO](docs/ZendeskResponseDTO.md)

## Documentation For Authorization


## x-api-key

- **Type**: API key
- **API key parameter name**: x-api-key
- **Location**: HTTP header


## Author

contact@harness.io
